<!--#include file="shop_adminmd5.asp"-->
<%
'**************************************************************
' 7.02
' 22 August 2012
' HK Programming Enhancement to VP-ASP Shopping Cart 7.0
' All Rights reserved
' Copyright (c) 2007-1010 HK Programming.
' All rights reserved.
' This software and documentation constitutes a published work
' and contains valuable trade secrets and proprietary information
' belonging to HK Programming.
' None of the foregoing material may be copied,
' duplicated or disclosed without the express written permission
' of HK Programming.
'*******************************************************
'' Allows administrator to logon using cookies and not expire
' set cookie expiry days
' See if cookie exists and password exists
' match user and password
' If they match then logon automatically
' do nomal login store in tbllog and email merchant if that has been turned onral
' hk_checkadmin=Yes then being call from shopadmin from checkadmin
'                    then do not do mailing
' Dec 8, 2009       HK Programming Admin Enhancement
' Jan 24, 2009      Support Encrypted password
'**********************************************************

dim hkallowcookielogin,hkcookiedays,hkcookiehours
hkallowcookielogin = getconfig("xhkcookieloginenable")
hkcookiedays = getconfig("xhkcookiedays")
hkcookiehours = getconfig("xhkcookiehours")
const hkdebug = "No" ' developer only
dim hk_checkadmin ' set to yes by checkadmin so we do not do mail

if trim(hkcookiedays) = "" then hkcookiedays = 1
if trim(hkcookiehours) = "" then hkcookiehours = 0

sub HK_AdminLogon (dbc)
   dim hkusername, username, userpassword, hashpassword, temppass
   dim tablesallowed
   dim cookiepassword
   dim sql, rs
   dim rc
   dim adminmenus
   dim admintype
   dim tempusername
   dim saveusername
   if lcase(hkallowcookielogin) <> "yes" then exit sub
   RC = 4
   if lcase(hkdebug) = "yes" then
      debugwrite "username=" & Request.Cookies("shopuserid" & "_" & xshopid)
      debugwrite "userpassword=" & Request.Cookies("shoppassword" & "_" & xshopid)
   end if
   hkusername = Request.Cookies("shopuserid" & "_" & xshopid)
   username = hkusername
   userpassword = Request.Cookies("shoppassword" & "_" & xshopid)
   if hkusername = "" or userpassword = "" then exit sub

   hkusername = cleanchars(hkusername)
   cookiepassword = cleanchars(userpassword)
   if hkusername = "" or cookiepassword = "" then exit sub

   SetSess "Login", "Force"
   if GetSess("Login") = "Force" then SetSess "Login", ""
   sql = "select * from tbluser where fldusername='" & hkusername & "'"
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open SQL, dbc, adOpenStatic, adLockReadOnly
   if rs.eof then
      closerecordset rs
      exit sub
   end if
   temppass = rs("fldpassword")
   tablesallowed = rs("tablesallowed")
   adminmenus = rs("fldaccess")
   admintype = rs("admintype")
   closerecordset rs
   hashpassword = convertmd5(temppass)
   if lcase(hkdebug) = "yes" then
      debugwrite "hash=" & hashpassword & " cookiepassword=" & cookiepassword
   end if
   if hashpassword <> cookiepassword then exit sub

   saveusername = hkusername
   tempusername = EnDeCrypt2(hkusername, xencryptkey, "D")
   SetSess "shopadmin" , tempusername
   SetSess "login" , tempusername
   setsess "usertables", tablesallowed
   setsess "adminmenus", adminmenus
   SetSess "ShopAdmindb", xdatabase
   if isnull(Admintype) then
      SetSess "admintype", "SUPER"
   else
      setsess "admintype", admintype
   end if
   SaveCookieLogin saveusername, hashpassword, hkcookiedays, hkcookiehours
   LogUser GetSess("ShopAdmin"), "in", dbc
   SetSess("Supplierid"), ""
   if hk_checkadmin<>"Yes" then ' called from shopadmin
      CheckSecurity temppass ' do what shopadmin would do
      AdminEmailmerchantSuccess ' mail to merchant
   end if
   rc = 0
end sub

'**********************************************************************
' save login for quick login again
' if days=-1 then cookie is deleted
' '**************************************************************************
sub SaveCookieLogin (userid, password, days, hours)
   dim expiredate
   if lcase(hkallowcookielogin) <> "yes" then exit sub
   expiredate = now()
   if trim(days) <> "" then
      expiredate = expiredate + days
   end if
   if trim(hours) <> "" then
      expiredate = dateadd("h", hours, expiredate)
   end if
   Response.Cookies("shopuserid" & "_" & xshopid) = userid
   Response.Cookies("shopuserid" & "_" & xshopid).expires = expiredate
   Response.Cookies("shoppassword" & "_" & xshopid) = password
   Response.Cookies("shoppassword" & "_" & xshopid).expires = expiredate
end sub

'***********************************************************************
' a normal logon has occurred,
' save information as a cookie
'**********************************************************************
sub HK_SaveNormalCookieLogin (username, userpassword)
   dim hashpassword
   if lcase(hkallowcookielogin) <> "yes" then exit sub
   hashpassword = convertmd5(userpassword)
   SaveCookieLogin username, hashpassword, hkcookiedays, hkcookiehours
end sub

'*************************************************************
' reset logon cookies
'**************************************************************
sub Hk_Logoff
   Response.Cookies("shopuserid" & "_" & xshopid).expires = date() -1
   Response.Cookies("shoppassword" & "_" & xshopid).expires = date() -1
end sub
%>