<%option explicit%>
<%response.buffer=true%>
<!-- #include file="admin$db.asp" -->
<%ShopOpenDatabase dbc%>
<!-- #include file="shopa_diagnostic_subs.asp" -->
<!-- #include file="shopa_modules_configure_subs.asp" -->
<%
'*********************************************************************************
' 8.00
' 01 August 2014
' Diagnostic Manager
' Diagnostic for database setup
'***********************************************"**********************************

dim currenturl
currenturl = "shopa_diag_dbtest.asp"
ShopCheckAdmin currenturl
SetSess "CurrentURL", currenturl

dim curTest
dim PrevTest
dim errorCount
dim sAction
sAction = cleanchars(request("dbshop"))
if saction<>"" then
   saction = "DBSHOP"
else
   saction = cleanchars(request("dbcustom"))
   if saction<>"" then
      saction = "DBCUSTOM"
   end if
end if

if saction = "" then
   DiagnosticPageHeader getlang("langdatabase"), "", ""
   DisplayForm
else
   verifygenpredefinedsecuritycode request("genpredefinedsecuritycode")
   DiagnosticPageHeader getlang("langdatabase"), currenturl, getlang("langbacktodiagnosticdatabase")
   htmlwrite "<table width='100%'>"
   RunTests
   htmlwrite "</table>"
end if
DiagnosticPageTrailer
shopclosedatabase dbc

sub DisplayForm
   displaytablecaption_common getlang("langdiagnosticdatabasedesc1")
   htmlwrite "<form name=""diagnosticform"" action="""& currenturl &""" method=""POST"">"
   htmlwrite "<input type=""hidden"" name=""genpredefinedsecuritycode"" value="""& session("genpredefinedsecuritycode") &""" />"
   GenerateDisplayHeader getlang("langtestdatabaseconnection")
   GenerateDisplayBodyHeader
%>
   <table width="100%" cellpadding="2" cellspacing="2" border="0">
     <tr>
       <td align='left'><%=getlang("langtestdatabaseconnectionmethod1")%><br /><br /><input class="submitbtn" type=submit name=dbshop value='<%=getlang("langtestdatabaseconnectionshopconfig")%>'></td>
     </tr>
     <tr><td colspan="2">&nbsp;</td></tr>
     <tr>
       <td align='left'><%=getlang("langtestdatabaseconnectionmethod2")%></td>
     </tr>
     <tr>
       <td align='left'>
	     <table><%
   '800 - 2015.04.10 - Bug Fix: Dianogstic Manager - syntax error
   formatmodulestextbox getlang("langdatabasename"), "xDatabase", "", "", "", "20%", "80%", "28", "28", "left", "middle"
   formatmodulestextbox getlang("langdatabaseusername"), "xsqluser", "", "", "", "20%", "80%", "28", "28", "left", "middle"
   formatmodulestextbox getlang("langdatabasepassword"), "xsqlpwd", "", "", "", "20%", "80%", "28", "28", "left", "middle"
   formatmodulestextbox getlang("langserveraddress"), "xsqlserver", "", "", "", "20%", "80%", "28", "28", "left", "middle"
   formatmodulesdropdown getlang("langdatabasetype"), "xDatabaseType", "", "Access,DRIVE,MYSQL,MYSQL351,MYSQL510,ODBC,SQLSERVER,ACCESS2007", ",DRIVE,MYSQL,MYSQL351,MYSQL510,ODBC,SQLSERVER,ACCESS2007", "", "20%", "70%", "28", "28", "left", "middle"
   formatmodulestextbox getlang("langdatabaselocation"), "xDbLocation", "", "", "", "20%", "80%", "28", "28", "left", "middle"
%></table>
        <br />
        <input class="submitbtn" type=submit name=dbcustom value='<%=getlang("langtestdatabaseconnectionshopcustom")%>'>
	  </td>
	  <td align="center">&nbsp;</td>
    </tr>
   </table>
<%
   GenerateDisplayBodyFooter
   htmlwrite "</form>"
end sub

sub RunTests
   ErrorCount = 0
   if saction = "DBSHOP" then
      GetShopValues
      RunDatabaseTests
      exit sub
   end if
   if saction = "DBCUSTOM" then
      GetCustomValues
      RunDatabaseTests
      exit sub
   end if
end sub

sub GetShopValues
   SetSess "diagnosticdb", xDatabase
   SetSess "diagnosticDbLocation", xDbLocation
   SetSess "diagnosticxDatabaseType", ucase(xDatabaseType)
   SetSess "diagnosticxSQLServer", xSQLServer
   SetSess "diagnosticxSQLUser", xSQLUser
   SetSess "diagnosticxSQLPwd", xSQLPwd
end sub

sub GetCustomValues
   SetSess "diagnosticdb", cleanchars(request("xDatabase"))
   SetSess "diagnosticDbLocation", cleanchars(request("xDbLocation"))
   SetSess "diagnosticxDatabaseType", ucase(cleanchars(request("xDatabaseType")))
   SetSess "diagnosticxSQLServer", cleanchars(request("xSQLServer"))
   SetSess "diagnosticxSQLUser", cleanchars(request("xSQLUser"))
   SetSess "diagnosticxSQLPwd", cleanchars(request("xSQLPwd"))
end sub

sub RunDatabaseTests
   GenerateDisplayHeader getlang("langtestresults")
   GenerateDisplayBodyHeader
   dim conn
   dim testsql
   dim testrs
   dim rstemp
   dim dbtable, dbfield, fieldvalue
   on error resume next
   DBTable = "tbluser"
   dbfield = "fldDatabase"
   SetSess "diagnostic", "Yes"
   curTest = getlang("langdatabaseopen")
   ShopOpenDatabase_diag conn, GetSess("diagnosticdb"), getsess("diagnosticxDatabaseType")
   SetSess "diagnostic", ""
   curTest = getlang("langdatabaseread")
   testsql = "select "& dbfield &" from " & DBTable
   set testrs = Server.createobject("ADODB.Recordset")
   testrs.open Testsql, conn, adOpenStatic, adLockReadOnly
   fieldvalue = testrs(dbfield)
   if err.number > 0 then
      addError "<span class='fontbold'>"& getlang("langcommonfail") &"</span>"
      addError "<span class='fontbold'>"& getlang("langdatabasefaildesc1") &"</span>"
      AddError GetSess("OpenError")
      CheckMicrosoftError conn
   else
      addInfo getlang("langcommonpass")
   end if
   closerecordset testrs
   curTest = "Database Write"
   if instr(ucase(xdatabasetype), "MYSQL") > 0 then
      Testsql = "Update " & DBTable & " set " & dbfield & "='shopdbtest'"
      conn.execute(testsql)
   else
      set rstemp = Server.createobject("ADODB.Recordset")
      rstemp.open DBTable, conn, 1, 3
      rstemp.update
      rstemp(dbfield) = "shopdbtest"
      rstemp.update
      closerecordset rstemp
   end if
   if err.number > 0 then
      addError "<span class='fontbold'>"& getlang("langcommonfail") &"</span>"
      if instr(ucase(xdatabasetype), "MYSQL") > 0 or instr(ucase(xdatabasetype), "SQLSERVER") > 0 then
      else
         addError "<span class='fontbold'>"& getlang("langdatabasefaildesc2") &"</span>"
      end if
      AddError GetSess("OpenError")
      CheckMicrosoftError conn
   else
      if conn.errors.count> 0 then
         addError "<span class='fontbold'>"& getlang("langcommonfail") &"</span>"
         addError "<span class='fontbold'>"& getlang("langdatabasefaildesc2") &"</span>"
         htmlwritewrite "<tr><td></td><td>&nbsp;</td></tr>"
         AddError GetSess("OpenError")
         CheckMicrosoftError conn
      else
         addInfo getlang("langcommonpass")
      end if
   end if
   if instr(ucase(xdatabasetype), "MYSQL") > 0 or instr(ucase(xdatabasetype), "SQLSERVER") > 0 then
   else
      curTest = getlang("langdatabasepermissions")
      dim mysql
      mysql = "select * from configuration"
      set rstemp = Server.createobject("ADODB.RecordSet")
      rstemp.cursorlocation = aduseclient
      rstemp.cachesize = 5
      rstemp.open MYSQL, conn, adOpenKeyset, adLockReadOnly, adCmdText
      if err.number > 0 then
         addError "<span class='fontbold'>"& getlang("langcommonfail") &"</span>"
         addError getlang("langdatabasefaildesc3")
      else
         if conn.errors.count> 0 then
            addError "<span class='fontbold'>"& getlang("langcommonfail") &"</span>"
            addError getlang("langdatabasefaildesc1")
            CheckMicrosoftError conn
         else
            addInfo getlang("langcommonpass")
         end if
      end if
      closerecordset rstemp
   end if
   conn.close
   set conn = nothing
   on error goto 0
   GenerateDisplayBodyFooter
end sub

sub CheckMicrosoftError (conn)
   dim counter
   if conn.errors.count> 0 then
      for counter = 0 to conn.errors.count -1
         addError ""& getlang("langerrordesc") &" " & conn.errors(counter).description
      next
   end if
end sub

sub addError (msg)
   if curtest<>PrevTest then
      response.write "<tr><td align='left' valign='top'><span class='fontbold'>" & curtest & "</span></td>" & vbcrlf
   else
      response.write "<tr><td></td>" & vbcrlf
   end if
   response.write "<td>" & msg & "</td></tr>" & vbcrlf
   errorcount = errorCount + 1
   PrevTest = CurTest
end sub

sub addErrorCurrent (msg)
   if curtest<>PrevTest then
      response.write "<tr bgcolor='efefef'><td align='left' valign='top'><span class='fontbold'>" & curtest & "</span></td>" & vbcrlf
   else
      response.write "<tr bgcolor='efefef'><td></td>" & vbcrlf
   end if
   response.write "<td>" & msg & "</td></tr>" & vbcrlf
   errorcount = errorCount + 1
   PrevTest = CurTest
end sub

sub addInfo (msg)
   if curtest<>PrevTest then
      response.write "<tr><td align='left'><span class='fontbold'>" & curtest & "</span></td>" & vbcrlf
   else
      response.write "<tr><td align='left'></td>" & vbcrlf
   end if
   response.write "<td align='left'>" & msg & "</td></tr>" & vbcrlf
   PrevTest = CurTest
end sub

sub addInfoCurrent (msg)
   if curtest<>PrevTest then
      response.write "<tr bgcolor='efefef'><td align='left'><span class='fontbold'>" & curtest & "</span></td>" & vbcrlf
   else
      response.write "<tr bgcolor='efefef'><td align='left'></td>" & vbcrlf
   end if
   response.write "<td align='left'>" & msg & "</td></tr>" & vbcrlf
   PrevTest = CurTest
end sub

sub ProcessAccessOpen_diag(connection)
   dim DbLocation
   dim strconn
   dim Database
   dim sqlpwd, sqluser
   Database = GetSess("diagnosticdb") & ".mdb"
   DbLocation = GetSess("diagnosticDbLocation")
   sqlpwd = GetSess("diagnosticxSQLPwd")
   sqluser = GetSess("diagnosticxSQLUser")
   if DbLocation<>"" then
      Database = GetSess("diagnosticDbLocation") & "\" & Database
   end if
   if ucase(getsess("diagnosticxDatabaseType")) = "DRIVE" then
      if xAccessOLE<>"Yes" then
         strconn = "DRIVER=Microsoft Access Driver (*.mdb);DBQ=" & Database
      else
         strconn = "provider=microsoft.jet.oledb.4.0;persist security info=false;data source=" & Database
      end if
   else
      if xAccessOLE<>"Yes" then
         strconn = "DRIVER=Microsoft Access Driver (*.mdb);DBQ=" & Server.MapPath(Database)
      else
         strconn = "provider=microsoft.jet.oledb.4.0;persist security info=false;data source=" & Server.MapPath(Database)
      end if
   end if
   set connection = Server.createobject("ADODB.Connection")
   on error resume next
   if sqlpwd = "" then
      connection.open strConn
   else
      connection.open strConn, sqluser, sqlpwd
   end if
   if connection.errors.count <> 0 then
      SetSess "OpenError", "Open Messages<br />" & connection.errors(0).description & " <br />" & GetSess("dbc")
   else
      SetSess "OpenError", ""
   end if
   on error goto 0
end sub

sub ProcessAccess2007_diag(connection)
   dim DbLocation
   dim strconn
   dim Database
   Database = GetSess("diagnosticdb") & ".accdb"
   DbLocation = GetSess("diagnosticDbLocation")
   if DbLocation<>"" then
      Database = GetSess("diagnosticDbLocation") & "\" & Database
   end if
   strconn = "Provider=Microsoft.ACE.OLEDB.12.0;persist security info=false;data source=" & Server.MapPath(Database)
   set connection = Server.createobject("ADODB.Connection")
   on error resume next
   connection.open strConn
   if connection.errors.count> 0 then
      SetSess "OpenError", "Open Messages<br />" & connection.errors(0).description & " <br />" & GetSess("dbc")
   else
      SetSess "OpenError", ""
   end if
   on error goto 0
end sub

sub ProcessODBC_diag (connection)
   on error resume next
   dim strconn
   set connection = Server.createobject("ADODB.Connection")
   strconn = GetSess("diagnosticdb")
   connection.open strConn
   if connection.errors.count> 0 then
      SetSess "OpenError", "Open Messages<br />" & connection.errors(0).description & " <br />" & GetSess("dbc")
   else
      SetSess "OpenError", ""
   end if
   on error goto 0
end sub

sub ProcessSQLServer_diag(connection)
   on error resume next
   set connection = Server.createobject("ADODB.Connection")
   dim varServerIP, varUserName, varPassword, varDatabaseName
   dim strconn
   varServerIP = GetSess("diagnosticxSQLServer")
   varUserName = GetSess("diagnosticxSQLUser")
   varPassword = GetSess("diagnosticxSQLPwd")
   varDatabaseName = GetSess("diagnosticdb")
   if xSqlOLEDb = "Yes" then
      strconn = "Provider=sqloledb;" & "Source=" & varServerIP & ";" & "Database=" & varDatabaseName & ";" & "UID=" & varUserName & ";" & "Password=" & varPassword & ";"
   else
      strconn = "DRIVER={SQL Server}; Server=" & varServerIP & "; Database=" & varDatabaseName & "; UID=" & varUserName & "; PWD=" & varPassword'
   end if
   Connection.open strconn
   if connection.errors.count> 0 then
      SetSess "OpenError", "Open Messages<br />" & connection.errors(0).description & " <br />" & GetSess("dbc")
   else
      SetSess "OpenError", ""
   end if
   on error goto 0
end sub

sub ProcessMYSQLServer_diag(connection)
   set connection = Server.createobject("ADODB.Connection")
   dim varServerIP, varUserName, varPassword, varDatabaseName, databasetype
   varServerIP = GetSess("diagnosticxSQLServer")
   varUserName = GetSess("diagnosticxSQLUser")
   varPassword = GetSess("diagnosticxSQLPwd")
   varDatabaseName = GetSess("diagnosticdb")
   databasetype = getsess("diagnosticxDatabaseType")
   dim mysqlconn
   on error resume next
   if ucase(databasetype) = "MYSQL351" then
      mysqlconn = "DRIVER={MYSQL ODBC 3.51 Driver};"
   elseif ucase(databasetype) = "MYSQL510" then
      mysqlconn = "DRIVER={MySQL ODBC 5.1 Driver}; "
   else
      mysqlconn = "DRIVER={MySQL}; "
   end if
   mysqlconn = mysqlconn & " Server=" & varServerIP & "; Database=" & varDatabaseName & "; UID=" & varUserName & "; PWD=" & varPassword
   Connection.open mysqlconn
   if connection.errors.count> 0 then
      SetSess "OpenError", "Open Messages<br />" & connection.errors(0).description & " <br />" & GetSess("dbc")
   else
      SetSess "OpenError", ""
   end if
   on error goto 0
end sub

sub ShopOpenDatabase_diag (connection, Database, DatabaseType)
   select case ucase(DatabaseType)
      case "ODBC"
         ProcessODBC_diag connection
      case "ACCESS2007"
         ProcessAccess2007_diag connection
      case else
         if instr(ucase(DatabaseType), "SQLSERVER") > 0 then
            ProcessSQLServer_diag connection
         elseif instr(ucase(DatabaseType), "MYSQL") > 0 then
            ProcessMYSQLServer_diag connection
         elseif DatabaseType = "" then
            ProcessAccessOpen_diag connection
         else
            ProcessAccessOpen_diag connection
         end if
   end select
end sub
%>