<%
'*********************************************************************************
' 8.00
' 01 August 2014
' Modules Manager
'***********************************************"**********************************

const defaultfilename = ""
dim sAction
dim currentURL
dim filename, phpfilename
dim ifile, ofile, ofs, ifs
dim record, outrecord, readcount
dim char, word, pos, recordlength
dim currentstate
dim equalpos
dim words(1000), wordcount
dim tables(200), fields(200), tablecount
dim curTest
dim PrevTest
dim errorCount
dim setupfileerror, filestring

'======================================
' Subroutine ConvertDatabase
'======================================
sub reloadsite
   loadlanguagevariables
   dim InitName
   InitName = "init" & "_" & xShopId
   application(InitName) = ""
   LoadApplicationVariables
end sub

sub checksetupfile (access_scriptfile, mysql_scriptfile, sqlserver_scriptfile)
   dim sqlfilename, rc
   setupfileerror = ""
   ' check what type of database is using in the vpsap.
   select case ucase(xDatabaseType)
      case "DRIVE", "ACCESS2007", "", "ODBC"
         sqlfilename = "sqlscripts\"& modules_scriptfolder & "\" & access_scriptfile &""
      case "SQLSERVER"
         sqlfilename = "sqlscripts\"& modules_scriptfolder & "\" & sqlserver_scriptfile &""
      case "MYSQL", "MYSQL510", "MYSQL351"
         sqlfilename = "sqlscripts\"& modules_scriptfolder & "\" & mysql_scriptfile &""
	  case else
         if instr(ucase(xdatabasetype), "MYSQL") > 0 then
		    sqlfilename = "sqlscripts\"& modules_scriptfolder & "\" & mysql_scriptfile &""
         end if
   end select
   OpenInputFile sqlfilename, ifs, ifile, rc
   if rc> 0 then
      setupfileerror = setupfileerror & "<br>unable to read " & sqlfilename & "<br />"
   end if
   CloseFile ifs, ifile, rc
   filestring = sqlfilename
end sub

sub ConvertFile(filestring)
   dim rc, command, commandcount, Morecommands, split_filestring, item, fi
   split_filestring = split(filestring, "|")
   fi = 0
   for each item in split_filestring
      OpenInputFile split_filestring(fi), ifs, ifile, rc
      readcount = 0
      Server.ScriptTimeout = 3600
      setsess "diagnostic", "Yes"
      Checkdatabaseopen dbc
      setsess "diagnostic", ""
      MoreCommands = true
      do while MoreCommands = true
         response.flush
         GetCommand command
         if command<>"" then
            commandcount = commandcount + 1
            ProcessCommand command
            response.flush
         else
            morecommands = false
         end if
      loop
      fi = fi + 1
   next
   CloseFile ifs, ifile, rc
end sub

sub Getcommand (text)
   dim pos, rc
   text = ""
   rc = 0
   ReadARecord Ifile, record, rc
   do while rc = 0
      readcount = readcount + 1
      text = text & record
      pos = instr(record, ";")
      if pos>0 then
         exit sub
      end if
      ReadaRecord ifile, record, rc
   loop
end sub

sub Convertname (ifile, outfile)
   dim templen, asp
   asp = right(ifile, 3)
   if ucase(asp) = "ASP" then
      templen = len(ifile) -3
      outfile = left(ifile, templen) & "php"
   else
      outfile = ifile & ".php"
      ifile = ifile & ".asp"
   end if
   Writemsg ("creating " & outfile)
end sub

sub Writemsg (msg)
   response.write msg & "<br />"
end sub

'======================================
' Subroutine FormatRow
'======================================
sub FormatRow (fieldname, fieldvalue, sRowColor)
   htmlwrite "<tr bgcolor=" & sRowColor &"><td width=""30%""><b>" _
             & trim(fieldname) & "</b></td><td><input size=50 name=" & fieldname _
             & " value=" & chr(34) & fieldvalue & chr(34) & "></td></tr>"
end sub

sub OpenOutput (filename, fso, ofile, rc)
   dim whichfile
   whichfile = server.mappath(filename)
   set fso = createobject("Scripting.FileSystemObject")
   set ofile = fso.opentextfile(whichfile, 2, true)
   if err.number> 0 then
      Serror = "Could not open output " & filename& "<br />"
      rc = 4
   else
      rc = 0
   end if
end sub

sub ProcessRecord
   AnalyzeRecord
end sub

sub WriteOutput (outrec)
   oFile.writeline outrec
end sub

sub ProcessCommand(record)
   on error resume next
   dim firstchar
   firstchar = left(record, 1)
   if firstchar = "'" then
      ProcessComment
      exit sub
   end if
   record = trim(record)
   record = replace(record, ";", "")
   parserecord record, words, wordcount, " "
   dim tempword

   '800 - 2015.04.21 - Admin: Modules Manager: Better handling reading script files
   Tempword=replace(ucase(words(0)),chr(13),"")

   select case tempword
      case "CREATE"
         CREATEProcess record
      case "ALTER"
         ALTERProcess record
      case "INSERT"
         INSERTProcess record
      case "DELETE"
         DELETEProcess record
      case "UPDATE"
         '800 - 2015.04.20 - Page/Blogs/News Manager: Better handling on messagetype field empty space
         if instr(lcase(record),"update hyphen ") > 0 then
	        UPDATEProcess_hyphen record
		 '800 - 2015.04.22 - Auto assign new links to current installing user
	     elseif instr(lcase(record),"update link currentusers") > 0 then
		    UPDATEProcess_link_currentusers record
		 else
	        UPDATEProcess record
	     end if
      case "SET"
         SETProcess record
      case "SELECT"
	     '800 - 2015.04.15 - Enahncement: Module manager: To include select process
         selectProcess record
   end select
end sub

sub CREATEProcess (record)
   dim tempword, tablename
   Tempword = ucase(words(1))
   if ucase(tempword) = "DATABASE" then exit sub
   tablename = words(2)
   curTest = "Create " & tablename
   sql = record
   Adderror SQL
   dbc.execute(SQL)
end sub

sub INSERTProcess (record)
   dim tempword, tablename
   tablename = words(1)
   if ucase(tablename) = "INTO" then
      tablename = words(2)
   end if
   tablename = lcase(tablename)
   Fixtablename tablename
   curTest = "Insert into " & tablename
   select case tablename
      case "configuration"
         ProcessInsertconfiguration record
         exit sub
      case "languages"
         ProcessInsertlanguage record
         exit sub
      case "tbluser"
         ProcessInserttbluser record
         exit sub
      case "tblaccess"
         ProcessInserttblaccess record
         exit sub
      case "mycompany"
         ProcessInsertmycompany record
         exit sub
      case "currencyvalues"
         ProcessInsertCurrency record
         exit sub

	  '800 - 2016.08.30 - Modules Manager: Support multiple sites
      case "addoninfo"
         ProcessInsertaddoninfo record
         exit sub

      case else
         processinsertothers record, tablename
         exit sub
   end select
   sql = record
   Adderror SQL
   dbc.execute(SQL)
end sub

sub ALTERProcess (record)
   on error resume next
   dim tempword, tablename
   tablename = words(2)
   curTest = "Alter " & tablename
   if trim(xconfigtable) <> "" then record = replace(record, "configuration", xconfigtable)
   sql = record
   Adderror SQL
   dbc.execute(SQL)
end sub

sub SETProcess (record)
   dim tempword, tablename
   tablename = words(2)
   curTest = "Set " & tablename
   sql = record
   Adderror SQL
   dbc.execute(SQL)
end sub

sub DELETEProcess (record)
   dim tempword, tablename
   tablename = words(2)
   curTest = "Delete from " & tablename
   sql = record
   Adderror SQL
   dbc.execute(SQL)
end sub

sub UPDATEProcess (record)
   dim tempword, tablename
   tablename = words(2)
   curTest = "Update " & tablename
   if trim(xconfigtable) <> "" then record = replace(record, "configuration", xconfigtable)
   sql = record
   Adderror SQL
   dbc.execute(SQL)
end sub

'======================================
' Subroutine addError
'======================================
sub addError (msg)
   dim completed
   if errorcount>0 then
      completed = "completed"
   end if
   if curtest<>PrevTest then
   end if
   errorcount = errorCount + 1
   PrevTest = CurTest
end sub

sub OpenInputFile (filename, fsObj, RecordObj, rc)
   on error resume next
   dim whichfile
   whichfile = server.mappath(filename)

   set fsObj = Server.createobject("Scripting.FileSystemObject")
   set RecordObj = fsObj.opentextfile(whichfile, 1, false)
   if err.number > 0 then
      rc = 4
      fsObj.close
      set fsObj = nothing
   else
      rc = 0
   end if
end sub

' close a file
sub CloseFile (fsObj, RecordObj, rc)
   set RecordObj = nothing
   set fsObj = nothing
   rc = 0
end sub

sub ReadARecord (RecordObj, record, rc)
   if RecordObj.atendofstream then
      rc = 4
      exit sub
   end if
   record = RecordObj.readline
   rc = 0
end sub

sub ProcessInsertConfiguration (record)
   dim fieldstr, valuestr, fieldnames(10), fieldvalues(10), fieldname, fieldvalue
   dim found, rs, fieldc, valuec
   parseInsert record, fieldstr, valuestr
   parserecord fieldstr, fieldnames, fieldc, ","
   parserecord valuestr, fieldvalues, valuec, ","
   fieldname = fieldnames(0)
   fieldvalue = fieldvalues(0)
   if fieldname = "id" then
      fieldname = fieldnames(1)
      fieldvalue = fieldvalues(1)
   end if
   if trim(xconfigtable) <> "" then
      sql = "select * from "& xconfigtable &" where " & fieldname & "=" & fieldvalue
   else
      sql = "select * from configuration where " & fieldname & "=" & fieldvalue
   end if

   set rs = Server.createobject("ADODB.Recordset")
   rs.open sql, dbc, adOpenStatic, adLockReadOnly
   if not rs.eof then
      found = true
   else
      found = false
   end if
   closerecordset rs
   if found = true then
      AddError "Bypassing insert for " & fieldvalue
      exit sub
   end if
   if trim(xconfigtable) <> "" then record = replace(record, "configuration", xconfigtable)
   sql = record
   Adderror SQL
   dbc.execute(SQL)
end sub

'800 - 2015.11.24 - Stock notification: Better database handling
sub ProcessInsertLanguage (record)
   dim fieldstr, valuestr, fieldnames(10), fieldvalues(10), fieldname, fieldvalue
   dim found, rs, fieldc, valuec, pos
   parseInsert record, fieldstr, valuestr
   parserecord fieldstr, fieldnames, fieldc,","
   parserecord valuestr, fieldvalues, valuec,","
   fieldname=fieldnames(0)
   fieldvalue=fieldvalues(0)
   If fieldname="id" then
      pos=2
   else
      pos=1
   end if      
   fieldname=fieldnames(pos)
   fieldvalue=fieldvalues(pos)
   dim languages(30), langsql, langrs, langcount, maxlangs
   maxlangs = 30
   langcount = 0
   langsql = "SELECT lang from languages GROUP BY lang"
   Set langrs = Server.CreateObject("ADODB.Recordset")
   langrs.open langsql, dbc, adOpenForwardOnly, adLockReadOnly
   while not langrs.eof and langcount<maxlangs
      if isnull(langrs("lang")) = false then
	     if trim(langrs("lang")) <> "" then
            languages(langcount) = langrs("lang")
            langcount = langcount + 1
   	     end if
      end if
      langrs.MoveNext
   wend
   closerecordset langrs
   dim icnt, newsql, allbypass, sql
   allbypass = true
   for icnt = 0 to (langcount - 1)
      sql="select * from languages where " & fieldname & "=" & fieldvalue & " and lang = '"& languages(icnt) &"'"
      Set rs = Server.CreateObject("ADODB.Recordset")
      rs.open sql, dbc, adOpenForwardOnly, adLockReadOnly
      if not rs.eof then
         found=true
      else 
         found=false
      end if
      closerecordset rs
	  if not found then
	     allbypass = false
	     newsql = replace(record,"'English'","'"& languages(icnt) &"'")
		 Adderror newsql
		 dbc.Execute(newsql)
      end if
   next
   if allbypass then 
      AddError "Bypassing insert for " & fieldvalue
   end if
end sub

sub ProcessInsertCurrency (record)
   dim fieldstr, valuestr, fieldnames(10), fieldvalues(10), fieldname, fieldvalue
   dim found, rs, fieldc, valuec, pos
   parseInsert record, fieldstr, valuestr
   parserecord fieldstr, fieldnames, fieldc, ","
   parserecord valuestr, fieldvalues, valuec, ","
   fieldname = fieldnames(0)
   fieldvalue = fieldvalues(0)
   if fieldname = "id" then
      fieldname = fieldnames(1)
      fieldvalue = fieldvalues(1)
   end if
   sql = "select * from currencyvalues where " & fieldname & "=" & fieldvalue
   set rs = Server.createobject("ADODB.Recordset")
   rs.open sql, dbc, adOpenStatic, adLockReadOnly
   if not rs.eof then
      found = true
   else
      found = false
   end if
   closerecordset rs
   if found = true then
      AddError "Bypassing insert for " & fieldvalue
      exit sub
   end if
   sql = record
   Adderror SQL
   dbc.execute(SQL)
end sub

sub ProcessInserttblaccess (record)
   dim fieldstr, valuestr, fieldnames(99), fieldvalues(99), fieldname, fieldvalue, fieldname2, fieldvalue2
   dim found, rs, fieldc, valuec, pos, sql
   parseInsert record, fieldstr, valuestr
   parserecord fieldstr, fieldnames, fieldc, ","
   parserecord valuestr, fieldvalues, valuec, ","
   fieldname = fieldnames(0)
   fieldvalue = fieldvalues(0)
   fieldname = fieldnames(1)
   fieldvalue = fieldvalues(1)
   fieldname2 = fieldnames(3)
   fieldvalue2 = fieldvalues(3)
   sql = "select * from tblaccess where fldname = "& fieldvalues(0) &" and fldurl = "& fieldvalues(1) &" "
   set rs = Server.createobject("ADODB.Recordset")
   rs.open sql, dbc, 0, 1
   if not rs.eof then
      found = true
   else
      found = false
   end if
   rs.close
   set rs = nothing
   if found = true then
      AddError "Bypassing insert for " & fieldvalue & " and " & fieldvalue2
      exit sub
   end if
   sql = record
   Adderror SQL
   dbc.execute(SQL)
end sub

sub ProcessInserttbluser (record)
   ' Don't insert new users
   dim fieldstr, valuestr, fieldnames(10), fieldvalues(10), fieldname, fieldvalue
   dim found, rs, fieldc, valuec, pos, rc
   parseInsert record, fieldstr, valuestr
   parserecord fieldstr, fieldnames, fieldc, ","
   parserecord valuestr, fieldvalues, valuec, ","
   fieldname = fieldnames(0)
   fieldvalue = fieldvalues(0)
   Verifytbluser rc
   if rc = 4 then
      AddError "Bypassing insert for " & fieldvalue
      exit sub
   end if
   sql = "select * from tbluser where " & fieldname & "=" & fieldvalue
   set rs = Server.createobject("ADODB.Recordset")
   rs.open sql, dbc, adOpenStatic, adLockReadOnly
   if not rs.eof then
      found = true
   else
      found = false
   end if
   closerecordset rs
   if found = true then
      AddError "Bypassing insert for " & fieldvalue
      exit sub
   end if
   sql = record
   Adderror SQL
   dbc.execute(SQL)
end sub

sub ProcessInsertmycompany (record)
   ' Don't insert new users
   dim fieldstr, valuestr, fieldnames(10), fieldvalues(10), fieldname, fieldvalue
   dim found, rs, fieldc, valuec, pos
   parseInsert record, fieldstr, valuestr
   parserecord fieldstr, fieldnames, fieldc, ","
   parserecord valuestr, fieldvalues, valuec, ","
   fieldname = fieldnames(0)
   fieldvalue = fieldvalues(0)
   sql = "select * from mycompany where " & fieldname & "=" & fieldvalue
   set rs = Server.createobject("ADODB.Recordset")
   rs.open sql, dbc, adOpenStatic, adLockReadOnly
   if not rs.eof then
      found = true
   else
      found = false
   end if
   closerecordset rs
   if found = true then
      AddError "Bypassing insert for " & fieldvalue
      exit sub
   end if
   sql = record
   Adderror SQL
   dbc.execute(SQL)
end sub

sub updatauserright (passtring)
   dim ors, osql, fldautostring
   fldautostring = ""
   set ors = Server.createobject("ADODB.Recordset")
   osql = "select fldauto from tblaccess  where fldname = '"& passtring &"'"
   ors.open osql, dbc, adOpenForwardOnly, adLockReadOnly
   if not ors.eof then
      do while not ors.eof
         if trim(fldautostring) = "" then
            fldautostring = ors("fldauto")
         else
            fldautostring = fldautostring&","&ors("fldauto")
         end if
         ors.movenext
      loop
   end if
   closerecordset ors
   if trim(fldautostring) = "" then exit sub

   'get all Super user from fldaccess
   dim updatesql
   set ors = Server.createobject("ADODB.Recordset")
   osql = "select fldauto,fldaccess,tablesallowed from tbluser where fldusername ='"& EnDeCrypt2(getsess("shopadmin"), xencryptkey, "E")&"'"
   ors.open osql, dbc, adOpenForwardOnly, adLockReadOnly
   if not ors.eof then
      updatesql = " update tbluser set fldaccess ='"&ors("fldaccess")&","&fldautostring&"' "
      dbc.execute(updatesql)
   end if
   ors.close
   set ors = nothing
end sub

sub ParseInsert (record, fieldstr, valuestr)
   dim pos, reststr, remaining, remainlen, posend, length
   pos = instr(record, "(")
   posend = instr(record, ")")
   length = posend - pos -1
   pos = pos + 1
   fieldstr = mid(record, pos, length)
   pos = posend + 1
   remainlen = len(record) - length
   remaining = mid(record, pos, remainlen)
   pos = instr(remaining, "(")
   posend = instr(remaining, ")")
   length = posend - pos -1
   pos = pos + 1
   valuestr = mid(remaining, pos, length)
end sub

sub Fixtablename (tablename)
   dim pos, temp
   pos = instr(tablename, "(")
   if pos = 0 then exit sub
   temp = left(tablename, pos -1)
   tablename = temp
end sub

sub Verifytbluser (rc)
   dim sql, rs, userid
   rc = 0
   sql = "select * from tbluser"
   set rs = Server.createobject("ADODB.Recordset")
   rs.open sql, dbc, adOpenStatic, adLockReadOnly
   do while not rs.eof
      userid = EnDeCrypt2(rs("fldusername"), xencryptkey, "D")
      userid = lcase(userid)
      if userid = "admin" or userid = "vpasp" then
      else
         rc = 4
         exit do
      end if
      rs.movenext
   loop
   closerecordset rs
end sub

sub processinsertothers (record, tablename)
   '800 - 2015.04.15 - Enahncement: Module manager: To include insert table process
   on error resume next

   dim fieldstr, valuestr, fieldnames(99), fieldvalues(99), fieldname, fieldvalue
   dim found, rs, fieldc, valuec, pos, sql
   parseInsert record, fieldstr, valuestr
   parserecord fieldstr, fieldnames, fieldc, ","
   parserecord valuestr, fieldvalues, valuec, ","
   fieldname = fieldnames(0)
   fieldvalue = fieldvalues(0)
   sql = "select * from "& tablename &" where "& fieldnames(0) &" = "& fieldvalues(0) &" "
   set rs = Server.createobject("ADODB.Recordset")
   rs.open sql, dbc, 0, 1
   if not rs.eof then
      found = true
   else
      found = false
   end if
   rs.close
   set rs = nothing

   '800 - 2015.04.15 - Enahncement: Module manager: To include insert table process
   if instr(lcase(record)," select * from ") > 0 then
      found = false
   end if

   if found = true then
      AddError "Bypassing insert for " & fieldvalue & " and " & fieldvalue2
      exit sub
   end if
   sql = record
   Adderror SQL
   dbc.execute(SQL)

   '800 - 2015.04.15 - Enahncement: Module manager: To include insert table process
   on error goto 0
end sub

'800 - 2015.04.15 - Enahncement: Module manager: To include select process
sub selectProcess (record)
   dim tempword, tablename
   tablename = words(2)
   curTest = "Select "
   sql = record
   Adderror SQL
   dbc.execute(SQL)
end sub

'800 - 2015.04.20 - Page/Blogs/News Manager: Better handling on messagetype field empty space
sub UPDATEProcess_hyphen (record)
   dim tablename, sql, rs, fieldname, fieldvalue
   tablename = words(2)
   fieldname = words(3)
   curTest = "Update "
   sql="select * from "& tablename &" where "& fieldname &" LIKE '% %' "
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   do while not rs.eof
      fieldvalue = rs("messagetype")
	  fieldvalue = replace(fieldvalue," ","-")
	  rs("messagetype") = fieldvalue
	  rs.update
      rs.movenext
   loop
   closerecordset rs
   Adderror record
end sub

'800 - 2015.04.22 - Auto assign new links to current installing user
sub UPDATEProcess_link_currentusers (record)
   dim listid,originallist,sql,sqlrs,checkfiledvalue,updateflag
   updateflag = false
   checkfiledvalue = words(3)
   originallist = "," & getsess("adminmenus") & ","
   sql="select fldauto from tblaccess where fldurl = '"& tosql(checkfiledvalue,"Text") &"' order by fldauto"
   set sqlrs = Server.createobject("ADODB.Recordset")
   sqlrs.open sql, dbc, adOpenStatic, adLockReadOnly
   do while not sqlrs.eof
      listid= "," & sqlrs("fldauto") & ","
	  if instr(originallist,listid) > 0 then
	     'do nothing
      else
	     updateflag = true
	     originallist = originallist & listid
	  end if
      sqlrs.movenext
   loop
   closerecordset sqlrs
   if updateflag then
      originallist = mid(originallist,2,len(originallist)-2)
	  originallist = replace(originallist,",,",",")
      SetSess "adminmenus", originallist
      sql="Update tbluser set fldaccess='" & originallist & "' where fldusername='"& EnDeCrypt2(getsess("shopadmin"),xencryptkey,"E") &"' "
      dbc.execute(sql)
   end if
end sub

'800 - 2016.08.30 - Modules Manager: Support multiple sites
sub ProcessInsertaddoninfo (record)
   dim fieldstr, valuestr, fieldnames(99), fieldvalues(99), fieldname, fieldvalue
   dim found, rs, fieldc, valuec, pos, sql
   parseInsert record, fieldstr, valuestr
   parserecord fieldstr, fieldnames, fieldc, ","
   parserecord valuestr, fieldvalues, valuec, ","
   fieldname = fieldnames(0)
   fieldvalue = fieldvalues(0)
   dim foundfield
   foundfield = FieldExists_ModuleManager("addoninfo", "addonxshopid")
   sql = "select * from addoninfo where "& fieldnames(0) &" = "& fieldvalues(0) &" "

   '800 - 2016.12.21 - Modules Manager: Better logic handling
   if lcase(getconfig("xproductmatch")) = "yes" then
      if foundfield then
         sql = sql & " and (addonxshopid is null or addonxshopid = '' or addonxshopid = '"& tosql(xShopId,"Text") &"') "
      end if
   end if

   set rs = Server.createobject("ADODB.Recordset")
   rs.open sql, dbc, 0, 1
   if not rs.eof then
      found = true
   else
      found = false
   end if
   closerecordset rs
   if found = true then
      '800 - 2016.12.21 - Modules Manager: Better logic handling
      if lcase(getconfig("xproductmatch")) = "yes" then
         if foundfield then
            sql = "update addoninfo set addonxshopid = '"& tosql(xShopId,"Text") &"' where "& fieldnames(0) &" = "& fieldvalues(0) &" and (addonxshopid is null or addonxshopid = '')"
	        dbc.execute sql
         end if
	  end if
      AddError "Bypassing insert for " & fieldnames & ""
      exit sub
   end if
   sql = record
   Adderror sql
   dbc.execute sql

   '800 - 2016.12.21 - Modules Manager: Better logic handling
   if lcase(getconfig("xproductmatch")) = "yes" then
      if foundfield then
         sql = "update addoninfo set addonxshopid = '"& tosql(xShopId,"Text") &"' where "& fieldnames(0) &" = "& fieldvalues(0) &" and (addonxshopid is null or addonxshopid = '')"
	     dbc.execute sql
      end if
   end if
end sub

'800 - 2016.08.30 - Modules Manager: Support multiple sites
function FieldExists_ModuleManager (tableName, fieldName)
   dim rs
   dim sql
   dim tempflag
   sql = "select "& fieldName &" from " & tableName   
   tempflag = false
   set rs = Server.createobject("ADODB.Recordset")
   rs.open sql, dbc, adOpenStatic, adLockReadOnly
   on error resume next
   if err.number = 0 then
      tempflag = true
   end if
   closerecordset rs
   on error goto 0
   FieldExists_ModuleManager = tempflag
end function
%>