<!-- #include file="shophash.asp" -->
<%
'700 - 2010.09.08 - Enhancment: Cover Old IIS issue
Assigncodepagevalue 65001

processcnt = 8
dim alinetext(),stepcnt,errordesc,connection
redim alinetext(processcnt)

dim asteps(),astatus(),amain()
redim asteps(processcnt),astatus(processcnt),amain(processcnt)

dim mainsectionarray(),subsectionarray(),processstatusarray(),processcnt

redim mainsectionarray(processcnt)
redim subsectionarray(processcnt)
redim processstatusarray(processcnt)

sub writesetupfile (filename)
   if trim(filename) = "" then exit sub
   
   dim sMapPath
   sMapPath = Server.MapPath(filename)

   dim fso,fname,fs_overwrite,icnt
   on error resume next
   fs_overwrite = true
   set fso=Server.CreateObject("Scripting.FileSystemObject")
   set fname=fso.CreateTextFile(""& sMapPath &"",fs_overwrite)
   for icnt = 0 to processcnt - 1
      fname.WriteLine(""& amain(icnt) &"," & ""& asteps(icnt) &"," & astatus(icnt))
   next
  fname.close
  set fname=nothing
  set fso=nothing
end sub

function getprocessurl (firstpending)
   dim tempstring
   tempstring = ""
   select case trim(ucase(firstpending))
      case "CHECK FOLDER PERMISSIONS"
	     tempstring = "setupfilefolderpermission.asp"
	  'case "VERIFY PACKAGE"
	  '   tempstring = "setupverifypackage.asp"
	  case "CONNECT TO DATABASE"
	     tempstring = "setupdbconnection.asp"
	  case "SETUP DATABASE STRUCTURE"
	     tempstring = "setupdbstructure.asp"
	  case "CREATE ADMIN PASSWORD"
	     tempstring = "setupsetpassword.asp"
	  case "RENAME ADMIN PAGE"
	     tempstring = "setuprenameadmin.asp"
	  case "CREATE ENCRYPTION KEY"
	     tempstring = "setupencrykey.asp"
	  case "REGISTER YOUR PRODUCT"
	     tempstring = "setupregister.asp"
	  case "SET/VERIFY FILE PERMISSION"
	     tempstring = "setupverifyfinalpermission.asp"
	  case "CART DETAILS"
	     tempstring = "setupcart.asp"
   end select
   getprocessurl = tempstring
end function

sub readsetupfile (filename,firstpending)
   if len(trim(filename)) = 0 then exit sub

   dim realpath
   dim objFSO, objstream
   
   on error resume next
   set objFSO=server.createobject("scripting.filesystemObject")
   realpath=Server.MapPath(filename)
   set objstream=objFSO.opentextfile(realpath)
   
   if err.number <> 0 then
      errordesc = err.description
	  exit sub
   end if
   stepcnt = 0
   firstpending = ""
   do while not objstream.atendofStream
	  alinetext(stepcnt) = objstream.readline
	  stepcnt = stepcnt + 1
   loop
   objstream.close
   set objstream = nothing
   set objFSO = nothing
   
   dim jcnt,atemp(),tempcount,firstflag
   redim atemp(10)
   firstflag = false
   for jcnt = 0 to stepcnt - 1
      setupParseRecord alinetext(jcnt),atemp,tempcount,","
	  amain(jcnt) = atemp(0)
	  asteps(jcnt) = atemp(1)
	  astatus(jcnt) = atemp(2)
	  if firstflag = false then
	     if lcase(astatus(jcnt)) = "pending" then
	        firstpending = asteps(jcnt)
			firstflag = true
	     end if
      end if
   next
end sub

sub setupParseRecord (record,words,wordcount,delimiter)
   dim pos
   dim recordl
   dim bytex
   dim temprec
   dim maxwords
   dim i
   maxwords = 10
   temprec = record
   dim maxentries
   pos = 1
   wordcount = 0
   'make sure word array is null
   maxentries = UBound(words)
   for i = 0 To maxentries - 1
      words(i) = ""
   next
   recordl = Len(temprec)
   'first eliminate leading blanks
   do
      bytex = Mid(temprec, pos, 1)
      while bytex = " " and pos <= recordl
         pos = pos + 1
         bytex = Mid(temprec, pos, 1)
      wend

      'copy word into word array
      while bytex <> delimiter And pos <= recordl
         words(wordcount) = words(wordcount) & bytex
         pos = pos + 1
         bytex = Mid(temprec, pos, 1)
      wend

      wordcount = wordcount + 1
      pos = pos + 1
      if wordcount > maxentries then exit sub
   loop until pos > recordl
end sub

sub setupDebugWrite (msg)
   response.write msg & "<br />"
end sub

sub genwarningtable (pmessage,errordesc)
   dim tempstr
   tempstr = ""
   tempstr = tempstr & "<table width=""100%"" border=""0"" cellspacing=""1"" cellpadding=""0"" class=""warning_table"">"
   tempstr = tempstr & "<tr>"
   tempstr = tempstr & "<th>Warning</th>"
   tempstr = tempstr & "</tr>"
   tempstr = tempstr & "<tr>"
   tempstr = tempstr & "<td>"
   tempstr = tempstr & pmessage
   tempstr = tempstr & "</td>"
   tempstr = tempstr & "</tr>"
   tempstr = tempstr & "</table>"
   tempstr = tempstr & "<br />"
   tempstr = tempstr & errordesc
   errordesc = tempstr
end sub

sub genpasstable (pmessage,errordesc)
   dim tempstr
   tempstr = ""
   tempstr = tempstr & "<table width=""100%"" border=""0"" cellspacing=""1"" cellpadding=""0"" class=""pass_table"">"
   tempstr = tempstr & "<tr>"
   tempstr = tempstr & "<th>Pass</th>"
   tempstr = tempstr & "</tr>"
   tempstr = tempstr & "<tr>"
   tempstr = tempstr & "<td>"
   tempstr = tempstr & pmessage
   tempstr = tempstr & "</td>"
   tempstr = tempstr & "</tr>"
   tempstr = tempstr & "</table>"
   tempstr = tempstr & "<br />"
   tempstr = tempstr & errordesc
   errordesc = tempstr
end sub

function CleanChars(strWords) 
   if strwords = "" then exit function
   if isnull(strwords) then exit function

   strWords = replace(strWords, "''", "'")
   do while instr(strWords,"  ") > 0
      strWords = replace(strWords, "  ", " ")
   loop

   dim badChars,i
   dim newChars, decodeChars
   dim sensitiveChars
 
   badChars = array("select ", "drop ", "--", "insert into", "delete from","xp_","char(","@@","|","<script",".js","onload","alert(","xss","onmouseover","document.cookie","convert(","<iframe","cast(","nvarchar","varchar","chr(","exec(","%00") 

   sensitiveChars = array("union ","update ","declare ") 
 
   newChars = strWords
   dim newReplace,bpos,bpos2

   ' check bad chars and assign to null
   for i = 0 to uBound(badChars)
      if instr(1,lcase(newchars),lcase(badchars(i)),1)>0 then
	     bpos = instr(1,lcase(newchars),lcase(badchars(i)),1)
	     newReplace=""
		 bpos2 = bpos + len(newReplace)
		 newchars = mid(newchars,1,bpos-1) & newReplace & mid(newchars,len(badchars(i))+bpos,len(newchars) + bpos2 + 999)
      end if
   next

   ' check sensitive chars and assign spaces to %nbsp;
   for i = 0 to uBound(sensitiveChars)
      if instr(1,lcase(newchars),lcase(sensitiveChars(i)),1)>0 then
	     bpos = instr(1,lcase(newchars),lcase(sensitiveChars(i)),1)
	     newReplace=replace(lcase(sensitiveChars(i))," ","&nbsp;")
		 bpos2 = bpos + len(newReplace)
		 newchars = mid(newchars,1,bpos-1) & newReplace & mid(newchars,len(sensitiveChars(i))+bpos,len(newchars) + bpos2 + 999)
      end if
   next

   newchars=replace(newchars,"'","''")
   newchars=replace(newchars,"""","&quot;")
   newchars=Replace(newchars,"%22","")  'remove any encoded double quotes

   CleanChars = newChars
end function

sub writeconfigfile (filename)
   if trim(filename) = "" then exit sub
   
   if trim(session("setupxsavesession")) = "" then session("setupxsavesession") = "No"

   dim sMapPath
   sMapPath = Server.MapPath(filename)

   dim fso,fname,fs_overwrite,icnt
   on error resume next
   fs_overwrite = true
   set fso=Server.CreateObject("Scripting.FileSystemObject")
   set fname=fso.CreateTextFile(""& sMapPath &"",fs_overwrite)
   
   fname.WriteLine "<%"
   fname.WriteLine "'PLEASE NOTE: THERE ARE 2 INSTANCES OF SHOP$CONFIG.ASP. ONE IN /CONFIG/ AND ONE IN THE /ADMIN/CONFIG/ FOLDER."
   fname.WriteLine "'YOUR ADMIN FOLDER MAY HAVE BEEN RENAMED."
   fname.WriteLine "'ANY CHANGES YOU MAKE TO ONE FILE MUST BE REPLICATED IN THE OTHER OR MANY FUNCTIONS WILL NOT WORK PROPERLY."
   fname.WriteLine "const xDatabase="""& session("setupxDatabase") &""" 'Database name"
   fname.WriteLine "const xDbLocation="""& session("setupxDbLocation") &""" 'location of Database relative to VP-ASP files"
   fname.WriteLine "const xDatabaseType="""& session("setupxDatabaseType") &""""
   fname.WriteLine "const xSQLUser="""& session("setupxSQLUser") &""" ' SQL Server user"
   fname.WriteLine "const xSQLPwd="""& session("setupxSQLPwd") &""" ' SQL Server password"
   fname.WriteLine "const xSQLServer="""& session("setupxSQLServer") &""" ' SQL Server name or IP address"
   fname.WriteLine "const xSQL05Above="""& session("setupxSQL05Above") &""" 'paging navigation - if mssql 2005 and above, please specify ""Yes"", else, please set it to ""No"""
   fname.WriteLine "const SecondPassword="""& session("setupSecondPassword") &""" 'admin page second password."
   fname.WriteLine "const xencryptkey="""& session("setupxencryptkey") &""" 'enter an encryption key here for greater security"

   fname.WriteLine "const xShopId="""& session("setupxShopId") &""" 'Must be changed - needs to be a unique name for your shop - eg. ""shop800_myshopname"""
   fname.WriteLine "const xordernumber="""& session("setupxordernumber") &""""
   
   'fname.WriteLine "const xCheckout=""shopcheckout.asp"" 'Specify a particular electronic payment add-on here."
   'fname.WriteLine "                                   'The default is to use standard VP-ASP shopcheckout.asp"
   'fname.WriteLine "                                   'If you have a VP-ASP electronic payment add-on for example, Eway, then enter ewayshopcheckout.asp"

   fname.WriteLine "const xssl="""& session("setupxssl") &""" 'This is your secure URL to which credit card information is encrypted."
   fname.WriteLine "              'In many cases it is simply your own URL with an 's' added to HTTP."
   fname.WriteLine "              'If you are unsure, check with your ISP."
   
   fname.WriteLine "const xmysite="""& session("setupxmysite") &""" 'This represents the URL of your site where the shopping cart files are located (eg. http://www.yourvpcartwebsiteurl.com/vpcart)"
   fname.WriteLine "const xconfigtable=""configuration"""
   fname.WriteLine "const xproductmatch="""" 'display products matching these"
   fname.WriteLine "const xsavesession="""& session("setupxsavesession") &""" 'Yes to replace session with Database sessions."

   fname.WriteLine replace("% >"," ", "")
     
   fname.close
   set fname=nothing
   set fso=nothing
end sub

sub readconfigfile (filename)
   if len(trim(filename)) = 0 then exit sub

   dim realpath
   dim objFSO, objstream
   
   on error resume next
   set objFSO=server.createobject("scripting.filesystemObject")
   realpath=Server.MapPath(filename)
   set objstream=objFSO.opentextfile(realpath)
   
   if err.number <> 0 then
      errordesc = err.description
	  exit sub
   end if

   dim tempstring,tempdesc
   tempstring = ""
   tempdesc = ""
   do while not objstream.atendofStream
      tempstring = cstr(objstream.readline)
	  tempstring = replace(tempstring,"	"," ")
	  do while instr(tempstring,"  ") > 0
	     tempstring = replace(tempstring,"  "," ")
	  loop
	  tempstring = replace(tempstring,"= ","=")
	  tempstring = replace(tempstring," =","=")
      if instr(lcase(tempstring),"const xdatabase=") > 0 and mid(tempstring,1,1) <> "'" then
	     tempstring = mid(tempstring,len("const xdatabase=")+1,len(tempstring) - len("const xdatabase="))
	     'tempstring = replace(lcase(tempstring),"const xdatabase=","")
		 if instr(tempstring,"'") > 0 then
		    tempdesc = mid(tempstring,instr(tempstring,"'"),(len(tempstring)-instr(tempstring,"'")+1))
	     end if
		 tempstring = replace(tempstring,tempdesc,"")
		 tempstring = replace(tempstring,"""","")
		 tempstring = trim(tempstring)
		 session("setupxDatabase") = tempstring
		 'setupdebugwrite tempstring
	  end if

      if instr(lcase(tempstring),"const xdblocation=") > 0 and mid(tempstring,1,1) <> "'" then
	     tempstring = mid(tempstring,len("const xdblocation=")+1,len(tempstring) - len("const xdblocation="))
	     'tempstring = replace(lcase(tempstring),"const xdblocation=","")
		 if instr(tempstring,"'") > 0 then
		    tempdesc = mid(tempstring,instr(tempstring,"'"),(len(tempstring)-instr(tempstring,"'")+1))
	     end if
		 tempstring = replace(tempstring,tempdesc,"")
		 tempstring = replace(tempstring,"""","")
		 tempstring = trim(tempstring)
		 session("setupxDbLocation") = tempstring
		 'setupdebugwrite tempstring
	  end if

      if instr(lcase(tempstring),"const xdatabasetype=") > 0 and mid(tempstring,1,1) <> "'" then
	     tempstring = mid(tempstring,len("const xdatabasetype=")+1,len(tempstring) - len("const xdatabasetype="))
	     'tempstring = replace(lcase(tempstring),"const xdatabasetype=","")
		 if instr(tempstring,"'") > 0 then
		    tempdesc = mid(tempstring,instr(tempstring,"'"),(len(tempstring)-instr(tempstring,"'")+1))
	     end if
		 tempstring = replace(tempstring,tempdesc,"")
		 tempstring = replace(tempstring,"""","")
		 tempstring = trim(tempstring)
		 session("setupxDatabaseType") = tempstring
		 'setupdebugwrite tempstring
	  end if

      if instr(lcase(tempstring),"const xsqluser=") > 0 and mid(tempstring,1,1) <> "'" then
	     tempstring = mid(tempstring,len("const xsqluser=")+1,len(tempstring) - len("const xsqluser="))
	     'tempstring = replace(lcase(tempstring),"const xsqluser=","")
		 if instr(tempstring,"'") > 0 then
		    tempdesc = mid(tempstring,instr(tempstring,"'"),(len(tempstring)-instr(tempstring,"'")+1))
	     end if
		 tempstring = replace(tempstring,tempdesc,"")
		 tempstring = replace(tempstring,"""","")
		 tempstring = trim(tempstring)
		 session("setupxSQLUser") = tempstring
		 'setupdebugwrite tempstring
	  end if

      if instr(lcase(tempstring),"const xsqlpwd=") > 0 and mid(tempstring,1,1) <> "'" then
		 tempstring = mid(tempstring,len("const xsqlpwd=")+1,len(tempstring) - len("const xsqlpwd="))
	     'tempstring = replace(lcase(tempstring),"const xsqlpwd=","")
		 if instr(tempstring,"'") > 0 then
		    tempdesc = mid(tempstring,instr(tempstring,"'"),(len(tempstring)-instr(tempstring,"'")+1))
	     end if
		 tempstring = replace(tempstring,tempdesc,"")
		 tempstring = replace(tempstring,"""","")
		 tempstring = trim(tempstring)
		 session("setupxSQLPwd") = tempstring
		 'setupdebugwrite tempstring
	  end if

      if instr(lcase(tempstring),"const xsqlserver=") > 0 and mid(tempstring,1,1) <> "'" then
	     tempstring = mid(tempstring,len("const xsqlserver=")+1,len(tempstring) - len("const xsqlserver="))
	     'tempstring = replace(lcase(tempstring),"const xsqlserver=","")
		 if instr(tempstring,"'") > 0 then
		    tempdesc = mid(tempstring,instr(tempstring,"'"),(len(tempstring)-instr(tempstring,"'")+1))
	     end if
		 tempstring = replace(tempstring,tempdesc,"")
		 tempstring = replace(tempstring,"""","")
		 tempstring = trim(tempstring)
		 session("setupxSQLServer") = tempstring
		 'setupdebugwrite tempstring
	  end if

      if instr(lcase(tempstring),"const sql05above=") > 0 and mid(tempstring,1,1) <> "'" then
	     tempstring = mid(tempstring,len("const sql05above=")+1,len(tempstring) - len("const sql05above="))
	     'tempstring = replace(lcase(tempstring),"const sql05above=","")
		 if instr(tempstring,"'") > 0 then
		    tempdesc = mid(tempstring,instr(tempstring,"'"),(len(tempstring)-instr(tempstring,"'")+1))
	     end if
		 tempstring = replace(tempstring,tempdesc,"")
		 tempstring = replace(tempstring,"""","")
		 tempstring = trim(tempstring)
		 session("setupxSQL05Above") = tempstring
		 'setupdebugwrite tempstring
	  end if

      if instr(lcase(tempstring),"const secondpassword=") > 0 and mid(tempstring,1,1) <> "'" then
	     tempstring = mid(tempstring,len("const secondpassword=")+1,len(tempstring) - len("const secondpassword="))
	     'tempstring = replace(lcase(tempstring),"const secondpassword=","")
		 if instr(tempstring,"'") > 0 then
		    tempdesc = mid(tempstring,instr(tempstring,"'"),(len(tempstring)-instr(tempstring,"'")+1))
	     end if
		 tempstring = replace(tempstring,tempdesc,"")
		 tempstring = replace(tempstring,"""","")
		 tempstring = trim(tempstring)
		 session("setupSecondPassword") = tempstring
		 'setupdebugwrite tempstring
	  end if
	  
      if instr(lcase(tempstring),"const xencryptkey=") > 0 and mid(tempstring,1,1) <> "'" then
	     tempstring = mid(tempstring,len("const xencryptkey=")+1,len(tempstring) - len("const xencryptkey="))
	     'tempstring = replace(lcase(tempstring),"const xencryptkey=","")
		 if instr(tempstring,"'") > 0 then
		    tempdesc = mid(tempstring,instr(tempstring,"'"),(len(tempstring)-instr(tempstring,"'")+1))
	     end if
		 tempstring = replace(tempstring,tempdesc,"")
		 tempstring = replace(tempstring,"""","")
		 tempstring = trim(tempstring)
		 session("setupxencryptkey") = tempstring
		 'setupdebugwrite tempstring
	  end if

      if instr(lcase(tempstring),"const xshopid=") > 0 and mid(tempstring,1,1) <> "'" then
	     tempstring = mid(tempstring,len("const xshopid=")+1,len(tempstring) - len("const xshopid="))
	     'tempstring = replace(lcase(tempstring),"const xshopid=","")
		 if instr(tempstring,"'") > 0 then
		    tempdesc = mid(tempstring,instr(tempstring,"'"),(len(tempstring)-instr(tempstring,"'")+1))
	     end if
		 tempstring = replace(tempstring,tempdesc,"")
		 tempstring = replace(tempstring,"""","")
		 tempstring = trim(tempstring)
		 session("setupxShopId") = tempstring
		 'setupdebugwrite tempstring
	  end if

      if instr(lcase(tempstring),"const xordernumber=") > 0 and mid(tempstring,1,1) <> "'" then
 	     tempstring = mid(tempstring,len("const xordernumber=")+1,len(tempstring) - len("const xordernumber="))
	     'tempstring = replace(lcase(tempstring),"const xordernumber=","")
		 if instr(tempstring,"'") > 0 then
		    tempdesc = mid(tempstring,instr(tempstring,"'"),(len(tempstring)-instr(tempstring,"'")+1))
	     end if
		 tempstring = replace(tempstring,tempdesc,"")
		 tempstring = replace(tempstring,"""","")
		 tempstring = trim(tempstring)
		 session("setupxordernumber") = tempstring
		 'setupdebugwrite tempstring
	  end if

      if instr(lcase(tempstring),"const xssl=") > 0 and mid(tempstring,1,1) <> "'" then
	     tempstring = mid(tempstring,len("const xssl=")+1,len(tempstring) - len("const xssl="))
	     'tempstring = replace(lcase(tempstring),"const xssl=","")
		 if instr(tempstring,"'") > 0 then
		    tempdesc = mid(tempstring,instr(tempstring,"'"),(len(tempstring)-instr(tempstring,"'")+1))
	     end if
		 tempstring = replace(tempstring,tempdesc,"")
		 tempstring = replace(tempstring,"""","")
		 tempstring = trim(tempstring)
		 session("setupxssl") = tempstring
		 'setupdebugwrite tempstring
	  end if

      if instr(lcase(tempstring),"const xmysite=") > 0 and mid(tempstring,1,1) <> "'" then
	     tempstring = mid(tempstring,len("const xmysite=")+1,len(tempstring) - len("const xmysite="))
	     'tempstring = replace(lcase(tempstring),"const xmysite=","")
		 if instr(tempstring,"'") > 0 then
		    tempdesc = mid(tempstring,instr(tempstring,"'"),(len(tempstring)-instr(tempstring,"'")+1))
	     end if
		 tempstring = replace(tempstring,tempdesc,"")
		 tempstring = replace(tempstring,"""","")
		 tempstring = trim(tempstring)
		 session("setupxmysite") = tempstring
		 'setupdebugwrite tempstring
	  end if

      if instr(lcase(tempstring),"const xsavesession=") > 0 and mid(tempstring,1,1) <> "'" then
	     tempstring = mid(tempstring,len("const xsavesession=")+1,len(tempstring) - len("const xsavesession="))
	     'tempstring = replace(lcase(tempstring),"const xsavesession=","")
		 if instr(tempstring,"'") > 0 then
		    tempdesc = mid(tempstring,instr(tempstring,"'"),(len(tempstring)-instr(tempstring,"'")+1))
	     end if
		 tempstring = replace(tempstring,tempdesc,"")
		 tempstring = replace(tempstring,"""","")
		 tempstring = trim(tempstring)
		 session("setupxsavesession") = tempstring
		 'setupdebugwrite tempstring
	  end if

   loop
   objstream.close
   set objstream = nothing
   set objFSO = nothing
end sub

sub OpenInputFile (filename, fsObj, RecordObj, rc)
   on error resume next
   dim whichfile
   whichfile=server.mappath(filename)
   set fsObj = Server.CreateObject("Scripting.FileSystemObject")
   set RecordObj= fsObj.OpenTextFile(whichfile, 1, False)
   if err.number <> 0 then
      rc=4
      fsObj.close
      set fsObj=nothing
   else
      rc=0
   end if
end sub

Sub CloseFile (fsObj, RecordObj, rc)
   set RecordObj = nothing
   set fsObj = nothing
   rc=0
end sub

function ToSQL(Value, sType)
   dim Param
   Param = Value
   if Param = "" then
      ToSQL = ""
   else
      if sType = "Number" then
         ToSQL = CDbl(Param)
      else
         ToSQL = Replace(Param, "'", "''")
      end if
   end if
end function

sub shopopendatabase (xDatabaseType,xDatabase,xDbLocation,xSQLUser,xSQLPwd,xSQLServer,rc)
   dim strconn
   dim varServerIP, varUserName, varPassword, varDatabaseName
   on error resume next
   select case lcase(xDatabaseType)
      case "drive"
         strconn = "provider=microsoft.jet.oledb.4.0;persist security info=false;data source=" & ""& xDbLocation &"\"& xDatabase &".mdb"
         set connection = Server.CreateObject("ADODB.Connection")
         if xsqlpwd="" then
            connection.open strConn
         else
            connection.open strConn,xsqluser,xsqlpwd
         end if
      case "mysql351","mysql510"
         set connection = Server.CreateObject("ADODB.Connection")
         varServerIP = xSQLServer
         varUserName = xSQLUser
         varPassword = xSQLPwd
         varDatabaseName = xDatabase
         if ucase(xDatabaseType)="MYSQL351" then
            strconn="DRIVER={MYSQL ODBC 3.51 Driver};"
         elseif ucase(xDatabaseType)="MYSQL510" then
            strconn="DRIVER={MySQL ODBC 5.1 Driver}; "
         else
            strconn="DRIVER={MySQL}; "
         end if
         strconn=strconn & " Server=" & varServerIP & "; Database=" & varDatabaseName & "; UID=" & varUserName & "; PWD=" & varPassword
         Connection.Open strconn
      case "sqlserver"
         set connection = Server.CreateObject("ADODB.Connection")
         varServerIP = xSQLServer
         varUserName = xSQLUser
         varPassword = xSQLPwd
         varDatabaseName = xDatabase
   
         strconn= "DRIVER={SQL Server}; Server=" & varServerIP & "; Database=" & varDatabaseName & "; UID=" & varUserName & "; PWD=" & varPassword'
         Connection.Open strconn
      case "odbc"
         strconn = xDatabase
         set connection = Server.CreateObject("ADODB.Connection")
         connection.open strConn
   end select
   
   if err.number<> 0 then
      rc = 4
	  'setupdebugwrite strconn & "AA"
	  'setupdebugwrite err.description & "BB"
   else
      rc = 0
   end if
end sub

sub shopclosedatabase
   connection.close
   set connection = nothing
end sub

sub getadmininfo (adminusername,adminuserpassword)
   readconfigfile "config.asp"
   dim xDatabase,xDbLocation,xDatabaseType,xSQLUser,xSQLPwd,xSQLServer,rc
   xDatabase = session("setupxDatabase")
   xDbLocation = session("setupxDbLocation")
   xDatabaseType = session("setupxDatabaseType")
   xSQLUser = session("setupxSQLUser")
   xSQLPwd = session("setupxSQLPwd")
   xSQLServer = session("setupxSQLServer")   
   shopopendatabase xDatabaseType,xDatabase,xDbLocation,xSQLUser,xSQLPwd,xSQLServer,rc
   
   if rc = 0 then
	  dim sql,rstemp
	  sql = "select fldusername,fldpassword from tbluser where fldauto = 1"
	  set rstemp = Server.CreateObject("ADODB.RecordSet")
	  set rstemp = connection.execute(sql)
	  if not rstemp.eof then
	     if isencrypt(rstemp("fldusername")) = true then
	        adminusername = EnDeCrypt2(rstemp("fldusername"),session("setupxencryptkey"),"D")
		    adminuserpassword = EnDeCrypt2(rstemp("fldpassword"),session("setupxencryptkey"),"D")
		 else
	        adminusername = rstemp("fldusername")
		    adminuserpassword = rstemp("fldpassword")
		 end if
	  end if
	  set rstemp = nothing
   end if
   shopclosedatabase
end sub

function checkadminpageactual (filename)
   if trim(filename) = "" then
      checkadminpageactual = false
	  exit function
   end if
   
   dim sMapPath
   sMapPath = filename
   
   dim fso,fname,fs_overwrite,readflag,readfile
   readflag = true
   readfile = smappath
   on error resume next
   set fso=Server.CreateObject("Scripting.FileSystemObject")
   set fname=fso.OpenTextFile(sMapPath)
   fname.close
   set fname=nothing
   set fso=nothing
   if err.number <> 0 then
	  readflag = false
   end if
   checkadminpageactual = readflag
end function

function checkadminpage (filename)
   if trim(filename) = "" then
      checkadminpage = false
	  exit function
   end if
   
   dim sMapPath
   sMapPath = Server.MapPath(filename)
   sMapPath = replace(sMapPath,"installation\","")
   sMapPath = replace(sMapPath,"installation/","")
   
   dim fso,fname,fs_overwrite,readflag,readfile
   readflag = true
   readfile = smappath
   on error resume next
   set fso=Server.CreateObject("Scripting.FileSystemObject")
   set fname=fso.OpenTextFile(sMapPath)
   fname.close
   set fname=nothing
   set fso=nothing
   if err.number <> 0 then
	  readflag = false
   end if
   checkadminpage = readflag
end function

sub getmycompanyinfo (companyname,address,city,pstate,zipcode,country,phone,fax,email)
   readconfigfile "config.asp"
   dim xDatabase,xDbLocation,xDatabaseType,xSQLUser,xSQLPwd,xSQLServer,rc
   xDatabase = session("setupxDatabase")
   xDbLocation = session("setupxDbLocation")
   xDatabaseType = session("setupxDatabaseType")
   xSQLUser = session("setupxSQLUser")
   xSQLPwd = session("setupxSQLPwd")
   xSQLServer = session("setupxSQLServer")   
   shopopendatabase xDatabaseType,xDatabase,xDbLocation,xSQLUser,xSQLPwd,xSQLServer,rc
   
   if rc = 0 then
	  dim sql,rstemp
	  sql = "select * from mycompany where setupid = 1"
	  set rstemp = Server.CreateObject("ADODB.RecordSet")
	  set rstemp = connection.execute(sql)
	  if not rstemp.eof then
	     companyname = rstemp("companyname")
		 address = rstemp("address")
		 city = rstemp("city")
		 pstate = rstemp("state")
		 zipcode = rstemp("postalcode")
		 country = rstemp("country")
		 phone = rstemp("phonenumber")
		 fax = rstemp("faxnumber")
		 email = rstemp("myemail")
	  end if
	  set rstemp = nothing
   end if
   shopclosedatabase
end sub

function IsValidEmail(email)
   IsValidEmail=true
   dim names, name, i, c
   names = Split(email, "@")
   if UBound(names) <> 1 then
      IsValidEmail = false
       exit function
   end if

   for each name in names
      if Len(name) <=   0 then
         IsValidEmail = false
         exit function
      end if
      for i = 1 to Len(name)
         c = Lcase(Mid(name, i, 1))
         if InStr("abcdefghijklmnopqrstuvwxyz_-.", c) <= 0 and not IsNumeric(c) then
            IsValidEmail = false
            exit function
         end if
      next
      if Left(name, 1) = "." or Right(name, 1) = "." then
         IsValidEmail = false
         exit function
      end if
   next
   if InStr(names(1), ".") <= 0 then
      IsValidEmail = false
      exit function
   end if
   i = Len(names(1)) - InStrRev(names(1), ".")
   if i <> 2 and i <> 3 and i <> 4 then
      IsValidEmail = false
      exit function
   end if
   if InStr(email, "..") > 0 then
      IsValidEmail=false
   end if
end function

sub moveconfigfile (filename)
   if trim(filename) = "" then exit sub

   dim sMapPathOwn,sMapPathNew,sMapPathNew2
   sMapPathOwn = Server.MapPath("config.asp")

   sMapPathNew = Server.MapPath("admin/config/shop$config.asp")
   sMapPathNew = replace(sMapPathNew,"installation\","")
   sMapPathNew = replace(sMapPathNew,"installation/","")

   sMapPathNew2 = Server.MapPath("config/shop$config.asp")
   sMapPathNew2 = replace(sMapPathNew2,"installation\","")
   sMapPathNew2 = replace(sMapPathNew2,"installation/","")
   
   on error resume next
   dim objFSO
   Set objFSO = CreateObject("Scripting.FileSystemObject")
   objFSO.CopyFile sMapPathOwn, sMapPathNew
   objFSO.CopyFile sMapPathOwn, sMapPathNew2
   Set objFSO = Nothing
end sub

sub writetempfile (filename,tempstr)
   if trim(filename) = "" then exit sub

   dim sMapPath
   sMapPath = Server.MapPath(filename)

   dim fso,fname,fs_overwrite,icnt
   on error resume next
   fs_overwrite = true
   set fso=Server.CreateObject("Scripting.FileSystemObject")
   set fname=fso.CreateTextFile(""& sMapPath &"",fs_overwrite)
   
   fname.WriteLine tempstr
     
   fname.close
   set fname=nothing
   set fso=nothing
end sub

sub readtempfile (filename,tempstr)
   if len(trim(filename)) = 0 then exit sub
   
   dim realpath
   dim objFSO, objstream
   
   'on error resume next
   set objFSO=server.createobject("scripting.filesystemObject")
   realpath=Server.MapPath(filename)
   
   set objstream=objFSO.opentextfile(realpath)
   
   do while not objstream.atendofStream
      tempstr = cstr(objstream.readline)
   loop
   objstream.close
   set objstream = nothing
   set objFSO = nothing
end sub

function chkstrongpassword (pstring)
   dim icnt,inalpha,innumeric
   inalpha = false
   innumeric = false
   for icnt = 1 to len(pstring)
      if asc(mid(pstring,icnt,1)) >= 97 and asc(mid(pstring,icnt,1)) <= 122 then
	     inalpha = true
   	  end if
      if asc(mid(pstring,icnt,1)) >= 65 and asc(mid(pstring,icnt,1)) <= 90 then
	     inalpha = true
	  end if
      if asc(mid(pstring,icnt,1)) >= 48 and asc(mid(pstring,icnt,1)) <= 57 then
	     innumeric = true
	  end if
   next 
   
   if inalpha= false or innumeric = false then
      chkstrongpassword = false
   else
      chkstrongpassword = true
   end if
end function

sub deletetempfile (filename)
   if len(trim(filename)) = 0 then exit sub
   
   dim realpath
   dim objFSO, objstream
   
   'on error resume next
   set objFSO=server.createobject("scripting.filesystemObject")
   realpath=Server.MapPath(filename)
   
   objFSO.DeleteFile realpath
   
   set objFSO = nothing
end sub

sub emptyfile (filename,inadmin)
   if len(trim(filename)) = 0 then exit sub
   
   dim sMapPath
   
   if inadmin = false then
      sMapPath = Server.MapPath(filename)
      sMapPath = replace(sMapPath,"installation\","")
      sMapPath = replace(sMapPath,"installation/","")
   else
      sMapPath = Server.MapPath(filename)
   end if


   dim realpath
   dim objFSO, objstream,fs_overwrite,fname
   
   on error resume next
   fs_overwrite = true
   realpath=sMapPath
   set objFSO=server.createobject("scripting.filesystemObject")
   set fname=objFSO.CreateTextFile(realpath,fs_overwrite)
   fname.WriteLine("")
   fname.close
   
   set objFSO = nothing
end sub

sub emptyfileconfig (filename,inadmin)
   if len(trim(filename)) = 0 then exit sub
   
   dim sMapPath
   
   sMapPath = Server.MapPath(filename)

   dim realpath
   dim objFSO, objstream,fs_overwrite,fname
   
   on error resume next
   fs_overwrite = true
   realpath=sMapPath
   set objFSO=server.createobject("scripting.filesystemObject")
   set fname=objFSO.CreateTextFile(realpath,fs_overwrite)
   fname.WriteLine("")
   fname.close
   
   set objFSO = nothing
end sub

function getconfigvalue (fieldname)
   readconfigfile "config.asp"
   dim xDatabase,xDbLocation,xDatabaseType,xSQLUser,xSQLPwd,xSQLServer,rc
   xDatabase = session("setupxDatabase")
   xDbLocation = session("setupxDbLocation")
   xDatabaseType = session("setupxDatabaseType")
   xSQLUser = session("setupxSQLUser")
   xSQLPwd = session("setupxSQLPwd")
   xSQLServer = session("setupxSQLServer")   
   shopopendatabase xDatabaseType,xDatabase,xDbLocation,xSQLUser,xSQLPwd,xSQLServer,rc
   
   if rc = 0 then
      dim sql, rs,tempstr,xn
      sql="select fieldvalue from configuration where fieldname = '"& fieldname &"'"
      Set rs = Server.CreateObject("ADODB.Recordset")
      set rs = connection.execute(sql)
      if err.number<>0 then
         getconfigvalue="error"
         exit function
      end if
   
      xn=0
      do while not rs.eof
         tempstr=rs(0)
	     xn=xn+1
         rs.movenext
      loop

      if xn>0 then
         tempstr=tempstr
      else
         tempstr=""
      end if
      set rs=nothing
   end if
   if err.number>0 then tempstr=""
   getconfigvalue=tempstr
end function

sub ExecuteMail(mailtype, My_from, myin_fromaddress, my_to, my_toaddress, my_subject, body, emailformat, Orderattachments, Orderattachmentcount, xmailusername, xmailpassword, rc,my_system)
   dim mailer
   dim mailerror
   dim htmlformat
   dim i
   dim my_fromaddress
   my_fromaddress = myin_fromaddress
   htmlformat = ucase(emailformat)
   on error resume next
   if ucase(mailtype) = "CDONTS" then
      set Mailer = Server.createobject("CDONTS.NewMail")
      if err.number<> 0 then
         rc = 4
         exit sub
      end if
      Mailer.to = my_toaddress
      Mailer.From = my_from & " <" & my_fromaddress & ">"
      Mailer.Subject = my_subject
      Mailer.Body = body
      Mailer.Send
      set mailer = nothing
	  rc = 0
      exit sub
   end if
   if ucase(mailtype) = "ASPMAIL" then
      set Mailer = Server.createobject("SMTPsvg.Mailer")
      if err.number<> 0 then
         rc = 4
         exit sub
      end if
      Mailer.AddRecipient my_to, my_toaddress
      Mailer.RemoteHost = my_system
      Mailer.FromName = my_from
      Mailer.FromAddress = my_fromAddress
      Mailer.Subject = my_subject
      Mailer.BodyText = body
      if Mailer.SendMail then
         set Mailer = nothing
		 rc = 0
         exit sub
      else
         set mailer = nothing
		 rc = 4
         exit sub
      end if
   end if
   if ucase(Mailtype) = "JMAIL" then
      set Mailer = Server.createobject("JMail.SMTPMail")
      if err.number<> 0 then
         rc = 4
         exit sub
      end if
      Mailer.ServerAddress = my_system
	  if trim(xmailpassword) <> "" then mailer.mailserverpassword = xmailpassword
	  if trim(xmailusername) <> "" then mailer.mailserverusername = xmailusername
      Mailer.Sender = my_fromAddress
      Mailer.SenderName = my_from
      Mailer.AddRecipient my_toaddress
      Mailer.Subject = my_subject
      Mailer.Body = body
      if Mailer.execute then
         set Mailer = nothing
		 rc = 0
         exit sub
      else
         set mailer = nothing
		 rc = 4
         exit sub
      end if
   end if
   if ucase(Mailtype) = "ASPEMAIL" then
      set Mailer = Server.createobject("Persits.MailSender")
      if err.number<> 0 then
         rc = 4
         exit sub
      end if
      Mailer.Host = my_system
      Mailer.From = my_fromAddress
      Mailer.FromName = my_from
      Mailer.AddAddress my_toaddress, my_to
      Mailer.Subject = my_subject
      Mailer.Body = body
      if Mailer.Send then
         set Mailer = nothing
		 rc = 0
         exit sub
      else
         set mailer = nothing
		 rc = 4
         exit sub
      end if
   end if
   if ucase(Mailtype) = "OCXMAIL" then
      dim attach
      attach = ""
      set mailer = Server.createobject("ASPMAIL.ASPMailCtrl.1")
      if err.number<> 0 then
         rc = 4
         exit sub
      end if
      mailerror = mailer.SendMail(my_system, my_toaddress, my_fromaddress, my_subject, body)
      if "" = mailerror then
         set mailer = nothing
		 rc = 0
         exit sub
      else
         set mailer = nothing
		 rc = 4
		 exit sub
      end if
   end if
   if ucase(Mailtype) = "DUNDAS" then
      set mailer = Server.createobject("Dundas.Mailer") 'Mailer object
      mailer.TOs.add my_toaddress, my_to
      mailer.Subject = my_subject
      mailer.SMTPRelayServers.add my_system
      mailer.FromAddress = my_fromaddress
      mailer.Fromname = my_from
      mailer.Body = body
      mailer.SendMail
      if err.number <> 0 then
         rc = 4
         exit sub
      end if
      set mailer = nothing 'release resources
	  rc = 0
      exit sub
   end if

   if ucase(Mailtype) = "JMAIL43" then
      set Mailer = Server.createobject("JMail.Message")
      if err.number<> 0 then
         rc = 4
         exit sub
      end if
      Mailer.From = my_fromAddress
      Mailer.FromName = my_from
      Mailer.AddRecipient my_toaddress, my_to
      Mailer.Subject = my_subject

      if trim(xmailpassword) <> "" then mailer.mailserverpassword = xmailpassword
	  if trim(xmailusername) <> "" then mailer.mailserverusername = xmailusername

      Mailer.Body = body
      if Mailer.Send(my_system) then
         set Mailer = nothing
		 rc = 0
         exit sub
      else
         set mailer = nothing
		 rc = 4
         exit sub
      end if
   end if
   if ucase(mailtype) = "SOFTART" then
      set Mailer = Server.createobject("SoftArtisans.SMTPMail")
      if err.number<> 0 then
         rc = 4
         exit sub
      end if
      Mailer.AddRecipient my_to, my_toaddress
      Mailer.RemoteHost = my_system
      Mailer.FromName = my_from
      Mailer.FromAddress = my_fromAddress
      Mailer.Subject = my_subject
      Mailer.BodyText = body
      if Mailer.SendMail then
         set Mailer = nothing
		 rc = 0
         exit sub
      else
         set mailer = nothing
		 rc = 4
         exit sub
      end if
   end if

   if ucase(mailtype) = "CDOSYS" then
      dim iConf
      dim Flds
      ' Send by connecting to port 2 of the SMTP server.
      const cdoSendUsingPort = 2
      set Mailer = createobject("CDO.Message")
      set iConf = createobject("CDO.Configuration")
      set Flds = iConf.Fields
      ' Set the CDOSYS configuration fields to use port 25 on the SMTP server.
      flds.item("http://schemas.microsoft.com/cdo/configuration/sendusing") = cdoSendUsingPort
      'ToDo: Enter name or IP address of remote SMTP server.
      flds.item("http://schemas.microsoft.com/cdo/configuration/smtpserver") = my_system
      flds.item("http://schemas.microsoft.com/cdo/configuration/smtpconnectiontimeout") = 10

      '6.50 - add support for username and password
      if trim(xmailusername) <> "" then
         flds.item("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") = 1
         flds.item("http://schemas.microsoft.com/cdo/configuration/sendusername") = xmailusername
      end if
      if trim(xmailpassword) <> "" then
         flds.item("http://schemas.microsoft.com/cdo/configuration/sendpassword") = xmailpassword
      end if

      flds.Update
      'Apply the settings to the message.
      set Mailer.Configuration = iConf
      Mailer.to = my_toaddress 'ToDo: Enter a valid email address.
      Mailer.From = my_from & " <" & my_fromaddress & ">" 'ToDo: Enter a valid email address.
      Mailer.Subject = my_subject
      Mailer.TextBody = body
      Mailer.Send
      set Mailer = nothing
      set iConf = nothing
	  rc = 0
      exit sub
   end if
end sub

function isencrypt(passstring)
   dim i,icnt
   icnt = 0
   for i = 1 to len(passstring)
      if mid(passstring,i,1) = "." then
	     icnt = icnt + 1
	  end if
   next
   if icnt >= 3 then
      isencrypt = true
   else
      isencrypt = false
   end if
end function

'700 - 2010.09.08 - Enhancment: Cover Old IIS issue
sub Assigncodepagevalue (codepagevalue)
   session.codepage = codepagevalue
   on error resume next
   response.codepage = codepagevalue
   on error goto 0
end sub

function URLDecode(sText)
dim sDecoded,oRegExpr,oMatchCollection,oMatch

sDecoded = sText
set oRegExpr = Server.CreateObject("VBScript.RegExp")
oRegExpr.Pattern = "%[0-9,A-F]{2}"
oRegExpr.Global = True
set oMatchCollection = oRegExpr.execute(sText)
for each oMatch in oMatchCollection
   sDecoded = Replace(sDecoded,oMatch.value,Chr(CInt("&H" & Right(oMatch.Value,2))))
next

'6.50.4 - add close calls
set oRegExpr = Nothing
set oMatchCollection = Nothing

URLDecode = sDecoded
end function
%>