<%option explicit%>
<!-- #include file="shop$db.asp" -->
<%shopopendatabase dbc%>
<!-- #include file="paypalproexpressconfig.asp" -->
<!-- #include file="shopxmlhttp.asp"-->
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' PayPal Website Payment Pro payment logic page.
' Now built into VP-ASP 7.00 by default.
'*********************************************************************************

dim CardInfo

Dim CustomerInfo
Dim Orders
Dim strSQL
Dim POrderamount
Dim Pfirstname
Dim Plastname
Dim Paddress
Dim Pcity
Dim Ppostcode
Dim Pstate
Dim Pcountry
Dim Pphone
Dim Pfax
Dim Pcompany
Dim Pcardtype
Dim Pcardno
Dim Pcardname
Dim Pcardexpires
Dim Pcardaddress
Dim PEmail

Dim Poid
Dim BackURL
Dim ForwardURL
Dim oid
oid = Getsess("oid")
if oid="" then
   shoperror getlang("LangOrderProcessed")
end if
poid=oid   
Dim oAuthNetSSL
Dim PostData
pAuthCode = ""							' null authorization code
Dim x_response_code
dim x_transaction_id
dim x_approval_number
Dim x_avs_code
Dim x_cvv2_resp_code
dim shipname,shipnames(5),shipcount
Dim shipaddress
Dim shipcity
Dim shippostcode
Dim shipstate
Dim shipcountry
dim merchanttype
Dim x_response_subcode
Dim x_response_reason_code
Dim x_response_reason_text
Dim PAuthCode              ' authorization code needs to be set
Dim PError                 ' if set we go back to shop thanks with

'702 - 2012.07.26 - PayPal Enhancement
dim x_pendingreason

'************************************************************************
' Use this routine to perform checks on credit card information
' Data is in orders database
' oid = order id to retrieve from database
' OutError = set to any error messages
' OutAuthorization = set to authorization code to be stored in
' database
'********************************************************************
'Initialize environment
' VP-ASP parameters
Perror=""                          ' no errors
PAuthCode=""                       ' null authorization code
setsess "PaymentError",""         ' no payment error

'800 - 2015.12.14 - PayPal Pro: Better handling with onepage checkout
if check_onepage_status then
   backurl = onepage_filename
else
   backurl = "shopcheckout.asp"
end if

forwardurl="shopthanks.asp"         'go forward when finished
GetDatabaseRecord Poid   ' Get Order from database
ProcessCreditCard        ' Validate Credit Card

'If Traceflag<>"Yes" then
   If pError = "" then
      '702 - 2012.07.26 - PayPal Enhancement
      UpdateTransactionType x_PaymentType

      UpdateAuthorization				' add authorization to database
      ResponseRedirect forwardurl	' go to shopthanks
   Else
      '702 - 2012.07.26 - PayPal Enhancement
      UpdateTransactionType "D"

      setsess "PaymentError", pError

	  '800 - 2015.12.14 - PayPal Pro: Better handling with onepage checkout
	  session("onepage_serror") = PError

      UpdateDeclined 
      ResponseRedirect backurl
      debugwrite perror 
   End If 
'else
  ' debugwrite "Error=" & perror
'end if  

shopclosedatabase dbc

'*********************************************************************
' Here is PayPal Pro Credit Card Process
'********************************************************************
Sub ProcessCreditCard
   dim anrequest

   anrequest = ""
   anrequest = anrequest & ""& Server.URLEncode("METHOD") &"=" & Server.URLEncode(x_Method)
   anrequest = anrequest & "&"& Server.URLEncode("VERSION") &"=" & Server.URLEncode(x_VERSION)
   anrequest = anrequest & "&"& Server.URLEncode("USER") &"=" & Server.URLEncode(x_USERNAME)
   anrequest = anrequest & "&"& Server.URLEncode("PWD") &"=" & Server.URLEncode(x_PASSWORD)
   anrequest = anrequest & "&"& Server.URLEncode("SIGNATURE") &"=" & Server.URLEncode(x_SIGNATURE)
   anrequest = anrequest & "&"& Server.URLEncode("BUTTONSOURCE") &"=" & Server.URLEncode(BN_PPRO)
   anrequest = anrequest &  CardInfo
   anrequest = anrequest & "&"& Server.URLEncode("PAYMENTACTION") &"=" & Server.URLEncode(x_PaymentType)
   anrequest = anrequest & "&"& Server.URLEncode("CURRENCYCODE") &"=" & Server.URLEncode(x_CurrencyCode)
   'debugwrite anrequest
   SendtoGateWay anrequest, Responsedata
   analyzeResult Responsedata

   '702 - 2012.07.26 - PayPal Enhancement
   '702 - 2013.03.25 - Security updates - To remove sensitive details if recording paypal logs
   dim requesttolog
   requesttolog = ""
   requesttolog = requesttolog & ""& Server.URLEncode("METHOD") &"=" & Server.URLEncode(x_Method)
   requesttolog = requesttolog & "&"& Server.URLEncode("VERSION") &"=" & Server.URLEncode(x_VERSION)
   requesttolog = requesttolog & "&"& Server.URLEncode("BUTTONSOURCE") &"=" & Server.URLEncode(BN_PPRO)
   requesttolog = requesttolog & "&"& Server.URLEncode("PAYMENTACTION") &"=" & Server.URLEncode(x_PaymentType)
   requesttolog = requesttolog & "&"& Server.URLEncode("CURRENCYCODE") &"=" & Server.URLEncode(x_CurrencyCode)
   createlogs_paypalpro_process oid, requesttolog, Responsedata
End Sub

'*************************************************************
' Get Database Record
' Probably no change required here
'**************************************************************
Sub GetDatabaseRecord(oid)
   dim strsql
   dim amount
   strsql = "select * from orders where orderid=" & oid
   Set Orders = Server.CreateObject("ADODB.Recordset")
   orders.open strsql, dbc, adopenkeyset, adlockoptimistic

   '701 - 2012.05.11 - Bug Fix: Should pass amount to PayPal based on xcurrencybase
   '701 - 2012.07.24 - Bug Fix: PayPal is sending wrong amount if customer change currencybase
   porderamount = orders("orderamount")

   amount = porderamount
   amount = FormatNumber(amount, 2)  
   amount = Replace(amount, ",", "")

   '800 - 2015.12.14 - Gateways: Revert back correct charactes while passing string to gateways
   pfirstname = convert_backto_origin_str(orders("ofirstname"))
   plastname = convert_backto_origin_str(orders("olastname"))

   pemail = orders("oemail")

   '800 - 2015.12.14 - Gateways: Revert back correct charactes while passing string to gateways
   paddress = convert_backto_origin_str(orders("oaddress"))
   pcity = convert_backto_origin_str(orders("ocity"))
   ppostcode = convert_backto_origin_str(orders("opostcode"))
   pstate = convert_backto_origin_str(orders("ostate"))
   
   '2010.04.22 - 700 - Paypalpro UK country code
   pcountry = orders("ocountry")
   if ucase(pcountry) = "UK" then
      pcountry = "GB"
   end if

   pphone = orders("ophone")
   pfax = orders("ofax")

   '800 - 2015.12.14 - Gateways: Revert back correct charactes while passing string to gateways
   pcompany = convert_backto_origin_str(orders("ocompany"))
   
   pcardtype = session("ocardtype")
   pcardno = session("ocardno")

   pcardexpires = session("ocardexpires")

   '800 - 2015.12.14 - Gateways: Revert back correct charactes while passing string to gateways
   shipaddress = convert_backto_origin_str(orders("oshipaddress"))
   shipcity = convert_backto_origin_str(orders("oshiptown"))
   shippostcode = convert_backto_origin_str(orders("oshipzip"))
   shipstate = convert_backto_origin_str(orders("oshipstate"))

   '2010.04.22 - 700 - Paypalpro UK country code
   shipcountry = orders("oshipcountry")
   if ucase(shipcountry) = "UK" then
      shipcountry = "GB"
   end if       
 
   shipname=orders("oshipname")
   If shipname<>"" then
      parserecord shipname,shipnames,shipcount," "
   end if
   
   dofieldCardInfo "AMT",amount
   dofieldCardInfo "CREDITCARDTYPE",pcardtype
   dofieldCardInfo "ACCT",pcardno
   
   dofieldCardInfo "EXPDATE",mid(pcardexpires,1,2) & "20" & mid(pcardexpires,4,2)
   dofieldCardInfo "CVV2",session("cvn")
   
   if lcase(pcardtype)="switch" or lcase(pcardtype)="solo" or lcase(pcardtype)="maestro" then
      dofieldCardInfo "STARTDATE",session("ocardvalidfrom")
	  dofieldCardInfo "ISSUENUMBER",session("ocardissue")
	  x_PaymentType = "Authorization"
	  x_CurrencyCode="GBP"
   end if
   
   dofieldCardInfo "INVNUM",oid
   dofieldCardInfo "FIRSTNAME",pfirstname
   dofieldCardInfo "LASTNAME",plastname
   dofieldCardInfo "STREET",paddress
   dofieldCardInfo "CITY",pcity
   if lcase(pstate) <> "none" then dofieldCardInfo "STATE",pstate
   dofieldCardInfo "ZIP",ppostcode
   dofieldCardInfo "COUNTRYCODE",pcountry

   '702 - 2013.01.30 - PayPal Pro Enhancement: To include shipping info and email to PayPal
   dim oaddress2, oshipaddress2

   '800 - 2015.12.14 - Gateways: Revert back correct charactes while passing string to gateways
   oaddress2 = convert_backto_origin_str(orders("oaddress2"))

   if isnull(oaddress2) then oaddress2 = ""

   '800 - 2015.12.14 - Gateways: Revert back correct charactes while passing string to gateways
   oshipaddress2 = convert_backto_origin_str(orders("oshipaddress2"))

   if isnull(oshipaddress2) then oshipaddress2 = ""
   dofieldCardInfo "EMAIL",pemail
   if trim(oaddress2) <> "" then dofieldCardInfo "STREET2",oaddress2
   dofieldCardInfo "SHIPTONAME",shipname
   dofieldCardInfo "SHIPTOSTREET",shipaddress
   if trim(oshipaddress2) <> "" then dofieldCardInfo "SHIPTOSTREET2",oshipaddress2
   dofieldCardInfo "SHIPTOCITY",shipcity
   dofieldCardInfo "SHIPTOSTATE",shipstate
   dofieldCardInfo "SHIPTOZIP",shippostcode
   dofieldCardInfo "SHIPTOCOUNTRY",shipcountry

   Orders.close
   set Orders=Nothing
end sub

'***************************************************************
' Updates PayPal Pro field in order
' PAuthcode has authorization value
'**************************************************************
Sub UpdateAuthorization 
   Dim sql
   Dim rstemp
   Dim pAuthCode

   '702 - 2012.07.26 - PayPal Enhancement
   if lcase(x_response_code) <> "completed" then

      PauthCode = "PayPalPro-DP " & x_response_code

      '702 - 2012.07.26 - PayPal Enhancement
	  PauthCode = PauthCode & "<br>Transaction ID=" & x_transaction_id
	  PauthCode = PauthCode & "<br>Pending Reason=" & x_pendingreason
      'PauthCode = PauthCode & "<br>PayPal Fraud Management Settings. Please logon to your Seller PayPal account to confirm the transaction."
   else
      PauthCode = "PayPalPro-DP " & x_response_code
      PauthCode = PauthCode & "<br>Transaction ID=" & x_transaction_id
   end if
   	
   sql = "Update orders set "

   '800 - 2016.02.02 - PayPal Pro: Better hanlding on returned results
   sql = sql & " oauthorization='" & tosql(pAuthCode,"Text") & "'"

   '702 - 2012.07.26 - PayPal Enhancement
   if lcase(x_response_code) <> "completed" then
      sql=sql & " ,ocardtype='" & "PayPalPro-DP-Pending" &"'"
   else
      sql=sql & " ,ocardtype='" & "PayPalPro-DP" &"'"
   end if
   sql = sql & " ,ocardno=NULL"
   sql = sql & " where orderid=" & oid

   '800 - 2016.02.01 - Enhancement: Must always commit transaction if execute sql execute
   on error resume next
   dbc.BeginTrans
   on error goto 0
   dbc.execute(sql)
   on error resume next
   dbc.CommitTrans
   on error goto 0
end sub

'*************************************************************************
' Decline transaction
'******************************************************
Sub UpdateDeclined 
   Dim sql
   Dim rstemp
   Dim pAuthCode
   pAuthCode = "Declined " & x_response_reason_text
   sql = "Update orders set "

   '800 - 2016.02.02 - PayPal Pro: Better hanlding on returned results
   sql = sql & " oauthorization='" & tosql(pAuthCode,"Text") & "'"

   sql = sql & " ,ocardtype='" & "PayPalPro-DP-Declined" & "'"
   sql = sql & " ,ocardno=NULL"
   sql = sql & " where orderid=" & oid

   '800 - 2016.02.01 - Enhancement: Must always commit transaction if execute sql execute
   on error resume next
   dbc.BeginTrans
   on error goto 0
   dbc.execute(sql)
   on error resume next
   dbc.CommitTrans
   on error goto 0
end sub	

Sub DoFieldCardInfo (fieldname,fieldvalue)
   if fieldvalue="" or isNull(fieldvalue) then
      exit sub
   end if
   CardInfo = CardInfo & "&"& Server.URLEncode(""& fieldname &"") &"=" & Server.URLEncode(fieldvalue)
end sub

'********************************************************************
' Routine to send out Creidt Card request to
' PayPal Pro Payment Gateway
'********************************************************************
Sub SendtoGateWay (anrequest, result)
   '702 - 2012.07.26 - PayPal Enhancement
   on error resume next
   dim resultXML,xmlerror

   '800 - 2016.05.25 - Enhancement: PayPal Pro: TLS 1.2 Enabled
   dim rheadercnt, rheadertypeary(10), rheadervalueary(10)
   rheadercnt = 0
   Shopxmlhttp_v8 "auto", x_GatewayLocation, anrequest, resultXML, "POST", xmlerror, rheadercnt, rheadertypeary, rheadervalueary, "", ""

   result = resultXML
   on error goto 0
   
   if trim(xmlerror) <> "" then
	  pError="Err. Description: "& xmlerror &""
	  setsess "PaymentError", pError
	  ResponseRedirect backurl
   end if

   If Err.Number <> 0 Then
	  pError="Err. Number: "& Err.Number &"<br>Err. Description: "& Err.Description &""
	  setsess "PaymentError", pError
	  ResponseRedirect backurl
   End If
end sub

'********************************************************************
' Analyse result, returned back from PayPal Pro Payment Gateway
'********************************************************************
Sub AnalyzeResult(result)
   dim anresult
   dim anresultcnt,xn
   dim strResponseMessage
   Dim strTransactionID
   Dim strAVSResponse
   Dim strCSCResponse
   Dim strErrorCode, strErrorMsg

   '702 - 2012.07.26 - PayPal Enhancement
   dim strPendingReason
   
   anresult=Split(result, "&")
   anresultcnt=ubound(anresult)
   for xn=0 to (anresultcnt)
      if instr(anresult(xn),"ACK=") > 0 then strResponseMessage=URLDecode(mid(anresult(xn),(instr(anresult(xn),"ACK=")+len("ACK=")),(len(anresult(xn))-1)))
	  if instr(anresult(xn),"TRANSACTIONID=") > 0 then strTransactionID=URLDecode(mid(anresult(xn),(instr(anresult(xn),"TRANSACTIONID=")+len("TRANSACTIONID=")),(len(anresult(xn))-1)))
	  if instr(anresult(xn),"AVSCODE=") > 0 then strAVSResponse=URLDecode(mid(anresult(xn),(instr(anresult(xn),"AVSCODE=")+len("AVSCODE=")),(len(anresult(xn))-1)))
	  if instr(anresult(xn),"CVV2MATCH=") > 0 then strCSCResponse=URLDecode(mid(anresult(xn),(instr(anresult(xn),"CVV2MATCH=")+len("CVV2MATCH=")),(len(anresult(xn))-1)))
	  if instr(anresult(xn),"L_ERRORCODE0=") > 0 then strErrorCode=URLDecode(mid(anresult(xn),(instr(anresult(xn),"L_ERRORCODE0=")+len("L_ERRORCODE0=")),(len(anresult(xn))-1)))
	  if instr(anresult(xn),"L_LONGMESSAGE0=") > 0 then strErrorMsg=URLDecode(mid(anresult(xn),(instr(anresult(xn),"L_LONGMESSAGE0=")+len("L_LONGMESSAGE0=")),(len(anresult(xn))-1)))

      '702 - 2012.07.26 - PayPal Enhancement
	  if instr(anresult(xn),"PENDINGREASON=") > 0 then strPendingReason=URLDecode(mid(anresult(xn),(instr(anresult(xn),"PENDINGREASON=")+len("PENDINGREASON=")),(len(anresult(xn))-1)))
	  'debugwrite anresult(xn)
	  'debugwrite strErrorCode
   next
   
   if lcase(strResponseMessage) = "failure" then
      x_response_reason_text = strErrorCode & " " & strErrorMsg
	  pError="Your credit card transaction failed<br>" & strErrorMsg
   else
      x_response_code=strResponseMessage
      x_transaction_id=strTransactionID
      x_avs_code=strAVSResponse
      x_cvv2_resp_code=strCSCResponse
      pError=""

      '702 - 2012.07.26 - PayPal Enhancement
      x_pendingreason = strPendingReason
   end if
end sub

Function URLDecode(byVal encodedstring)
   Dim strIn, strOut, intPos, strLeft
   Dim strRight, intLoop
   strIn  = encodedstring : strOut = "" : intPos = Instr(strIn, "+")
   Do While intPos
      strLeft = "" : strRight = ""
      If intPos > 1 then strLeft = Left(strIn, intPos - 1)
	  If intPos < len(strIn) then strRight = Mid(strIn, intPos + 1)
	  strIn = strLeft & " " & strRight
	  intPos = InStr(strIn, "+")
	  intLoop = intLoop + 1
   Loop
   intPos = InStr(strIn, "%")
   Do while intPos
	  If intPos > 1 then strOut = strOut & Left(strIn, intPos - 1)
	  strOut = strOut & Chr(CInt("&H" & mid(strIn, intPos + 1, 2)))
	  If intPos > (len(strIn) - 3) then
		 strIn = ""
	  Else
		 strIn = Mid(strIn, intPos + 3)
	  End If
	  intPos = InStr(strIn, "%")
   Loop
   URLDecode = strOut & strIn
End Function

'702 - 2012.07.26 - PayPal Enhancement
Sub UpdateTransactionType (updatestring)
   Dim sql
   sql = "Update orders set "
   sql = sql & " paypalprocessor='PayPalPro', "
   sql = sql & " paypaltranstype='" & updatestring & "'"
   sql = sql & " where orderid=" & getsess("oid")

   '800 - 2016.02.01 - Enhancement: Must always commit transaction if execute sql execute
   on error resume next
   dbc.BeginTrans
   on error goto 0
   dbc.execute(sql)
   on error resume next
   dbc.CommitTrans
   on error goto 0
end sub

'702 - 2012.07.26 - PayPal Enhancement
sub createlogs_paypalpro_process (oid, xmlsent, xmlreceive)
   dim foldername,filename,nowdate
   nowdate = replace(date(),"/","_")
   nowdate = replace(nowdate,"\","_")
   foldername = "paypalpro"
   filename = "paypalpro_"& nowdate &"_"& oid &".txt"
   WriteLogPayPal foldername, filename, "Start (Process): =================================================="
   WriteLogPayPal foldername, filename, "For Order ID: "& oid &""
   WriteLogPayPal foldername, filename, "XML Sent: "& xmlsent &""
   WriteLogPayPal foldername, filename, "XML Received: "& xmlreceive &""
   WriteLogPayPal foldername, filename, "End (Process): =================================================="
end sub
%>