<%option explicit%>
<%response.buffer=true%>
<!-- #include file="shop$db.asp" -->
<%shopopendatabase dbc%>
<!-- #include file="pfptrconfig.asp" -->
<!-- #include file="paypalpymtflink_sub.asp" -->
<%
'**************************************************************************
' PayFlow Pro Transparent Redirect
' VP-ASP 7.02
' 26 July 2012
'**************************************************************************

Dim Pauthcode,backurl,forwardurl,Poid
dim returnResult,returnRESPMSG,returnPPREF,returnINVOICE,returnSECURETOKENID,returnTRANSTIME
dim cancel_ec_trans
dim ppadvrandonstring
ppadvrandonstring = ""

PAuthCode = ""
setsess "PaymentError", ""

'800 - 2015.12.14 - PayFlow Pro Transparent: Better handling with onepage checkout
if check_onepage_status then
   backurl = onepage_filename
else
   backurl = "shopcheckout.asp"
end if

forwardurl = "shopthanks.asp"
returnResult = cleanchars(request("RESULT"))
returnRESPMSG = cleanchars(request("RESPMSG"))
returnPPREF = cleanchars(request("PPREF"))
returnINVOICE = cleanchars(request("INVOICE"))
returnSECURETOKENID = cleanchars(request("SECURETOKENID"))
returnTRANSTIME = cleanchars(request("TRANSTIME"))
cancel_ec_trans = cleanchars(request("cancel_ec_trans"))

Poid = getsess("oid") ' if not session, get from eway return
if trim(poid) = "" then
   Poid = returnINVOICE
   if IsNumeric(poid) Then setsess "oid", poid
end if
ppadvrandonstring = getpaypalfieldvalue("orders","paypalpayflowprotoken",Poid,"orderid",1)

if ppadvrandonstring <> returnSECURETOKENID then
   PauthCode = "Invalid Secure Token!"
   setsess "PaymentError", PauthCode

   '800 - 2015.12.14 - PayFlow Pro Transparent: Better handling with onepage checkout
   session("onepage_serror") = PauthCode

   shopclosedatabase dbc
   responseredirect backurl
end if

if cstr(returnResult) = "0" then
   '800 - 2016.08.30 - PayFlow Pro/Link: Should always update payment status via result page
   UpdateTransactionType xpayflowpro_transtype,"PayFlowPro"
   UpdateAuthorization

   shopclosedatabase dbc
   responseredirect forwardurl
else
   recreateSecureTokenID "paypalpayflowprotoken"
   if lcase(cancel_ec_trans) = "true" then
      PauthCode = "Customer cancelled payment."
	  setsess "PaymentError", PauthCode

	  '800 - 2015.12.14 - PayFlow Pro Transparent: Better handling with onepage checkout
	  session("onepage_serror") = PauthCode

	  UpdateDeclined
	  shopclosedatabase dbc
	  responseredirect backurl
   else
      PauthCode = "Result: " & returnResult&" - "&returnRESPMSG

	  '800 - 2015.12.14 - PayFlow Pro Transparent: Better handling with onepage checkout
	  PauthCode = PauthCode & "<br>Trans Time: " & returnTRANSTIME
	  setsess "PaymentError", PauthCode
	  session("onepage_serror") = PauthCode
	  UpdateDeclined

	  shopclosedatabase dbc
	  responseredirect backurl
   end if
end if

sub recreateSecureTokenID (updatefield)
   if trim(updatefield) = "" then exit sub
   Dim sqltemp
   sqltemp = "Update orders set "
   sqltemp = sqltemp & " "& updatefield &"='" & genrandomvalue(36) & "'"
   sqltemp = sqltemp & " where orderid=" & poid

   '800 - 2016.02.01 - Enhancement: Must always commit transaction if execute sql execute
   on error resume next
   dbc.BeginTrans
   on error goto 0
   dbc.execute(sqltemp)
   on error resume next
   dbc.CommitTrans
   on error goto 0
end sub

Sub UpdateDeclined
   Dim sqltemp
   sqltemp = "Update orders set "
   sqltemp = sqltemp & " oauthorization='" & PauthCode & "'"
   sqltemp = sqltemp & " ,ocardtype='" & xpayflowpro_paymentname & " - FAILED'"
   sqltemp = sqltemp & " ,ocardno=NULL"
   sqltemp = sqltemp & " where orderid=" & poid

   '800 - 2016.02.01 - Enhancement: Must always commit transaction if execute sql execute
   on error resume next
   dbc.BeginTrans
   on error goto 0
   dbc.execute(sqltemp)
   on error resume next
   dbc.CommitTrans
   on error goto 0
end sub

'800 - 2016.08.30 - PayFlow Pro/Link: Should always update payment status via result page
Sub UpdateAuthorization
   dim returnPPREF, returnPNREF, returnRESPMSG, returnTRANSTIME, returnResult
   returnPPREF = cleanchars(request("PPREF"))
   returnPNREF = cleanchars(request("PNREF"))
   returnRESPMSG = cleanchars(request("RESPMSG"))
   returnTRANSTIME = cleanchars(request("TRANSTIME"))
   returnResult = cleanchars(request("RESULT"))
   Dim sqltemp
   PauthCode = "PPRef. No: " & returnPPREF
   PauthCode = PauthCode & "<br>PNRef. No: " & returnPNREF
   PauthCode = PauthCode & "<br>Resp Msg: " & returnRESPMSG
   PauthCode = PauthCode & "<br>Trans Time: " & returnTRANSTIME
   PauthCode = PauthCode & "<br>Result: " & returnResult
   sqltemp = "Update orders set "
   sqltemp = sqltemp & " oauthorization='" & PAuthCode &"'"
   sqltemp = sqltemp & " ,ocardtype='" & xpayflowpro_paymentname &"'"
   sqltemp = sqltemp & " where orderid=" & poid
   on error resume next
   dbc.BeginTrans
   on error goto 0
   dbc.execute(sqltemp)
   on error resume next
   dbc.CommitTrans
   on error goto 0
End Sub
%>