<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Cart format design routines
'*********************************************************************************

'800 - 2015.04.15 - Responsive Layout updated
sub DisplayTitle (percent, titlename)
   if titlename = getlang("langproduct01") then
      '800 - 2015.07.13 - Bug Fux: View cart page: Layout issue if xdeliveryaddress is switched on
      HtmlWrite "<th class=""menuhdr"" colspan="""& percent &""">" & TitleName & "</th>"
   else
  	  HtmlWrite "<th style=""text-align: center"">" & TitleName & "</th>"
   end if
end sub

'800 - 2015.04.15 - Responsive Layout updated
sub AddField (percent, alignment, fieldvalue)
   if percent = "50%" AND instr(lcase(request.servervariables("script_name")), "shopcreateorder.asp") > 0 then
%>
<td class="item_row" colspan="2" style="text-align:<%=alignment%>" colspan="" width="<%=percent%>"><%=fieldvalue%></td>
<%
   else 
%>
<td class="item_row" style="text-align:<%=alignment%>" colspan="" width="<%=percent%>"><%=fieldvalue%></td>
<%
   end if
end sub

sub AddField_withclose (percent, alignment, fieldvalue, i)
   dim url
   url="shopremoveitem.asp?cartid=" & i
   url=addwebsess(url)

   '800 - 2015.05.01 - Enhancement: Layout updates
%>
<td class="item_row" style="text-align:<%=alignment%>" width="<%=percent%>"><%=fieldvalue%></td>
<%
end sub

sub AddQuantity (i, quantity)
   if cartremove<>"" then
      if minamount<>""  then
         if Minamount>0 then
            if GetConfig("xproductminimumquantity")<>"Yes" then
               GenerateMinQuantityList i, quantity
               exit sub
            end if
         end if
      end if
      if GetConfig("xcartstaticquantity")="Yes"  or maxamount=1 then
         HtmlWrite "<td class=""ac item_row"" width=""10%"">" & Quantity
         HtmlWrite "<input type=""hidden"" name=""quantity" & CStr(i) & """ value=""" & Quantity & """ /></td>"
      else
         HtmlWrite "<td width=""10%"" class=""ac item_row""><input class=""txtfield"" type=""text"" maxlength=""4"" size=""5"" name=""quantity" & CStr(i) & """ value=""" & Quantity & """></td>"
      end if
   else
      HtmlWrite "<td class=""ac item_row"" width=""10%"">" & quantity & "</td>"
   end if
end sub

sub AddRemoveBox (i)
   dim image, url
   image=GetConfig("xbuttonremove")
   if image<>"" then
      HtmlWrite "<td class=""ac item_row"" width=""5%"">"
      url="shopremoveitem.asp?cartid=" & i
      url=addwebsess(url)
      response.write "<a href=""" & url & """><img border=""0"" src=""" & image & """ alt="" "" /></a></td>"
      exit sub
   end if

   if GetConfig("xCartRemoveChecked")="Yes" then
      '800 - 2015.04.15 - Responsive Layout updated
      '800 - 2015.05.01 - Enhancement: Layout updates
%>
<td class="ac item_row" width="5%" ><input name="selected<%= Cstr(i)%>" type="checkbox" value="yes" checked="checked"/></td>
<%
   else
      '800 - 2015.04.15 - Responsive Layout updated
      '800 - 2015.05.01 - Enhancement: Layout updates
%>
<td class="ac item_row" width="5%"><input name="selected<%= Cstr(i)%>" type="checkbox" value="yes"/></td>
<%
   end if
end sub

sub AddEdit (i, deliveryaddress)
   dim prompt, promptimage, url
   prompt=GetLang("langDeliveryAdd")
   promptimage=GetConfig("xbuttonaddressadd")
   if isarray(DeliveryAddress) then
      prompt=GetLang("langDeliveryChange")
      promptimage=GetConfig("xbuttonaddresschange")
   end if

   CartResponseWrite "<td class=""ac item_row"" width=""5%"">"
   url="shopdeliveryedit.asp?id=" & i
   url=addwebsess(url)
   if promptimage="" then
      response.write "<a href=""" & url & """>" & prompt  & "</a>"
   else
      response.write "<a href=""" & url & """><img src=""" & promptimage & """ alt="" "" /></a>"
   end if
   CartResponseWrite "</td>"
end sub

sub CartFormatProductTotal
   if pricehide <> false then exit sub

   '800 - 2015.07.01 - Bundled products: Better layout on cart summary section
   CartResponseWrite "<tr class=""computation_info"">"

   if instr(lcase(request.ServerVariables("SCRIPT_NAME")),"shopcreateorder.asp") > 0 then
      AddColumnSpacing_white
   end if

   AddColumnSpacing_white

   if instr(lcase(request.ServerVariables("SCRIPT_NAME")),"paypalproexpressreview.asp") > 0 or instr(lcase(request.ServerVariables("SCRIPT_NAME")),"shoppaypalexpress_updateprices.asp") > 0 then
	  CartResponseWrite "<td></td>"
   end if

   '800 - 2015.04.15 - Responsive Layout updated
   CartResponseWrite "<td colspan=""3"" class=""menuhdr"">" & GetLang("langProductCost") & "</td>"

   if getsess("CartCount") > 0 then
      CartResponseWrite "<td class=""ar item_row2"" style=""background-color:#FFFFFF"">" & ShopFormatCurrency(cartisubtotal,xxdecimalpoint) & "</td>"
   else
      if GetSess("Newcurrencysymbol")<>"" then
         CartResponseWrite "<td class=""ar item_row2 white-cell"" style=""background-color:#FFFFFF"">" & GetSess("Newcurrencysymbol") & "0.00" & "</td>"
      elseif GetConfig("XCurrencySymbol") <> "" then
         CartResponseWrite "<td class=""ar item_row2 white-cell	"" style=""background-color:#FFFFFF"">" & "0.00" & "</td>"
      else
         CartResponseWrite "<td class=""ar item_row2 white-cell"" style=""background-color:#FFFFFF"">" & "$" & "0.00" & "</td>"
      end if
   end if

   CartResponseWrite "</tr>"
end sub

sub CartFormatTotal
   '702 - 2012.08.07 - PayPal Enhancement
%>
<tr <%if lcase(session("paypalexpressshipping")) = "yes" then response.Write "id=""paypalexpresordertotal""" %>>
  <td class="white-cell">&nbsp;</td>
  <%'VP-ASP 6.50 - add edit link to shopcreateorder.asp
   if lcase(right(request.ServerVariables("SCRIPT_NAME"), len(request.ServerVariables("SCRIPT_NAME")) - instrrev(request.ServerVariables("SCRIPT_NAME"), "/"))) ="shopcreateorder.asp" then%>
  <td class="white-cell">&nbsp;</td>
   <%end if%>
  <%'800 - 2015.04.15 - Responsive Layout updated%>
  <%'800 - 2016.03.02 - Responsive Layout updated%>
  <th colspan="3" class="menuhdr"><%=GetLang("langProductTotal")%></th>
  <%'VP-ASP 6.09 - If xprice0 in use and total is zero, don't display xprice0 value%>
  <!--<%'="<td class=""ar item_row2"" style=""background-color:#FFFFFF""><span class='fontbold'>"%><%'= ShopFormatCurrency(carttotal,xxdecimalpoint) %></font></span></TD>-->
  <%
   dim checkForZero
   dim newtotal

   if getsess("CartCount") = 0 then
      newtotal = GetConfig("XCurrencySymbol") & formatNumber (carttotal, GetConfig("xdecimalpoint"))
   else
      newtotal = ShopFormatCurrency(carttotal,xxdecimalpoint)
   end if%>
  <%="<td class=""ar item_row2"" style=""background-color:#FFFFFF""><span class='fontbold'>"%><%= newtotal %></span>
  </td>
  <%'End fix%>
  <%
   CartResponseWrite "</tr>"
   SetSess "OrderTotal",carttotal
   SetSess "DualTotal",dualtotal
end sub

sub CartShippingMessage
   if GetSess("shipmessage")="" then exit sub
   if ucase(GetConfig("xshippingcalc")) = "FIXED" then exit sub
   If GetConfig("xgiftregistry")="Yes"  and GetSess(REGISTRANTID)<>"" then exit sub
   HtmlWrite "<p class=""ac"">"
   HtmlWrite GetSess("shipmessage") & "<br />"
   HtmlWrite "</p>"
end sub

'if an image is to be displayed we need to create a small table within the cell
'800 - 2015.04.15 - Responsive Layout updated
sub CartAddimage (percent, alignment, image, cartfields)
   if percent = "50%" AND instr(lcase(request.servervariables("script_name")), "shopcreateorder.asp") > 0 then
%>
   <td class="item_row" colspan="2" style="text-align:<%=alignment%>" width="<%=percent%>"><table border="0" cellpadding="1" cellspacing="1">
<%'702 - 2015.01.16 : Bug Fix: Improper cart items layout%>
      <tr>
        <td class="al "><img border="0" src="<%=image%>" alt=" " /></td> 
      </tr>
	  <tr>
        <td class="vm al"><%=CartFields%>
        </td>
      </tr>

    </table></td>
  <%
   else
%>
   <td class="item_row" style="text-align:<%=alignment%>" width="<%=percent%>"><table border="0" cellpadding="1" cellspacing="1">
<%'702 - 2015.01.16 : Bug Fix: Improper cart items layout%>
      <tr>
        <td class="al "><img border="0" src="<%=image%>" alt=" " /></td> 
      </tr>
	  <tr>
        <td class="vm al"><%=CartFields%>
        </td>
      </tr>
    </table></td>
<%
   end if
end sub

'6.50 - allow customers to upload images
sub AddUploadLink (i, productid)
   dim prompt, promptimage, url
   if isnull(ArrCart(cuploadimagerequired,i)) then ArrCart(cuploadimagerequired,i)=""
   dim comparevalue
   if instr(ucase(xdatabasetype), "MYSQL") > 0 then
      comparevalue = "1"
   else
      comparevalue =  "true"
   end if

   if lcase(ArrCart(cuploadimagerequired,i))<>comparevalue then
      prompt=""
   else
      if ArrCart(cgraphicname1,i)<>"" then
	     prompt=GetLang("languploadchange")
      else
	     prompt=GetLang("langupload")
      end if
   end if

   promptimage=""
   CartResponseWrite "<td class=""ac item_row"" width=""5%"">"
   url="shopcartitemfeatures.asp?productid=" & productid & "&amp;cartid=" & i
   url=addwebsess(url)
   response.write "<a href=""" & url & """>" & prompt  & "</a>"
   CartResponseWrite "</td>"
end sub

'add Hyperlink back to product
sub CartCreateHyperlink (name, CatalogId)
dim strmessage, strurl
if GetConfig("xcarthyperlink")<>"Yes" then exit sub

'6.5.1 - link to parent product instead of child
dim hyperrs
Set hyperrs = Server.CreateObject("ADODB.Recordset")
hyperrs.open "select higherCatalogId from products where CatalogId = " & CatalogId, dbc, adOpenStatic, adLockReadOnly
if not hyperrs.eof then
   if (not isnull(hyperrs("higherCatalogId")) OR (hyperrs("higherCatalogId") > "")) then
	  CatalogId = hyperrs("higherCatalogId")
   end if
end if
CloseRecordSet hyperrs

strurl=""& getconfig("xcrosslinkurl") &"?id=" & CatalogId
strurl=addwebsess(strurl)
strMessage="<a href='" & strURL & "'>" &  name & "</a>"
name=strmessage
end sub

sub CartUPSMessage
if GetSess("ShipMethodType") = "UPS Real-Time" then
%>
  <br />
  <table width="75%">
    <tr>
      <td class="vt"><img src="images/ups_logo_small.gif" alt="UPS" title="UPS" /></td>
      <td>NOTE: These fees do not necessarily represent UPS published rates and may include charges levied by the store owner.<br />
        <br />
        UPS, UPS brandmark, and the Color Brown are trademarks of United Parcel Service of America, Inc. All Rights Reserved.</td>
    </tr>
  </table>
  <%
end if
end sub

'800 - 2015.07.13 - View cart page: Better layout arrangement
sub DisplayTitle_v8 (percent, titlename, position)
   if titlename = getlang("langproduct01") then
      HtmlWrite "<th class=""menuhdr"" colspan="""& percent &""">" & TitleName & "</th>"
   else
  	  HtmlWrite "<th style=""text-align: "& position &""">" & TitleName & "</th>"
   end if
end sub
%>