<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' customer form routines
'*********************************************************************************

sub DisplayForm()
   '800 - 2015.04.15 - Bug Fix: Mobile normal checkout is not working
   session("load_shopcustomer_js") = "yes"

   '700 - 2010.08.16 - Bug Fix: Possible error if using other checkout tool   
   AddInformationTable
   
   '6.50 - if trying as a new customer, keep new customer flag on
   dim theaction
   if request.QueryString("New") > "" then
      '800 - Enhanced SEO
      HtmlWrite "<form name=""shipping"" method=""post"" action="""& DoFriendlySEOPage("shopcustomer.asp") &"?new=yes"">"
   else
      '800 - Enhanced SEO
      HtmlWrite "<form name=""shipping"" method=""post"" action="""& DoFriendlySEOPage("shopcustomer.asp") &""">"
   end if

   '700 - 2010.04.22 - cross site script security enhancement
   htmlwrite "<input type=""hidden"" name=""genpredefinedsecuritycode"" value="""& session("genpredefinedsecuritycode") &""" />"

   if GetSess("Login")<>"" and GetSess("Lastname")<>"" then
      AddSubmitButton "d"
   end if

   dim displayshoppingform
   displayshoppingform = true
   if not generate_shippingform_status then
      displayshoppingform = false
   end if
   dim displayotherform
   displayotherform = true
   if GetConfig("xenablesurcharge")="No" and GetConfig("xdeliverydate")<>"Yes" and GetConfig("xdeliverytime")<>"Yes" and GetConfig("xaffcustomerform")<>"Yes" and getconfig("xcheckoutcommentsenable") <> "Yes" and GetConfig("Xlicenseagreement")<>"Yes" and GetConfig("xGiftCertificates")<>"Yes" and GetConfig("xAllowCoupons")<>"Yes" and GetConfig("xPromptForOptional")<>"Yes" then
      displayotherform = false
   end if

   ShopCustomerForm displayshoppingform, displayotherform
   
   if displayshoppingform then
      AddShippingForm
   end if

   if GetConfig("xshippingundercustomer")<>"Yes" then
      HtmlWrite "<div class=""cb"">&nbsp;</div>" & vbCrLf
   end if

   if displayotherform then
      '800 - 2015.05.17 - Enhancement: Remove multiple steps on normal checkout (shopcustomer.asp) to make process much simple and smooth
      htmlwrite "<div id=""other_info""class=""customer-wrapper active"">"

      htmlwrite "<div class=""title mobile-view"">"

      '800 - 2015.08.03 - Responsive layout update
      htmlwrite "<h2 class=""mobile-view"">" & GetLang("langcommonoptions") & "</h2>"

      htmlwrite "</div>"
      AddSurchargeForm
      ShopDeliveryDate true
      ShopDeliveryTime true
      AddAffiliate
	  Addcomments
      AddLicense
      AddGiftCertificate
      AddDiscountCoupon
      AddOptionalStuff
	  AddSubmitButton "m"
	  htmlwrite "</div>"
   end if

   '800 - 2015.05.19 - Enhancemeht: Normal checkout: Guest checkout
   if lcase(right(request.ServerVariables("SCRIPT_NAME"),len(request.ServerVariables("SCRIPT_NAME")) - instrrev(request.ServerVariables("SCRIPT_NAME"), "/"))) = "shopcustomer.asp" then
      AddPassword

      '800 - 2015.05.20 - Better Guest Checkout process
	  AddCookieMessage
   end if

   AddSubmitButton "d"
   AddWebSessForm
   HtmlWrite "</form>"
'   if GetConfig("xshippingundercustomer")<>"Yes" then
'      HtmlWrite "</div>" & vbCrLf
'   end if
end sub

sub AddInformationTable
   if GetSess("Login")="" then
      HtmlWrite "<p class=""ac"">" & "<span class=""largeinfofont"">"

      '800 - 2015.05.19 - Message: Should use common routine shopwriteheader
	  ShopWriteHeader ""& GetLang("langCustomerPrompt") & ""

	  HtmlWrite "</span>" & "</p>"
   end if

   '800 - 2015.05.18 - Better Layout arrangement on normal checkout (shopcustomer.asp)
'   if GetConfig("xshippingform")="Yes" or GetConfig("xshippingselection")="Yes" then
'      '6.50 - hide this message if purchasing for a registry
'      if GetSess(REGISTRANTID)<>"" then
'      else
'  	     '700 - Free Shipping Products enhancement
'         if CheckNonShippingItems=false then
'		    HtmlWrite "<span class=""desktop-view""><p class=""ac"">" & "<span class=""largeinfofont"">"
'	        ShopWriteHeader ""& GetLang("langShip02") & ""
'			HtmlWrite "</span>" & "</p></span>"
'         end if
'      end if
'   end if
end sub

sub AddSubmitButton_old
   '750 - Include captcha
   '800 - 2015.05.01 - Enhancement: Layout updates
   HtmlWrite "<div class=""std_table std_table_customer ar pull-right"">"

   ShopButton GetConfig("xbuttoncontinue"),trim(GetLang("langCommonContinue")),""
   HtmlWrite "</div>"

   '800 - 2015.05.01 - Enhancement: Layout updates
   htmlWrite "<div class=""row""></div>"
end sub

'Should affiliate info be generated in form
sub AddAffiliate
   if GetConfig("xaffcustomerform")<>"Yes" then exit sub
   straffid=GetSess("affid")
   if straffid<>"" then
      if isnumeric(straffid) then
         straffid=clng(straffid)
      end if
   end if

   ShopWriteHeaderBox GetLang("LangAff")
   CreateFieldSetRow  GetLang("LangAffID"),"straffid",straffid,"",""
   htmlwrite "<div class=""row"">"
   htmlwrite "<div class=""col-sm-5"">"
   HtmlWrite "<label>" & GetLang("langaff") & "</label>"
   htmlwrite "</div>"
   htmlwrite "<div class=""col-sm-7"">"
   GenerateTableV dbc,"affiliates","affid","company","lastname",straffid,"straffid1", "company", GetLang("langcommonselect"), ""
   htmlwrite "</div>"
   htmlwrite "<div class=""cb""></div>"
   htmlwrite "</div>"
   ShopWriteFooterBox "yes"
end sub

'adds a license url to display
sub AddLicense
   dim blnlicense
   dim licenseurl

   '6.50 - precautionary security fix
   blnlicense=CleanChars(Request.Form("blnlicense"))

   if blnlicense="" then
      blnlicense=GetSess("Licenseagreement")
   end if
   licenseurl=GetConfig("Xlicenseurl")
   if GetConfig("Xlicenseagreement")<>"Yes" then exit sub
   if licenseurl="" then exit sub
   ShopWriteHeaderBox GetLang("langLicenseAgreement")
   htmlwrite "<div align=""center"">"
   HtmlWrite "<iframe src=""" & licenseurl & """ class=""txtfield""></iframe>"
   htmlwrite "</div>"
   htmlwrite "<span>"

   '800 - 2015.05.18 - Better Layout arrangement on normal checkout (shopcustomer.asp)
   if blnlicense<>""  then%>
<input type="checkbox" name="blnlicense" value="true" checked="checked" />
<%else%>
<input type="checkbox" name="blnlicense" value="true" />
<%
   end if
   '800 - 2015.05.18 - Better Layout arrangement on normal checkout (shopcustomer.asp)
   response.write "&nbsp;&nbsp;&nbsp;"
   htmlwrite "" & GetLang("langlicenseagreementcheck") & ""

   htmlwrite "<div class=""cb""></div>"
   HtmlWrite "</span>"
   ShopWriteFooterBox "yes"
   '6.50 - add flag to order to say customer has agreed to terms
   SetSess "blnlicense", blnlicense
end sub

sub AddGiftCertificate
   if GetConfig("xGiftCertificates")<>"Yes" then exit sub
   '6.50 - hide gift cert option if creating registry
   if GetSess(REGISTRANTID)<>"" then exit sub
   ShopWriteHeaderBox GetLang("langGiftEnter")
   strGiftCertificate=GetSess("GiftCertificate")
   CreateFieldSetRow GetLang("langGiftCertificate"), "strGiftcertificate", strgiftcertificate,"No",""
   ShopWriteFooterBox "yes"
end sub

sub AddDiscountCoupon
   strcoupon=GetSess("coupon")
   if GetConfig("xAllowCoupons")<>"Yes" then exit sub

   '6.50 - hide coupon option if creating registry
   if GetSess(REGISTRANTID)<>"" then exit sub
   ShopWriteHeaderBox GetLang("langCustCouponPrompt")
   CreateFieldSetRow  GetLang("langCouponDiscount"),"strCoupon",strCoupon,"",""
   ShopWriteFooterBox "yes"
end sub

sub AddOptionalStuff
   if GetConfig("xPromptForOptional")="Yes" then
      ShopWriteHeaderBox GetLang("langCust02")
      CreateFieldSetRow GetLang("langCustWebsite"), "strwebsite", strwebsite,"No",""
      CreateFieldSetRow GetLang("langCustWorkphone"), "strWorkphone", strWorkPhone, "No",""
      CreateFieldSetRow GetLang("langCustMobilephone"), "strMobilephone", strMobilePhone, "No",""
      CreateFieldSetRow GetLang("langCustFax"), "strFax", strFax, "No",""
      ShopWriteFooterBox "yes"
   end if
end sub

'6.08 - Address2 is now copied across
'***********************************************************
sub AddCopyAcross%>
<script type="text/javascript" language="javascript">
<!-- Begin Shipping information transfer
var shipFirst = "";
var shipLast = "";
var shipCompany = "";
var shipAddress = "";
var shipCity = "";
var shipState = "";
var shipZip = "";
var shipCountry = "";
<%if GetConfig("xcustomeraddress2") = "Yes" then%>
var shipAddress2 = "";
<%end if%>
function InitSaveVariables(form) {
shipFirst = form.strfirstname.value;
shipLast = form.strlastname.value;
shipCompany = form.strcompany.value;
shipAddress = form.straddress.value;
<%if GetConfig("xcustomeraddress2") = "Yes" then%>
shipAddress2 = form.straddress2.value;
<%end if%>
shipCity = form.strcity.value;
shipZip = form.strpostcode.value;
<%if GetConfig("xpromptforstate") = "Yes" then%>
shipState = form.strstate.value;
<%end if%>
<%if GetConfig("xpromptforcountry") = "Yes" then%>
shipCountry = form.strcountry.value;
<%end if%>
}
function ShipToBillPerson(form) {
if (form.copy.checked) {
InitSaveVariables(form);
form.shipname.value = form.strfirstname.value + " " + form.strlastname.value;
form.shipcompany.value = form.strcompany.value;
form.shipaddress.value = form.straddress.value;
<%if GetConfig("xcustomeraddress2") = "Yes" then%>
form.shipAddress2.value =form.straddress2.value;
<%end if%>
form.shiptown.value = form.strcity.value;
<%if GetConfig("xpromptforstate") = "Yes" then%>
form.shipstate.value = form.strstate.value;
<%end if%>
form.shipzip.value = form.strpostcode.value;
<%if GetConfig("xpromptforcountry") = "Yes" then%>
form.shipcountry.value = form.strcountry.value;
<%end if%>
}
else {
form.shipname.value = "";
form.shipcompany.value = "";
form.shipaddress.value = "";
<%if GetConfig("xcustomeraddress2") = "Yes" then%>
form.shipAddress2.value = "";
<%end if%>
form.shiptown.value = "";
form.shipzip.value = "";
<%if GetConfig("xpromptforstate") = "Yes" then%>
form.shipstate.value = "";
<%end if%>
<%if GetConfig("xpromptforcountry") = "Yes" then%>
form.shipcountry.value = "";
<%end if%>
}
}
// End Shipping info transfer-->
</script>
<%'800 - 2015.10.26 - Site speed enhancement%>
<script type="text/javascript">
<!--
//'800 - 2016.09.20 - Browser auto refresh JS/CSS files wihout hard refresh
jQl.loadjQdep('js/shopajaxshipping.js?<%=getfilelastupdatedate("js/shopajaxshipping.js")%>');
-->
</script>
<%
end sub

sub AddSubmitButton (passtype)
   dim viewstring
   select case lcase(passtype)
      case "d"
	     viewstring = "desktop-view"
	  case "m"
	     viewstring = "mobile-view"
   end select
   '800 - 2015.05.01 - Enhancement: Layout updates
   HtmlWrite "<div class=""std_table std_table_customer ar pull-right "& viewstring &""">"

   ShopButton GetConfig("xbuttoncontinue"),trim(GetLang("langCommonContinue")),""
   HtmlWrite "</div>"

   '800 - 2015.05.01 - Enhancement: Layout updates
   HtmlWrite "<div class=""row""></div>"
end sub

sub Addcomments
   if getconfig("xcheckoutcommentsenable") <> "Yes" then exit sub
   ShopWriteHeaderBox GetLang("langCreate06")
   htmlwrite "<div class=""row"">"
   htmlwrite "<div class=""col-sm-5""><label>"& getlang("langcommoncomments") &"</label>"
   htmlwrite "</div>"
   htmlwrite "<div class=""col-sm-7"">"
   HtmlWrite "<textarea rows=""3"" name=""shipcomment"" cols=""50"" class=""txtfield form-control"">" & strshipcomment & "</textarea>"
   HtmlWrite "</div>"
   HtmlWrite "</div>"
   ShopWriteFooterBox "yes"
end sub

'800 - 2015.04.15 - Bug Fix: Mobile normal checkout is not working
sub load_shopcustomer_js
   if lcase(session("load_shopcustomer_js")) <> "yes" then exit sub
%>
<script type="text/javascript">
<!--
//800 - 2015.10.26 - Site speed enhancement
//'800 - 2016.09.20 - Browser auto refresh JS/CSS files wihout hard refresh
jQl.loadjQdep('js/checkout/shopcustomer_mobile.js?<%=getfilelastupdatedate("js/checkout/shopcustomer_mobile.js")%>');
-->
</script>
<%
   session("load_shopcustomer_js") = ""
end sub
%>