<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' This routine calculates handling fee for VP-ASP
' Inputs are
' subtotal - price of of products order
' total - price including shipping
' shippingcost  cost of shipping
' handling this value needs to be set and returned
'*********************************************************************************

sub CalculateHandling (subtotal, total, shippingcost, handling)
   Handling = 0
   if GetConfig("xhandlingPrice")<>"" then
      Handling = GetConfig("xhandlingPrice")
   end if
   if GetConfig("xhandlingbyproduct")<>"" then
      Calculatehandlingbyproduct handling
   end if
end sub

'read product record. If there is a handling cost then use it
'If also have  xhandinlngcombine and it is a sub product
'get the handling cost of the parent product and add to cost
sub Calculatehandlingbyproduct (handling)
   dim handlingfield
   handlingfield = GetConfig("xhandlingbyproduct")
   dim productname, quantity, price
   dim scartitem, ArrCart, productid, productcode, handlingforitem
   dim handlingamount

   '6.50 - parent/child handling costs
   dim parenthandling

   dim i
   dim productql
   dim rsitem

   scartItem = GetSess("CartCount") ' number of products
   ArrCart = GetSessa("CartArray")
   for i = 1 to scartItem
      productid = ArrCart(cProductid, i)
      productcode = ArrCart(cProductCode, i)
      productname = ArrCart(cProductname, i)
      quantity = ArrCart(cQuantity, i)
      Price = ArrCart(cUnitPrice, i)
      productql = "select * from products where CatalogId=" & productid
      Set rsItem = Server.CreateObject("ADODB.Recordset")
      rsItem.open Productql, dbc, adOpenDynamic, adLockOptimistic
      handlingforitem = 0
      if not rsItem.eof then
         '6.50 - parent/child handling costs
         handlingamount = 0

         if not isnull(rsitem(handlingfield)) then
            handlingamount = rsitem(handlingfield)
            '800 - 2015.05.25 - Better handling on numeric value for handling cost
            handlingamount = cdbl(handlingamount)
            handlingforItem = cdbl(Quantity) * cdbl(handlingamount)
         end if

         '6.50 - parent/child handling costs
         ' get parent handling cost
         Getparenthandlingcost dbc, rsitem, parenthandling, handlingfield
         ' It is easy if we are combining them
         if GetConfig("xhandlingcombine") = "Yes" then
            '800 - 2015.05.25 - Better handling on numeric value for handling cost
            handlingamount = cdbl(handlingamount) + cdbl(parenthandling)
         else
            if handlingamount = 0 then
               '800 - 2015.05.25 - Better handling on numeric value for handling cost
               handlingamount = cdbl(parenthandling) ' parent take prference
            end if
         end if
         ' regardless of where we got them not calculate the current amount
         '800 - 2015.05.25 - Better handling on numeric value for handling cost
         handlingforItem = cdbl(Quantity) * cdbl(handlingamount)

      end if
      '800 - 2015.05.25 - Better handling on numeric value for handling cost
      handling = cdbl(handling) + cdbl(handlingForItem)

      '702 - 2012.09.18 - Bug Fix : Better handling on discount, handling, tax value
      '800 - 2015.05.25 - Better handling on numeric value for handling cost
	  handling = formatnumber(handling,GetConfig("xdecimalpoint"))

      CloseRecordSet rsitem
   next
end sub

'6.50 - parent/child handling costs
'is this product has a parent product, then get parent product handling cost
sub Getparenthandlingcost (dbc, rsitem, parenthandling, handlingfield)
   dim productsql, rs
   parenthandling = 0
   dim subCatalogId, higherCatalogId
   higherCatalogId = rsitem("higherCatalogId")
   if isnull(higherCatalogId) then exit sub
   if higherCatalogId = 0 then exit sub
   productsql = "select * from products where CatalogId=" & higherCatalogId
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open Productsql, dbc, adOpenDynamic, adLockOptimistic
   if not rs.eof then
      if not isnull(rs(handlingfield)) then
         parenthandling = rs(handlingfield)
         parenthandling = csng(parenthandling)
      end if
   end if
   CloseRecordSet rs
end sub
%>