<!-- #include file="shoplayoutmgrtopheaderbox.asp" -->
<!-- #include file="shoplayoutmgsliderbanners.asp" -->
<%
const layoutmgr_delimiter = "[-***-]"
dim layoutmgr_delimiter_len
layoutmgr_delimiter_len = len(layoutmgr_delimiter)
const hide_to_mobile_str = "hide-to-mobile"

sub ParseRecord_split (record,words,wordcount,delimiter)
   dim prevalue,x
   prevalue = Split(record,delimiter)
   wordcount = 0
   for each x in prevalue
      words(wordcount) = x
      wordcount = wordcount + 1
   next
end sub

function getotheroptions(containerdivname,containername,id,optionsnumber)
   if trim(containerdivname) = "" then
      getotheroptions = ""
	  exit function
   end if
   if lcase(trim(id)) = "empty" then
      getotheroptions = ""
	  exit function
   end if
   if lcase(trim(optionsnumber)) = "" then
      getotheroptions = ""
	  exit function
   end if
   dim sqlrs,strsql, tempstring
   '800 - 2015.04.15 - Change table containerbox to containerbox_v8 for version 8 stores to avoid conflict with V7
   strsql="select otheroptions"& optionsnumber &" from containerbox_v8 where containerdivname = "& sqlserverprefixn &"'"& containerdivname &"'"
   if trim(containername) <> "" then
      if lcase(containername) <> "any" then
         strsql = strsql & " and containername = "& sqlserverprefixn &"'"& containername &"' "
      else
	     strsql = strsql & " and containername <> '' "
	  end if
   else
      strsql = strsql & " and (containername = '' or containername is null) "
   end if
   if trim(id) <> "" then strsql = strsql & " and id = "& id &" "
   GenLayoutMgrStorematchSQL "and", strsql
   tempstring = ""
   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   '800 - 2015.04.15 - Layout Manager: Improve speed performance
   sqlrs.open strsql, dbc, adOpenStatic, adLockReadOnly
   if not sqlrs.eof then
      tempstring = sqlrs("otheroptions"& optionsnumber &"")
   end if
   closerecordset sqlrs
   if isnull(tempstring) then tempstring = ""
   getotheroptions = tempstring
end function

sub load_header_language(sqlrs, fromwhere)
   if lcase(sqlrs("otheroptions1")) <> "yes" then exit sub
   dim languages, langcount, force, i, name
   force = ""
   Readlanguages languages, langcount, Force
   dim url
   dim urlbit, newqs, urldelim
   if langcount <= 0 then exit sub
   dim childstr
   childstr = ""
   for i = 0 to langcount -1
      name = languages(i)
      url = xmysite2 & "/shoplanguageset.asp?LG=" & server.urlencode(name)
      if request.QueryString > "" then
         urldelim = ""
         newqs = ""
         for each urlbit in request.QueryString
            if CleanChars(request.QueryString(urlbit)) > "" then
               newqs = newqs & urldelim & CleanChars(urlbit) & "=" & CleanChars(request.QueryString(urlbit))
               urldelim = "&amp;"
            end if
         next
         if right(newqs, 1) = "&amp;" then
            newqs = CleanChars(left(newqs, len(newqs) - 1))
         end if
         if newqs > "" then
            url = url & "&amp;" & newqs
         end if
      end if
      url = addwebsess(url)
	  childstr = childstr & "<li><a href="""& url &""">"& name &"</a></li>"
   next
   dim currentlang, labelpass, labelstring, caretstring, checklabelfield
   select case lcase(fromwhere)
      case "topheaderleftbox"
		 caretstring = "fa fa-caret-down"
		 checklabelfield = "labelfield"
      case "welcomeboxsquare"
		 caretstring = "fa fa-caret-down"
		 checklabelfield = "otheroptions3"
   end select
   currentlang = GetSess("language")
   labelpass = false
   if isnull(sqlrs(checklabelfield)) = false then
	  if trim(sqlrs(checklabelfield)) <> "" then
	     labelpass = true
	  end if
   end if

   '800 - 2016.03.31 - Enhancement: Site speed enhancement
   dim displaystring
   displaystring = ""

   if labelpass then
      labelstring = translatehpmgrcaptions(sqlrs(checklabelfield)) & ": "

      '800 - 2016.03.31 - Enhancement: Site speed enhancement
	  displaystring = "<a data-toggle=""dropdown"" class=""dropdown-toggle"" href=""#"">"& labelstring &"<span class=""language"">"& currentlang &"</span><span class="""& caretstring &"""></span></a>"& vbcrlf
   else
      labelstring = ""

      '800 - 2016.03.31 - Enhancement: Site speed enhancement
	  displaystring = "<a data-toggle=""dropdown"" class=""dropdown-toggle"" href=""#"">"& currentlang &"<span class="""& caretstring &"""></span></a>"& vbcrlf
   end if

   '800 - 2016.03.31 - Enhancement: Site speed enhancement
   displaystring = displaystring & "<ul role=""menu"" class=""dropdown-menu"" id=""language_dropdown_"& sqlrs("id") &""">"& vbcrlf
   displaystring = displaystring & childstr & vbcrlf
   displaystring = displaystring & "</ul>"
   Application("loadlayout_topheaderleftbox_language_changed" & xShopId) = ""
   Application("loadlayout_topheaderleftbox_language_" & xShopId) = displaystring
end sub

sub load_header_currency(sqlrs, fromwhere)
   if lcase(sqlrs("otheroptions1")) <> "yes" then exit sub
   SetSess "ReturnURL", request.ServerVariables("scriptname")
   SetSess "ReturnURL", right(GetSess("ReturnURL"), instrrev(GetSess("ReturnURL"), "/"))

   '800 - 2016.03.31 - Enhancement: Site speed enhancement
   Readcurrency_dbsession
   dim cidcnt, icnt, cidary, fullunitnameary, currencysymbolary, theimageary
   dim cid, url, childstr, currentstr
   cidcnt = session("cidcnt")
   cidary = getsessa("cidary")
   fullunitnameary = getsessa("fullunitnameary")
   currencysymbolary = getsessa("currencysymbolary")
   theimageary = getsessa("theimageary")

   currentstr = ""
   childstr = ""

   '800 - 2016.03.31 - Enhancement: Site speed enhancement
   for icnt = 0 to (cdbl(cidcnt) - 1)
      cid = cidary(icnt)
      if cid = GetSess("cid") then
		 currentstr = ""& cidary(icnt) &""
      end if
	  url = xmysite2 &"/shopcurrency.asp?CID=" & cidary(icnt) & "&amp;goback=yes"
	  childstr = childstr &  "<li><a href="""& url &""">"& fullunitnameary(icnt) &"</a></li>"
   next

   dim currentlang, labelpass, labelstring, caretstring, checklabelfield
   select case lcase(fromwhere)
      case "topheaderleftbox"
		 caretstring = "fa fa-caret-down"
		 checklabelfield = "labelfield"
      case "welcomeboxsquare"
		 caretstring = "fa fa-caret-down"
		 checklabelfield = "otheroptions3"
   end select
   currentlang = GetSess("language")
   labelpass = false
   if isnull(sqlrs(checklabelfield)) = false then
	  if trim(sqlrs(checklabelfield)) <> "" then
	     labelpass = true
	  end if
   end if

   '800 - 2016.03.31 - Enhancement: Site speed enhancement
   dim displaystring
   displaystring = ""

   if labelpass then
      labelstring = translatehpmgrcaptions(sqlrs(checklabelfield)) & ": "

      '800 - 2016.03.31 - Enhancement: Site speed enhancement
	  displaystring = "<a data-toggle=""dropdown"" class=""dropdown-toggle"" href=""#"">"& labelstring &"<span class=""currency"">"& currentstr &"</span><span class="""& caretstring &"""></span></a>"& vbcrlf
   else
      labelstring = ""

      '800 - 2016.03.31 - Enhancement: Site speed enhancement
	  displaystring = "<a data-toggle=""dropdown"" class=""dropdown-toggle"" href=""#"">"& currentstr &"<span class="""& caretstring &"""></span></a>"& vbcrlf
   end if

   '800 - 2016.03.31 - Enhancement: Site speed enhancement
   displaystring = displaystring & "<ul role=""menu"" id=""currency_dropdown_"& sqlrs("id") &""" class=""dropdown-menu"">" & vbcrlf
   displaystring = displaystring & childstr & vbcrlf
   displaystring = displaystring & "</ul>"
   Application("loadlayout_topheaderleftbox_currency_changed" & xShopId) = ""
   Application("loadlayout_topheaderleftbox_currency_" & xShopId) = displaystring
end sub

sub load_header_search(sqlrs, fromwhere)
   '800 - 2015.05.17 - Bug Fix: Predictive search is not working properly if xlogonrequired have been set to Yes
   if lcase(GetConfig("xlogonrequired")) = "yes" then
      if trim(GetSess("customerid")) = "" then
	     exit sub
	  end if
   end if

   if lcase(sqlrs("otheroptions1")) <> "yes" then exit sub
   dim checklabelfield, classtring, labelstring
   select case lcase(fromwhere)
      case "topheaderleftbox"
		 classtring = "search"
		 checklabelfield = "labelfield"
      case "welcomeboxsquare"
         '800 - 2015.08.03 - Responsive layout update
		 classtring = ""

		 checklabelfield = "otheroptions3"
   end select
   if isnull(sqlrs(checklabelfield)) = false then
	  if trim(sqlrs(checklabelfield)) <> "" then
	     labelstring = translatehpmgrcaptions(sqlrs(checklabelfield))
	  end if
   end if
%>
   <div class="<%=classtring%>">
      <form method="post" action="<%=DoFriendlySEOPage("shopsearch.asp")%>?search=Yes" id="<%=fromwhere%>form" name="<%=fromwhere%>form">
      <div class="input-group input-group-custom margin-top-5">
<%
   if getconfig("xAjaxSearchEnable") = "No" or getconfig("xLoadJLibJQuery") = "No" then
%>
      <input type="text" class="searchfield form-control" name="keyword" size="19" placeholder="<%=labelstring%>" onclick="clearfield(this.form)" />
<%
   else
%>
      <input type="text" class="searchfield form-control" name="keyword" size="19" placeholder="<%=labelstring%>" onclick="clearfield(this.form)" onkeyup="getproductdesc(this.value,'<%=fromwhere%>')" />
<%
   end if
%>
      <div class="input-group-btn">
         <button type="submit" class="spriteicons sprite-search fa fa-search  btn-search global-background-color"></button>
      </div>
      </div>
      </form>
      <div><span id="<%=fromwhere%>resultlist" class="searchresultwrapper"></span></div>
   </div>
<%
end sub

'writes each record to browser
sub ShopTemplateWrite_tostring (Filename, RS, orc, outputstrng)
dim i
dim NewRecord
dim recordObj, FsObj
dim rc
dim MyText
dim readcount
dim Bypass

'700 moving to Template folder
dim xTemplate
dim tempfilename,tempfilename2
xTemplate= xmysite2 & "/" & "Templates/" & GetConfig("xTemplate") & "/"
tempfilename=xTemplate & Filename
tempfilename2=Filename

OpenInputFile tempfilename, fsObj, RecordObj, rc
if rc> 0 then
   ShopWriteError  GetLang("LangReadFail")  & tempfilename
   orc=4
   exit sub
end if
dim parsearray, fieldnames, fieldvalues, fieldtypes, fieldcount

'701 - 2010.12.01 - Bug Fix: Possible error if fields are more than 150 for templates
'800 - 2015.07.20 - Better handling on number of fileds on templates
redim fieldnames(300)
redim fieldvalues(300)
redim fieldtypes(300)

redim parsearray(Pparseattributes)
readcount=0
GetFieldValues RS, fieldnames, fieldvalues, fieldtypes, fieldcount
SetupParseArray Parsearray, tempfilename2, rs, fieldnames, fieldvalues, fieldtypes, fieldcount, fsobj, recordobj
Parsearray(pTemplateDisplay)="Yes"
ReadARecord RecordObj, MyText, rc, parsearray
do while rc=0
   Substitute mytext, NewRecord, Bypass, parsearray, rs
   if Bypass=False  then
      outputstrng = outputstrng & NewRecord & vbcrlf
   end if
   readcount=readcount+1
   ReadARecord RecordObj, MyText, rc, parsearray
loop
CloseFile fsObj,RecordObj, rc, parsearray
orc=0
end sub

sub generate_class_process
   session("centerboxclass") = ""
   session("leftboxclass") = ""
   session("rightboxclass") = ""
   dim centerstatus,leftstatus,rightstatus
   centerstatus = getotheroptions("centerbox","","",1)
   leftstatus = getotheroptions("leftsidebox","","",1)
   rightstatus = getotheroptions("rightsidebox","","",1)
   if session("leftsidebar_disable") = "yes" then
      leftstatus = "no"
   end if
   if session("rightsidebar_disable") = "yes" then
      rightstatus = "no"
   end if
   select case lcase(centerstatus)
      case "yes"
	     select case lcase(leftstatus)
		    case "yes"
			   select case lcase(rightstatus)
			      case "yes"
                     session("centerboxclass") = "col-md-6 col-sm-12 col-md-push-3 col-xs-12 mobile-wrapper"
                     session("leftboxclass") = "col-md-3 col-sm-6 col-xs-12 col-md-pull-6 mobile-wrapper"
                     session("rightboxclass") = "col-md-3 col-sm-6 col-xs-12 mobile-wrapper"
				  case else
                     session("centerboxclass") = "col-md-9  col-sm-8 col-md-push-3 col-xs-12 mobile-wrapper"
                     session("leftboxclass") = "col-md-3 col-sm-4 col-xs-12 col-md-pull-9 mobile-wrapper"
                     session("rightboxclass") = ""
			   end select
			case else
			   select case lcase(rightstatus)
			      case "yes"
                     session("centerboxclass") = "col-md-9 col-sm-8 col-xs-12 mobile-wrapper"
                     session("leftboxclass") = ""
                     session("rightboxclass") = "col-md-3 col-sm-4 col-xs-12 mobile-wrapper"
				  case else
                     session("centerboxclass") = "col-md-12 col-sm-12 col-xs-12 mobile-wrapper"
                     session("leftboxclass") = ""
                     session("rightboxclass") = ""
			   end select
		 end select
	  case else
         session("centerboxclass") = "col-md-6 col-sm-12 col-md-push-3 col-xs-12 mobile-wrapper"
         session("leftboxclass") = "col-md-3 col-sm-6 col-xs-12 col-md-pull-6 mobile-wrapper"
         session("rightboxclass") = "col-md-3 col-sm-6 col-xs-12 mobile-wrapper"
   end select
end sub

sub generate_centerbox_class
   response.write session("centerboxclass")
end sub

sub generate_carousel_noslide_dekstop_header (passstring)
   passstring = passstring & "<div class=""product_widgets carousel slide desktop-view"">"
end sub

sub generate_carousel_noslide_mobile_header (passstring)
   passstring = passstring & "<div class=""product_widgets row mobile-view"">"
end sub

'800 - 2016.02.26 - Layout Manager: Products: To have option Auto Rotate
sub generate_carousel_slide_dekstop_header (passstring, autorotate, rotatespeed)
   '800 - 2016.02.26 - Layout Manager: Products: To have option Auto Rotate
   dim rotatestatus
   if lcase(trim(autorotate)) = "no" or trim(autorotate) = "" then
      rotatestatus = "false"
   else
      if trim(rotatespeed) = "" then
	     rotatespeed = "3000"
      end if
      rotatestatus = rotatespeed
   end if
   passstring = passstring & "<div class=""product_widgets carousel slide desktop-view"" data-interval="""& rotatestatus &""" data-ride=""carousel"">"

   passstring = passstring & "<div class=""carousel-inner"">"
end sub

'800 - 2016.02.26 - Layout Manager: Products: To have option Auto Rotate
sub generate_carousel_slide_mobile_header (passstring, autorotate, rotatespeed)
   '800 - 2016.02.26 - Layout Manager: Products: To have option Auto Rotate
   dim rotatestatus
   if lcase(trim(autorotate)) = "no" or trim(autorotate) = "" then
      rotatestatus = "false"
   else
      if trim(rotatespeed) = "" then
	     rotatespeed = "3000"
      end if
      rotatestatus = rotatespeed
   end if
   passstring = passstring & "<div  class=""product_widgets carousel slide mobile-view"" data-interval="""& rotatestatus &""" data-ride=""carousel"">"

   passstring = passstring & "<div class=""carousel-inner"">"
end sub

sub generate_carousel_prev_next (passstring)
   passstring = passstring & "<a class=""left carousel-control prevbtn"" href=""#"" role=""button"" data-slide=""prev"">"
   passstring = passstring & "<span class=""fa fa-chevron-left"" aria-hidden=""true""></span>"
   passstring = passstring & "<span class=""sr-only"">"& getlang("langprevious") &"</span>"
   passstring = passstring & "</a>"
   passstring = passstring & "<a class=""right carousel-control nextbtn"" href=""#"" role=""button"" data-slide=""next"">"
   passstring = passstring & "<span class=""fa fa-chevron-right"" aria-hidden=""true""></span>"
   passstring = passstring & "<span class=""sr-only"">"& getlang("langnext") &"</span>"
   passstring = passstring & "</a>"
end sub

'800 - 2015.04.10 - Better loading categories speed improvement
'800 - 2015.04.15 - Enahncement: Loading categories speed performance
sub loadlayout_categories_once
   '800 - 2015.05.10 - Bug Fix: Multiple site showing same side/mobile categories
   if session("site_xShopId") <> xshopid then
      session("loadlayout_categories_once") = ""
      session("site_xShopId") = xshopid
   end if

   '800 - 2016.03.01 - Enhancement: Site speed enhancement
   load_categories_nologin "yes"

   if session("loadlayout_categories_once") = "yes" then exit sub
   dim catcount,maxcategories
   if trim(catcount) = "" then catcount = 0
   if lcase(xsavesession) = "yes" then
      catcount = 0
   end if
   if catcount = 0 then
      maxcategories = GetConfig("xmaxcategories")
   end if
   dim mobiledropflag, desktopdropflag, flyoutflag
   getlayout_categories_status mobiledropflag, desktopdropflag, flyoutflag
   dim filterfieldstring
   dim xsortcategories, xsortcategoriesary(99), xsortcategoriescnt, xsortcategoriesicnt
   xsortcategories = GetConfig("xsortcategories")
   parserecord xsortcategories,xsortcategoriesary,xsortcategoriescnt,","
   if xsortcategories <> "" then
      '800 - 2015.09.11 - Better handlling on configuration xsortcategories that able to handle DESC and ASC
      dim xsortcategoriesaryind

      filterfieldstring = "categoryid,catdescription,hassubcategory"
	  for xsortcategoriesicnt = 0 to (xsortcategoriescnt-1)
	     '800 - 2015.09.11 - Better handlling on configuration xsortcategories that able to handle DESC and ASC
   	     xsortcategoriesaryind = xsortcategoriesary(xsortcategoriesicnt)
	     xsortcategoriesaryind = replace(lcase(xsortcategoriesaryind)," desc","")
	     xsortcategoriesaryind = replace(lcase(xsortcategoriesaryind)," asc","")
	     if lcase(xsortcategoriesaryind) <> "categoryid" and lcase(xsortcategoriesaryind) <> "catdescription" and lcase(xsortcategoriesaryind) <> "hassubcategory" then
		    filterfieldstring = filterfieldstring & "," & xsortcategoriesaryind &""
		 end if		 
	  next
   else
	  filterfieldstring = "categoryid,catdescription,hassubcategory"
   end if
   dim catsql, catrs
   dim cid, catname, hassubcategory, totallevels, totalcatcount
   dim mylink_desktop, mylink_mobile, mylinkcount, mylink_desktop_normal
   dim mylink2_mobile, mylink2_desktop
   redim categories_mobile(maxcategories)
   redim categories_desktop(maxcategories)
   redim categories_normal(maxcategories)
   mylink_desktop = ""
   mylink_desktop_normal = ""
   mylink_mobile = ""
   mylinkcount = 0
   mylink2_mobile = ""
   mylink2_desktop = ""
   dim gensubflag_mobile, gensubflag_desktop
   gensubflag_mobile = false
   gensubflag_desktop = false
   catSQL = "Select "& filterfieldstring &" from categories where highercategoryid=0 and cathide is null "
   if GetConfig("xproductmatch") = "Yes" then
      catsql = catsql & " and "
      Generateproductmatchsqlsubscat catsql
   end if
   catsql = catsql & GenerateCustomerMatchSQL ("customermatch","excustomermatch","loggedin","and")
   if GetConfig("xselectproductsbylanguage") = "Yes" and GetSess("language")<>"" then
      catsql = catsql & " and (catlanguage="& sqlserverprefixn &"'" & GetSess("language") & "'"
      catsql = catsql & " or catlanguage is null)"
   end if
   '800 - 2015.04.30 - Enhancement: Loading side/mobile categories in Ajax to improve first load speed
   catSQL = catsql & " order by " & xsortcategories
   Set catrs = Server.CreateObject("ADODB.Recordset")
   '800 - 2015.04.30 - Enhancement: Loading side/mobile categories in Ajax to improve first load speed
   catrs.cursorlocation=aduseclient
   catrs.Open catsql,dbc,adOpenStatic,adLockReadOnly
   totalcatcount = -1
   while not catrs.eof and catcount<maxcategories
      gensubflag_mobile = false
	  gensubflag_desktop = false
      cid = catrs("categoryid")
      catname = catrs("catdescription")
      if isnull(catname) then catname = ""

	  '800 - 2015.10.20 - Category: Category name should not have any HTML tag
      catname = CMSRemoveHTML(TranslateLanguage(dbc, "categories", "catdescription", "categoryid", cid, catname))

      hassubcategory = catrs("hassubcategory")
      if isnull(hassubcategory) then
         hassubcategory = ""
      end if
      if hasSubcategory = "" then
         mylink_mobile = "<a href=""shopdisplayproducts.asp?id=" & cid & "&amp;cat=" & Server.URLEncode(replace(catname,"&amp;","&")) & addwebsesslink & """>"& catname &"</a>"

		 '800 - 2015.06.23 - Bug Fix: SEO Dynamic: Category is showing non-seo link on side widget
         genseocategoryproductlink mylink_mobile,cid,catname,catname,hasSubcategory,"Yes"

		 mylink_desktop = mylink_mobile
		 mylink_desktop_normal = mylink_mobile
      else
         if mobiledropflag then
		    gensubflag_mobile = true
            mylink_mobile = "<a href=""#"" onclick=""return false"">"& catname &"...</a>"
         else
		    gensubflag_mobile = false
	        mylink_mobile = "<a href=""shopdisplaycategories.asp?id=" & cid & "&amp;cat=" & Server.URLEncode(replace(catname,"&amp;","&")) & addwebsesslink & """>"& catname &"...</a>"
	 	    genseocategoryproductlink mylink_mobile,cid,catname,catname,hasSubcategory,"Yes"
         end if

	     if desktopdropflag then
		    gensubflag_desktop = true
            mylink_desktop = "<a href=""javascript:toggleMe('catnavcid"& cid &"')"">" & catname & "...</a>"
         elseif flyoutflag then
		    gensubflag_desktop = true
		    mylink_desktop = "<a href=""shopdisplaycategories.asp?id=" & cid & "&amp;cat=" & Server.URLEncode(replace(catname,"&amp;","&")) & addwebsesslink & """>" & catname & "...</a>"
	        genseocategoryproductlink mylink_desktop,cid,catname,catname,hasSubcategory,"Yes"
         else
		    gensubflag_desktop = false
			mylink_desktop_normal = "<a href=""shopdisplaycategories.asp?id=" & cid & "&amp;cat=" & Server.URLEncode(replace(catname,"&amp;","&")) & addwebsesslink & """>" & catname & "...</a>"
			genseocategoryproductlink mylink_desktop_normal,cid,catname,catname,hasSubcategory,"Yes"
		 end if
		 if gensubflag_mobile or gensubflag_desktop then
	        totallevels = 0
            generate_catsublinks cid, mylink2_mobile, mylink2_desktop, totallevels, totalcatcount, mobiledropflag, desktopdropflag, flyoutflag
			mylink_mobile = mylink_mobile & mylink2_mobile
			if desktopdropflag then
			   mylink_desktop = mylink_desktop & "<div id=""catnavcid"& cid &""" style=""display:none"" class=""submenulist"">" & mylink2_desktop & "</div>"
			else
			   mylink_desktop = mylink_desktop & mylink2_desktop
			end if
		 end if
      end if
      categories_mobile(mylinkcount) = mylink_mobile
	  categories_desktop(mylinkcount) = mylink_desktop
	  categories_normal(mylinkcount) = mylink_desktop_normal
      mylinkcount = cdbl(mylinkcount) + 1
	  catcount = cdbl(catcount) + 1
      catrs.MoveNext
   wend
   closerecordset catrs

   '800 - 2015.04.30 - Enhancement: Loading side/mobile categories in Ajax to improve first load speed
   dim j, tempstring, mylink
   dim mylink2, mylink3
   dim tempstring2, tempstring3
   tempstring = ""
   tempstring2 = ""
   tempstring3 = ""
   if desktopdropflag then
      tempstring2 = tempstring2 & "<ul class=""menulist"">"
   elseif flyoutflag then
	  tempstring2 = tempstring2 & "<ul id=""flyout1"">"
   end if
   if not desktopdropflag and not flyoutflag then
      tempstring3 = tempstring3 & "<ul class=""menulist"">"
   end if
   for j = 0 to mylinkcount -1
      mylink = categories_mobile(j)
	  tempstring = tempstring & "<li>" & vbcrlf
      tempstring = tempstring & mylink
	  tempstring = tempstring & "</li>" & vbcrlf
      mylink2 = categories_desktop(j)
	  tempstring2 = tempstring2 & "<li>"
      tempstring2 = tempstring2 & mylink2
	  tempstring2 = tempstring2 & "</li>"
      mylink3 = categories_normal(j)
	  tempstring3 = tempstring3 & "<li>"
      tempstring3 = tempstring3 & mylink3
	  tempstring3 = tempstring3 & "</li>"
   next
   tempstring2 = tempstring2 & "</ul>"
   tempstring3 = tempstring3 & "</ul>"
   session("loadlayout_categories_mobile") = tempstring
   session("loadlayout_categories_desktop") = tempstring2
   session("loadlayout_categories_normal") = tempstring3

   '800 - 2016.03.01 - Enhancement: Site speed enhancement
   if GetSess("Login") = "" then
      dim languagesess
      languagesess = session("language")
      if trim(languagesess) = "" then
         languagesess = GetConfig("xlanguage")
      end if
      languagesess = ucase(languagesess)
      Application("loadlayout_categories_mobile_"& languagesess &"" & "_" & xShopId) = tempstring
      Application("loadlayout_categories_desktop_"& languagesess &"" & "_" & xShopId) = tempstring2
      Application("loadlayout_categories_normal_"& languagesess &"" & "_" & xShopId) = tempstring3
   end if

   session("loadlayout_categories_once") = "yes"
   setsess "categories_catcount", catcount
   setsess "categories_totalcatcount", totalcatcount
   totalcatcount = cdbl(totalcatcount) + 1
end sub

'800 - 2015.04.10 - Better loading categories speed improvement
'800 - 2015.04.15 - Enahncement: Loading categories speed performance
sub generate_catsublinks (pcid, plink_mobile, plink_desktop, totallevels, catcount, mobiledropflag, desktopdropflag, flyoutflag)
   if pcid = "" then exit sub

   '800 - 2015.06.23 - Enhancement: Layout Manager: categories widget: To have levels of flyout/dropdown
   dim xcategory_flyout_levels
   xcategory_flyout_levels =  getconfig("xcategory_flyout_levels")
   if trim(xcategory_flyout_levels) = "" then xcategory_flyout_levels = 3
   if not isnumeric(xcategory_flyout_levels) then xcategory_flyout_levels = 3
   if cdbl(totallevels) >= cdbl(xcategory_flyout_levels) then exit sub

   dim catname, catSQL, cid
   dim catrs, hassubcategory
   dim filterfieldstring
   dim mylink_mobile, mylink2_mobile
   dim mylink_desktop, mylink2_desktop
   dim maxcategories, mylinkcount
   maxcategories = 1000
   redim categories_mobile(maxcategories)
   redim categories_desktop(maxcategories)
   mylink_mobile = ""
   mylink2_mobile = ""
   mylink_desktop = ""
   mylink2_desktop = ""
   mylinkcount = 0
   dim gensubflag_mobile, gensubflag_desktop
   gensubflag_mobile = false
   gensubflag_desktop = false

   '800 - 2015.04.30 - Enhancement: Loading side/mobile categories in Ajax to improve first load speed
   '800 - 2015.09.11 - Better handlling on configuration xsortcategories that able to handle DESC and ASC
   dim xsortcategories, xsortcategoriesary(99), xsortcategoriescnt, xsortcategoriesicnt

   xsortcategories = GetConfig("xsortcategories")
   if xsortcategories <> "" then
      '800 - 2015.09.11 - Better handlling on configuration xsortcategories that able to handle DESC and ASC
      dim xsortcategoriesaryind

      filterfieldstring = "categoryid,catdescription,hassubcategory"
	  for xsortcategoriesicnt = 0 to (xsortcategoriescnt-1)
	     '800 - 2015.09.11 - Better handlling on configuration xsortcategories that able to handle DESC and ASC
   	     xsortcategoriesaryind = xsortcategoriesary(xsortcategoriesicnt)
	     xsortcategoriesaryind = replace(lcase(xsortcategoriesaryind)," desc","")
	     xsortcategoriesaryind = replace(lcase(xsortcategoriesaryind)," asc","")
	     if lcase(xsortcategoriesaryind) <> "categoryid" and lcase(xsortcategoriesaryind) <> "catdescription" and lcase(xsortcategoriesaryind) <> "hassubcategory" then
		    filterfieldstring = filterfieldstring & "," & xsortcategoriesaryind &""
		 end if		 
	  next
   else
	  filterfieldstring = "categoryid,catdescription,hassubcategory"
   end if
   catSQL = "Select "& filterfieldstring &" from categories where highercategoryid="& pcid &" and cathide is null "
   if GetConfig("xproductmatch") = "Yes" then
      catsql = catsql & " and "
      Generateproductmatchsqlsubscat catsql
   end if
   catsql = catsql & GenerateCustomerMatchSQL ("customermatch","excustomermatch","loggedin","and")
   if GetConfig("xselectproductsbylanguage") = "Yes" and GetSess("language")<>"" then
      catsql = catsql & " and (catlanguage="& sqlserverprefixn &"'" & GetSess("language") & "'"
      catsql = catsql & " or catlanguage is null)"
   end if
   '800 - 2015.04.30 - Enhancement: Loading side/mobile categories in Ajax to improve first load speed
   catSQL = catsql & " order by " & xsortcategories
   Set catrs = Server.CreateObject("ADODB.Recordset")
   '800 - 2015.04.30 - Enhancement: Loading side/mobile categories in Ajax to improve first load speed
   catrs.cursorlocation=adUseServer
   catrs.Open catsql,dbc,adOpenStatic,adLockReadOnly
   if not catrs.eof then
      totallevels = cdbl(totallevels) + 1
      while not catrs.eof
         gensubflag_mobile = false
         gensubflag_desktop = false
	     catcount = cdbl(catcount) + 1
         cid = catrs("categoryid")
         catname = catrs("catdescription")
         if isnull(catname) then catname = ""

		 '800 - 2015.10.20 - Category: Category name should not have any HTML tag
         catname = CMSRemoveHTML(TranslateLanguage(dbc, "categories", "catdescription", "categoryid", cid, catname))

         hassubcategory = catrs("hassubcategory")
         if isnull(hassubcategory) then
            hassubcategory = ""
         end if
         if hasSubcategory = "" then
	    	mylink_mobile = "<a href=""shopdisplayproducts.asp?id=" & cid & "&amp;cat=" & Server.URLEncode(replace(catname,"&amp;","&")) & addwebsesslink & """>"& catname &"</a>"
	        genseocategoryproductlink mylink_mobile,cid,catname,catname,hasSubcategory,"Yes"
			mylink_desktop = mylink_mobile
         else
		    if mobiledropflag then
			   gensubflag_mobile = true
	           mylink_mobile = "<a href=""#"" onclick=""return false"">"& catname &"...</a>"
			else
			   gensubflag_mobile = false
		       mylink_mobile = "<a href=""shopdisplayproducts.asp?id=" & cid & "&amp;cat=" & Server.URLEncode(replace(catname,"&amp;","&")) & addwebsesslink & """>"& catname &"...</a>"
   		  	   genseocategoryproductlink mylink_mobile,cid,catname,catname,hasSubcategory,"Yes"
			end if
	        if desktopdropflag then
		       mylink_desktop = "<a href=""javascript:toggleMe('catnavcid"& cid &"')"">" & catname & "...</a>"
			   gensubflag_desktop = true
			elseif flyoutflag then
		       mylink_desktop = "<a href=""shopdisplaycategories.asp?id=" & cid & "&amp;cat=" & Server.URLEncode(replace(catname,"&amp;","&")) & addwebsesslink & """>"& catname &"...</a>"
 		       genseocategoryproductlink mylink_desktop,cid,catname,catname,hasSubcategory,"Yes"
			   gensubflag_desktop = true
            else
			   gensubflag_desktop = false
		    end if
   		    if gensubflag_mobile or gensubflag_desktop then
               generate_catsublinks cid, mylink2_mobile, mylink2_desktop, totallevels, catcount, mobiledropflag, desktopdropflag, flyoutflag
			   mylink_mobile = mylink_mobile & mylink2_mobile
			   if desktopdropflag then
			      mylink_desktop = mylink_desktop & "<div id=""catnavcid"& cid &""" style=""display:none"" class=""submenulist"">" & mylink2_desktop & "</div>"
			   else
			      mylink_desktop = mylink_desktop & mylink2_desktop
			   end if
		    end if
         end if
         categories_mobile(mylinkcount) = mylink_mobile
		 categories_desktop(mylinkcount) = mylink_desktop
         mylinkcount = cdbl(mylinkcount) + 1
         catrs.MoveNext
      wend
	  totallevels = cdbl(totallevels) - 1
   end if
   closerecordset catrs

   '800 - 2015.04.30 - Enhancement: Loading side/mobile categories in Ajax to improve first load speed
   dim j, plink, plink2
   plink=""
   plink2=""
   if cdbl(mylinkcount) > 0 then
      plink = plink & "<ul class=""2ndlevel-list"">" & vbcrlf
      if not flyoutflag then
         plink2 = plink2 & "<ul class=""menulist"">" & vbcrlf
      else
	     plink2 = plink2 & "<ul>" & vbcrlf
	  end if
      for j = 0 to mylinkcount -1
         plink = plink & "<li>"& categories_mobile(j) &"</li>" & vbcrlf
		 plink2 = plink2 & "<li>"& categories_desktop(j) &"</li>" & vbcrlf
      next
      plink = plink & "</ul>" & vbcrlf
	  plink2 = plink2 & "</ul>" & vbcrlf
   end if
   plink_mobile = plink
   plink_desktop = plink2
end sub

'800 - 2015.04.10 - Better loading categories speed improvement
'800 - 2015.04.15 - Enahncement: Loading categories speed performance
sub gensidecategories_fromsession (passstring)
   if GetConfig("Xnavigatecategories") = "No" then exit sub
   if GetConfig("xlogonrequired") = "Yes" then
      if GetSess("login") = "" then
         exit sub
      end if
   end if
   if GetConfig("init") = "" then exit sub
   '800 - 2015.04.30 - Enhancement: Loading side/mobile categories in Ajax to improve first load speed
   'loadlayout_categories_once
   htmlwrite passstring
end sub

'800 - 2015.04.15 - Enahncement: Loading categories speed performance
sub getlayout_categories_status (mobiledropflag, desktopdropflag, flyoutflag)
   dim sqlrs,strsql
   mobiledropflag = false
   desktopdropflag = false
   flyoutflag = false
   strsql = "select otheroptions3,containerdivname from containerbox_v8 where (containerdivname = 'headerlowerright' and (containername is null or containername = '')) "
   strsql = strsql & " or ((containerdivname = 'leftsidebox' or containerdivname = 'rightsidebox') and (containername = 'categories')) "
   GenLayoutMgrStorematchSQL "and", strsql
   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   sqlrs.open strsql, dbc, adOpenStatic, adLockReadOnly
   do while not sqlrs.eof
      if lcase(sqlrs("otheroptions3")) = "flyout" then
	     flyoutflag = true
	  end if
	  if lcase(sqlrs("containerdivname")) = "headerlowerright" then
         if lcase(sqlrs("otheroptions3")) = "dropdown" then
	        mobiledropflag = true
	     end if
      elseif lcase(sqlrs("containerdivname")) = "leftsidebox" or lcase(sqlrs("containerdivname")) = "rightsidebox" then
         if lcase(sqlrs("otheroptions3")) = "dropdown" then
	        desktopdropflag = true
	     end if
	  end if
	  sqlrs.movenext
   loop
   closerecordset sqlrs
end sub

'800 - 2015.04.30 - Enhancement: Loading side/mobile categories in Ajax to improve first load speed
sub load_sidemobile_cat_js
   if lcase(session("load_sidemobile_cat_js")) <> "yes" then exit sub
      '800 - 2015.05.08 - Enhancement: Side/Mobile Categories: Speed improvement for Ajax Category method
%>
<script type="text/javascript">
<!--
//800 - 2015.10.26 - Site speed enhancement
//'800 - 2016.09.20 - Browser auto refresh JS/CSS files wihout hard refresh
jQl.loadjQdep('js/categories/load_sidemobile_cat.js?<%=getfilelastupdatedate("js/categories/load_sidemobile_cat.js")%>');
-->
</script>
<%
   if lcase(session("load_sidemobile_cat_js")) = "yes" then
      '800 - 2015.05.08 - Enhancement: Side/Mobile Categories: Better handling on variable
%>
<script type="text/javascript">
<!--
var passtype_category = "flyout";
-->
</script>
<%
   end if
   if lcase(session("load_sidemobile_cat_normal_js")) = "yes" then
      '800 - 2015.05.08 - Enhancement: Side/Mobile Categories: Better handling on variable
%>
<script type="text/javascript">
<!--
var passtype_category = "normal";
-->
</script>
<%
   end if
   if lcase(session("load_sidemobile_cat_mobile_js")) = "yes" then
      '800 - 2015.05.08 - Enhancement: Side/Mobile Categories: Better handling on variable
%>
<script type="text/javascript">
<!--
var passtype_category2 = "mobile";
-->
</script>
<%
   '800 - 2015.05.08 - Enhancement: Side/Mobile Categories: Speed improvement for Ajax Category method
   elseif lcase(session("load_sidemobile_cat_mobile_loaded_js")) = "yes" then
%>
<script type="text/javascript">
<!--
var passtype_category = "loadedmobile";
-->
</script>
<%

   else
      '800 - 2015.05.08 - Enhancement: Side/Mobile Categories: Better handling on variable
%>
<script type="text/javascript">
<!--
var passtype_category2 = "";
-->
</script>
<%
   end if
   session("load_sidemobile_cat_js") = ""
   session("load_sidemobile_cat_fly_js") = ""
   session("load_sidemobile_cat_normal_js") = ""

   '800 - 2015.05.08 - Enhancement: Side/Mobile Categories: Speed improvement for Ajax Category method
   session("load_sidemobile_cat_mobile_js") = ""
   session("load_sidemobile_cat_mobile_loaded_js") = ""
end sub

'800 - 2015.05.10 - Enhancement: Ajax side/mobile topseller to make first load faster
sub load_sidemobile_topseller_js
   if lcase(session("load_sidemobile_topseller_js")) <> "yes" then exit sub
%>
<script type="text/javascript">
<!--
//800 - 2015.10.26 - Site speed enhancement
//'800 - 2016.09.20 - Browser auto refresh JS/CSS files wihout hard refresh
jQl.loadjQdep('js/topseller/load_sidemobile_topseller.js?<%=getfilelastupdatedate("js/topseller/load_sidemobile_topseller.js")%>');
-->
</script>
<script type="text/javascript">
<!--
var howmanyitems_topseller = "<%=session("load_sidemobile_howmanyitems_js")%>";

//'800 - 2016.02.26 - Layout Manager: Products: To have option Auto Rotate
var autorotate_topseller = "<%=session("load_sidemobile_autorotate_js")%>";
var rotatespeed_topseller = "<%=session("load_sidemobile_rotatespeed_js")%>";
-->
</script>
<%
   if lcase(session("load_sidemobile_topseller_slide_js")) = "yes" then
%>
<script type="text/javascript">
<!--
var passtype_topseller = "slide";
-->
</script>
<%
   elseif lcase(session("load_sidemobile_topseller_normal_js")) = "yes" then
%>
<script type="text/javascript">
<!--
var passtype_topseller = "normal";
-->
</script>
<%
   else
%>
<script type="text/javascript">
<!--
var passtype_topseller = "loaded";
-->
</script>
<%
   end if
   session("load_sidemobile_topseller_js") = ""
   session("load_sidemobile_topseller_slide_js") = ""
   session("load_sidemobile_topseller_normal_js") = ""
   session("load_sidemobile_howmanyitems_js") = ""
end sub

'800 - 2016.03.01 - Enhancement: Site speed enhancement
sub reset_categories_session_app
   session("loadlayout_categories_once") = ""
   dim langary(50), langary2, langcnt, currencyary(150), currencyary2, currencycnt, fromsess
   getapplication_lang_currency fromsess, langary, langary2, langcnt, currencyary, currencyary2, currencycnt
   dim icnt
   for icnt = 0 to (langcnt - 1)
      if fromsess then
         Application("loadlayout_categories_mobile_"& langary2(icnt) &"" & "_" & xShopId) = ""
         Application("loadlayout_categories_desktop_"& langary2(icnt) &"" & "_" & xShopId) = ""
         Application("loadlayout_categories_normal_"& langary2(icnt) &"" & "_" & xShopId) = ""
	  else
         Application("loadlayout_categories_mobile_"& langary(icnt) &"" & "_" & xShopId) = ""
         Application("loadlayout_categories_desktop_"& langary(icnt) &"" & "_" & xShopId) = ""
         Application("loadlayout_categories_normal_"& langary(icnt) &"" & "_" & xShopId) = ""
	  end if
   next
end sub

'800 - 2016.03.01 - Enhancement: Site speed enhancement
sub load_categories_nologin (resetchange)
   if Application("loadlayout_categories_changed" & "_" & xShopId) = "changed" then
      if resetchange = "yes" then
         Application("loadlayout_categories_changed" & "_" & xShopId) = ""
	  end if
      reset_categories_session_app
   end if
   if GetSess("Login") = "" then
      dim languagesess
      languagesess = session("language")
      if trim(languagesess) = "" then
         languagesess = GetConfig("xlanguage")
      end if
      languagesess = ucase(languagesess)
      if trim(Application("loadlayout_categories_mobile_"& languagesess &"" & "_" & xShopId)) <> "" then
         session("loadlayout_categories_mobile") = Application("loadlayout_categories_mobile_"& languagesess &"" & "_" & xShopId)
	     session("loadlayout_categories_once") = "yes"
      else
	     session("loadlayout_categories_once") = ""
      end if
      if trim(Application("loadlayout_categories_desktop_"& languagesess &"" & "_" & xShopId)) <> "" then
         session("loadlayout_categories_desktop") = Application("loadlayout_categories_desktop_"& languagesess &"" & "_" & xShopId)
  	     session("loadlayout_categories_once") = "yes"
      else
	     session("loadlayout_categories_once") = ""
      end if
      if trim(Application("loadlayout_categories_normal_"& languagesess &"" & "_" & xShopId)) <> "" then
         session("loadlayout_categories_normal") = Application("loadlayout_categories_normal_"& languagesess &"" & "_" & xShopId)
  	     session("loadlayout_categories_once") = "yes"
      else
	     session("loadlayout_categories_once") = ""
      end if
   end if
end sub

'800 - 2016.03.01 - Enhancement: Site speed enhancement
sub getapplication_lang_currency (fromsess, langary, langary2, langcnt, currencyary, currencyary2, currencycnt)
   dim langsql, langrs
   langcnt = session("application_langcnt")
   if trim(langcnt) = "" then
      fromsess = false
      langcnt = 0
      langsql = "select lang from languages GROUP BY lang"
      Set langrs = Server.CreateObject("ADODB.Recordset")
      langrs.open langsql, dbc, adOpenForwardOnly, adLockReadOnly
      while not langrs.eof
         if isnull(langrs("lang")) = false then
	        if trim(langrs("lang")) <> "" then
		       langary(langcnt) = ucase(langrs("lang"))
		       langcnt = langcnt + 1
      	     end if
         end if
         langrs.MoveNext
      wend
      closerecordset langrs
	  session("application_langcnt") = langcnt
	  session("application_langary") = langary
   else
      fromsess = true
      langary2 = session("application_langary")
   end if
   dim currencysql, currencyrs
   if not fromsess then
      currencycnt = 0
      currencysql = "select cid from currencyvalues order by cid"
      Set currencyrs = Server.CreateObject("ADODB.Recordset")
      currencyrs.open currencysql, dbc, adOpenForwardOnly, adLockReadOnly
      while not currencyrs.eof
         if isnull(currencyrs("cid")) = false then
	        if trim(currencyrs("cid")) <> "" then
   		       currencyary(currencycnt) = ucase(currencyrs("cid"))
		       currencycnt = currencycnt + 1
   	        end if
         end if
         currencyrs.MoveNext
      wend
      closerecordset langrs
	  session("application_currencycnt") = currencycnt
	  session("application_currencyary") = currencyary
   else
      currencycnt = session("application_currencycnt")
      currencyary2 = session("application_currencyary")
   end if
end sub

'800 - 2016.03.01 - Enhancement: Site speed enhancement
sub reset_topseller_session_app
   session("loadlayout_topseller_once") = ""
   dim langary(50), langary2, langcnt, currencyary(150), currencyary2, currencycnt, fromsess
   getapplication_lang_currency fromsess, langary, langary2, langcnt, currencyary, currencyary2, currencycnt
   dim icnt, jcnt
   for icnt = 0 to (langcnt - 1)
      for jcnt = 0 to (currencycnt - 1)
	     if fromsess then
            Application("loadlayout_topseller_desktop_"& langary2(icnt) &"_"& currencyary2(jcnt) &"" & "_" & xShopId) = ""
            Application("loadlayout_topseller_mobile_"& langary2(icnt) &"_"& currencyary2(jcnt) &"" & "_" & xShopId) = ""
		 else
            Application("loadlayout_topseller_desktop_"& langary(icnt) &"_"& currencyary(jcnt) &"" & "_" & xShopId) = ""
            Application("loadlayout_topseller_mobile_"& langary(icnt) &"_"& currencyary(jcnt) &"" & "_" & xShopId) = ""
		 end if
	  next
   next
end sub

'800 - 2016.03.01 - Enhancement: Site speed enhancement
sub load_topseller_nologin (resetchange)
   if Application("loadlayout_topseller_changed" & "_" & xShopId) = "changed" then
      if resetchange = "yes" then
         Application("loadlayout_topseller_changed" & "_" & xShopId) = ""
	  end if
      reset_topseller_session_app
   end if
   if GetSess("Login") = "" then
      dim languagesess
      languagesess = session("language")
      if trim(languagesess) = "" then
         languagesess = GetConfig("xlanguage")
      end if
      languagesess = ucase(languagesess)
	  dim currencysess
	  currencysess = ucase(session("CID"))
      if trim(Application("loadlayout_topseller_desktop_"& languagesess &"_"& currencysess &"" & "_" & xShopId)) <> "" then
         session("loadlayout_topseller_desktop") = Application("loadlayout_topseller_desktop_"& languagesess &"_"& currencysess &"" & "_" & xShopId)
	     session("loadlayout_topseller_once") = "yes"
      else
	     session("loadlayout_topseller_once") = ""
      end if
      if trim(Application("loadlayout_topseller_mobile_"& languagesess &"_"& currencysess &"" & "_" & xShopId)) <> "" then
         session("loadlayout_topseller_mobile") = Application("loadlayout_topseller_mobile_"& languagesess &"_"& currencysess &"" & "_" & xShopId)
  	     session("loadlayout_topseller_once") = "yes"
      else
	     session("loadlayout_topseller_once") = ""
      end if
   end if
end sub

'800 - 2016.03.01 - Enhancement: Site speed enhancement
sub reset_featuredpros_session_app (id)
   dim langary(50), langary2, langcnt, currencyary(150), currencyary2, currencycnt, fromsess
   getapplication_lang_currency fromsess, langary, langary2, langcnt, currencyary, currencyary2, currencycnt
   dim kcnt, jcnt
   if cstr(id) = "all" then
      dim idsary(20), idscnt, icnt
      ParseRecord_split session("loadlayout_featuredpros_ids"),idsary,idscnt,","
	  for icnt = 0 to (idscnt - 1)
         session("loadlayout_featuredpros_once_"& idsary(icnt) &"") = ""
         for kcnt = 0 to (langcnt - 1)
            for jcnt = 0 to (currencycnt - 1)
	           if fromsess then
                  Application("loadlayout_featuredpros_desktop_"& idsary(icnt) &"_"& langary2(kcnt) &"_"& currencyary2(jcnt) &"" & "_" & xShopId) = ""
                  Application("loadlayout_featuredpros_mobile_"& idsary(icnt) &"_"& langary2(kcnt) &"_"& currencyary2(jcnt) &"" & "_" & xShopId) = ""
		       else
                  Application("loadlayout_featuredpros_desktop_"& idsary(icnt) &"_"& langary(kcnt) &"_"& currencyary(jcnt) &"" & "_" & xShopId) = ""
                  Application("loadlayout_featuredpros_mobile_"& idsary(icnt) &"_"& langary(kcnt) &"_"& currencyary(jcnt) &"" & "_" & xShopId) = ""
		       end if
	        next
         next
	  next
   else
      session("loadlayout_featuredpros_once_"& id &"") = ""
      for kcnt = 0 to (langcnt - 1)
         for jcnt = 0 to (currencycnt - 1)
	        if fromsess then
               Application("loadlayout_featuredpros_desktop_"& id &"_"& langary2(kcnt) &"_"& currencyary2(jcnt) &"" & "_" & xShopId) = ""
               Application("loadlayout_featuredpros_mobile_"& id &"_"& langary2(kcnt) &"_"& currencyary2(jcnt) &"" & "_" & xShopId) = ""
		    else
               Application("loadlayout_featuredpros_desktop_"& id &"_"& langary(kcnt) &"_"& currencyary(jcnt) &"" & "_" & xShopId) = ""
               Application("loadlayout_featuredpros_mobile_"& id &"_"& langary(kcnt) &"_"& currencyary(jcnt) &"" & "_" & xShopId) = ""
		    end if
	     next
      next
   end if
end sub

'800 - 2016.03.01 - Enhancement: Site speed enhancement
sub load_featuredpros_nologin (id, resetchange)
   dim loadlayout_featuredpros_ids
   loadlayout_featuredpros_ids = session("loadlayout_featuredpros_ids")
   if trim(loadlayout_featuredpros_ids) = "" then
      session("loadlayout_featuredpros_ids") = id
   else
      loadlayout_featuredpros_ids = loadlayout_featuredpros_ids & "," & id
	  session("loadlayout_featuredpros_ids") = loadlayout_featuredpros_ids
   end if
   if Application("loadlayout_featuredpros_changed" & "_" & xShopId) = "changed" then
      '800 - 2016.09.08 - Bug Fix: Layout Manager: 2nd feature product same as first featrure product after v8.1.0.3
      'if resetchange = "yes" then
      '   Application("loadlayout_featuredpros_changed" & "_" & xShopId) = ""
	  'end if
      reset_featuredpros_session_app id
   end if
   if GetSess("Login") = "" then
      dim languagesess
      languagesess = session("language")
      if trim(languagesess) = "" then
         languagesess = GetConfig("xlanguage")
      end if
      languagesess = ucase(languagesess)
	  dim currencysess
	  currencysess = ucase(session("CID"))
      if trim(Application("loadlayout_featuredpros_desktop_"& id &"_"& languagesess &"_"& currencysess &"" & "_" & xShopId)) <> "" then
         session("loadlayout_featuredpros_desktop_"& id &"") = Application("loadlayout_featuredpros_desktop_"& id &"_"& languagesess &"_"& currencysess &"" & "_" & xShopId)
	     session("loadlayout_featuredpros_once_"& id &"") = "yes"
      else
	     session("loadlayout_featuredpros_once_"& id &"") = ""
      end if
      if trim(Application("loadlayout_featuredpros_mobile_"& id &"_"& languagesess &"_"& currencysess &"" & "_" & xShopId)) <> "" then
         session("loadlayout_featuredpros_mobile_"& id &"") = Application("loadlayout_featuredpros_mobile_"& id &"_"& languagesess &"_"& currencysess &"" & "_" & xShopId)
  	     session("loadlayout_featuredpros_once_"& id &"") = "yes"
      else
	     session("loadlayout_featuredpros_once_"& id &"") = ""
      end if
   end if
end sub

'800 - 2016.03.31 - Enhancement: Site speed enhancement
sub Readcurrency_dbsession
   dim rs, sql
   dim cidary(30), fullunitnameary(30), currencysymbolary(30), theimageary(30), icnt
   dim cidcnt
   cidcnt = session("cidcnt")
   if trim(cidcnt) = "" then cidcnt = 0
   if cdbl(cidcnt) > 0 then exit sub
   icnt = 0
   sql = "select cid,fullunitname,currencysymbol,theimage from currencyvalues where hide = 0 order by fullunitname"
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenForwardOnly, adLockReadOnly
   do while not rs.eof
      cidary(icnt) = rs("cid")
	  fullunitnameary(icnt) = rs("fullunitname")
	  currencysymbolary(icnt) = rs("currencysymbol")
	  theimageary(icnt) = rs("theimage")
	  icnt = icnt + 1
      rs.MoveNext
   loop
   CloseRecordSet rs
   session("cidcnt") = icnt
   setsessa "cidary", cidary
   setsessa "fullunitnameary", fullunitnameary
   setsessa "currencysymbolary", currencysymbolary
   setsessa "theimageary", theimageary
end sub
%>