<%
sub genfooterfreeimage (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub

   dim logoaltname,logoimage,logowidth,logoheight,logolink
   logoaltname = translatehpmgrcaptions(sqlrs("labelfield"))
   logoimage = sqlrs("otheroptions3")
   logowidth = sqlrs("otheroptions4")
   logoheight = sqlrs("otheroptions5")
   logolink = sqlrs("otheroptions6")
  
   if trim(logoimage) = "" then exit sub

   '701 - 2011.07.08 - Enhancement: Link target options to free image box
   dim linktargetoption,linktargetvalue
   linktargetoption = sqlrs("otheroptions7")
   if isnull(linktargetoption) then linktargetoption = ""
   if lcase(linktargetoption) = "_self" or trim(linktargetoption) = "" then
      linktargetvalue = "target=""_self"""
   else
      linktargetvalue = "target=""_blank"""
   end if
      
   dim dislogostring
   dislogostring = ""
   if isnull(logolink) = false then
	  if trim(logolink) <> "" then
	     '701 - 2011.07.08 - Enhancement: Link target options to free image box
	     dislogostring = dislogostring & "<div class=""bottomlogo""><a "& linktargetvalue &" href="""& logolink &""">"
	  end if
   end if
   dislogostring = dislogostring & "<img  "
   dislogostring = dislogostring & "src="""& logoimage &""" "
   
   if trim(logowidth) <> "" then
      dislogostring = dislogostring & "width="""& logowidth &""" "
   end if

   if trim(logoheight) <> "" then
      dislogostring = dislogostring & "height="""& logoheight &""" "
   end if

   if trim(logoaltname) <> "" then
      dislogostring = dislogostring & "alt="""& logoaltname &""" title="""& logoaltname &""" "
   end if
   
   dislogostring = dislogostring & "/>"
   if isnull(logolink) = false then
	  if trim(logolink) <> "" then
	     dislogostring = dislogostring & "</a></div>"
      end if
   end if
   htmlwrite dislogostring
end sub

'700 - layout manager enhancement - 2010.03.01
sub gencenterfreeimage (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub

   dim logoaltname,logoimage,logowidth,logoheight,logolink
   logoaltname = translatehpmgrcaptions(sqlrs("labelfield"))
   logoimage = sqlrs("otheroptions3")
   logowidth = sqlrs("otheroptions4")
   logoheight = sqlrs("otheroptions5")
   logolink = sqlrs("otheroptions6")
  
   if trim(logoimage) = "" then exit sub

   '701 - 2011.07.08 - Enhancement: Link target options to free image box
   dim linktargetoption,linktargetvalue
   linktargetoption = sqlrs("otheroptions7")
   if isnull(linktargetoption) then linktargetoption = ""
   if lcase(linktargetoption) = "_self" or trim(linktargetoption) = "" then
      linktargetvalue = "target=""_self"""
   else
      linktargetvalue = "target=""_blank"""
   end if
   
   dim dislogostring
   dislogostring = ""
   if isnull(logolink) = false then
	  if trim(logolink) <> "" then
	     '701 - 2011.07.08 - Enhancement: Link target options to free image box
	     dislogostring = dislogostring & "<a "& linktargetvalue &" href="""& logolink &""">"
	  end if
   end if
   dislogostring = dislogostring & "<div class=""main-product freecenterimage"" align=""center""><img "
   dislogostring = dislogostring & "src="""& logoimage &""" "

   dim owidth, maxwidth
   owidth = getimgproperty_width(logoimage)
   maxwidth = 650
   if cdbl(owidth) > cdbl(maxwidth) then
      owidth = maxwidth
   end if
   if trim(logowidth) <> "" then
      dislogostring = dislogostring & "width="""& logowidth &""" "
   else
      dislogostring = dislogostring & "width="""& owidth &""" "
   end if

   if trim(logoheight) <> "" then
      dislogostring = dislogostring & "height="""& logoheight &""" "
   end if

   if trim(logoaltname) <> "" then
      dislogostring = dislogostring & "alt="""& logoaltname &""" title="""& logoaltname &""" "
   end if
   
   dislogostring = dislogostring & "/></div>"
   if isnull(logolink) = false then
	  if trim(logolink) <> "" then
	     dislogostring = dislogostring & "</a>"
      end if
   end if
   dim hidetomobile
   if lcase(sqlrs("ismobile")) <> "yes" then
      hidetomobile = hide_to_mobile_str
   end if
   htmlwrite "<div class=""mainlogo "& hidetomobile &""">"
   htmlwrite dislogostring
   htmlwrite "</div>"
end sub

sub gensidefreeimage (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub

   dim logoaltname,logoimage,logowidth,logoheight,logolink
   logoaltname = translatehpmgrcaptions(sqlrs("labelfield"))
   logoimage = sqlrs("otheroptions3")
   logowidth = sqlrs("otheroptions4")
   logoheight = sqlrs("otheroptions5")
   logolink = sqlrs("otheroptions6")
  
   if trim(logoimage) = "" then exit sub

   '701 - 2011.07.08 - Enhancement: Link target options to free image box
   dim linktargetoption,linktargetvalue
   linktargetoption = sqlrs("otheroptions7")
   if isnull(linktargetoption) then linktargetoption = ""
   if lcase(linktargetoption) = "_self" or trim(linktargetoption) = "" then
      linktargetvalue = "target=""_self"""
   else
      linktargetvalue = "target=""_blank"""
   end if
      
   dim dislogostring
   dislogostring = ""
   if isnull(logolink) = false then
	  if trim(logolink) <> "" then
	     '701 - 2011.07.08 - Enhancement: Link target options to free image box
	     dislogostring = dislogostring & "<a "& linktargetvalue &" href="""& logolink &""">"
	  end if
   end if
   dislogostring = dislogostring & "<img  "
   dislogostring = dislogostring & "src="""& logoimage &""" "
   
   if trim(logowidth) <> "" then
      dislogostring = dislogostring & "width="""& logowidth &""" "
   end if

   if trim(logoheight) <> "" then
      dislogostring = dislogostring & "height="""& logoheight &""" "
   end if

   if trim(logoaltname) <> "" then
      dislogostring = dislogostring & "alt="""& logoaltname &""" title="""& logoaltname &""" "
   end if
   
   dislogostring = dislogostring & "/>"

   if isnull(logolink) = false then
	  if trim(logolink) <> "" then
	     dislogostring = dislogostring & "</a>"
	  end if
   end if
	  
   dim hidetomobile
   if lcase(sqlrs("ismobile")) <> "yes" then
      hidetomobile = hide_to_mobile_str
   end if
   htmlwrite "<div class=""sidelogo "& hidetomobile &""">"
   htmlwrite dislogostring
   htmlwrite "</div>"
end sub

function getimgproperty_width(img)
   on error resume next
   dim objFSO, objGF, objLP, imgWdt
   img = Server.MapPath(img)
   Set objFSO= CreateObject("Scripting.FileSystemObject")
   if objFSO.fileExists(img) Then
      Set objGF = objFSO.GetFile(img)
      Set objGF = Nothing
      Set objLP = loadpicture(img)
      imgWdt = round(objLP.width / 26.4583)
      Set objLP = Nothing
      Set objFSO = Nothing
      getimgproperty_width = imgWdt
   else
      getimgproperty_width = 0
   end if
   on error goto 0
end function
%>