<%
sub genfooterfreetext (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   if lcase(request.ServerVariables("HTTPS")) = "on" or lcase(request.ServerVariables("HTTP_X_HTTPS")) = "on" or lcase(request.ServerVariables("HTTP_CLUSTER_HTTPS")) = "on" then
      if isnull(sqlrs("otheroptions4")) then exit sub
      if sqlrs("otheroptions4") = "No" then exit sub
   end if
   if len(sqlrs("labelfield")) > 0 then
      htmlwrite "<h3>"& translatehpmgrcaptions(sqlrs("labelfield")) &"</h3>"
   end if
   if isnull(sqlrs("otheroptions3")) = false then
      if trim(sqlrs("otheroptions3")) <> "" then
	     '800 - 2015.04.10 - W3C issue
	     response.write replace(translatehpmgrcaptions(sqlrs("otheroptions3")),"&","&amp;")
      end if
   end if
end sub

sub gencenterfreetext (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   
   '700 - 2010.10.02 - Bug Fix: Free text show in ssl not working
   '701 - 2010.11.30 - Enhancement: Support HTTP_CLUSTER_HTTPS for secured mode
   if lcase(request.ServerVariables("HTTPS")) = "on" or lcase(request.ServerVariables("HTTP_X_HTTPS")) = "on" or lcase(request.ServerVariables("HTTP_CLUSTER_HTTPS")) = "on" then
      if isnull(sqlrs("otheroptions5")) then exit sub
      if sqlrs("otheroptions5") = "No" then exit sub
   end if
   
   dim displaywithbox,displaytext
   displaywithbox = sqlrs("otheroptions3")

   '701 - 2011.02.22 - freetext is formatting wrongly if containing html markup
   if not istable(sqlrs("otheroptions4")) then
      displaytext = replace(translatehpmgrcaptions(sqlrs("otheroptions4")),chr(13),"<br>")
   else
      displaytext = sqlrs("otheroptions4")
   end if
   '800 - 2015.04.10 - W3C issue
   displaytext = replace(displaytext,"&","&amp;")

   dim noborderstring
   noborderstring = "noborder"
   if lcase(displaywithbox) = "yes" then
      noborderstring = ""
   end if
   
   dim hidetomobile
   if lcase(sqlrs("ismobile")) <> "yes" then
      hidetomobile = hide_to_mobile_str
   end if
   htmlwrite "<div id=""center_freetext_title_"& sqlrs("id") &""" class=""main-freetext "& noborderstring &" "& hidetomobile &""">"
	  
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
          '800 - 2015.08.03 - Responsive layout update
 	      htmlwrite "<div class=""title""><h2 class='global-font-color'>"& translatehpmgrcaptions(sqlrs("labelfield")) &"</h2></div>"
	  end if
   end if

   htmlwrite "<p>"
	  
   dim divfrontstr
   divfrontstr = "<div "
   '700 - 2010.05.20 - Bug Fix: Center Free Text description not displaying
   divfrontstr = divfrontstr & ">"
   htmlwrite divfrontstr & displaytext
   htmlwrite "</div>"
     
   htmlwrite "</p>"  
   htmlwrite "</div>"
end sub

sub gensidefreetext (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   
   '700 - 2010.10.02 - Bug Fix: Free text show in ssl not working
   '701 - 2010.11.30 - Enhancement: Support HTTP_CLUSTER_HTTPS for secured mode
   if lcase(request.ServerVariables("HTTPS")) = "on" or lcase(request.ServerVariables("HTTP_X_HTTPS")) = "on" or lcase(request.ServerVariables("HTTP_CLUSTER_HTTPS")) = "on" then
      if isnull(sqlrs("otheroptions5")) then exit sub
      if sqlrs("otheroptions5") = "No" then exit sub
   end if

   dim displaywithbox,displaytext
   displaywithbox = sqlrs("otheroptions3")
   if instr(sqlrs("otheroptions4"),"</script>") > 0 then
      displaytext = sqlrs("otheroptions4")
   else
      '701 - 2011.02.22 - freetext is formatting wrongly if containing html markup
      if not istable(sqlrs("otheroptions4")) then
         displaytext = replace(translatehpmgrcaptions(sqlrs("otheroptions4")),chr(13),"<br />")
	  else
	     displaytext = sqlrs("otheroptions4")
	  end if
   end if
   '800 - 2015.04.10 - W3C issue
   displaytext = replace(displaytext,"&","&amp;")

   dim hidetomobile
   if lcase(sqlrs("ismobile")) <> "yes" then
      hidetomobile = hide_to_mobile_str
   end if
   if lcase(displaywithbox) = "yes" then
	  htmlwrite "<div class=""sidebarcell "& hidetomobile &""">"
   else
      htmlwrite "<div class=""sidebarcell_noborder "& hidetomobile &""">"
   end if
	  
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
         htmlwrite "<div id=""side_freetext_title_"& sqlrs("id") &""" class=""title"">"

         '800 - 2015.08.03 - Responsive layout update
         '800 - 2016.09.07 - SEO: To have h3 sidebar header
 	     ShopWriteSideHeading translatehpmgrcaptions(sqlrs("labelfield"))

	 	 htmlwrite "</div>"
	  end if
   end if
   htmlwrite "<div class=""contentcell"">"
   dim divfrontstr
   divfrontstr = "<div class=""sidefreetext"" "
   divfrontstr = divfrontstr & ">"
   htmlwrite divfrontstr & displaytext
   htmlwrite "</div>"
   htmlwrite "</div>"
   htmlwrite "</div>"
end sub

sub gencopypowerfreetext (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   if lcase(request.ServerVariables("HTTPS")) = "on" or lcase(request.ServerVariables("HTTP_X_HTTPS")) = "on" or lcase(request.ServerVariables("HTTP_CLUSTER_HTTPS")) = "on" then
      if isnull(sqlrs("otheroptions4")) then exit sub
      if sqlrs("otheroptions4") = "No" then exit sub
   end if
   if isnull(sqlrs("otheroptions3")) = false then
      if trim(sqlrs("otheroptions3")) <> "" then
         dim hidetomobile,alignposition
         if lcase(sqlrs("ismobile")) <> "yes" then
            hidetomobile = hide_to_mobile_str
         end if
		 alignposition = sqlrs("otheroptions5")
		 if trim(alignposition) = "" then
		    alignposition = "center"
		 end if
		 htmlwrite "<div class=""row "& hidetomobile &""">"
         htmlwrite "<div class=""col-sm-12 "& hidetomobile &" pull-" & alignposition & """>"
         dim divfrontstr
         divfrontstr = "<div class=""freetext"" "
         divfrontstr = divfrontstr & ">"
         htmlwrite divfrontstr & translatehpmgrcaptions(sqlrs("otheroptions3"))
         htmlwrite "</div>"
		 htmlwrite "</div>"
		 htmlwrite "</div>"
      end if
   end if
end sub
%>