<%
sub gencenterrandomproducts (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub

   '700 - 2010.09.30 - Enhancement: Better handling if xlogonrequired is Yes
   if GetConfig("xlogonrequired")="Yes" and GetSess("Login")="" then exit sub

   dim howmanyitems
   if isnumeric(sqlrs("otheroptions3")) = false then
      howmanyitems = 10
   else
      howmanyitems = int(sqlrs("otheroptions3"))
   end if

   dim passcaption
   if trim(sqlrs("labelfield")) <> "" then
      passcaption = translatehpmgrcaptions(sqlrs("labelfield"))
   else
      passcaption = GetLang("langcommonrandomproduct")
   end if
   displayhpmgrrandomproducts sqlrs, howmanyitems, passcaption
end sub

'700 - layout manager enhancement - 2010.03.30 - sidebox random products
sub gensiderandomproducts (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   
   '700 - 2010.09.30 - Enhancement: Better handling if xlogonrequired is Yes
   if GetConfig("xlogonrequired")="Yes" and GetSess("Login")="" then exit sub

   dim hidetomobile
   if lcase(sqlrs("ismobile")) <> "yes" then
      hidetomobile = hide_to_mobile_str
   end if
   htmlwrite "<div class=""sidebarcell "& hidetomobile &""">"
   htmlwrite "<div id=""side_randomproducts_title_"& sqlrs("id") &""" class=""title"">"
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
         '800 - 2015.08.03 - Responsive layout update
         '800 - 2016.09.07 - SEO: To have h3 sidebar header
   	     ShopWriteSideHeading translatehpmgrcaptions(sqlrs("labelfield"))
	  end if
   end if
   htmlwrite "</div>"
   htmlwrite "<div class=""contentcell"">"
   htmlwrite "<div class=""siderandomproducts"">"
	  
   dim howmanyitems
   if isnumeric(sqlrs("otheroptions3")) = false then
      howmanyitems = 10
   else
      howmanyitems = int(sqlrs("otheroptions3"))
   end if

   dim desktopstring, mobilestring
   desktopstring = ""
   mobilestring = ""
   if lcase(sqlrs("otheroptions4")) = "yes" then
      'to slide show
	  '800 - 2016.02.26 - Layout Manager: Products: To have option Auto Rotate
	  generate_carousel_slide_dekstop_header desktopstring, sqlrs("otheroptions7"), sqlrs("otheroptions8")
	  generate_carousel_slide_mobile_header mobilestring, sqlrs("otheroptions7"), sqlrs("otheroptions8")

	  displayhpmgrsideboxrandomproducts sqlrs("otheroptions5"), howmanyitems, "", "yes", desktopstring, mobilestring
	  desktopstring = desktopstring & "</div>"
	  generate_carousel_prev_next desktopstring
	  desktopstring = desktopstring & "</div>"
	  mobilestring = mobilestring & "</div>"
	  generate_carousel_prev_next mobilestring
	  mobilestring = mobilestring & "</div>"
   else
      generate_carousel_noslide_dekstop_header desktopstring
	  generate_carousel_noslide_mobile_header mobilestring
      displayhpmgrsideboxrandomproducts sqlrs("otheroptions5"), howmanyitems, "", "no", desktopstring, mobilestring
	  desktopstring = desktopstring & "</div>"
	  mobilestring = mobilestring & "</div>"
   end if
   htmlwrite desktopstring
   htmlwrite mobilestring
   htmlwrite "</div>"
   htmlwrite "</div>"
   htmlwrite "</div>"
end sub
%>