<%
'Front Page Side Box
sub Handle_leftsidebox (value)
   Value=""
   leftsidebox
end sub

sub Handle_rightsidebox (value)
   Value=""
   rightsidebox
end sub

sub rightsidebox
   loadsideboxcontent "rightsidebox"

   '800 - 2016.09.08 - Bug Fix: Layout Manager: 2nd feature product same as first featrure product after v8.1.0.3
   Application("loadlayout_featuredpros_changed" & "_" & xShopId) = ""
end sub

'Front Page Side Box
sub leftsidebox
   loadsideboxcontent "leftsidebox"
end sub

'Loading SideBox Content
sub loadsideboxcontent (leftorright)
   '800 - 2016.03.10 - Quick View: Speed performance
   if lcase(request("quickview")) = "yes" then exit sub

   '800 - 2016.03.01 - Enhancement: Site speed enhancement
   session("loadlayout_featuredpros_ids") = ""

   '800 - 2016.02.22 - Side Filter
   if lcase(session("CurrentUrl")) = "shopdisplayproducts.asp" then
      if lcase(getconfig("xproductfiltering_sidefilter_enable")) = "yes" then
	     dim sidefilter_rc
	     loadside_filter_wrapper leftorright, sidefilter_rc
         if sidefilter_rc = 4 then
            exit sub
	     end if
	  end if
   end if

   dim mainstatus, prefix
   prefix = leftorright
   mainstatus = getotheroptions(prefix,"","",1)
   select case lcase(leftorright)
      case "rightsidebox"
         if session("rightsidebar_disable") = "yes" then
            mainstatus = "no"
         end if
	  case "leftsidebox"
         if session("leftsidebar_disable") = "yes" then
            mainstatus = "no"
         end if
   end select
   if lcase(mainstatus) <> "yes" then exit sub

   dim tempstatus,strsql,sqlrs
   tempstatus = ""

   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   '700 - 2010.06.16 - Enhancement: Layout manager - multi-store support
   '800 - 2015.04.15 - Change table containerbox to containerbox_v8 for version 8 stores to avoid conflict with V7
   strsql="select * from containerbox_v8 where containerdivname = "& sqlserverprefixn &"'"& leftorright &"' and otheroptions1 = 'Yes' "
   GenLayoutMgrStorematchSQL "and", strsql
   strsql = strsql & "order by otheroptions2 asc,containername asc"

   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   sqlrs.open strsql, dbc, adOpenStatic, adLockReadOnly
   if sqlrs.eof then
      '700 - 2010.05.03 - Check all databasae must close after opened.
      closerecordset sqlrs
      exit sub
   else
      '800 - 2015.06.15 - Enhancement: Quick View
      set_quickview_sidebox_session "yes"

      dim hidetomobile_def
	  if lcase(getsess("ondefaultpage")) = "" then
	     hidetomobile_def = hide_to_mobile_str
	  end if
      if trim(lcase(leftorright)) = "leftsidebox" then
         htmlwrite "<div class="""& session("leftboxclass") &" "& hidetomobile_def &""">"
      else
         htmlwrite "<div class="""& session("rightboxclass") &" "& hidetomobile_def &""">"
      end if

      '800 - 2015.05.01 - Enhancement: Layout updates
	  htmlwrite "<div class=""vp_sidebar"">"

      while not sqlrs.eof
	     tempstatus = sqlrs("otheroptions1")

         '800 - 2016.05.25 - Quick View: Speed improvement when opening quickview
		 if lcase(sqlrs("containername")) <> "minicart" then
		    if lcase(request("quickvieworder")) = "yes" then
			   tempstatus = "no"
			end if
		 end if

		 if lcase(tempstatus) = "yes" then
		    select case lcase(sqlrs("containername"))
			   case "minicart"
				  gensideminicart sqlrs
			   case "categories"
			      gensidecategories sqlrs
			   case "search"
			      gensidesearch sqlrs
			   case "language"
			      gensidelanguage sqlrs
			   case "currency"
			      gensidecurrency sqlrs
			   case "featuredpros"
			      gensidefeaturedpros sqlrs
			   case "topseller"
			      gensidetopseller sqlrs
			   case "page"
			      gensidepage sqlrs
			   case "news"
			      gensidenews sqlrs
			   case "blogs"
			      gensideblogs sqlrs
			   case "freetext"
			      gensidefreetext sqlrs
			   case "freeimage"
			      gensidefreeimage sqlrs
			   '700 - layout manager enhancement - 2010.03.01
			   case "freeflash"
			      gensidefreeflash sqlrs
			   '700 - layout manager enhancement - 2010.03.30
			   case "randomproducts"
			      gensiderandomproducts sqlrs
			   '700- 2010.04.05 - twitter
               case "twitter"
		          gensidetwitter sqlrs
               '800 - Enhancement: Newsletter system
               case "newsletter"
                  gensidenewsletter sqlrs
			end select
		 end if

         '800 - 2015.10.05 - Site speed improvement
		 response.flush

	     sqlrs.movenext
	  wend
      htmlwrite "<div style=""clear:both""></div>"
      htmlwrite "</div>"

      '800 - 2015.05.01 - Enhancement: Layout updates
      htmlwrite "</div>"

      '800 - 2015.06.15 - Enhancement: Quick View
      set_quickview_sidebox_session ""
   end if
   closerecordset sqlrs
end sub

sub gensidepage (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub

   dim howmanyitems
   dim category,categorys(9999),categorycnt,icnt
   category = sqlrs("otheroptions4")
   categorycnt = 0
   if isnull(category) = false then
      parserecord category,categorys,categorycnt,","
   end if
	  
   dim hidetomobile
   if lcase(sqlrs("ismobile")) <> "yes" then
      hidetomobile = hide_to_mobile_str
   end if

   '800 - 2016.09.07 - SEO: To have h3 sidebar header
   dim content_page_title

   for icnt = 0 to (categorycnt - 1)
      htmlwrite "<div class=""sidebarcell "& hidetomobile &""">"
	  htmlwrite "<div id=""side_page_title_"& icnt &"_"& sqlrs("id") &""" class=""title"">"

      '800 - 2015.08.03 - Responsive layout update
      '800 - 2016.09.07 - SEO: To have h3 sidebar header
      ShowContentBoxCatName_retname categorys(icnt),content_page_title
      ShopWriteSideHeading content_page_title

	  htmlwrite"</div>"
	  htmlwrite "<div class=""contentcell"">"
      if isnumeric(sqlrs("otheroptions3")) = false then
         howmanyitems = 10
      else
	     howmanyitems = int(sqlrs("otheroptions3"))
      end if
	  htmlwrite "<ul class=""sidepage"">"
  	  ShowContentBox categorys(icnt),howmanyitems
	  htmlwrite "</ul>"
	  htmlwrite "</div>"
	  htmlwrite "</div>"
   next
end sub

sub gensidetopseller (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   if lcase(GetConfig("xtopsellers")) <> "yes" then exit sub
   
   '700 - 2010.09.30 - Enhancement: Better handling if xlogonrequired is Yes
   if GetConfig("xlogonrequired")="Yes" and GetSess("Login")="" then exit sub

   dim hidetomobile
   if lcase(sqlrs("ismobile")) <> "yes" then
      hidetomobile = hide_to_mobile_str
   end if
   htmlwrite "<div class=""sidebarcell "& hidetomobile &""">"
   htmlwrite "<div id=""side_topseller_title_"& sqlrs("id") &""" class=""title"">"
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
         '800 - 2015.08.03 - Responsive layout update
         '800 - 2016.09.07 - SEO: To have h3 sidebar header
   	     ShopWriteSideHeading translatehpmgrcaptions(sqlrs("labelfield"))
	  end if
   end if
   htmlwrite "</div>"

   htmlwrite "<div class=""contentcell"">"

   '800 - 2015.05.10 - Enhancement: Ajax side/mobile topseller to make first load faster
   htmlwrite "<div class=""sidetopseller loadsidetopseller_wrapper"">"
	  
   dim howmanyitems
   if isnumeric(sqlrs("otheroptions3")) = false then
      howmanyitems = 10
   else
      howmanyitems = int(sqlrs("otheroptions3"))
   end if
	  
   dim processstatus
   dim desktopstring, mobilestring
   desktopstring = ""
   mobilestring = ""

   '800 - 2015.05.10 - Enhancement: Ajax side/mobile topseller to make first load faster
   session("load_sidemobile_topseller_js") = "yes"
   session("load_sidemobile_howmanyitems_js") = howmanyitems

   '800 - 2016.02.26 - Layout Manager: Products: To have option Auto Rotate
   session("load_sidemobile_autorotate_js") = sqlrs("otheroptions5")
   session("load_sidemobile_rotatespeed_js") = sqlrs("otheroptions6")

   '800 - 2015.11.20 - Layout Manager: Top Seller: Better handling on resetting session content
   if lcase(sqlrs("otheroptions25")) = "changed" then
      '800 - 2016.03.01 - Enhancement: Site speed enhancement
	  reset_topseller_session_app
	  reset_featuredpros_session_app "all"

      '800 - 2016.02.01 - Enhancement: Must always commit transaction if execute sql execute
	  on error resume next
      dbc.BeginTrans
	  on error goto 0
      dbc.execute("update containerbox_v8 set otheroptions25 = '' where id = "& sqlrs("id") &"")
	  on error resume next
      dbc.CommitTrans
	  on error goto 0
   end if

   '800 - 2016.03.01 - Enhancement: Site speed enhancement
   load_topseller_nologin ""

   if lcase(sqlrs("otheroptions4")) = "yes" then
      'to slide show
      '800 - 2015.05.10 - Enhancement: Ajax side/mobile topseller to make first load faster
	  if session("loadlayout_topseller_once") <> "yes" then
	     session("load_sidemobile_topseller_slide_js") = "yes"
	  else
	     session("load_sidemobile_topseller_slide_js") = ""

		 '800 - 2016.02.26 - Layout Manager: Products: To have option Auto Rotate
         generate_carousel_slide_dekstop_header desktopstring, sqlrs("otheroptions5"), sqlrs("otheroptions6")
	     generate_carousel_slide_mobile_header mobilestring, sqlrs("otheroptions5"), sqlrs("otheroptions6")

		 desktopstring = session("loadlayout_topseller_desktop")
		 mobilestring = session("loadlayout_topseller_mobile")
  	     desktopstring = desktopstring & "</div>"
	     generate_carousel_prev_next desktopstring
	     desktopstring = desktopstring & "</div>"
	     mobilestring = mobilestring & "</div>"
	     generate_carousel_prev_next mobilestring
	     mobilestring = mobilestring & "</div>"
	  end if
   else
      '800 - 2015.05.10 - Enhancement: Ajax side/mobile topseller to make first load faster
      if session("loadlayout_topseller_once") <> "yes" then
	     session("load_sidemobile_topseller_normal_js") = "yes"
	  else
	     session("load_sidemobile_topseller_normal_js") = ""
         generate_carousel_noslide_dekstop_header desktopstring
	     generate_carousel_noslide_mobile_header mobilestring
		 desktopstring = session("loadlayout_topseller_desktop")
		 mobilestring = session("loadlayout_topseller_mobile")
	     desktopstring = desktopstring & "</div>"
	     mobilestring = mobilestring & "</div>"
	  end if
   end if
   htmlwrite desktopstring
   htmlwrite mobilestring
	  
   htmlwrite "</div>"
   htmlwrite "</div>"
   htmlwrite "</div>"
end sub

sub gensidefeaturedpros (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   
   '700 - 2010.09.30 - Enhancement: Better handling if xlogonrequired is Yes
   if GetConfig("xlogonrequired")="Yes" and GetSess("Login")="" then exit sub

   dim processstatus
   dim hidetomobile
   if lcase(sqlrs("ismobile")) <> "yes" then
      hidetomobile = hide_to_mobile_str
   end if
   htmlwrite "<div class=""sidebarcell "& hidetomobile &""">"
   htmlwrite "<div id=""side_featuredproduct_title_"& sqlrs("id") &""" class=""title"">"
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
         '800 - 2015.08.03 - Responsive layout update
         '800 - 2016.09.07 - SEO: To have h3 sidebar header
         ShopWriteSideHeading translatehpmgrcaptions(sqlrs("labelfield"))
	  end if
   end if
   htmlwrite "</div>"

   htmlwrite "<div class=""contentcell"">"
   htmlwrite "<div class=""sidefeaturedproducts"">"
   dim desktopstring, mobilestring
   desktopstring = ""
   mobilestring = ""

   '800 - 2016.03.01 - Enhancement: Site speed enhancement
   load_featuredpros_nologin sqlrs("id"), ""

   if lcase(sqlrs("otheroptions3")) = "yes" then
      'to slide show
	  '800 - 2016.02.26 - Layout Manager: Products: To have option Auto Rotate
      generate_carousel_slide_dekstop_header desktopstring, sqlrs("otheroptions7"), sqlrs("otheroptions8")
	  generate_carousel_slide_mobile_header mobilestring, sqlrs("otheroptions7"), sqlrs("otheroptions8")

      '800 - 2016.03.01 - Enhancement: Site speed enhancement
	  if lcase(session("loadlayout_featuredpros_once_"& sqlrs("id") &"")) = "yes" then
         desktopstring = session("loadlayout_featuredpros_desktop_"& sqlrs("id") &"")
	     mobilestring = session("loadlayout_featuredpros_mobile_"& sqlrs("id") &"")
	  else
	     NavigateFeaturedProductsNew sqlrs("otheroptions5"), sqlrs("otheroptions6"), "yes", desktopstring, mobilestring, sqlrs("id")
      end if

	  desktopstring = desktopstring & "</div>"
	  generate_carousel_prev_next desktopstring
	  desktopstring = desktopstring & "</div>"
	  mobilestring = mobilestring & "</div>"
	  generate_carousel_prev_next mobilestring
	  mobilestring = mobilestring & "</div>"
   else
	  ' normal display
      generate_carousel_noslide_dekstop_header desktopstring
	  generate_carousel_noslide_mobile_header mobilestring

	  '800 - 2016.03.01 - Enhancement: Site speed enhancement
	  if lcase(session("loadlayout_featuredpros_once_"& sqlrs("id") &"")) = "yes" then
         desktopstring = session("loadlayout_featuredpros_desktop_"& sqlrs("id") &"")
	     mobilestring = session("loadlayout_featuredpros_mobile_"& sqlrs("id") &"")
	  else
	     NavigateFeaturedProductsNew sqlrs("otheroptions5"), sqlrs("otheroptions6"), "no", desktopstring, mobilestring, sqlrs("id")
      end if

	  desktopstring = desktopstring & "</div>"
	  mobilestring = mobilestring & "</div>"
   end if
   htmlwrite desktopstring
   htmlwrite mobilestring
   htmlwrite "</div>"
   htmlwrite "</div>"
   htmlwrite "</div>"
end sub

sub gensidecurrency (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   
   '700 - 2010.09.30 - Enhancement: Better handling if xlogonrequired is Yes
   if GetConfig("xlogonrequired")="Yes" and GetSess("Login")="" then exit sub

   dim hidetomobile
   if lcase(sqlrs("ismobile")) <> "yes" then
      hidetomobile = hide_to_mobile_str
   end if
   htmlwrite "<div class=""sidebarcell "& hidetomobile &""">"
   htmlwrite "<div id=""side_currency_title_"& sqlrs("id") &""" class=""title"">"
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
         '800 - 2015.08.03 - Responsive layout update
         '800 - 2016.09.07 - SEO: To have h3 sidebar header
	     ShopWriteSideHeading translatehpmgrcaptions(sqlrs("labelfield"))
	  else
	     'htmlwrite "<h2 class='global-font-color'>"& GetLang("langcurrency") &"</h2>"
	  end if
   else
	  'htmlwrite "<h2 class='global-font-color'>"& GetLang("langcurrency") &"</h2>"
   end if
   htmlwrite "</div>"

   htmlwrite "<div class=""contentcell"">"
   htmlwrite "<div class=""sidecurrency"">"
   htmlwrite "<p><a href=""shopcurrency.asp"">"& GetLang("langchangecurrency") &"</a></p>"
   
   if isnull(sqlrs("otheroptions3")) = false then
      if lcase(sqlrs("otheroptions3")) = "yes" then
         htmlwrite "<p><a href=""shopcurrency.asp"">"
	     ShowCurrencyFlag
	     htmlwrite "</a></p>"
	  end if
   end if

   if isnull(sqlrs("otheroptions4")) = false then
      select case lcase(sqlrs("otheroptions4"))
         case "yes"
	        Navigateshowcurrencies "cur" & sqlrs("id")
         case "no"
            navigateshowcurrency
      end select
   end if
   htmlwrite "</div>"
   htmlwrite "</div>"
   htmlwrite "</div>"
end sub

sub gensidelanguage (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub

   dim hidetomobile
   if lcase(sqlrs("ismobile")) <> "yes" then
      hidetomobile = hide_to_mobile_str
   end if
   htmlwrite "<div class=""sidebarcell "& hidetomobile &""">"
   htmlwrite "<div id=""side_language_title_"& sqlrs("id") &""" class=""title"">"
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
         '800 - 2015.08.03 - Responsive layout update
         '800 - 2016.09.07 - SEO: To have h3 sidebar header
	     ShopWriteSideHeading translatehpmgrcaptions(sqlrs("labelfield"))
      else
	     'htmlwrite "<h2 class='global-font-color'>"& GetLang("langlanguage") &"</h2>"
	  end if
   else
	  'htmlwrite "<h2 class='global-font-color'>"& GetLang("langlanguage") &"</h2>"
   end if
   htmlwrite "</div>"
		 
   htmlwrite "<div class=""contentcell"">"
   htmlwrite "<div class=""sidelanguage"">"
   Navigateshowlanguages "lang" & sqlrs("id")
   htmlwrite "</div>"
   htmlwrite "</div>"
   htmlwrite "</div>"
end sub

sub gensidesearch (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   
   '700 - 2010.09.30 - Enhancement: Better handling if xlogonrequired is Yes
   if GetConfig("xlogonrequired")="Yes" and GetSess("Login")="" then exit sub

   dim prefix
   
   prefix = "left" & sqlrs("id")
   dim hidetomobile
   if lcase(sqlrs("ismobile")) <> "yes" then
      hidetomobile = hide_to_mobile_str
   end if
   htmlwrite "<div class=""sidebarcell "& hidetomobile &""">"
   htmlwrite "<div id=""side_search_title_"& sqlrs("id") &""" class=""title"">"
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
         '800 - 2015.08.03 - Responsive layout update
         '800 - 2016.09.07 - SEO: To have h3 sidebar header
	     ShopWriteSideHeading translatehpmgrcaptions(sqlrs("labelfield"))
	  else
		 'htmlwrite "<h2 class='global-font-color'>"& GetLang("langhpmgrsearch") &"</h2>"
	  end if
   else
	  'htmlwrite "<h2 class='global-font-color'>"& GetLang("langhpmgrsearch") &"</h2>"
   end if
   htmlwrite "</div>"
		 
   htmlwrite "<div class=""contentcell"">"
   htmlwrite "<div class=""sidesearch"">"
   navigateshowsearch prefix, "", sqlrs("otheroptions3")
   htmlwrite "</div>"
   htmlwrite "</div>"
   htmlwrite "</div>"
end sub

'700 - 2010.05.31 - Enhancement: Category Flyout issue with browser IE6 and W3C
dim flyout1counter
flyout1counter = 0
sub gensidecategories (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   
   '700 - 2010.09.30 - Enhancement: Better handling if xlogonrequired is Yes
   if GetConfig("xlogonrequired")="Yes" and GetSess("Login")="" then exit sub

   dim hidetomobile
   if lcase(sqlrs("ismobile")) <> "yes" then
      hidetomobile = hide_to_mobile_str
   end if
   htmlwrite "<div class=""sidebarcell "& hidetomobile &""">"
   htmlwrite "<div id=""side_categories_title_"& sqlrs("id") &""" class=""title"">"
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
         '800 - 2015.08.03 - Responsive layout update
         '800 - 2016.09.07 - SEO: To have h3 sidebar header
	     ShopWriteSideHeading translatehpmgrcaptions(sqlrs("labelfield"))
	  end if
   end if
   htmlwrite "</div>"

   '700 - 2010.05.19 - Bug Fix: Category Flyout issue with browser IE6
   htmlwrite "<div class=""contentcell"">"
   if lcase(sqlrs("otheroptions3")) = "flyout" then
      'htmlwrite "<div id=""catnavflyout"">"
	  '700 - 2010.05.31 - Enhancement: Category Flyout issue with browser IE6 and W3C
	  flyout1counter = flyout1counter + 1
      '800 - 2015.04.30 - Enhancement: Loading side/mobile categories in Ajax to improve first load speed
	  htmlwrite "<div class=""flyout loadcategory_wrapper"">"
   else
      '800 - 2015.04.30 - Enhancement: Loading side/mobile categories in Ajax to improve first load speed
      htmlwrite "<div class=""loadcategory_wrapper"">"
   end if

   '800 - 2016.03.01 - Enhancement: Site speed enhancement
   load_categories_nologin ""

   if isnull(sqlrs("otheroptions3")) = false then
      '800 - 2015.04.30 - Enhancement: Loading side/mobile categories in Ajax to improve first load speed
      '800 - 2015.05.08 - Enhancement: Side/Mobile Categories: Speed improvement for Ajax Category method
	  if session("loadlayout_categories_once") <> "yes" then
         session("load_sidemobile_cat_js") = "yes"
	  end if

      '800 - 2015.06.23 - Enhancement: Layout Manager: categories widget: To have pre-load option
      '800 - 2016.03.01 - Enhancement: Site speed enhancement
      'if lcase(getconfig("xcategory_preload_enable")) <> "yes" then
         'session("load_sidemobile_cat_js") = "yes"
      'end if

      select case lcase(sqlrs("otheroptions3"))
         case "dropdown"
            '800 - 2015.04.10 - Better loading categories speed improvement
            '800 - 2015.04.15 - Enahncement: Loading categories speed performance
            '800 - 2015.04.30 - Enhancement: Loading side/mobile categories in Ajax to improve first load speed
            '800 - 2015.05.08 - Enhancement: Side/Mobile Categories: Speed improvement for Ajax Category method
			if session("loadlayout_categories_once") <> "yes" then
			   session("load_sidemobile_cat_fly_js") = "yes"
			else
               '800 - 2016.03.01 - Enhancement: Site speed enhancement
			   session("load_sidemobile_cat_fly_js") = ""

		       gensidecategories_fromsession session("loadlayout_categories_desktop")
			end if
         case "flyout"
            '800 - 2015.04.10 - Better loading categories speed improvement
            '800 - 2015.04.15 - Enahncement: Loading categories speed performance
            '800 - 2015.04.30 - Enhancement: Loading side/mobile categories in Ajax to improve first load speed
            '800 - 2015.05.08 - Enhancement: Side/Mobile Categories: Speed improvement for Ajax Category method
			if session("loadlayout_categories_once") <> "yes" then
			   session("load_sidemobile_cat_fly_js") = "yes"
            else
               '800 - 2016.03.01 - Enhancement: Site speed enhancement
			   session("load_sidemobile_cat_fly_js") = ""

		       gensidecategories_fromsession session("loadlayout_categories_desktop")
			end if
   	     case else
            '800 - 2015.04.10 - Better loading categories speed improvement
            '800 - 2015.04.15 - Enahncement: Loading categories speed performance
            '800 - 2015.04.30 - Enhancement: Loading side/mobile categories in Ajax to improve first load speed
            '800 - 2015.05.08 - Enhancement: Side/Mobile Categories: Speed improvement for Ajax Category method
			if session("loadlayout_categories_once") <> "yes" then
  			   session("load_sidemobile_cat_normal_js") = "yes"
			else
               '800 - 2016.03.01 - Enhancement: Site speed enhancement
			   session("load_sidemobile_cat_normal_js") = ""

		       gensidecategories_fromsession session("loadlayout_categories_normal")
			end if
      end select
   else
      '800 - 2015.05.06 - Bug Fix: Side category: Lite version is displaying wronly
      '800 - 2015.05.08 - Enhancement: Side/Mobile Categories: Speed improvement for Ajax Category method
	  if session("loadlayout_categories_once") <> "yes" then
         session("load_sidemobile_cat_js") = "yes"
	     session("load_sidemobile_cat_normal_js") = "yes"
      else
         '800 - 2016.03.01 - Enhancement: Site speed enhancement
		 session("load_sidemobile_cat_normal_js") = ""

	     gensidecategories_fromsession session("loadlayout_categories_normal")
	  end if
      'NavigateShowCategories
   end if
   htmlwrite "</div>"

   '700 - 2010.05.19 - Bug Fix: Category Flyout issue with browser IE6
   if lcase(sqlrs("otheroptions3")) = "flyout" then
      htmlwrite "</div>"
   else
      '800 - 2015.04.30 - Enhancement: Loading side/mobile categories in Ajax to improve first load speed
      htmlwrite "</div>"
   end if
   
   htmlwrite "</div>"
end sub

'Front Page - Side Box - Mini Cart
sub gensideminicart (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   
   '700 - 2010.09.30 - Enhancement: Better handling if xlogonrequired is Yes
   if GetConfig("xlogonrequired")="Yes" and GetSess("Login")="" then exit sub

   dim hidetomobile
   if lcase(sqlrs("ismobile")) <> "yes" then
      hidetomobile = hide_to_mobile_str
   end if
   htmlwrite "<div class=""sidebarcell "& hidetomobile &""">"

   '800 - 2015.06.15 - Enhancement: Quick View
   htmlwrite "<div id=""side_minicart_title_"& sqlrs("id") &""" class=""title "& get_quickview_targetstr("side") &""">"
   assign_side_minicart_target sqlrs

   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
         '800 - 2015.08.03 - Responsive layout update
         '800 - 2016.09.07 - SEO: To have h3 sidebar header
	     ShopWriteSideHeading translatehpmgrcaptions(sqlrs("labelfield"))
	  end if
   end if
   htmlwrite "</div>"
   NavigateShowMiniCartCssStyled
   htmlwrite "</div>"
end sub

'800 - 2016.09.07 - SEO: To have h3 sidebar header
sub ShopWriteSideHeading (heading)
   htmlwrite "<h3 class=""global-font-color"">" & heading & "</h3>"
end sub

'800 - 2016.09.07 - SEO: To have h3 sidebar header
sub ShowContentBoxCatName_retname(categoryid,retname)
   retname = ""
   if len(trim(categoryid))<= 0 then exit sub
   categoryid=cleanchars(categoryid)
   dim newsrs,strsql
   strsql="select ncategoryid,ncatdescription from contentcategories where ncategoryid = "& categoryid &" and ncathide is null or ncathide = '' or ncathide = 'No' or ncathide = 'False'"
   Set newsrs = Server.CreateObject("ADODB.Recordset")
   newsrs.open strsql, dbc, adOpenForwardOnly, adLockReadOnly
   if not newsrs.eof then
	  retname = translatelanguage(dbc, "contentcategories", "ncatdescription","ncategoryid", newsrs("ncategoryid"), newsrs("ncatdescription"))
   else
	  retname = getlang("Langcontentcategorynorecord")
   end if
   closerecordset newsrs
end sub
%>