<%
'Handle Front Page - Welcome Box Square
sub Handle_welcomeboxsquare (value)
   Value=""
   welcomeboxsquare
end sub

'Handle Front Page - Welcome Box Square
sub welcomeboxsquare
   '800 - 2016.03.10 - Quick View: Speed performance
   if lcase(request("quickview")) = "yes" then exit sub

   dim boxstatus, prefix
   prefix = "welcomeboxsquare"
   boxstatus = getotheroptions(prefix,"","",1)
   if lcase(boxstatus) <> "yes" then exit sub

   dim strsql,sqlrs,icnt,tempstatus
   '800 - 2015.04.15 - Change table containerbox to containerbox_v8 for version 8 stores to avoid conflict with V7
   strsql="select * from containerbox_v8 where containerdivname = 'welcomeboxsquare' and labelfield = 'vertical' and otheroptions1 = 'Yes' "
   GenLayoutMgrStorematchSQL "and", strsql
   strsql = strsql & "order by otheroptions2 asc,containername asc"
   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   sqlrs.open strsql, dbc, adOpenStatic, adLockReadOnly, adcmdText
   if sqlrs.eof then
	  closerecordset sqlrs
      exit sub
   else
      htmlwrite "<div id=""vp_welcomeboxsquare"" class=""col-sm-6 col-xs-12"">"

      '800 - 2015.04.17 - Front store: Fix layout issue
      htmlwrite "<div id=""welcome-container"">"

      icnt = 1
      while not sqlrs.eof
	     tempstatus = sqlrs("otheroptions1")

         '800 - 2016.05.25 - Quick View: Speed improvement when opening quickview
		 if lcase(sqlrs("containername")) <> "minicartsection" then
		    if lcase(request("quickvieworder")) = "yes" then
			   tempstatus = "no"
			end if
		 end if

		 if lcase(tempstatus) = "yes" then
		    select case cdbl(icnt)
			   case 1
			      htmlwrite "<!--TOP LEVEL  NOTE: TOP LEVEL ALWAYS HAVE THE BORDER BOTTOM DASHED STYLE-->"
				  htmlwrite "<div class=""row toprightsection toplevel"">"
			   case 2
			      htmlwrite "<!--MIDDLE LEVEL -->"
				  htmlwrite "<div class=""row toprightsection midlevel"">"
			   case 3
			      htmlwrite "<!-- BOTTOM LEVEL-->"
				  htmlwrite "<div class=""row toprightsection bottomlevel"">"
			end select
		    select case lcase(sqlrs("containername"))
			   case "welcomesection"
			      getwelcomesectionhtml
			   case "minicartsection"
                  '800 - 2015.06.15 - Enhancement: Quick View
			      getminicartsectionhtml sqlrs
			   case "formsection"
			      getformsectionhtml
			   case "freetext"
			end select
		    select case cdbl(icnt)
			   case 1
				  htmlwrite "</div>"
				  htmlwrite "<!--END OF TOP LEVEL -->"
			   case 2
				  htmlwrite "</div>"
				  htmlwrite "<!--END OF MID LEVEL -->"
			   case 3
				  htmlwrite "</div>"
				  htmlwrite "<!--END OF BOTTOM LEVEL -->"
			end select
			icnt = icnt + 1
		 end if

         '800 - 2015.10.05 - Site speed improvement
		 response.flush

	     sqlrs.movenext
	  wend
	  htmlwrite "<div class=""row""></div>"
	  htmlwrite "</div>"

      '800 - 2015.04.17 - Front store: Fix layout issue
	  htmlwrite "</div>"

   end if
   closerecordset sqlrs
end sub

'Welcome Square - Welcome Section
sub getwelcomesectionhtml
   htmlwrite "<div class=""col-xs-12"">"
   htmlwrite "<ul class=""mid-topright-nav"">"
   htmlwrite "<li>"
   htmlwrite "<p class=""welcome"">"
   welcomenote
   htmlwrite "</p>"
   htmlwrite "</li>"
   htmlwrite "<li>"
   htmlwrite "<span style="""">"
   htmlwrite "("
   htmlwrite "<a href="""& DoFriendlySEOPage("shopcustadmin.asp") &""
   htmlwrite """>"& GetLang("langHeadMyAccount") &"</a> &nbsp;|&nbsp;"
   htmlwrite "<a href="""& DoFriendlySEOPage("shopaddtocart.asp") &""
   htmlwrite """>"& GetLang("langcommonviewcart") &"</a> &nbsp;|&nbsp;"
   loginlogouttoggle
   htmlwrite ")"
   htmlwrite "</span>"
   htmlwrite "</li>"
   htmlwrite "</ul>"
   htmlwrite "</div>"
end sub

'Welcome Square - MiniCart Section
'800 - 2015.06.15 - Enhancement: Quick View
sub getminicartsectionhtml (sqlrs)
   if trim(getsess("totalcartquantity")) = "" then setsess "totalcartquantity", 0
   if trim(getsess("OrderTotal")) = "" then setsess "OrderTotal", 0

   '800 - 2015.06.15 - Enhancement: Quick View
   generate_minicart_openwrapper sqlrs, "square"
   htmlwrite "<div class=""square_mini_cart_wrapper"">"
   htmlwrite "<div class=""col-xs-12 welcomeboxsquareminicart"">"

   htmlwrite "<span style="""">" & GetLang("langcart01") & " " & getsess("totalcartquantity")
   htmlwrite "&nbsp;&nbsp;" & GetLang("langcommonsubtotal") & " : "
   if trim(getsess("CartCount")) <> "" then
      if getsess("CartCount") > 0 then
         htmlwrite shopformatcurrency(getsess("OrderTotal"),GetConfig("xdecimalpoint")) & "</span>"
      else
         if GetSess("Newcurrencysymbol")<>"" then
	        htmlwrite GetSess("Newcurrencysymbol") & "0.00" & "</span>"
         elseif GetConfig("XCurrencySymbol") <> "" then
	        htmlwrite GetConfig("XCurrencySymbol") & "0.00" & "</span>"
         else
	        htmlwrite "$" & "0.00" & "</span>"
         end if
	  end if
   else
      if GetSess("Newcurrencysymbol")<>"" then
	     htmlwrite GetSess("Newcurrencysymbol") & "0.00" & "</span>"
      elseif GetConfig("XCurrencySymbol") <> "" then
	     htmlwrite GetConfig("XCurrencySymbol") & "0.00" & "</span>"
      else
	     htmlwrite "$" & "0.00" & "</span>"
      end if
   end if
   htmlwrite "</div>"

   '800 - 2015.06.15 - Enhancement: Quick View
   htmlwrite "</div>"
end sub

'Welcome Square - Form Section
sub getformsectionhtml
   dim strsql,sqlrs
   dim prefix
   prefix = "welcomeboxsquare"
   '800 - 2015.04.15 - Change table containerbox to containerbox_v8 for version 8 stores to avoid conflict with V7
   strsql="select otheroptions1,containername,otheroptions3,id from containerbox_v8 where containerdivname = 'welcomeboxsquare' and labelfield = 'horizontal' and (otheroptions1 = 'Yes' or otheroptions1 = 'yes') "
   GenLayoutMgrStorematchSQL "and", strsql
   strsql = strsql & "order by otheroptions2 asc,containername asc"
   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   sqlrs.open strsql, dbc, adOpenStatic, adLockReadOnly
   if sqlrs.eof then
	  closerecordset sqlrs
      exit sub
   else
      htmlwrite "<ul class=""left-topnav nav navbar-nav pull-right"">"
      while not sqlrs.eof
	     htmlwrite "<li class=""dropdown"">"
         select case lcase(sqlrs("containername"))
		    case "currency"
			   '800 - 2016.09.07 - Layout Manager: WelcomeboxSquare: Currency/Languages: Not showing after v8.1.0.3
 		       if trim(Application("loadlayout_topheaderleftbox_currency_changed" & xShopId) = "") then
				  if trim(Application("loadlayout_topheaderleftbox_currency_" & xShopId)) = "" then
				     load_header_currency sqlrs, prefix
				  end if
			   else
				  load_header_currency sqlrs, prefix
			   end if
			   htmlwrite Application("loadlayout_topheaderleftbox_currency_" & xShopId)
		    case "language"
			   '800 - 2016.09.07 - Layout Manager: WelcomeboxSquare: Currency/Languages: Not showing after v8.1.0.3
 		       if trim(Application("loadlayout_topheaderleftbox_language_changed" & xShopId) = "") then
				  if trim(Application("loadlayout_topheaderleftbox_language_" & xShopId)) = "" then
				     load_header_language sqlrs, prefix
				  end if
			   else
				  load_header_language sqlrs, prefix
			   end if
			   htmlwrite Application("loadlayout_topheaderleftbox_language_" & xShopId)
			case "search"
               load_header_search sqlrs, prefix
		 end select
		 htmlwrite "</li>"
	     sqlrs.movenext
	  wend
	  htmlwrite "</ul>"
   end if
   closerecordset sqlrs
end sub

sub getwelcomeboxsquarefreetext (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub

   '700 - 2010.10.02 - Bug Fix: Free text show in ssl not working
   '701 - 2010.11.30 - Enhancement: Support HTTP_CLUSTER_HTTPS for secured mode
   if lcase(request.ServerVariables("HTTPS")) = "on" or lcase(request.ServerVariables("HTTP_X_HTTPS")) = "on" or lcase(request.ServerVariables("HTTP_CLUSTER_HTTPS")) = "on" then
      if isnull(sqlrs("otheroptions5")) then exit sub
      if sqlrs("otheroptions5") = "No" then exit sub
   end if

   dim divfrontstr
   divfrontstr = "<div class=""freetext"" "
   divfrontstr = divfrontstr & ">"
   htmlwrite divfrontstr & translatehpmgrcaptions(sqlrs("otheroptions4"))
   htmlwrite "</div>"
end sub
%>