<%
'Front Page WelcomeBox Stretch
sub Handle_welcomeboxstretch (value)
   Value=""
   welcomeboxstretch
end sub

'Front Page WelcomeBox Stretch
sub welcomeboxstretch
   '800 - 2016.03.10 - Quick View: Speed performance
   if lcase(request("quickview")) = "yes" then exit sub

   dim welcomeboxstretchstatus
   dim strsql,sqlrs
   
   '700 - 2010.06.16 - Enhancement: Layout manager - multi-store support
   '800 - 2015.04.15 - Change table containerbox to containerbox_v8 for version 8 stores to avoid conflict with V7
   strsql="select otheroptions1 from containerbox_v8 where containerdivname = 'welcomeboxstretch' and (containername = '' or containername is null)"
   GenLayoutMgrStorematchSQL "and", strsql

   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   sqlrs.open strsql, dbc, adOpenStatic, adLockReadOnly
   if sqlrs.eof then
      '700 - 2010.05.03 - Check all databasae must close after opened.
	  closerecordset sqlrs
      exit sub
   else
      while not sqlrs.eof
	     welcomeboxstretchstatus = sqlrs("otheroptions1")
	     sqlrs.movenext
	  wend
   end if
   closerecordset sqlrs
   if lcase(welcomeboxstretchstatus) <> "yes" then exit sub

   dim recordcnt
   
   '700 - 2010.06.16 - Enhancement: Layout manager - multi-store support
   '800 - 2015.04.15 - Change table containerbox to containerbox_v8 for version 8 stores to avoid conflict with V7
   strsql="select count(*) as reccnt from containerbox_v8 where containerdivname = 'welcomeboxstretch' and labelfield = 'main' and otheroptions1 = 'Yes'"
   GenLayoutMgrStorematchSQL "and", strsql

   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   sqlrs.open strsql, dbc, adOpenForwardOnly, adLockReadOnly, adcmdText
   if sqlrs.eof then
      recordcnt = 0
   else
      recordcnt = cdbl(sqlrs("reccnt"))
   end if
   closerecordset sqlrs
   if recordcnt <= 0 then exit sub

   htmlwrite "<div class=""utility-bar"">"
   
   dim tempstatus,icnt,instylestr,sortstr
   tempstatus = ""
   
   '700 - 2010.06.16 - Enhancement: Layout manager - multi-store support
   '800 - 2015.04.15 - Change table containerbox to containerbox_v8 for version 8 stores to avoid conflict with V7
   '800 - 2015.06.15 - Enhancement: Quick View
   strsql="select otheroptions1,containername, otheroptions3 from containerbox_v8 where containerdivname = 'welcomeboxstretch' and labelfield = 'main' "
   GenLayoutMgrStorematchSQL "and", strsql
   strsql = strsql & "order by otheroptions2 asc,containername asc"

   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   sqlrs.open strsql, dbc, adOpenStatic, adLockReadOnly
   if sqlrs.eof then
      '700 - 2010.05.03 - Check all databasae must close after opened.
	  closerecordset sqlrs
      exit sub
   else
      icnt = 1
      while not sqlrs.eof
	     tempstatus = sqlrs("otheroptions1")

         '800 - 2016.05.25 - Quick View: Speed improvement when opening quickview
		 if lcase(sqlrs("containername")) <> "minicartsection" then
		    if lcase(request("quickvieworder")) = "yes" then
			   tempstatus = "no"
			end if
		 end if

		 if lcase(tempstatus) = "yes" then
	        if icnt = 3 then
			   instylestr = "style=""float:right;"""
			   sortstr = "desc"
			elseif icnt = recordcnt then
			   instylestr = "style=""float:right;"""
			   sortstr = "desc"
			else
			   instylestr = "style=""float:left;"""
			   sortstr = "asc"
            end if

		    select case lcase(sqlrs("containername"))
			   case "welcomesection"
				  htmlwrite "<div "& instylestr &" class=""welcome"">"
			      getwelcomesectionhtml2
			   case "minicartsection"
                  '800 - 2015.06.15 - Enhancement: Quick View
				  generate_minicart_openwrapper sqlrs, "stretch"

			      htmlwrite "<div "& instylestr &" class=""cart_summary"">"
			      getminicartsectionhtml2
			   case "formsection"
			      htmlwrite "<div "& instylestr &" class=""utility_form"">"
			      getformsectionhtml2 instylestr, sortstr
			end select
			
			htmlwrite "</div>"
			icnt = icnt + 1
		 end if

         '800 - 2015.10.05 - Site speed improvement
		 response.flush

	     sqlrs.movenext
	  wend
   end if
   closerecordset sqlrs
   
   htmlwrite "<div style=""clear:both""></div>"
   htmlwrite "</div>"
end sub

'Welcome Stretch Welcome Section
sub getwelcomesectionhtml2
   welcomenote
   htmlwrite " ("
   loginlogouttoggle
   htmlwrite ") "
end sub

'Welcome Box Stretch MiniCart Section
sub getminicartsectionhtml2
   '800 - 2015.06.15 - Enhancement: Quick View
   htmlwrite "<div class=""welcomeboxstretchminicart"">"

   if trim(getsess("totalcartquantity")) = "" then setsess "totalcartquantity", 0
   if trim(getsess("OrderTotal")) = "" then setsess "OrderTotal", 0

   htmlwrite GetLang("langcart01") & " " & getsess("totalcartquantity")
   htmlwrite "&nbsp;&nbsp;" & GetLang("langcommonsubtotal") & " : "
   if trim(getsess("CartCount")) <> "" then
      if getsess("CartCount") > 0 then
         htmlwrite shopformatcurrency(getsess("OrderTotal"),GetConfig("xdecimalpoint"))
      else
         if GetSess("Newcurrencysymbol")<>"" then
	        htmlwrite GetSess("Newcurrencysymbol") & "0.00"
         elseif GetConfig("XCurrencySymbol") <> "" then
	        htmlwrite GetConfig("XCurrencySymbol") & "0.00"
         else
	        htmlwrite "$" & "0.00"
         end if
      end if
   else
      if GetSess("Newcurrencysymbol")<>"" then
	     htmlwrite GetSess("Newcurrencysymbol") & "0.00"
      elseif GetConfig("XCurrencySymbol") <> "" then
	     htmlwrite GetConfig("XCurrencySymbol") & "0.00"
      else
	     htmlwrite "$" & "0.00"
      end if
   end if
   '800 - 2015.06.15 - Enhancement: Quick View
   htmlwrite "</div>"
end sub

'Welcome Box Stretch Form Section
sub getformsectionhtml2 (instylestr, sortstr)
   dim strsql,sqlrs
   dim tempstatus
   dim prefix
   
   prefix = "welcomeboxstretch"
   tempstatus = ""

   '700 - 2010.06.16 - Enhancement: Layout manager - multi-store support
   '800 - 2015.04.15 - Change table containerbox to containerbox_v8 for version 8 stores to avoid conflict with V7
   strsql="select otheroptions1,containername,otheroptions3,id from containerbox_v8 where containerdivname = 'welcomeboxstretch' and labelfield = 'formmain' "
   GenLayoutMgrStorematchSQL "and", strsql
   strsql = strsql & "order by otheroptions2 "& sortstr &",containername asc"

   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   sqlrs.open strsql, dbc, adOpenStatic, adLockReadOnly
   if sqlrs.eof then
      '700 - 2010.05.03 - Check all databasae must close after opened.
	  closerecordset sqlrs
      exit sub
   else
      while not sqlrs.eof
	     tempstatus = sqlrs("otheroptions1")
		 if lcase(tempstatus) = "yes" then
		    select case lcase(sqlrs("containername"))
			   case "currency"
			      htmlwrite "<div "& instylestr &" class=""currency"">"
				  if isnull(sqlrs("otheroptions3")) = false then
				     if trim(sqlrs("otheroptions3")) <> "" then
					    response.write translatehpmgrcaptions(sqlrs("otheroptions3"))
					 end if
				  end if
				  Navigateshowcurrencies "cur" & sqlrs("id")
				  htmlwrite "</div>"
			   case "language"
   			      htmlwrite "<div "& instylestr &" class=""language"">"
				  if isnull(sqlrs("otheroptions3")) = false then
				     if trim(sqlrs("otheroptions3")) <> "" then
					    response.write translatehpmgrcaptions(sqlrs("otheroptions3"))
					 end if
				  end if
				  Navigateshowlanguages "lang" & sqlrs("id")
				  htmlwrite "</div>"
			   case "search"
			      '800 - 2015.05.17 - Bug Fix: Predictive search is not working properly if xlogonrequired have been set to Yes
			      dim passsearchflag
				  passsearchflag = true
                  if lcase(GetConfig("xlogonrequired")) = "yes" then
				     if trim(GetSess("customerid")) = "" then
					    passsearchflag = false
					 end if
				  end if
				  if passsearchflag then

                  HtmlWrite "<div "& instylestr &" class=""search"">"
%>
                  <%'800 - Enhanced SEO%>
                  <form method="post" action="<%=DoFriendlySEOPage("shopsearch.asp")%>?search=Yes" id="<%=prefix%>form3" name="<%=prefix%>form3">
                  <div>
<%
				  if isnull(sqlrs("otheroptions3")) = false then
				     if trim(sqlrs("otheroptions3")) <> "" then
					    response.write translatehpmgrcaptions(sqlrs("otheroptions3"))
					 end if
				  end if
				  
				  '700 - 2010.06.03 - Enhancement: W3C updates
                  '700 - 2010.07.14 - Enhancement: Ajax search able to be switch off
				  '701 - 2011.03.15 - Enhancement: Speed up store performance
                  if getconfig("xAjaxSearchEnable") = "No" or getconfig("xLoadJLibJQuery") = "No" then
%>
                  <input type="text" class="searchfield" name="keyword" size="19" value="<%=GetLang("langsearchboxdefault")%>" onclick="clearfield(this.form)" />
<%
				  else
%>
                  <input type="text" class="searchfield" name="keyword" size="19" value="<%=GetLang("langsearchboxdefault")%>" onclick="clearfield(this.form)" onkeyup="getproductdesc(this.value,'<%=prefix%>')" />
<%
				  end if
%>
                  <button type="submit" class="submitbtn"><span class="fa fa-search"></span></button>
                  </div>
                  <div><span id="<%=prefix%>resultlist" class="searchresultwrapper"></span></div>
                  </form>
<%
                  htmlwrite "</div>"

                  '800 - 2015.05.17 - Bug Fix: Predictive search is not working properly if xlogonrequired have been set to Yes
                  end if

			end select
		 end if
	     sqlrs.movenext
	  wend
   end if
   closerecordset sqlrs
end sub
%>