<%option explicit%>
<%response.buffer=true%>
<!--#include file="shop$db.asp"-->
<%ShopOpenDatabase dbc%>
<!--#include file="shopcustomerform.asp"-->
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' If everyone must login then make them login
'*********************************************************************************

dim strPassword1
dim strPassword2
dim msg, newcust
dim i
dim sAction
dim rs

'800 - 2016.03.18 : Bug Fix: shoploginforce.asp not working properly for existing users
dim loginforce_fromupdate

' Set defaults here
SetSess "CurrentURL", "shoploginforce.asp"

'700 - 2010.09.30 - Enhancement: Better handling if xlogonrequired is Yes
if trim(session("logonafterurl")) = "" then
   SetSess "FollowonURL", "shopdisplaycategories.asp"
else
   SetSess "FollowonURL", session("logonafterurl")
end if

sAction = Request.form("Action") ' find out if we are being called via submit
if saction = "" then
   sAction = Request.form("Action.x") ' find out if we are being called via submit
end if
SError = GetSess("Loginerror") ' possible mesage from login
SetSess "Loginerror", "" ' error from shop login
if sAction = "" then ' no came from customer logic
   GetCustomerSessionData
   DisplayEveryThing
else
   '700 - 2010.04.22 - cross site script security enhancement
   verifygenpredefinedsecuritycode request("genpredefinedsecuritycode")

   SError = ""
   ValidateData() ' need to validate anything, nothing is required
   if SError = "" then
      UpdateOrderInformation ' put in customer and order data

      '6.50 - when customer registers, they should be logged in as well
      if GetConfig("xcustomerrequiresauthorization") = "Yes" then
	     '800 - 2016.03.18 : Bug Fix: shoploginforce.asp not working properly for existing users
	     if loginforce_fromupdate = "n" then
            SetSess "Login", ""
            SetSess "CustomerID", ""
            SetSess "Lastname", ""
            ShopError GetLang("langauthnotdone")
         else
		    SetSess "Login", strlastname
		 end if 
      else
         SetSess "Login", strlastname
      end if

      '700 - 2010.09.30 - Enhancement: Better handling if xlogonrequired is Yes
      session("logonafterurl") = ""

	  ResponseRedirect GetSess( "FollowonURL")
   else
      DisplayEveryThing
   end if
end if
ShopCloseDatabase dbc

sub DisplayEveryThing
   ShopPageHeader ' Normal page header
   DisplayErrors ' any input errors
   DisplayLoginForm() ' display customer
   ShopPageTrailer ' Normal page trailer
end sub

sub UpdateOrderInformation
   UpdateContact ' add customer to Database
   strCustomerid = GetSess("Customerid")
   strDiscount = GetSess("CustDiscount")
   UpdateCustomerSessionData
end sub

sub DisplayLoginForm()
	htmlwrite "<div class=""main-product"">"
   AddLogin ' User login form
   if GetConfig("xRestrictedtoExisting") = "Yes" then exit sub
   ' Outside table
   htmlwrite "<form name=""Loginform"" method=""post"" action=""shoploginforce.asp"">"

   '700 - 2010.04.22 - cross site script security enhancement
   htmlwrite "<input type=""hidden"" name=""genpredefinedsecuritycode"" value="""& session("genpredefinedsecuritycode") &""" />"

   AddInformationTable
   ShopCustomerForm false, false
   AddSubmitButton
   addwebsessform
   htmlwrite "</form>"
   htmlwrite "</div>"
end sub

sub ValidateData()
   '6.50 - security fix
   strFirstname = CleanChars(Request.form("strFirstname"))
   strLastname = CleanChars(Request.form("strLastname"))
   strAddress = CleanChars(Request.form("strAddress"))

   '6.50.4 Bugs Fix - 08 October 2008
   strAddress2 = CleanChars(Request.form("strAddress2"))
   strCity = CleanChars(Request.form("strCity"))
   strState = CleanChars(Request.form("strState"))
   strPostCode = CleanChars(Request.form("strPostCode"))
   strCountry = CleanChars(Request.form("strCountry"))
   strCompany = CleanChars(Request.form("strCompany"))
   strWebsite = CleanChars(Request.form("strWebsite"))
   strPhone = CleanChars(Request.form("strPhone"))
   strWorkphone = CleanChars(Request.form("strWorkphone"))
   strMobilephone = CleanChars(Request.form("strMobilephone"))
   strFax = CleanChars(Request.form("strFax"))
   strEmail = CleanChars(Request.form("strEmail"))
   strPassword1 = CleanChars(Request.form("strPassword1"))
   strPassword2 = CleanChars(Request.form("strPassword2"))
   strcustuserid = CleanChars(Request.form("strcustuserid"))
   strhearaboutus = CleanChars(Request.form("hearaboutus"))

   CustomerGetFields
   if strFirstname = "" then
      SError = SError & GetLang("LangCustFirstname") &GetLang("LangCustRequired")& "<br />"
   end if

   if strLastname = "" then
      SError = SError & GetLang("LangCustLastname") & GetLang("LangCustRequired")& "<br />"
   end if

   if strAddress = "" then
      SError = SError & GetLang("LangCustAddress") &GetLang("LangCustRequired")& "<br />"
   end if

   if strCity = "" then
      SError = SError & GetLang("LangCustCity") &GetLang("LangCustRequired")& "<br />"
   end if
   if GetConfig("xPromptForState") = "Yes" then
      if strState = "" or strState = "??" then
         SError = SError & GetLang("LangCustState") &GetLang("LangCustRequired")& "<br />"
      end if
   end if
   if strPostCode = "" then
      SError = SError & GetLang("LangCustPostCode") &GetLang("LangCustRequired")& "<br />"
   end if

   if strPhone = "" then
      SError = SError & GetLang("LangCustPhone") &GetLang("LangCustRequired")& "<br />"
   end if

   if strEmail = "" then
      SError = SError & GetLang("LangCustEmail") &GetLang("LangCustRequired")& "<br />"
   else
      CustomerValidateEmail stremail
   end if
   if GetConfig("xCountryRequired") = "Yes" then
      if strCountry = "" or strCountry = "??" then
         SError = SError & GetLang("LangCustCountry") &GetLang("LangCustRequired")& "<br />"
      end if
   end if
   if strhearaboutus = GetLang("langcommonselect") then
      strhearaboutus = ""
   end if
   if GetConfig("xhearaboutusrequired") = "Yes" and strhearaboutus = "" then
      SError = SError & GetLang("langhearaboutus") & GetLang("langCustRequired") & "<br />"
   end if
   ValidatePassword

   dim emailrc
   '800 - 2016.03.18 : Bug Fix: shoploginforce.asp not working properly for existing users
   if GetSess("Login")<>"" then
      loginforce_fromupdate = "y"
      validateemail_existing strEmail, "y", "update", emailrc
   else
      loginforce_fromupdate = "n"
      validateemail_existing strEmail, "y", "add", emailrc
   end if
end sub

sub AddLogin
   if GetSess("Login")<>"" then
      exit sub
   end if
   ShoploginForceform
end sub

sub AddOptionalStuff
   if GetConfig("xPromptForOptional") = "Yes" then
      response.write("<br /><span class='fontbold'>" & GetLang("LangCust02") & "</span>")
      htmlwrite "<table border=""0"" cellpadding=""3"" cellspacing=""3"" align=""center"">"
      CreateCustRow GetLang("LangCustWebsite"), "strwebsite", strwebsite, "No",""
      CreateCustRow GetLang("LangCustWorkphone"), "strWorkphone", strWorkPhone, "No",""
      CreateCustRow GetLang("LangCustMobilephone"), "strMobilephone", strMobilePhone, "No",""
      CreateCustRow GetLang("LangCustFax"), "strFax", strFax, "No",""
      response.write("</table><p>")
   end if
end sub


sub ValidatePassword
   '800 - 2016.03.18 : Bug Fix: shoploginforce.asp not working properly for existing users
   if GetSess("Login")<>"" then
      exit sub
   end if

   dim rc
   if ucase(GetConfig("xpassword")) = "YES" then
      if GetConfig("xcustomeruserid") = "Yes" then
         if strcustuserid = "" then
            SError = SError & GetLang("LangAdminusername") &GetLang("LangCustRequired")& "<br />"
         end if
      end if
      if strPassword1 = "" then
         SError = SError & GetLang("LangPassword") & "1" &GetLang("LangCustRequired")& "<br />"
         exit sub
      end if
      if strPassword2 = "" then
         SError = SError & GetLang("LangPassword") & "2" &GetLang("LangCustRequired")& "<br />"
         exit sub
      end if
      if StrPassword1<>strPassword2 then
         SError = SError & GetLang("LangPasswordMismatch") & "<br />"
         exit sub
      end if
      if len(strPassword1) >= 6 then
         CheckForDuplicate rc
         if rc > 0 then
            SError = SError & GetLang("LangPasswordDuplicate") & "<br />"
         end if
      else
         SError = SError & GetLang("LangPasswordLength") & "<br />"
      end if
   end if
end sub

sub DisplayErrors
   if SError<> "" then
      ShopWriteError SError
      SError = ""
   end if
end sub

sub AddSubmitButton
   if GetConfig("xbuttoncontinue") = "" then
      response.write("<input class=""submitbtn"" type=""submit"" name=""action"" value=""" & trim( GetLang("LangCommonContinue")) & """ />")
   else
      response.write("<input type=""image"" name=""action"" src=""" & GetConfig("xbuttoncontinue") & """ />")
   end if
end sub

sub CheckForDuplicate (rc)
   dim testsql
   SetSess "Login", "Force"
   '6.09 - clean insecure characters from email
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   sql = "select * from customers where lastname="& sqlserverprefixn &"'" & strlastname & "' and  password ="& sqlserverprefixn &"'" & strpassword1 & "'"
   sql = sql & " and email='" & CleanChars(stremail) & "'"
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open SQL, dbc, adOpenStatic, adLockReadOnly
   if not rs.eof then
      rc = 4
   else
      rc = 0
   end if
   CloseRecordSet rs
   SetSess "Login", ""
end sub

sub AddInformationTable
   htmlwrite "<p class=""ac"">" & "<span class=""largeinfofont"">"
   response.write GetLang("LangCustomerPrompt") & "<br />"
   htmlwrite "</span>" & "</p>"
end sub

sub ValidateEmail
   if not instr(strEmail, "@") > 1 then
      SError = SError & GetLang("LangInvalidEmail") & "<br />"
   end if
end sub

sub ShopLOginForceForm
   dim caption
   if GetConfig("xcustomeruserid") = "Yes" then
      caption = GetLang("langAdminUsername")
   else
      caption = GetLang("langStatusEmail")
   end if
%>
  <h1 class="global-font-color"><%=GetLang("langCust01")%></h1>
  <form name="form1" method="post" action="shoplogin.asp">
<%
'700 - 2010.04.22 - cross site script security enhancement
htmlwrite "<input type=""hidden"" name=""genpredefinedsecuritycode"" value="""& session("genpredefinedsecuritycode") &""" />"
%>
  <div class="comment_title fontbold"><%=getlang("langcommonlogin")%></div>
    <div class="sidebarcell">
	<div class="comment_text">
        <div class="blog_review_container" >
        <% If ucase(GetConfig("Xpassword"))="YES" then %>
            <%'800 - 2016.01.14 - Remove xPasswordLastname related code as xPasswordLastname is redundant%>
            <div class="row">
				<div class="col-sm-4">
					<label><%=caption%></label>
				</div>
				<div class="col-sm-8">
					<input class="textarea form-control" size="20" name="strEmail" />
				</div>
            </div>
            <div class="row">
				<div class="col-sm-4">
					<label><%=GetLang("langLoginPassword")%></label>
				</div>
				<div class="col-sm-8">
					<input size="20" class="textarea form-control" type="password" name="strPassword" />
				</div>
			</div>
        <% else %>
            <div class="row">
				<div class="col-sm-4">
					<label><%=GetLang("langCustLastname")%></label>
				</div>
				<div class="col-sm-8">
					<input class="textarea" size="20" name="strLastname" class="form-control" value=<%=Chr(34) & strLastname & Chr(34)%> />
				</div>
            </div>
            <fieldset>
            <label><%=GetLang("langCustEmail")%></label>
            <input size="20" class="textarea" name="strEmail" />
            <div class="cb"></div>
            </fieldset>
        <% end if %>
        
            <div class="row">
				<div class="col-sm-6"
					<%'800 - Enhanced SEO%>
					<span class="al"><a href="<%=DoFriendlySEOPage("shopmailpwd.asp")%><%addwebsesslink%>"><%=GetLang("langLoginForgot")%></a></span>
				</div>
				<div class="col-sm-6">
					<div class="pull-right">
						<%ShopButton GetConfig("xbuttonlogin"),GetLang("langcommonlogin"),""%>
					</div>
				</div>
			</div>
		</div>
    </div>
    <div class="submit_btn_container">
	</div>
	</div>
    <% addwebsessform %>
    </form>
<%
end sub
%>