<%'option explicit%>
<%response.buffer=true%>
<!-- #include file="shop$db.asp" -->
<%ShopOpenDatabase dbc%>
<!-- #include file="shopcartformat.asp" -->
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' creates a confirmation form that the user can use to mail or fax manually
' or to just verify the order details before proceeeding
'*********************************************************************************

ShopPageHeader ' Normal page header
response.write "<div class=""ac"">"
GetCustomerSessionData ' make sure we have all session data in local variables
GetCompanyInfo ' Write our own company information
CartFormat "NOREMOVE" ' common format cart routine
FormatSessionOrder
if GetConfig("XDisplayPrices")<>"No" then
   FormatCreditCard
end if
response.write "</div>"
ShopPageTrailer ' Normal Shop page trailer
ShopCloseDatabase dbc

'Get company info
sub GetCompanyInfo
   dim rsus
   set rsus = Server.createobject ("ADODB.Recordset")

   '800 - 2016.09.06 - Company info: Multiple sites can have unique company information
   dim sql
   sql="select * from mycompany"
   if lcase(getconfig("xsite_sharecompany")) = "no" then
      sql = sql & " where (xshopid is null or xshopid = '' or xshopid = '"& tosql(xshopid,"Text") &"')"
   end if
   rsus.open sql, dbc, adOpenKeyset, adLockReadOnly

   if rsus.eof then
      rsus.close
      set rsus = nothing
      exit sub
   end if
   ShopWriteHeader GetLang("LangMailForm01")
   response.write rsus("companyname") & "<br />"
   response.write rsus("address")& "<br />"
   response.write rsus("city") & " " & rsus("state") & " " & rsus("postalcode") & "<br />"
   response.write rsus("country") & "<br />"
   response.write GetLang("LangCustPhone") & ": " & rsus("phonenumber") & "<br />"
   response.write GetLang("LangCustFax") & ": " & rsus("faxnumber") & "<br />"
   response.write GetLang("LangCustEmail") & ": " & rsus("myemail") & "<br /><br />"

   '6.50 - show extra information
   if rsus("other1") > "" then
      response.write rsus("other1") & "<br />"
   end if
   if rsus("other2") > "" then
      response.write rsus("other2") & "<br />"
   end if
   if rsus("other3") > "" then
      response.write rsus("other3") & "<br />"
   end if
   if rsus("other4") > "" then
      response.write rsus("other4") & "<br />"
   end if
   response.write "<br />"

   rsus.close
   set rsus = nothing
end sub

sub FormatSessionOrder
   htmlwrite "<br />" & "<table border=""0"" cellpadding=""1"" cellspacing=""1"" width=""100%"" class=""info_table"">"
   DoHeader GetLang("LangFormatCustomerInformation")
   DoField GetLang("LangCustFirstName"), strFirstName
   DoField GetLang("LangCustLastName"), strLastName
   DoField GetLang("LangCustAddress") , strAddress
   DoField GetLang("LangCustAddress")& "2" , strAddress2
   DoField GetLang("LangCustCity"), strCity
   DoField GetLang("LangCustState") , strState
   DoField GetLang("LangCustPostCode"), strPostCode
   DoField GetLang("LangCustCountry"), strcountry
   DoField GetLang("LangCustEmail"), stremail
   DoField GetLang("LangCustPhone"), strphone
   DoField GetLang("LangCustFax"), strfax
   DoField GetLang("LangCustCompany"), strcompany
   if GetConfig("xShippingForm") = "Yes" then
      DoHeader GetLang("LangFormatShippingInformation")
      DoField GetLang("LangShippingMethod"), GetSess("shipmethod")
      DoField GetLang("LangShipName"), GetSess("shipname")
      DoField GetLang("LangShipAddress"), GetSess("shipaddress")
      DoField GetLang("LangShipAddress")& "2", GetSess("shipaddress2")
      DoField GetLang("LangShipCity"), GetSess("Shiptown")
      DoField GetLang("LangShipState"), GetSess("Shipstate")
      DoField GetLang("LangShipPostcode"), GetSess("shipzip")
      DoField GetLang("LangShipCompany"), GetSess("Shipcompany")
      DoField GetLang("LangShipCountry"), GetSess("Shipcountry")
      DoField GetLang("LangDeliverydate"), GetSess("deliverydate")
      DoField GetLang("LangDeliverytime"), GetSess("deliverytime")
   end if
   htmlwrite "</table>"
end sub

sub DoField (fieldname, fieldvalue)
   if fieldvalue = "" or isnull(fieldvalue) then
      exit sub
   end if
   htmlwrite "<tr>"
   htmlwrite "<td class=""al item_row"" width=""30%""><span class='fontbold'>" & fieldname & "</span></td>"
   htmlwrite "<td class=""al item_row"" width=""740"">" & fieldvalue & "</td></tr>"
end sub

sub DoHeader (mytext)
   htmlwrite "<tr>"
   htmlwrite "<td colspan=""2"" class=""menuhdr al""><span style=""color:""><span class='fontbold'>" & mytext & "</span></span></td>"
   htmlwrite "</tr>"
end sub

sub FormatCreditCard
   htmlwrite "<table border=""0"" cellpadding=""1"" cellspacing=""1"" width=""100%"" class=""info_table"">"
   DoHeader GetLang("LangFormatPaymentInformation")
   DoFieldX GetLang("LangCheckoutCardNumber")
   DoFieldx GetLang("LangCheckoutCardName")
   DoFieldx GetLang("LangCheckoutExpiry")
   DoFieldx GetLang("LangCheckoutAddress")
   DoFieldx GetLang("LangCheckoutCVN")
   htmlwrite "</TABLE>"
   if GetSess("shipcomment") <> "" then
      ShopWriteHeader GetLang("LangOrderComments")
      ShopWriteError GetSess("shipcomment")
      htmlwrite "<br /><br />"
   end if
end sub

sub DoFieldx (fieldname)
   dim fieldvalue
   fieldvalue = "&nbsp;"
   htmlwrite "<tr>"
   htmlwrite "<td class=""al item_row"" width=""30%""><span class='fontbold'>" & fieldname & "</span></td>"
   htmlwrite "<td class=""al item_row"" width=""740"">" & fieldvalue & "</td></tr>"
end sub
%>