<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Generates SQL to display a product.
' Creates SQL for display products, search and shopquery
' expects most parameters to be in global
'*********************************************************************************

dim xSearchSortField, xsearchsortupdown

sub Productcreatesql (sql, dbc)
   sql = ""
   
   dim strProductFields
   dim i
   dim strdistinct
   strdistinct = "DISTINCTROW"
   if ucase(xDatabaseType) = "SQLSERVER" or ucase(GetConfig("xDatabaseType")) = "SQLSERVER" then
      strdistinct = "DISTINCT"
   end if
   strProductFields = GetSess("strProductFields")
   if strProductFields = "" then
      GetProductfields dbc
      strProductFields = GetSess("strProductFields")
   end if
   if GetConfig("xCategoriesSimple") = "Yes" then
      NewProductSQL sql
      exit sub
   end if
   ' Find sql injection attack
   dim tcategory, tproductname
   CatalogId = CleanCharsint(CatalogId)
   cat_id = CleanCharsint(cat_Id)
   tcategory = CleanChars(category)
   tproductname = CleanChars(productname)

   sql = "select " & strdistinct & " " & strproductfields
   sql = sql & " from products p, prodcategories cc, categories c "
   sql = sql & " where cc.intCatalogId=p.CatalogId and cc.intcategoryid=c.categoryid and"
   if cat_id <> "" then
      sql = sql & " cc.intcategoryid = " & cat_id
   else
      if CatalogId<>"" then
         sql = sql & " p.CatalogId = " & CatalogId
      else
	     '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
         if tproductname = "" then
            sql = sql & " c.catdescription like "& sqlserverprefixn &"'"& tcategory & "%'"
         else
            sql = sql & " p.cname like "& sqlserverprefixn &"'"& tproductname & "%'"
         end if
      end if
   end if

   '700 - generate sql by product criteria - 2010.04.03
   generateproductstdcriteriasql sql, "p.", "c.", "generateproductmatchsql"
   
   'inventory
   sql = sql & " AND (higherCatalogId is null)"

   '700 - 2010.09.02 - Bug Fix: xsortproducts with multiple tables sql issues
   generateprefixsortfield sql
   
   if GetConfig("xdebug") = "Yes" then
      DebugWrite sql
   end if
end sub

sub SearchGenerateSQL(dbc)
   dim i, j
   dim whereok
   dim SearchFields
   dim Fieldcount
   dim strdistinct
   dim tword
   strdistinct = "DISTINCTROW"
   if ucase(xDatabaseType) = "SQLSERVER" or ucase(GetConfig("xDatabaseType")) = "SQLSERVER" then
      strdistinct = "DISTINCT"
   end if
   if GetConfig("xCategoriesSimple") = "Yes" then
      NewSearchGenerateSQL sql
      exit sub
   end if
   SetupSearchFields SearchFields
   Fieldcount = ubound(Searchfields)
   whereok = " AND "
   dim strProductFields, tmpstr
   GetProductFields dbc
   strProductFields = GetSess("strProductFields")

   '6.50.1 - fix for error when xsearchsortfield is not included in select list
   if xSearchSortField <> "" then
      tmpstr = "select " & strdistinct & " " & strproductfields & "," & xSearchSortField & " from products p, prodcategories cc, prodcategories sc, categories c"
   else
      tmpstr = "select " & strdistinct & " " & strproductfields & " from products p, prodcategories cc, prodcategories sc, categories c"
   end if

   sql = " where cc.intCatalogId=p.CatalogId and cc.intcategoryid=c.categoryid AND sc.intCatalogId=p.CatalogId"
   if wordcount> 0 then
      SQL = SQL & whereok
      SQL = SQL & "("
      Whereok = ""
      for i = 0 to wordcount -1
         SQL = SQL & whereok
         for j = 0 to fieldcount
            if j> 0 then
               SQL = SQL & " OR "
            else
               SQL = SQL & " ( "
            end if
            tword = CleanChars(Words(i))
			'700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
            SQL = SQL & Searchfields(j) & " Like "& sqlserverprefixn &"'%" & tword & "%' "
         next
         SQL = SQL & " )"
         whereok = " OR "
      next
      SQL = SQL & ")"
      whereok = " AND "
   end if
   if catCount<>0 then
      SQL = SQL & whereok
      SQL = SQL & " ("
      whereok = ""
      for i = 0 to catcount -1
         sql = sql & whereok & " cc.intcategoryid = " & CleanCharsint(catarray(i))
         whereOK = " OR "
      next
      Sql = Sql & ")"
      whereok = " AND "
   end if

   if SubcatCount<>0 then
      SQL = SQL & whereok
      SQL = SQL & " ("
      whereok = ""
      dim blnSubcat
      blnSubCat = False
      for i = 0 to Subcatcount -1
         sql = sql & whereok & "sc.intcategoryid" & "=" & CleanCharsint(subcatarray(i))
         whereOK = " OR "
         blnSubCat = True
      next
      Sql = Sql & ")"
      whereok = " AND "
   end if
   '
   Sql = Sql & whereok
   sql = sql & " hide=0"
   whereok = " AND "
   if GetConfig("xstocklow")<>"" then
      lngCStock = clng(GetConfig("xStockLow"))
      SQL = SQL & WhereOK
      sql = sql & " cstock> " & lngcstock
      whereok = " AND "
   end if

   if GetConfig("xsearchbyprice") = "Yes" then
      highprice = CleanCharsint(highprice)
      lowprice = CleanCharsint(lowprice)
      if lowprice>0 then
         SQL = SQL & WhereOK
         sql = sql & " cprice> " & lowprice
      end if
      if highprice>0 then
         SQL = SQL & WhereOK
         sql = sql & " cprice< " & highprice
      end if
      whereok = " AND "
   end if

   if GetConfig("xproductmatch") = "Yes" then
      SQL = SQL & WhereOK
      '6.50 - enhanced product matching
      GenerateProductMatchSql sql
      whereok = " AND "
   end if

   '700 - Customer Groups - Matching Custormer match
   sql = sql & GenerateCustomerMatchSQL ("p.customermatch","p.excustomermatch","p.loggedin",whereok)
   sql = sql & GenerateCustomerMatchSQL ("c.customermatch","c.excustomermatch","c.loggedin","and")
   whereok = " AND "

   if GetConfig("xselectproductsbylanguage") = "Yes" and GetSess("language")<>"" then
      '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      sql = sql & " and (clanguage="& sqlserverprefixn &"'" & GetSess("language") & "'"
      sql = sql & " or clanguage is null)"
   end if

   'added for search sort 3 April 2002n
   if xSearchSortField<>"" then
      sql = sql & " order by " & xSearchSortField & " " & xsearchsortupdown
   else
      '700 - 2010.09.02 - Bug Fix: xsortproducts with multiple tables sql issues
      generateprefixsortfield sql
   end if
   sql = tmpStr & sql
   SetSess "SQL", SQL
   SetSessA "words", Words
   SetSess "wordcount", wordcount
   if GetConfig("xdebug") = "Yes" then
      DebugWrite sql
   end if
end sub

sub QueryGenerateSQL (dbc)
   dim i
   dim rc
   dim strProductFields
   dim strdistinct, whereok
   strdistinct = "DISTINCTROW"
   if ucase(xDatabaseType) = "SQLSERVER" or ucase(GetConfig("xDatabaseType")) = "SQLSERVER" then
      strdistinct = "DISTINCT"
   end if
   if GetConfig("xCategoriesSimple") = "Yes" then
      NewQueryGenerateSQL
      exit sub
   end if
   strProductFields = GetSess("strProductFields")
   if strProductFields = "" then
      GetProductFields dbc
      strProductFields = GetSess("strProductFields")
   end if
   tmpstr = "select " & strdistinct & " " & strproductfields & " from products p, prodcategories cc, categories c "
   firsttime = "FALSE"
   sql = " where cc.intCatalogId=p.CatalogId and cc.intcategoryid=c.categoryid "
   for i = 0 to keycount -1
      if lcase(keys(i)) <> "template" then
         AddSQL keys(i), keyvalues(i), SQL
      end if
   next
   AddPrefix

   '700 - generate sql by product criteria - 2010.04.03
   generateproductstdcriteriasql sql, "p.", "c.", "generateproductmatchsql"
   
   whereok = " AND "

   '6.5.1 - exclude child products from alphabet display
   sql = sql & " AND (higherCatalogId is null)"

   '700 - 2010.09.02 - Bug Fix: xsortproducts with multiple tables sql issues
   generateprefixsortfield sql

   sql = tmpStr & sql
   if GetConfig("xdebug") = "Yes" then
      DebugWrite sql
   end if
end sub

sub addPrefix
   if firsttime = "TRUE" then
      SQL = SQL & " WHERE "
      firsttime = "FALSE"
   else
      SQL = SQL & " AND "
   end if
end sub

sub GetProductFields (dbc)
   dim sortfields, strproductfields
   strproductfields = "p.CatalogId"
   sortfields = lcase(GetConfig("xsortproducts"))

   '6.50 - added lcase() call around sortfields to ensure ASC and DESC are removed correctly
   sortfields = replace(lcase(sortfields), " asc", "")
   sortfields = replace(lcase(sortfields), " desc", "")

   '6.50.4 Bugs Fix - 08 October 2008
   sortfields = replace(lcase(sortfields), ",catalogid", "")
   sortfields = replace(lcase(sortfields), "catalogid,", "")
   sortfields = replace(lcase(sortfields), "catalogid", "")
   if sortfields<>"" then
      '700 - 2010.09.02 - Bug Fix: xsortproducts with multiple tables sql issues
	  '7.01 - 2010.10.08 - Bug Fix: assign more than 2 values to xsortproducts returned errors
	  sortfields = replace(lcase(sortfields), ", ", ",")
	  
      if instr(sortfields,"p.") <= 0 then
         sortfields = "p." & sortfields
		 
		 '7.01 - 2010.10.08 - Bug Fix: assign more than 2 values to xsortproducts returned errors
	     sortfields = replace(lcase(sortfields), ",", ",p.")
      end if

      strproductfields = strproductfields & "," & sortfields
   end if
   SetSess "strProductFields", strProductFields
end sub

sub AddSQL (strname, strvalue, SQL)
   dim Queryprefix
   Queryprefix = "%"
   dim queryreq
   queryreq = request("queryprefix")
   if lcase(queryreq) = "no" then
      queryprefix = ""
   end if
   dim fieldtype, istrname, tvalue
   ustrname = ucase(strname)
   CheckValIDField ustrname, rc, fieldtype
   if rc>0 then
      exit sub
   end if
   if Fieldtype = "Number" or FieldType = "Currency" then
      strvalue = CleanCharsInt(strvalue)
   end if

   if fieldtype = "Text" or fieldtype = "Memo" then
      if ucase(strvalue) = allvalues then ' make all really mean all
         strvalue = ""
      end if
      addprefix
	  
	  '700 - 2010.08.20 - Bug Fix: Security - possible cross-site script error
      tvalue = tosql(CleanChars(strvalue),"Text")

	  '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      SQL = SQL & " p." & strname & " like "& sqlserverprefixn &"'" & queryprefix & tvalue & "%'"
      exit sub
   end if
   if Fieldtype = "DateTime" then
      addprefix
      SQL = SQL & " p." & strname & "=#" & cdate(strvalue) & "#"
      exit sub
   end if

   '702 - 2013.06.11 - Bug Fix: Search cprice is not working if using MySQL or MsSQL DB
   if Fieldtype = "Currency" or trim(lcase(strname)) = "cprice" then

      if strvalue<0 then
         exit sub
      end if
      if not isnumeric(strvalue) then
         exit sub
      end if
      if GetConfig("xConvertEuropeanNumbers") = "Yes" then
         strvalue = replace(strvalue, ",", ".")
      end if
      addprefix
      if strname<>"lowprice" then
         SQL = SQL & " p." & strname & "<=" & strvalue
		 SQL = SQL & " and p." & strname & "<> 0"
      else
         SQL = SQL & " p.cprice>=" & strvalue
      end if
      exit sub
   end if
   if Fieldtype = "Number" then
      if strvalue<0 then
         exit sub
      end if
      if not isnumeric(strvalue) then
         exit sub
      end if
      addprefix
      SQL = SQL & " p." & strname & "=" & strvalue
      exit sub
   end if
   addprefix
   SQL = SQL & " p." & strname & " like '" & strvalue & "%'"
end sub

' dont use prod categories table
sub NewProductSQL(sql)
   dim strProductFields
   dim i
   dim strdistinct
   strdistinct = "DISTINCTROW"
   if ucase(xDatabaseType) = "SQLSERVER" or ucase(GetConfig("xDatabaseType")) = "SQLSERVER" then
      strdistinct = "DISTINCT"
   end if
   strProductFields = GetSess("strProductFields")
   if strProductFields = "" then
      GetProductfields dbc
      strProductFields = GetSess("strProductFields")
   end if
   sql = "select " & strdistinct & " " & strproductfields
   sql = sql & " from products p, prodcategories cc, categories c where "
   sql = sql & " cc.intCatalogId=p.CatalogId and cc.intcategoryid=c.categoryid and "
   if cat_id <> "" then
      sql = sql & " (p.ccategory = " & cat_id & " or p.subcategoryid = " & cat_id & ") "
   else
      if CatalogId<>"" then
         sql = sql & " p.CatalogId = " & CleanCharsint(CatalogId)
      else
	     '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
         if productname = "" then
            sql = sql & "p.category like "& sqlserverprefixn &"'"& CleanChars(category) & "%'"
         else
            sql = sql & "p.cname like "& sqlserverprefixn &"'"& CleanChars(productname) & "%'"
         end if
      end if
   end if

   '700 - generate sql by product criteria - 2010.04.03
   generateproductstdcriteriasql sql, "p.", "c.", "generateproductmatchsql"

   '700 - 2010.09.02 - Bug Fix: xsortproducts with multiple tables sql issues
   generateprefixsortfield sql
end sub

' Simple category mode for searches
sub NewSearchGenerateSQL(sql)
   dim i, j, tword
   dim whereok
   dim SearchFields
   dim Fieldcount
   SetupSearchFields SearchFields
   Fieldcount = ubound(Searchfields)
   whereok = " WHERE "
   SQL = "SELECT * FROM products p, prodcategories cc, categories c "
   SQL = SQL & " where cc.intCatalogId=p.CatalogId and cc.intcategoryid=c.categoryid "
   whereok = " AND "
   if wordcount> 0 then
      SQL = SQL & whereok
      SQL = SQL & "("
      Whereok = ""
      for i = 0 to wordcount -1
         SQL = SQL & whereok
         for j = 0 to fieldcount
            if j> 0 then
               SQL = SQL & " OR "
            else
               SQL = SQL & " ( "
            end if
            tword = CleanChars(words(i))
			'700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
            SQL = SQL & Searchfields(j) & " Like "& sqlserverprefixn &"'%" & tword & "%' "
         next
         SQL = SQL & " )"
         whereok = " OR "
      next
      SQL = SQL & ")"
      whereok = " AND "
   end if
   if catCount<>0 then
      SQL = SQL & whereok
      SQL = SQL & " ("
      whereok = ""
      for i = 0 to catcount -1
         sql = sql & whereok & " ccategory = " & clearcharint(catarray(i))
         whereOK = " OR "
      next
      Sql = Sql & ")"
      whereok = " AND "
   end if
   if SubcatCount<>0 then
      SQL = SQL & whereok
      SQL = SQL & " ("
      whereok = ""
      for i = 0 to Subcatcount -1
         sql = sql & whereok & " subcategoryid = " & CleanCharsint(subcatarray(i))
         whereOK = " OR "
      next
      Sql = Sql & ")"
      whereok = " AND "
   end if
   Sql = Sql & whereok
   sql = sql & " (hide=0)"
   whereok = " AND "
   if GetConfig("xstocklow")<>"" then
      lngCStock = clng(GetConfig("xStockLow"))
      SQL = SQL & WhereOK
      Sql = sql & " cStock> " & lngCStock
      whereok = " AND "
   end if

   if GetConfig("xsearchbyprice") = "Yes" then
      highprice = CleanCharsint(highprice)
      lowprice = CleanCharsint(lowprice)
      if lowprice>0 then
         SQL = SQL & WhereOK
         sql = sql & " cprice> " & lowprice
      end if
      if highprice>0 then
         SQL = SQL & WhereOK
         sql = sql & " cprice< " & highprice
      end if
      whereok = " AND "
   end if

   if GetConfig("xproductmatch") = "Yes" then
      SQL = SQL & WhereOK
      '6.50 - enhanced product matching
      generateproductmatchsql sql
      whereok = " AND "
   end if

   '700 - Customer Groups - Matching Custormer match
   sql = sql & GenerateCustomerMatchSQL ("p.customermatch","p.excustomermatch","p.loggedin",whereok)
   sql = sql & GenerateCustomerMatchSQL ("c.customermatch","c.excustomermatch","c.loggedin","and")
   whereok = " AND "

   if GetConfig("xselectproductsbylanguage") = "Yes" and GetSess("language")<>"" then
      '6.50 - added code to handle clanguage
	  '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      sql = sql & " "& whereok &" (clanguage="& sqlserverprefixn &"'" & GetSess("language") & "'"
      sql = sql & " or clanguage is null)"
   end if

   '700 - 2010.09.02 - Bug Fix: xsortproducts with multiple tables sql issues
   generateprefixsortfield sql

   SetSess "SQL", SQL
   SetSessA "words", Words
   SetSess "wordcount", wordcount
end sub

' simple category mode for shopquery
sub NEWQueryGenerateSQL
   on error resume next

   '700 - 2010.06.13 - Bug Fix: Query product while xCategoriesSimple = Yes using wrong SQL Query
   firsttime = "FALSE"

   '700 - 2010.08.30 - Bug Fix: Alphabet search is not working if xCategoriesSimple = Yes
   dim strProductFields,strdistinct
   strdistinct = "DISTINCTROW"
   if ucase(xDatabaseType) = "SQLSERVER" or ucase(GetConfig("xDatabaseType")) = "SQLSERVER" then
      strdistinct = "DISTINCT"
   end if
   strProductFields = GetSess("strProductFields")
   if strProductFields = "" then
      GetProductFields dbc
      strProductFields = GetSess("strProductFields")
   end if
   SQL = "SELECT " & strdistinct & " " & strproductfields & " FROM products p, categories c"

   SQL = SQL & " where p.ccategory=c.categoryid "

   if GetConfig("xstocklow")<>"" then
      lngCStock = clng(GetConfig("xStockLow"))
      oldaddprefix
      SQL = SQL & " cStock> " & lngCStock
   end if
   
   '700 - 2010.08.30 - Bug Fix: Alphabet search is not working if xCategoriesSimple = Yes
   dim i
   for i = 0 to keycount -1
      '700 - 2010.08.30 - Bug Fix: Alphabet search is not working if xCategoriesSimple = Yes
      AddSQL keys(i), keyvalues(i), SQL
   next

   oldaddprefix
   sql = sql & " (hide is NULL OR hide=0)"
   if GetConfig("xproductmatch") = "Yes" then
      oldaddprefix

      '6.50 - enhanced product matching
      generateproductmatchsql sql
   end if

   '700 - Customer Groups - Matching Custormer match
   if firsttime = "TRUE" then
	  sql = sql & GenerateCustomerMatchSQL ("p.customermatch","p.excustomermatch","p.loggedin","and")
	  sql = sql & GenerateCustomerMatchSQL ("c.customermatch","c.excustomermatch","c.loggedin","and")
   else
	  sql = sql & GenerateCustomerMatchSQL ("p.customermatch","p.excustomermatch","p.loggedin","and")
	  sql = sql & GenerateCustomerMatchSQL ("c.customermatch","c.excustomermatch","c.loggedin","and")
   end if
   whereok = " AND "

   if GetConfig("xselectproductsbylanguage") = "Yes" and GetSess("language")<>"" then
      oldaddprefix
      '6.50 - added code to handle clanguage
	  '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      sql = sql & " (clanguage="& sqlserverprefixn &"'" & GetSess("language") & "'"
      sql = sql & " or clanguage is null)"
   end if

   '700 - 2010.09.02 - Bug Fix: xsortproducts with multiple tables sql issues
   generateprefixsortfield sql

   if GetConfig("xdebug") = "Yes" then
      DebugWrite sql
   end if
end sub

sub OLDAddSQL (strname, strvalue, SQL)
   dim fieldtype, istrname
   ustrname = ucase(strname)
   CheckValIDField ustrname, rc, fieldtype
   if rc>0 then
      exit sub
   end if
   if Fieldtype = "Number" or FieldType = "Currency" then
      strvalue = CleanCharsint(strvalue)
   end if

   if fieldtype = "Text" or fieldtype = "Memo" then
      if ucase(strvalue) = allvalues then ' make all really mean all
         strvalue = ""
      end if
      oldaddprefix
	  '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      SQL = SQL & " " & strname & " like "& sqlserverprefixn &"'" & CleanChars(strvalue) & "%'"
      exit sub
   end if
   if Fieldtype = "DateTime" then
      oldaddprefix
      SQL = SQL & " " & strname & "=#" & cdate(strvalue) & "#"
      exit sub
   end if
   if Fieldtype = "Currency" then
      if strvalue<0 then
         exit sub
      end if
      if not isnumeric(strvalue) then
         exit sub
      end if
      if GetConfig("xConvertEuropeanNumbers") = "Yes" then
         strvalue = replace(strvalue, ",", ".")
      end if
      oldaddprefix
      SQL = SQL & " " & strname & "<=" & strvalue
      exit sub
   end if
   if Fieldtype = "Number" then
      if strvalue<0 then
         exit sub
      end if
      if not isnumeric(strvalue) then
         exit sub
      end if
      oldaddprefix
      SQL = SQL & " " & strname & "=" & strvalue
      exit sub
   end if
   oldaddprefix
   SQL = SQL & " " & strname & " like '" & strvalue & "%'"
end sub

sub oldaddPrefix
   if firsttime = "TRUE" then
      SQL = SQL & " WHERE "
      firsttime = "FALSE"
   else
      SQL = SQL & " AND "
   end if
end sub

' SQL injection Function
function CleanCharsInt(strWords)
   dim newchars
   newchars = strwords
   if not isnumeric(strwords) then
      newchars = 0
   end if
   CleanCharsint = newChars
end function

' SQL generator for new search system
' Steve 21/9/2005
sub SearchGenerateSQLv2(dbc)
   dim i, j
   dim whereok
   dim SearchFields
   dim Fieldcount
   dim strdistinct
   dim tword
   '800 - 2015.07.27 - Enhancement: To inlcude prodfeatures to the search
   strdistinct = "DISTINCT "

   if ucase(xDatabaseType) = "SQLSERVER" or ucase(GetConfig("xDatabaseType")) = "SQLSERVER" then
      strdistinct = "DISTINCT "
   end if
   SetupSearchFields SearchFields
   Fieldcount = ubound(Searchfields)

   '800 - 2015.12.02 - To remove prodfeatures from sql query if xsearchfields does not have any prodfeatures fields
   dim productfeatureflag
   if instr(lcase(GetConfig("xsearchfields")),"pf.") > 0 then
      productfeatureflag = true
   else
      productfeatureflag = false
   end if

   whereok = " AND "
   dim strProductFields, tmpstr
   GetProductFields dbc
   strProductFields = GetSess("strProductFields")

   '6.50.1 - fix for error when xsearchsortfield is not included in select list
   '800 - 2015.07.27 - Enhancement: To inlcude prodfeatures to the search
   '800 - 2015.09.22 - Bug Fix: xsortproducts is not working properly if others than value cname,ccode,catalogid
   '800 - 2015.09.22 - Better handlling on configuration xsortproducts that able to handle DESC and ASC and multiple values
   dim xsortproducts, selectlist
   dim xsortproductsary(99), xsortproductscnt, icnt
   xsortproducts = getconfig("xsortproducts")
   selectlist = "p.cname,p.ccode,p.catalogid"
   parserecord_split xsortproducts,xsortproductsary,xsortproductscnt,","
   if trim(xsortproducts) <> "" then
      dim xsortproductsind
	  for icnt = 0 to (xsortproductscnt-1)
   	     xsortproductsind = trim(xsortproductsary(icnt))
	     xsortproductsind = replace(lcase(xsortproductsind)," desc","")
	     xsortproductsind = replace(lcase(xsortproductsind)," asc","")
	     if lcase(xsortproductsind) <> "cname" and lcase(xsortproductsind) <> "ccode" and lcase(xsortproductsind) <> "catalogid" then
            if instr(selectlist,replace(lcase(xsortproductsind),"p.","")) <= 0 then
	           if instr(lcase(xsortproducts),"p.") <= 0 then
                  selectlist = selectlist & ",p." & xsortproductsind
               else
		          selectlist = selectlist & "," & xsortproductsind
		       end if
            end if
		 end if
	  next
   end if
   tmpstr = "select " & strdistinct & " " & selectlist

   if ucase(xdatabasetype) = "SQLSERVER" then
      tmpstr = tmpstr & " from products p inner join prodcategories cc on cc.intCatalogId = p.CatalogId inner join categories c on cc.intcategoryid=c.categoryid"

      '800 - 2015.12.02 - To remove prodfeatures from sql query if xsearchfields does not have any prodfeatures fields
	  if productfeatureflag then
	     tmpstr = tmpstr & " left join prodfeatures pf on ',' + p.features + ',' like '%,'+ convert(nvarchar,pf.featurenum) +',%' "
	  end if
   elseif instr(ucase(xdatabasetype), "MYSQL") > 0 then
      tmpstr = tmpstr & " from products p inner join prodcategories cc on cc.intCatalogId = p.CatalogId inner join categories c on cc.intcategoryid=c.categoryid"

      '800 - 2015.12.02 - To remove prodfeatures from sql query if xsearchfields does not have any prodfeatures fields
	  if productfeatureflag then
	     tmpstr = tmpstr & " left join prodfeatures pf on concat(',',p.features,',') like concat('%,',pf.featurenum,',%') "
	  end if
   else
      tmpstr = tmpstr & " from (((products p) inner join prodcategories cc on cc.intCatalogId = p.CatalogId) inner join categories c on cc.intcategoryid=c.categoryid)"

      '800 - 2015.12.02 - To remove prodfeatures from sql query if xsearchfields does not have any prodfeatures fields
	  if productfeatureflag then
         tmpstr = tmpstr & " left join prodfeatures pf on ',' + p.features + ',' like '%,'+ Iif(pf.featurenum Is Null, '', cstr(pf.featurenum)) +',%' "
	  end if
   end if

   '800 - 2015.07.27 - Enhancement: To inlcude prodfeatures to the search
   sql = " "
   whereok = " where "
   dim withpflagstr

   ' All of these words
   if (allwordscount> 0) then
      SQL = SQL & whereok
      SQL = SQL & "("
      Whereok = ""
      for i = 0 to allwordscount -1
         SQL = SQL & whereok
         for j = 0 to fieldcount
            if j> 0 then
               SQL = SQL & " OR "
            else
               SQL = SQL & " ( "
            end if
            tword = CleanChars(allwordsWords(i))
			'700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues

            '800 - 2015.07.27 - Enhancement: To inlcude prodfeatures to the search
            if left(searchfields(j),3) <> "pf." then
               withpflagstr = "p."
            else
               withpflagstr = ""
            end if
            SQL = SQL & withpflagstr & searchfields(j) & " Like "& sqlserverprefixn &"'%" & tosql(tword,"Text") & "%' "
         next
         SQL = SQL & " )"
         whereok = " AND "
      next
      SQL = SQL & ")"
      whereok = " AND "
   end if

   ' At least one of these words
   if atleastcount> 0 then
      SQL = SQL & whereok
      SQL = SQL & "("
      Whereok = ""
      for i = 0 to atleastcount -1
         SQL = SQL & whereok
         for j = 0 to fieldcount
            if j> 0 then
               SQL = SQL & " OR "
            else
               SQL = SQL & " ( "
            end if
            tword = CleanChars(atleastWords(i))
			'700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
            '800 - 2015.07.27 - Enhancement: To inlcude prodfeatures to the search
            if left(searchfields(j),3) <> "pf." then
               withpflagstr = "p."
            else
               withpflagstr = ""
            end if
            SQL = SQL & withpflagstr & searchfields(j) & " Like "& sqlserverprefixn &"'%" & tosql(tword,"Text") & "%' "
         next
         SQL = SQL & " )"
         whereok = " OR "
      next
      SQL = SQL & ")"
      whereok = " AND "
   end if

   if exactString <> "" then
      SQL = SQL & whereok
      SQL = SQL & "("
      Whereok = ""
      exactString = CleanChars(exactString)
      for j = 0 to fieldcount
         if j> 0 then
            SQL = SQL & " OR "
         else
         end if

         '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
         '800 - 2015.07.27 - Enhancement: To inlcude prodfeatures to the search
         if left(searchfields(j),3) <> "pf." then
            withpflagstr = "p."
         else
            withpflagstr = ""
         end if
         SQL = SQL & withpflagstr & searchfields(j) & " LIKE "& sqlserverprefixn &"'%" & tosql(exactString,"Text") & "%' "
      next
      SQL = SQL & ")"
      whereok = " AND "
   end if

   ' Without these words
   if withoutcount> 0 then
      dim wtmpstr, wsql

	  '800 - 2016.09.07 - Bug Fix: Search: Without the words not working properly
      wtmpstr = "select " & strdistinct & " p.CatalogId"
      if ucase(xdatabasetype) = "SQLSERVER" then
         wtmpstr = wtmpstr & " from products p inner join prodcategories cc on cc.intCatalogId = p.CatalogId inner join categories c on cc.intcategoryid=c.categoryid"
	     if productfeatureflag then
	        wtmpstr = wtmpstr & " left join prodfeatures pf on ',' + p.features + ',' like '%,'+ convert(nvarchar,pf.featurenum) +',%' "
   	     end if
      elseif instr(ucase(xdatabasetype), "MYSQL") > 0 then
         wtmpstr = wtmpstr & " from products p inner join prodcategories cc on cc.intCatalogId = p.CatalogId inner join categories c on cc.intcategoryid=c.categoryid"
	     if productfeatureflag then
	        wtmpstr = wtmpstr & " left join prodfeatures pf on concat(',',p.features,',') like concat('%,',pf.featurenum,',%') "
	     end if
      else
         wtmpstr = wtmpstr & " from (((products p) inner join prodcategories cc on cc.intCatalogId = p.CatalogId) inner join categories c on cc.intcategoryid=c.categoryid)"
	     if productfeatureflag then
            wtmpstr = wtmpstr & " left join prodfeatures pf on ',' + p.features + ',' like '%,'+ Iif(pf.featurenum Is Null, '', cstr(pf.featurenum)) +',%' "
   	     end if
      end if
      SQL = SQL & " "& whereok &" p.CatalogId NOT IN (" & wtmpstr & " "
      SQL = SQL & " where "

      SQL = SQL & "("
      Whereok = ""
      for i = 0 to withoutcount -1
         SQL = SQL & whereok
         for j = 0 to fieldcount
            if j> 0 then
               SQL = SQL & " OR "
            else
               SQL = SQL & " ( "
            end if
            tword = CleanChars(withoutWords(i))
			'700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
            '800 - 2015.07.27 - Enhancement: To inlcude prodfeatures to the search
            if left(searchfields(j),3) <> "pf." then
               withpflagstr = "p."
            else
               withpflagstr = ""
            end if
            SQL = SQL & withpflagstr & searchfields(j) & " LIKE "& sqlserverprefixn &"'%" & tosql(tword,"Text") & "%'"
         next
         SQL = SQL & " )"
         whereok = " OR "
      next
      SQL = SQL & "))"
      whereok = " AND "
   end if

   Sql = Sql & whereok

   '800 - 2015.07.27 - Enhancement: To inlcude prodfeatures to the search
   sql = sql & " p.hide=0"

   whereok = " AND "

   '700 - Sub Category Handling - advanced search
   if ucase(chosencategory) <> "ALL" then
      if isnumeric(chosencategory) = false then chosencategory = 0
      dim tempRS
      Set tempRS = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
	  '701 - 2011.03.15 - Enhancement: Speed up store performance
      tempRS.open "Select categoryid from categories where highercategoryid = " & chosencategory, dbc, adOpenForwardOnly, adLockReadOnly
      sql = sql & WhereOK
      sql = sql & "(cc.intcategoryid = " & chosencategory

      while not tempRS.EOF
         GetAllSubCategories sql,tempRS("categoryid")
         tempRS.movenext
      wend
      closerecordset tempRS
      sql = sql & ")"
      whereok=" AND "
   end if

   if GetConfig("xstocklow")<>"" then
      lngCStock = clng(GetConfig("xStockLow"))
      SQL = SQL & WhereOK
      sql = sql & " cstock> " & lngcstock
      whereok = " AND "
   end if

   if GetConfig("xsearchbyprice") = "Yes" then
      highprice = CleanCharsint(highprice)
      lowprice = CleanCharsint(lowprice)
      if lowprice>0 then
         SQL = SQL & WhereOK
         sql = sql & " cprice> " & lowprice
      end if
      if highprice>0 then
         SQL = SQL & WhereOK
         sql = sql & " cprice< " & highprice
      end if
      whereok = " AND "
   end if

   if GetConfig("xproductmatch") = "Yes" then
      SQL = SQL & WhereOK
      '6.50 - enhanced product matching
      generateproductmatchsql sql
      whereok = " AND "
   end if

   '700 - Customer Groups - Matching Custormer match
   sql = sql & GenerateCustomerMatchSQL ("p.customermatch","p.excustomermatch","p.loggedin",WhereOK)
   sql = sql & GenerateCustomerMatchSQL ("c.customermatch","c.excustomermatch","c.loggedin","and")
   whereok = " AND "

   if GetConfig("xselectproductsbylanguage") = "Yes" and GetSess("language")<>"" then
      '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      '800 - 2015.07.27 - Enhancement: To inlcude prodfeatures to the search
      sql = sql & " and (p.clanguage="& sqlserverprefixn &"'" & GetSess("language") & "'"
      sql = sql & " or p.clanguage is null)"
   end if

   'inventory
   '800 - 2015.07.27 - Enhancement: To inlcude prodfeatures to the search
   sql = sql & " AND (p.higherCatalogId is null)"

   'added for search sort 3 April 2002n
   if xSearchSortField<>"" then
      sql = sql & " order by " & xSearchSortField & " " & xsearchsortupdown
   else
      '700 - 2010.09.02 - Bug Fix: xsortproducts with multiple tables sql issues
      generateprefixsortfield sql
   end if

   sql = tmpStr & sql
   SetSess "SQL", SQL
   if GetConfig("xdebug") = "Yes" then
      DebugWrite sql
   end if
end sub

'700 - Sub Category Handling - advanced search
sub GetAllSubCategories (sql, catid)
   dim tempRS 
   Set tempRS = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   tempRS.open "Select categoryid from categories where highercategoryid = " & catid, dbc, adOpenForwardOnly, adLockReadOnly
   while not tempRS.eof
      GetAllSubCategories sql, tempRS("categoryid")
      tempRS.moveNext
   wend
   sql = sql & " OR cc.intcategoryid = " & catid
   closerecordset tempRS
end sub

'6.50
'xproductmatch can be a list of shopids
'a,b,ddd,ee
'add them all to the sql
sub GenerateProductmatchsql (sql)
   dim shops(50), shopcount, i
   ParseRecord xproductmatch, shops, shopcount, "," ' get all shops allowed
   sql = sql & "("
   for i = 0 to shopcount -1
      if i>0 then
         sql = sql & " or "
      end if
	  '7.00 - product matching enhancement
	  if instr(lcase(xdatabasetype),"mysql") > 0 then
	     sql = sql & " concat(',',p.productmatch,',') like '%," & shops(i) & ",%'"
	  else
	     '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
	     sql = sql & " ',' + p.productmatch + ',' like "& sqlserverprefixn &"'%," & shops(i) & ",%'"
	  end if
   next
   sql = sql & " or p.productmatch is null or p.productmatch = '')"
end sub

'700 - 2010.09.02 - Bug Fix: xsortproducts with multiple tables sql issues
sub generateprefixsortfield (sql)
   dim sortfields
   sortfields = GetConfig("xsortproducts")
   
   '7.01 - 2010.10.08 - Bug Fix: assign more than 2 values to xsortproducts returned errors
   sortfields = replace(lcase(sortfields), ", ", ",")

   if sortfields <> "" then
      if instr(sortfields,"p.") <= 0 then
         sortfields = "p." & trim(sortfields)
		 
		 '7.01 - 2010.10.08 - Bug Fix: assign more than 2 values to xsortproducts returned errors
         sortfields = replace(lcase(sortfields), ",", ",p.")
      end if
	  sql = sql & " order by " & sortfields
   end if
end sub
%>