<!--#include file="shopproductformat_Template.asp"-->
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Product Formatting
'*********************************************************************************

dim hideprice
dim ProdFields
dim ProdHeaders
dim QuantityFlag

' format one row
sub ProductFormatRow
   dim strinventoryproducts
   dim url, stayonpage
   QuantityFlag = False

   hideprice = false
   if GetConfig("xdisplayprices") <> "Yes" then
      hideprice = true
   end if
   if GetConfig("xpriceloggedinonly") = "Yes" then
      if GetSess ("login") = "" then
         hideprice = true
      end if
   end if

   if ProductSelect = "Yes" then
      htmlwrite "<tr>"
      ProductFormatFields
      if GetConfig("xproductcatalogonly")<>"Yes" then
         AddSelect
      end if
      htmlwrite "</tr>"
   else
      '7.00 - added xMySite call
	  htmlwrite "<form action=""" & genredirecturl("shopaddtocart.asp") & """ method=""post"">"
      htmlwrite "<tr>"
      ProductFormatFields ' actual row is formatted
      if GetConfig("xproductcatalogonly")<>"Yes" then
         FormatButton
      end if
      htmlwrite "</tr>"
      htmlwrite "<input type=""hidden"" name=""productid"" value=""" & lngCatalogId & """ />"
      stayonpage = GetConfig("Xproductstayonpage")
      if stayonpage = "Yes" then

		 '700 - 2010.04.16 - Search Stay on page
		 if lcase(request.QueryString("search")) = "yes" then
		    url = "shopdisplayproducts.asp?Search=Yes&page=" & mypage & ""
         else
   		    url = "shopdisplayproducts.asp?page=" & mypage & "&id="& CAT_ID &"&cat="& CATEGORY &""
		 end if

         htmlwrite "<input type=""hidden"" name=""ReturnURL"" value=""" & url & """ /></form>"
      end if
      AddWebSessform
      htmlwrite "</form>"
   end if
end sub

' The fields being displayed are configurable in xproductfields
sub ProductFormatFields
   dim FieldCount
   dim i
   Fieldcount = ubound(ProdFields)
   if fieldcount = 0 then
      ShopError GetLang("langcommonno") & " " & GetLang("langsearchfields") & " to " & GetLang("langeditdisplay")
   end if
   for i = 0 to FieldCount
      FormatProductField ProdFields(i)
   next
end sub

' most text fiels are displayed. Some need special format such as currency
sub FormatProductField (fieldname)
   dim rc, fieldvalue
   ProcessSpecial fieldname, rc
   if RC = 0 then exit sub
   Fieldvalue = objRS(fieldname)
   htmlwrite "<td class=""vm"" style=""background-color:#FCFCFC"">" & fieldvalue & "</td>"
end sub

sub ProcessSpecial (fieldname, rc)
   fieldname = ucase(fieldname)
   rc = 4
   select case fieldname
      case "CDESCRIPTION"
         FormatDescription
         rc = 0
      case "QUANTITY"
         FormatQuantity
         rc = 0
      case "CPRICE"
         FormatPrice
         rc = 0
      case "CNAME"
         FormatName
         rc = 0
   end select
end sub

'a dda  check box to the product. If it has subproducts that are being displayed
'in a table, do't add checkbox
' other subproducts allow check box
sub AddSelect
   dim rc
   if GetConfig("xproductcatalogonly") = "Yes" then
      exit sub
   end if

   '702 - 2014.02.10 - Bug Fix: if xProductSelect is Yes, don't display checkbox/button if xpriceloggedinonly = True and customer isn't logged in
   if (GetConfig("xpriceloggedinonly") = "Yes") and (GetSess("Login") = "") then
      exit sub
   end if

   if inventorycheck = true then
      if inventorypricedisplay = False then
         addinventoryColumn
         exit sub
      end if
   end if
   PWriteNoStockMessage rc
   if rc> 0 then exit sub
   if productwithhtml<>"Yes" then
      htmlwrite "<td style=""background-color:" & "#FCFCFC" & """>"
	  '800 - 2015.04.28 - Bug Fix: Layout: If xproductselect set to Yes, checkbox should under quantity box
%>
<input type="checkbox" name="Processed<%=prodIndex%>"  value="<%=lngCatalogId%>" class="submitbtn" />
<div class="row"></div>
</td>
<%
   else
      '800 - 2015.04.28 - Bug Fix: Layout: If xproductselect set to Yes, checkbox should under quantity box
%>
<input type="checkbox" name="Processed<%=prodIndex%>"  value="<%=lngCatalogId%>" class="submitbtn" />
<div class="row"></div>
<%
   end if
end sub

sub FormatName
   dim productname
   productname = objrs("cname")
   productname = TranslateLanguage(dbc, "products", "cname", "CatalogId", lngCatalogId, productname)
   htmlwrite "<td class=""ac vt"" style=""background-color:#FFFFFF"">" & "<span class='fontbold'>"
   response.write productname
   FormatImage
   Formatoverallrating
   htmlwrite "</span></td>"
end sub

sub FormatDescription
   dim Fieldvalue
   Fieldvalue = memcdescription
   fieldvalue = TranslateLanguage(dbc, "products", "cdescription", "CatalogId", lngCatalogId, fieldvalue)
   htmlwrite "<td class=""vt al"" width=""100%"" style=""background-color:#FFFFFF"">" & fieldvalue
   FormatProductOptions
   FormatUserText
   FormatSpecialOffer
   FormatHyperlinks
   FormatComparison
   Formatinventoryproducts dbc, objrs
   htmlwrite "</td>"
end sub

' put out a quantity box unless using inventory products
' Inventory products cannot be purchased so put our nothing
sub FormatQuantity
   if GetConfig("xproductcatalogonly") = "Yes" then
      exit sub
   end if

   '6.5.1 - don't display this if xpriceloggedinonly = True and customer isn't logged in
   if (GetConfig("xpriceloggedinonly") = "Yes") and (GetSess("Login") = "") then
      exit sub
   end if
   '6.5.1 - don't display this if product is out of stock
   if GetConfig("xOutOfStocklImit") > "" then
      if lngcstock<= clng(GetConfig("xOutOfStocklImit")) then
	     htmlwrite "<input class=""txtfield"" type=""hidden"" maxlength=""4"" size=""3"" value=""0"" name=""quantity"" />"
         exit sub
      end if
   end if
   if GetConfig("xstocklow") > "" then
      if lngcstock<= clng(GetConfig("xstocklow")) then
	     htmlwrite "<input class=""txtfield"" type=""hidden"" maxlength=""4"" size=""3"" value=""0"" name=""quantity"" />"
         exit sub
      end if
   end if
   if productwithhtml = "Yes" then
      if inventoryquantitydisplay = false then
         ' exit sub
      end if
   end if
   if inventorycheck = true and inventoryquantitydisplay = false then
      '6.08 - Quantity issue in inventory products
      htmlwrite "<input class=""txtfield"" type=""hidden"" maxlength=""4"" size=""3"" value=""0"" name=""quantity"" />"
      QuantityFlag = True
      exit sub
   end if
   if strMinimumQuantity = 0 or strMinimumquantity = "" then
      if productwithhtml<>"Yes" then
         htmlwrite "<td class=""ac"" style=""background-color:#FFFFFF"">" & "<input class=""txtfield"" type=""text"" maxlength=""4"" size=""3"" value=""1"" name=""quantity"" />" & "</td>"
      else
         htmlwrite "<input class=""txtfield quantity"" type=""text"" maxlength=""4"" size=""3"" value=""1"" name=""quantity"" />"
      end if
   else
      GenerateMinList
   end if
   QuantityFlag = True
end sub

sub FormatPrice
   if hideprice = true then exit sub
   dim OriginalPrice, decimalpoint
   dim savings, displaysavings
   if inventorycheck = true then
      addinventoryprice
      exit sub
   end if

   displaysavings = GetConfig("xproductdisplaysaving")
   dim strPrice, newprice
   ' if we read product in getproduct values all this has been done
   if ProductFieldValid<>True then
      lngCatalogId = objrs("CatalogId")
      lngccategory = objrs("ccategory")
      curcprice = objrs("cprice")
      NewPrice = curCPrice
      curOriginalPrice = curCprice
      shopcustomerprices objrs, lngCatalogId, lngCcategory, CurCprice, Newprice, lngDiscount
      curCPrice = Newprice
   end if
   decimalpoint = GetConfig("xdecimalpoint")
   strPrice = ShopFormatCurrency(curCprice, decimalpoint)
   htmlwrite "<td class=""ac"" style=""background-color:#FCFCFC"">" & strPrice
   if not isnull(objrs("retailprice")) then
      if strRetailPrice> 0 then
         if Displaysavings<>"Yes" then
            htmlwrite "<br /><em>" & GetLang("langProductRetailPrice") & ShopFormatCurrency(strRetailPrice, decimalpoint) & "</em>"
         else
            savings = strRetailprice - curcprice
            htmlwrite "<br /><em>" & GetLang("langProductRetailPrice")
            response.write ShopFormatCurrency(strRetailPrice, decimalpoint)
            htmlwrite "<br />" & GetLang("langProductPriceSaving") & " " & ShopFormatCurrency(savings, decimalpoint)
            htmlwrite "</em>"
         end if
      end if
   end if
   if GetConfig("xDisplayOriginalPrice") = "Yes" and lngdiscount<>0 then
      htmlwrite "<br /><em>" & GetLang("langProductBasePrice") & ShopFormatCurrency(curOriginalPrice, decimalpoint) & "</em>"
   end if
   AddCurrencyConvert curcprice
   htmlwrite "</td>"
end sub

' dual price is normally computed but may come from product record itself
sub FormatDualPrice
   dim strPrice
   if strcdualprice = "" then
      ConvertCurrency curCprice, strPrice
   else
      strprice = strcdualprice
   end if
   strPrice = ShopFormatDualCurrency(strprice, 2)
   htmlwrite "<td class=""ac"" style=""background-color:#FCFCFC"">" & strPrice
   htmlwrite "</td>"
end sub

'Format Image and Extended Description
sub FormatImage
   if isnull(strcimageurl) then
      strcimageurl = ""
   end if

   if isnull(strDescurl) then
      strdescurl = ""
   end if

   '700 - 2010.08.23 - Bug Fix: Error product reference if xGenerateShopexdLink = No and xcrosslinkurl = shopexd.asp
   if GetConfig("xGenerateShopexdLink") = "Yes" and lcase(strDescURL) = "shopexd.asp" then strDescURL = ""

   '800 - 2015.07.29 - SEO: Duplicate content issue on product listings page
   if lcase(getconfig("xSEODynamicEnable")) = "yes" and lcase(getconfig("xSEODynamicProductsEnable")) = "yes" then strDescURL = ""

   if strDescURL<>"" then
      if GetConfig("xAddCatalogId") = "Yes" then
	     if instr(lcase(strdescurl),"id=") <= 0 then
            strDescURL = strDescURL & "?id=" & lngCatalogId
         end if
      end if
   else
      if GetConfig("xGenerateShopexdLink") = "Yes" then
         strdescurl = "shopexd.asp"
         strDescURL = strDescURL & "?id=" & lngCatalogId
	     '700 - SEO
	     genseoproductlink strDescURL,lngCatalogId,"","No"
         '6.09 - if breadcrumb is set to no, hide on exd page as well
         if request.QueryString("bc") = "no" or session("seocbc") = "no" then
			if getconfig("xSEODynamicEnable") = "Yes" and getconfig("xSEODynamicProductsEnable") = "Yes" then
			   strdescurl = strdescurl & "?bc=no"
			else
			   strdescurl = strdescurl & "&bc=no"
			end if
         end if
      end if
   end if

   '6.00 - inventory - if layout selected is table and this is parent, don't show more info link
   if not objrs.eof then
      if lcase(objrs("spdisplaytype")) = "table" then
         strdescurl = ""
      end if
   end if

   '700 - Quick Admin Order Form
   if getsess("fromquickorder") = "Yes" then
      strdescurl = ""
   end if
   
   'exit sub if both empty, no piont going further
   if strdescurl = "" and strcimageurl = "" then
      '6.50 - show placeholder if there is no image
      if GetConfig("xnoimage") > "" then
         GenerateImagePlaceholder
         exit sub
      else
         exit sub
      end if
   end if

   if strcImageUrl<>"" then
      GenerateImage
   else
      GenerateNoImage
   end if
end sub

'6.09 - Generate Image wasn't showing more info button if there is one defined in config if there is an image for the product
sub GenerateImage
   dim productname
   productname = objrs("cname")
   productname = TranslateLanguage(dbc, "products", "cname", "CatalogId", lngCatalogId, productname)

   dim buttonimage
   buttonimage = GetConfig("xbuttonmoreinfo")
   if isnull(buttonimage) or buttonimage = "" then
      buttonimage = ""
   end if
   if strDescUrl<>"" then
      strDescurl = addwebsess(strdescurl)
      '6.09 - if showing search results, don't show breadcrumb on extended page
      if request("Search") = "Yes" then
	     if getconfig("xSEODynamicEnable") = "Yes" and getconfig("xSEODynamicProductsEnable") = "Yes" then
		    '700 - 2010.08.23 - Bug Fix: Error product reference if xGenerateShopexdLink = No and xcrosslinkurl = shopexd.asp
		    if instr(lcase(strDescURL),"shopexd.asp") > 0 then
			   strDescurl = strDescURL & "&bc=no"
			else
		       strDescurl = strDescURL & "?bc=no"
			end if
		 else
		    strDescurl = strDescURL & "&bc=no"
		 end if
      end if

      if GetConfig("XextendedPopup") = "Yes" then
%>
<script language="JavaScript" type='text/javascript'>
		<!-- Begin
		function popUp(URL) {
			day = new Date();
			id = day.getTime();
			eval("page" + id + " = window.open(URL, '" + id + "', 'width=550,height=400,menubar=no,toolbar=no,location=no,status=no,directories=no,copyhistory=no,resizable=yes,scrollbars=yes');");
		}
		// End -->
</script>
<%
         if buttonimage = "" then
%>
  <a href="javascript:popUp('<%=xmysite2 & "/" & strDescURL%>')"><img class="product_thumbnail" src="<%=strcimageURL%>" alt="<%=productname%>" /></a><br />
  <a href="javascript:popUp('<%=xmysite2 & "/" & strDescURL%>')"><%=GetLang("langProductClick")%></a>
<%
         else
%>
<a href="javascript:popUp('<%=xmysite2 & "/" & strDescURL%>')"><img class="product_thumbnail" src="<%=strcimageURL%>" alt="<%=productname%>" border="0" /></a><br />
  <a href="javascript:popUp('<%=xmysite2 & "/" & strDescURL%>')"><img border="0" src="<%=buttonimage%>" alt="<%=productname%>"/></a>
<%
         end if
      else
   	     '800 - 2015.06.15 - Enhancement: Quick View
         '800 - 2016.01.20 - Bug Fix: Quick View: not working properly with gift-type products
	     Generate_quickview_wrapper_v2 strDescURL, "n", "", objrs

         if buttonimage = "" then
%>
<a href="<%=strDescURL%>"><img class="product_thumbnail" src="<%=strcimageURL%>" alt="<%=GetLang("langProductClick")%>"/></a><br />

<%
         else
            '800 - 2015.04.21 - Bug Fix: Extra characters displayed beside on product image
%>
<a href="<%=strDescURL%>"><img class="product_thumbnail" src="<%=strcimageURL%>" alt="<%=GetLang("langProductClick")%>"/></a>
<%
         end if
      end if
   else
      '701 - 2011.01.25 - Bug Fix: No class product_thumbnail assigned to image if xgenerateshopexdlink = No
%>
<img class="product_thumbnail" src="<%=strcimageURL%>" alt="<%=productname%>" />
<%
   end if
end sub

sub GenerateImage_old
   if strDescUrl<>"" then
      strDescurl = addwebsess(strdescurl)
      if GetConfig("XextendedPopup") = "Yes" then
%>
  <a href="#" onClick="window.open('<%=strDescURL%>','','width=550,height=400,menubar=no,toolbar=no,location=no,status=no,directories=no,copyhistory=no,resizable=yes,scrollbars=yes')"><img src="<%=strcimageURL%>" alt=" " border="0" /></a><br />
  <a href="#" onClick="window.open('<%=strDescURL%>','','width=550,height=400,menubar=no,toolbar=no,location=no,status=no,directories=no,copyhistory=no,resizable=yes,scrollbars=yes')"><%=GetLang("langProductClick")%></a>
<%
      else
%>
  <a href="<%=strDescURL%>"><img border="0" src="<%=strcimageURL%>"></a><br />
  <a href="<%=strDescURL%>"><%=GetLang("langProductClick")%></a>
<%
      end if
   else
%>
<img src="<%=strcimageURL%>" alt=" " />
<%
   end if
end sub

sub GenerateNoImage
   dim buttonimage
   strdescurl = addwebsess(strdescurl)
   buttonimage = GetConfig("xbuttonmoreinfo")
   if isnull(buttonimage) or buttonimage = "" then
      buttonimage = ""
   end if

   '6.50 - show placeholder if there is no image
   if GetConfig("xnoimage") > "" then
      if strDescURL > "" then
         if GetConfig("XextendedPopup") = "Yes" then
%>
<script language="JavaScript" type='text/javascript'>
		<!-- Begin
		function popUp(URL) {
			day = new Date();
			id = day.getTime();
			eval("page" + id + " = window.open(URL, '" + id + "', 'width=550,height=400,menubar=no,toolbar=no,location=no,status=no,directories=no,copyhistory=no,resizable=yes,scrollbars=yes');");
		}
		// End -->
</script>
<%
            '701 - 2011.01.25 - Bug Fix: No class product_thumbnail assigned to category image
%>
<a href="javascript:popUp('<%=xmysite2 & "/" & strDescURL%>')"><img class="product_thumbnail" src="<%=GetConfig("xnoimage")%>" alt="<%=productname%>" /></a><br />
<%
         else
		    '701 - 2011.01.25 - Bug Fix: No class product_thumbnail assigned to category image
%>
<a href="<%=strDescURL%>"><img class="product_thumbnail" src="<%=GetConfig("xnoimage")%>" alt="<%=productname%>" /></a>
<%
         end if
      else
	     '701 - 2011.01.25 - Bug Fix: No class product_thumbnail assigned to category image
%>
<img class="product_thumbnail" src="<%=GetConfig("xnoimage")%>" alt="<%=productname%>" />
<%
      end if
   end if

   if GetConfig("XextendedPopup") = "Yes" then
      if buttonimage = "" then
%>
<a href="#" onClick="window.open('<%=strDescURL%>','','width=550,height=400,menubar=no,toolbar=no,location=no,status=no,directories=no,copyhistory=no,resizable=yes,scrollbars=yes')"><%=GetLang("langProductExtendeddescription")%></a>
<%
      else
   	     '800 - 2015.06.15 - Enhancement: Quick View
         '800 - 2016.01.20 - Bug Fix: Quick View: not working properly with gift-type products
	     Generate_quickview_wrapper_v2 strDescURL, "n", "", objrs

	     '701 - 2011.01.25 - Bug Fix: No class product_thumbnail assigned to category image
		 '701 - 2011.09.15 - Bug Fix: xbuttonmoreinfo should not associated with product_thumbnail
%>
<a href="#" onClick="window.open('<%=strDescURL%>','','width=550,height=400,menubar=no,toolbar=no,location=no,status=no,directories=no,copyhistory=no,resizable=yes,scrollbars=yes')"><img src="<%=buttonimage%>" alt="<%=GetLang("langProductExtendeddescription")%>" /></a><br />
<%
      end if
   else
      if buttonimage<>"" then
      else
      end if
   end if
end sub

'6.50 - show placeholder if there is no image
sub GenerateImagePlaceholder
   if GetConfig("xnoimage") > "" then
      if strdescurl > "" then
	     '701 - 2011.01.25 - Bug Fix: No class product_thumbnail assigned to category image
%>
<a href="<%=strDescURL%>"><img class="product_thumbnail" src="<%=GetConfig("xnoimage")%>"  alt="<%=productname%>" /></a>
<%
      else
	     '701 - 2011.01.25 - Bug Fix: No class product_thumbnail assigned to category image
%>
<img class="product_thumbnail" src="<%=GetConfig("xnoimage")%>"  alt="<%=productname%>" />
<%
      end if
   end if
end sub

' If product has a button image
' it is formatted here
' If a product has sub products dont add order button unless
' subproduct is formatted as a form type field (radio, dropdown)
sub FormatButton
   dim mybutton
   dim mytext
   dim rc
   if GetConfig("xproductcatalogonly") = "Yes" then
      exit sub
   end if

   '6.5.1 - don't display this if xpriceloggedinonly = True and customer isn't logged in
   if (GetConfig("xpriceloggedinonly") = "Yes") and (GetSess("Login") = "") then
      exit sub
   end if

   if inventorycheck = True then
      if inventorypricedisplay = false then
         exit sub
      end if
   end if
   PWriteNoStockMessage rc
   if rc> 0 then exit sub

   if mytext = "" then
      mytext = GetLang("langproductorder")
   end if
   if mytext = "" then
      mytext = "Order"
   end if
   mybutton = ""
   ' If strButtonimage is not null use it
   ' If Sess("buttonimage") is not null use it otherwise you normall button
   if productwithhtml<>"Yes" then
      htmlwrite "<td width=""15%"" class=""vm"" style=""background-color:#FCFCFC"">"
   end if
   if strButtonImage<>"" then
      mybutton = strbuttonimage
   else
      if GetConfig("xButtonImage") <>"" then
         mybutton = GetConfig("xbuttonimage")
      end if
   end if
   if myButton = "" then
      htmlwrite "<input class=""submitbtn"" type=""submit"" value=""" & mytext & """ name=""Order"" />"
      exit sub
   end if
   htmlwrite "<input src=""" & mybutton & """ type=""image"" class=""imgbtn"" />"
   if productwithhtml<>"Yes" then
      htmlwrite "</td>"
   end if
end sub

sub FormatSpecialOffer
   if strSpecialOffer<>"" then
      htmlwrite "<br />" & "<span style=""color:#0000FF"">" & strSpecialOffer & "</span>"
   end if
end sub

' Headers for product are displayed here
sub ProductFormatHeader
   dim FieldCount
   dim I

   hideprice = false
   if GetConfig("xdisplayprices") <> "Yes" then
      hideprice = true
   end if
   if GetConfig("xpriceloggedinonly") = "Yes" then
      if GetSess ("login") = "" then
         hideprice = true
      end if
   end if

   SetupProductFields ProdFields, ProdHeaders
   Fieldcount = ubound(ProdHeaders)
   htmlwrite "<table border=""0"" cellpadding=""4"" cellspacing=""1"" width=""100%"" align=""center"" class=""vt"">"
   htmlwrite "<tr>"

   for i = 0 to FieldCount
      if GetLang("langProductPrice") = ProdHeaders(i) then
         if hideprice <> true then
            FormatProductHeaders ProdHeaders(i)
         end if
      elseif GetLang("langProductQuantity") = ProdHeaders(i) then
         if GetConfig("xproductcatalogonly")<>"Yes" then
            formatProductHeaders ProdHeaders(i)
         end if
      else
         FormatProductHeaders ProdHeaders(i)
      end if
   next
   if GetConfig("xproductcatalogonly")<>"Yes" then
      if productSelect = "Yes" then
         FormatProductHeaders GetLang("langProductSelect")
      else
         if GetConfig("xproductcatalogonly")<>"Yes" then
            FormatProductHeaders GetLang("langProductOrder")
         end if
      end if
   end if
   htmlwrite "</tr>"
end sub

sub FormatProductHeaders (name)
   htmlwrite "<td class=""menuhdr ac"">" & name & "</span></span></p></td>"
end sub

sub PWriteNoStockMessage (rc)
   rc = 0
   
   include_stocknotification_js
   
   ' August 9 mod to check inventory is in stock
   if Inventorycheck = true then
      if inventoryoutofstock = true then
         if productwithhtml = "Yes" then
		    response.write GetLang("langOutOfStock")
  	        display_stocknotification_info
         else
            HtmlWrite "<td class=""ac"">" & GetLang("langOutOfStock")
			display_stocknotification_info
	        HtmlWrite "</td>"
         end if
         rc = 4
      end if
      exit sub
   end if
   if GetConfig("xOutOfStockLimit") = "" then exit sub
   if isnull(lngcstock) then exit sub
   if lngcstock>clng(GetConfig("xOutOfStocklImit")) then exit sub
   if productwithhtml = "Yes" then
      response.write GetLang("langOutOfStock")
	  display_stocknotification_info
   else
      HtmlWrite "<td class=""ac"">" & GetLang("langOutOfStock")
	  display_stocknotification_info
	  HtmlWrite "</td>"
   end if
   rc = 4
end sub

' see if product has any cross selling products
' if there is use subroutine in shopproductsubs.asp to format the products
sub FormatCrossSelling
   dim lngcstock
   dim headercaption
   dim strCrossProductIDs, strsql
   if GetConfig("XCrossSelling")<>"Yes" then exit sub
   strcrossproductids = objrs("crossselling")
   if isnull(strCrossProductids) then exit sub
   strsql = "select * from products p, prodcategories cc, categories c where CatalogId in (" & strcrossproductids & ")"
   strsql = strsql & " and cc.intCatalogId=p.CatalogId and cc.intcategoryid=c.categoryid "

   '600 - DON'T SHOW CHILD PRODUCTS
   strsql = strsql & " AND (higherCatalogId is null)"

   '700 - generate sql by product criteria - 2010.04.03
   generateproductstdcriteriasql strsql, "p.", "c.", "generateproductmatchsqlsubs"
   
   Headercaption = GetLang("LangCrossSellingMessage")
   FormatAssociatedProducts dbc, strsql, headercaption, ""
end sub

sub FormatHyperlinks
   dim strmessage, strurl
   if GetConfig("xProductLinkTellaFriend") = "Yes" then
      strurl = "shoptellafriend.asp?id=" & lngCatalogId
      strurl = addwebsess(strurl)
      if GetConfig("xbuttontellafriend")<>"" then
         strmessage = "<a href=""" & strurl & """><img src=""" & GetConfig("xbuttontellafriend") & """ alt=""" & GetLang("langTellaFriend") & """ border=""0"" /></a>"
      else
         strMessage = "<a href=""" & strURL & """>" & GetLang("langTellaFriend") & "</a>"
      end if
      htmlwrite "<div>" & strMessage & "</div>"
   end if
   if GetConfig("xProductQuestion") = "Yes" then
      strurl = "shopquestion.asp?id=" & lngCatalogId
      strurl = addwebsess(strurl)
      strMessage = "<a href=""" & strURL & """>" & GetLang("langQuestion") & "</a>"
      htmlwrite "<div>" & strMessage & "</div>"
   end if
   if GetConfig("xProductmakeanoffer") = "Yes" then
      strurl = "shopmakeanoffer.asp?id=" & lngCatalogId
      strurl = addwebsess(strurl)
      strMessage = "<a href=""" & strURL & """>" & GetLang("langmakeanoffer") & "</a>"
     htmlwrite "<div>" & strMessage & "</div>"
   end if
   if GetConfig("xProductwishlist") = "Yes" then
      '800 - Enhanced SEO
      strurl = ""& DoFriendlySEOPage("shopwishlist.asp") &"?action=add&amp;id=" & lngCatalogId

      strurl = addwebsess(strurl)
      strMessage = "<a href=""" & strURL & """>" & GetLang("Langwishlistsave") & "</a>"
      htmlwrite "<div class=""wishlist-link"">" & strMessage & "</div>"
   end if
end sub

sub Formatratinglinks
   if GetConfig("xRatingproducthyperlink") = "Yes" then
      dim strurl,strmessage,breaker 
      strurl = "shopreviewadd.asp?id=" & lngCatalogId
      strurl = addwebsess(strurl)
      if GetConfig("xbuttonwritereview")<>"" then
         strmessage = breaker & "<a href=""" & strurl & """><img src=""" & GetConfig("xbuttonwritereview") & """ alt=""" & GetLang("langRatingWrite") & """ border=""0"" /></a>"
      else
         strMessage = breaker & "<a href=""" & strURL & """>" & GetLang("langRatingWrite") & "</a>"
      end if
      'breaker = "&nbsp; | &nbsp;"
	  breaker = "<br />"
      response.write strMessage
      strurl = "shopreviewlist.asp?id=" & lngCatalogId
      strurl = addwebsess(strurl)
      if GetConfig("xbuttonreadreview")<>"" then
         strmessage = breaker & "<a href=""" & strurl & """><img src=""" & GetConfig("xbuttonreadreview") & """ alt=""" & GetLang("langRatingRead") & """ border=""0"" /></a>"
      else
         strMessage = breaker & "<a href=""" & strURL & """>" & GetLang("langRatingRead") & "</a>"
      end if
      breaker = "<br />"
      response.write strMessage
   end if
end sub

sub FormatOverallrating
   dim oaverage, image, count
   if GetConfig("xAllowRatingProducts")<>"Yes" then exit sub
   if GetConfig("xAllowRatingSummary")<>"Yes" then exit sub
   Reviewaverage lngCatalogId, oaverage, image, count, dbc
   if image = "" then
      htmlwrite "" & GetLang("langNoReviews") & ""
      exit sub
   end if
   htmlwrite ""
   htmlwrite count & "&nbsp;" & GetLang("langratingheader") & ""
   htmlwrite "<img src=""" & image & """ alt="" "" />"
end sub

sub ProductFormatTrailer
end sub

sub AddInventoryColumn
   htmlwrite "<td width=""15%"" class=""vm"" style=""background-color:#FCFCFC"">"
   response.write "&nbsp;"
   htmlwrite "</td>"
end sub

sub AddInventoryprice
   htmlwrite "<td class=""ac"" style=""background-color:#FCFCFC"">" & "&nbsp;"
   htmlwrite "</td>"
end sub

' ShopConvertCurrencylink is in shopproductsubs
sub AddCurrencyConvert (total)
   if GetConfig("xproductConvertCurrency")<>"Yes" then exit sub
   dim url, cprice
   cprice = ShopFormatNumber(total, GetConfig("xdecimalpoint"))
   ShopConvertCurrencyLink cprice, url
   response.write "<br />" & url
end sub

sub Formatbuttonview
   if strDescUrl<>"" then
      strDescurl = addwebsess(strdescurl)
      '6.09 - if showing search results, don't show breadcrumb on extended page
      if request("Search") = "Yes" then
	     if getconfig("xSEODynamicEnable") = "Yes" and getconfig("xSEODynamicProductsEnable") = "Yes" then
		    '700 - 2010.08.23 - Bug Fix: Error product reference if xGenerateShopexdLink = No and xcrosslinkurl = shopexd.asp
		    if instr(lcase(strDescURL),"shopexd.asp") > 0 then
			   strDescurl = strDescURL & "&bc=no"
			else
		       strDescurl = strDescURL & "?bc=no"
			end if
		 else
		    strDescurl = strDescURL & "&bc=no"
		 end if
      end if
	  htmlwrite "<a href="& strDescURL &" class=""submitbtn  global-background-color"">"& getlang("langviewmore") &"</a>"
   end if
end sub

'800 - 2015.04.28 - Bug Fix: If xproductselect set to Yes, quantity is added wrongly from 2nd selected items onwards
sub FormatQuantity_order
   if GetConfig("xproductcatalogonly") = "Yes" then
      exit sub
   end if
   if (GetConfig("xpriceloggedinonly") = "Yes") and (GetSess("Login") = "") then
      exit sub
   end if
   if GetConfig("xOutOfStocklImit") > "" then
      if lngcstock<= clng(GetConfig("xOutOfStocklImit")) then
	     '800 - 2015.05.14 - Bug Fix: Quantity added wrongly if Minimum Quantity field and xproductselect have beetn set
	     htmlwrite "<input class=""txtfield quantity"" type=""hidden"" maxlength=""4"" size=""3"" value=""0"" name=""quantity"& prodIndex &""" />"
         exit sub
      end if
   end if
   if GetConfig("xstocklow") > "" then
      if lngcstock<= clng(GetConfig("xstocklow")) then
	     '800 - 2015.05.14 - Bug Fix: Quantity added wrongly if Minimum Quantity field and xproductselect have beetn set
	     htmlwrite "<input class=""txtfield quantity"" type=""hidden"" maxlength=""4"" size=""3"" value=""0"" name=""quantity"& prodIndex &""" />"
         exit sub
      end if
   end if
   if productwithhtml = "Yes" then
      if inventoryquantitydisplay = false then
         ' exit sub
      end if
   end if
   if inventorycheck = true and inventoryquantitydisplay = false then
      '800 - 2015.05.14 - Bug Fix: Quantity added wrongly if Minimum Quantity field and xproductselect have beetn set
      htmlwrite "<input class=""txtfield quantity"" type=""hidden"" maxlength=""4"" size=""3"" value=""0"" name=""quantity"& prodIndex &""" />"
      QuantityFlag = True
      exit sub
   end if
   if strMinimumQuantity = 0 or strMinimumquantity = "" then
      if productwithhtml<>"Yes" then
         htmlwrite "<td class=""ac"" style=""background-color:#FFFFFF"">" & "<input class=""txtfield"" type=""text"" maxlength=""4"" size=""3"" value=""1"" name=""quantity"& prodIndex &""" />" & "</td>"
      else
         htmlwrite "<input class=""txtfield quantity"" type=""text"" maxlength=""4"" size=""3"" value=""1"" name=""quantity"& prodIndex &""" />"
      end if
   else
      GenerateMinList
   end if
   QuantityFlag = True
end sub

'800 - 2015.-5.14 - Better handling if xgenerateshopexdlink set to No
sub formatexdlink_v8 (value, parseRS, passtype)
   dim passcatalogid, strDescURL
   strDescURL = parsers("cdescurl")
   passcatalogid = parsers("catalogid")
   if isnull(strDescurl) then
      strdescurl = ""
   end if
   if lcase(GetConfig("xGenerateShopexdLink")) = "yes" and lcase(strDescURL) = "shopexd.asp" then strDescURL = ""
   if strDescURL<>"" then
      if lcase(GetConfig("xAddCatalogId")) = "yes" then
	     if instr(lcase(strdescurl),"id=") <= 0 then
            strDescURL = strDescURL & "?id=" & passcatalogid
         end if
      end if
   else
      if lcase(GetConfig("xGenerateShopexdLink")) = "yes" then
         strdescurl = "shopexd.asp"
         strDescURL = strDescURL & "?id=" & passcatalogid

         '800 - 2016.01.16 - Enhancement: SEO Dynamic: Speed performance
		 genseoproductlink_v8 strDescURL,passcatalogid,parsers,"No"

         if request.QueryString("bc") = "no" or session("seocbc") = "no" then
			if lcase(getconfig("xSEODynamicEnable")) = "yes" and lcase(getconfig("xSEODynamicProductsEnable")) = "yes" then
			   strdescurl = strdescurl & "?bc=no"
			else
			   strdescurl = strdescurl & "&bc=no"
			end if
         end if
      end if
   end if
   if lcase(parseRS("spdisplaytype")) = "table" then
      strdescurl = ""
   end if
   if getsess("fromquickorder") = "Yes" then
      strdescurl = ""
   end if
   if trim(strdescurl) = "" then
      dim toexit
	  select case lcase(passtype)
         case "searchlink", "div", "mobiledetail"
	        toexit = true
	     case else
	        toexit = false
            strdescurl = "shopquery.asp"
            strDescURL = strDescURL & "?id=" & passcatalogid
      end select
	  if toexit then exit sub
   end if
   dim passstring
   passstring = ""
   select case lcase(passtype)
      case "searchlink"
	     passstring = "<a href="""& strdescurl &""" class=""submitbtn"">"
		 passstring = passstring & "<span class=""fa fa-search""></span>"
		 passstring = passstring & "</a>"
	  case "div"
	     passstring = "style=""cursor: pointer;"" onclick=""location.href='"& strdescurl &"'"""
      case "mobiledetail"
	     passstring = "<a href="""& strdescurl &""" class=""submitbtn"">"
		 passstring = passstring & getlang("langdetails")
		 passstring = passstring & "</a>"
      case "sidedesktopdetail"
	     passstring = "<a href="""& strdescurl &""" class=""btn-details default-btn-style global-background-color"">"
		 passstring = passstring & getlang("langdetails")
		 passstring = passstring & "</a>"
      case "sidemobiledetail"
	     passstring = "<a href="""& strdescurl &""" class=""btn submitbtn"">"
		 passstring = passstring & getlang("langdetails")
		 passstring = passstring & "</a>"
      case "frontdesktopsearch"
	     passstring = "<a href="""& strdescurl &""" class=""btn submitbtn pull-right"">"
		 passstring = passstring & "<span class=""fa fa-search""></span>"
		 passstring = passstring & "</a>"
      case "frontmobiletopsearch"
	     passstring = "<a href="""& strdescurl &""" class=""btn submitbtn pull-right"">"
		 passstring = passstring & "<span class=""fa fa-search""></span>"
		 passstring = passstring & "</a>"

   end select
   value = passstring
end sub
%>