<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Search page routines
'*********************************************************************************

sub showMiniSearch
   '6.50
   'Nov 11, 2005    Use languages variables. Fix error in captionstring is empty
%>
<%'800 - Enhanced SEO%>
<form action="<%=DoFriendlySEOPage("shopsearch.asp")%>" method="get">
  <table cellpadding="0" cellspacing="0" border="0">
    <tr>
      <td class="ac"><input type="text" name="exact" />
        <input type="hidden" name="category" value="ALL" />
        <input type="hidden" name="Search" value="Yes" />
      </td>
    </tr>
    <tr>
      <td class="ac"><input type="submit" name="Submit" value="<%=GetLang("langcommonsearch")%>" class="submitbtn" />
      </td>
    </tr>
    <tr>
      <%'800 - Enhanced SEO%>
      <td class="ac"><a href="<%=DoFriendlySEOPage("shopsearch.asp")%>"><%=GetLang("langadvancedsearchAdvanced")%></a></td>
    </tr>
  </table>
</form>
<%
end sub

' Advanced search table reorganised by Joseph (01/11/2006)
' table.std_table gives border to table and blue/grey background
' Second table has each element floated so that they will shift
' and balance when settings are removed
sub showAdvancedSearch
   dim othercount, i, stroOther
   dim OtherTypes(50), othercaptions(50), othercaptioncount
   dim sortupdownnames(2), sortupdownvalues(2), sortupdowncount
   dim strsearchsort, strsearchsortupdown
%>
<div class="main-product">
<div class="title"><h2 class="global-font-color"><%=GetLang("langcommonsearch")%></h2></div>
<div id="searchform">
<%
ShopWriteHeader GetLang("LangSearch01")
%>
<%'800 - Enhanced SEO%>
<form name="form1" method="post" action="<%=DoFriendlySEOPage("shopsearch.asp")%>?search=Yes">
      <div class="row">
        <div class="col-xs-5"><%=GetLang("langSearchAllWords")%></div>
        <div class="col-xs-7"><input name="allwords" type="text" id="allwords" class="txtfield form-control" /></div>
      </div>
      <div class="row">
        <div class="col-xs-5"><%=GetLang("langSearchExactPhrase")%></div>
        <div class="col-xs-7"><input name="exact" type="text" id="exact" class="txtfield form-control" /></div>
      </div>
      <div class="row">
        <div class="col-xs-5"><%=GetLang("langSearchAtLeast")%></div>
        <div class="col-xs-7"><input name="atleast" type="text" id="atleast" class="txtfield form-control" /></div>
      </div>
      <div class="row">
        <div class="col-xs-5"><%=GetLang("langSearchWithoutWords")%></div>
        <div class="col-xs-7"><input name="without" type="text" id="without" class="txtfield form-control" /></div>
      </div>
	  <div class="row">
		<div class="col-xs-12"><% makeFieldChooser %> <br/></div>
      </div>
  
<div class="searchfilters">
    <div class="searchresultsperpage row">
		<div class="col-xs-5"><span class='fontbold'><%=GetLang("langitemsperpage")%></span></div>
		<div class="col-xs-7">
			<select name="howmanyitems"  class="txtfielddropdown form-control"> 
				<option value="10">10 <%=GetLang("langSearchItemsPerPage")%></option>
				<option value="20">20 <%=GetLang("langSearchItemsPerPage")%></option>
				<option value="30">30 <%=GetLang("langSearchItemsPerPage")%></option>
				<option value="50">50 <%=GetLang("langSearchItemsPerPage")%></option>
				<option value="100">100 <%=GetLang("langSearchItemsPerPage")%></option>
			  </select>
		</div>
    </div>
    <%
   if GetConfig("xSearchDisplayCategories") = "Yes" then
%>
      <% makeCategoryDropdown %>
    <%
   end if
   if GetConfig("xSearchSortFields")<>"" then
%>
    <div>
      <%
      ParseRecord GetConfig("xSearchSortFields"), OtherTypes, othercount, ","
      if GetConfig("xSearchSortCaptions")<>"" then
         ParseRecord GetConfig("xSearchSortCaptions"), OtherCaptions, othercaptioncount, ","
      end if

      for i = 0 to othercount -1
         if othercaptions(i) = "" then
            Othercaptions(i) = othertypes(i)
         end if
      next

      Sortupdownnames(0) = GetLang("langAscending")
      Sortupdownnames(1) = GetLang("langDescending")
      Sortupdownvalues(0) = "ASC"
      Sortupdownvalues(1) = "DESC"
      SortUpDowncount = 2

      if othercount>0 then
%>
      <span class='fontbold'><%=GetLang("langEditSort")%></span> <br />
      <%GenerateSelectV OtherCaptions,OtherTypes,strsearchsort,"strsearchsort",OtherCount,"" %>
      <%GenerateSelectV Sortupdownnames,sortupdownvalues,strsearchsortupdown,"strsearchsortupdown",sortupdowncount,"" %>
      <%
      end if
%>
    </div>
    <%
   end if
%>
    <%
   if GetConfig("xsearchbyprice") = "Yes" then
%>
    <div>
		<div class="row">
			<div class="col-xs-5"><span class='fontbold'><%=GetLang("langsearchlowprice")%></span></div>
			<div class="col-xs-7"><input size="10" name="lowprice" class="txtfield form-control" /></div> 
		</div>
		<div class="row">
			<div class="col-xs-5"><span class='fontbold'><%=GetLang("langsearchhighprice")%></span></div>
			<div class="col-xs-7"> <input size="10" name="highprice" class="txtfield form-control" /></div>
        </div>
		<br/>
    </div>
    <%
   end if
%>
</div>
  <div class="submit_btn_container">
    <% ShopButton GetConfig("xbuttonsearch"),GetLang("langCommonSearch"),"action"%>
  </div>
</form>
</div>
</div>
<%
end sub

sub makeCategoryDropdown
   dim rscat
   dim SQL

   if GetConfig("xSearchDisplayCategories") = "Yes" then
      SQL = "SELECT * from categories "
      sql = sql & " where highercategoryid=0 "
      if GetConfig("xproductmatch") = "Yes" then
         '7.00 - enhanced product matching
         sql = sql & " and "
         GenerateProductmatchsqlsubs sql
      end if

	  '700 - Customer Groups - Matching Custormer match
	  sql = sql & GenerateCustomerMatchSQL ("customermatch","excustomermatch","loggedin","and")

      if GetConfig("xselectproductsbylanguage") = "Yes" and GetSess("language")<>"" then
	     '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
         sql = sql & " and (catlanguage="& sqlserverprefixn &"'" & GetSess("language") & "'"
         sql = sql & " or catlanguage is null)"
      end if
      sql = sql & " order by " & GetConfig("xsortcategories")
      Set rscat = Server.CreateObject("ADODB.Recordset")
      rscat.open SQL, dbc, adOpenDynamic, adLockOptimistic
%>
<div class="row">
<div class="col-xs-5"><label><%=GetLang("langcat01")%></label></div>
<div class="col-xs-7"><select name="category" class="txtfielddropdown form-control">
  <option value="all">All</option>
  <%
      do while not RSCat.eof
         if rscat("catdescription") <> "" then
            if isnull(rscat("cathide")) then
%>
  <option value="<%=RSCat("categoryid")%>"><%=RSCat("catdescription")%></option>
  <%
            end if
         end if
         RSCat.MoveNext
      loop
      rscat.close
      set rscat = nothing
%>
</select>
</div>
</div>
<%
   end if
end sub

sub makeFieldChooser
   dim fieldString, fieldLength, captionString
   fieldString = GetConfig("xsearchfields")
   captionString = GetConfig("xsearchsortcaptions")
   if captionstring = "" then
      captionstring = fieldstring
   end if
   dim fieldArray, captionArray
   fieldArray = split(fieldString, ",")
   captionArray = split(captionString, ",")
%>
<div class="comment_title"><%=GetLang("langcommonsearch")%>&nbsp;<%=GetLang("langSearchFields")%></div>
<div class="row">
  <%
   dim i
   
   '700 - 2010.09.01 - Bug Fix: Not showing last xsearchfields
   for i = 0 to (ubound(fieldArray))
%>
   <div class="col-sm-4 col-xs-12 ">
      <input type="checkbox" name="searchFields" value="<%=fieldArray(i)%>" checked="checked" />
	  <%=captionArray(i)%>
  </div>
  <%
   Next %>
</div>
<%
end sub
%>