<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Database Sessions - Auto Update Prices routines
'*********************************************************************************

'700 - Database Sessions For SQL Server - Always get the latest price from database
function getcprice (proid)
   if len(proid) <= 0 then
      getcprice = 0
	  exit function
   end if

   if isnumeric(proid) = false then
      getcprice = 0
	  exit function
   end if
   
   '701 - 2011.10.07 - Bug Fix: gift cert is not working while database session is turned on
   if cstr(proid) = cstr(getconfig("xgiftproductid")) then
      getcprice = getsess("giftamount")
      exit function
   end if
   
   dim strsql,tempprice,orders,newprice,discount
   tempprice = 0
   strsql = "select * from products where catalogid=" & proid
   'on error resume next
   Set Orders = Server.CreateObject("ADODB.Recordset")
   orders.open strsql, dbc, adopenkeyset, adlockoptimistic
   if not orders.eof then
      tempprice = orders("cprice")
	  shopcustomerprices orders, orders("catalogid"), orders("ccategory"), orders("cprice"), newprice,discount
	  if trim(newprice) <> "" then tempprice = newprice
   end if
   Orders.close
   set Orders=Nothing
   
   getcprice = tempprice
end function

'700 - Database Sessions For SQL Server - Always get the latest Xdualpricefield from database
function getXdualpricefield (proid)
   getXdualpricefield = 0
   exit function
   if len(proid) <= 0 then
      getXdualpricefield = 0
	  exit function
   end if

   if isnumeric(proid) = false then
      getXdualpricefield = 0
	  exit function
   end if
   
   dim Xdualpricefield
   Xdualpricefield = GetConfig("Xdualpricefield")
   if trim(Xdualpricefield) = "" then
      getXdualpricefield = 0
	  exit function
   end if
   
   dim strsql,tempprice,Orders
   tempprice = 0
   strsql = "select "& Xdualpricefield &" from products where catalogid=" & proid
   Set Orders = Server.CreateObject("ADODB.Recordset")
   orders.open strsql, dbc, adopenkeyset, adlockoptimistic
   if not orders.eof then
      tempprice = orders(Xdualpricefield)
   end if
   Orders.close
   set Orders=Nothing
   
   getXdualpricefield = tempprice
end function

'700 - Database Sessions For SQL Server - Always update the cart prices
sub UpdateCartPrices
   '800 - Cart cookies - Reload cart from cookie add-on
   '800 - 2016.12.21 - Bug Fix: Cartcookies: Throwing error on lite and value pack
   if lcase(getconfig("xcartcookiesenabled")) = "yes" then
      UpdateCartPricesCookies
      exit sub
   end if

   '700 - 2010.06.10 - Enhancement: Better session handling while using xsavesession
   if lcase(xsavesession) <> "yes" then exit sub
   if xautoupdatecartprices <> "Yes" then exit sub
   dim ArrCart,scartItem,i,ProductPrice,DiscountPrice,dualreprice
   dim temptotalprice
   scartItem = GetSess("CartCount")
   ArrCart = GetSessA("CartArray")
   temptotalprice = 0

   dim selectlistpos1,selectlistpos2,selectlistvalue

   '700 - 2010.08.12 - Bug Fix: Errors while using database session
   if trim(scartItem) = "" then scartItem = 0
   if isnull(scartItem) then scartItem = 0
   setsess "CartCount",scartItem
   
   '701 - 2012.02.21 - Enhancement: Better hanlding on auto update price when databaes session is switched on
   on error resume next
   if scartItem = 0 then exit sub
   if session("alredyupdatecartprices") = "Yes" then exit sub
   session("alredyupdatecartprices") = "Yes"

   for i = 1 to scartItem
     '700 - Database Sessions For SQL Server - Always get the latest price from database
	 if trim(ArrCart(cbundleparentid, i)) = "" then
	 
	    '701 - 2010.11.20 - Bug Fix: Project and database session not working properly
	    if GetConfig("xprojectCatalogId") <> arrCart(cProductid,i) then

	    ProductPrice = getcprice(arrCart(cProductid,i))

	    if trim(ArrCart(cProductFeatures,i)) <> "" then
		   '701 - 2011.08.26 - Bug Fix: Feature userprice are not carry forward to checkout process
		   '800 - 2015.09.28 - Better hanlding on numeric values for MySQL DB on view cart page
	       ProductPrice = cdbl(ProductPrice) + cdbl(getfpricepercent(arrCart(cProductFeatures,i),ProductPrice,arrCart(cfeatureuserprice,i)))
		   
		   if trim(arrCart(cfeatureotherpricing,i)) <> "" then
		      if instr(arrCart(cfeatureotherpricing,i),"-selectlistprice=[") > 0 then
		   	     selectlistpos1 = instr(arrCart(cfeatureotherpricing,i),"-selectlistprice=[") + len("-selectlistprice=[") - 1
				 selectlistpos2 = instr(mid(arrCart(cfeatureotherpricing,i),selectlistpos1+1,len(arrCart(cfeatureotherpricing,i)) - selectlistpos1 + 1),"]")
				 selectlistvalue = mid(arrCart(cfeatureotherpricing,i),selectlistpos1+1,selectlistpos2-1)
              else
			     selectlistvalue = 0
			  end if
		   end if
		   '702.04.23 - Bug Fix: Better handling on getfprice routine
		   '800 - 2015.09.28 - Better hanlding on numeric values for MySQL DB on view cart page
  		   ProductPrice = cdbl(ProductPrice) + cdbl(getfprice(arrCart(cProductFeatures,i),arrCart(cfeatureotherpricing,i))) + cdbl(selectlistvalue)
	   end if
 
	    ArrCart(cOriginalPrice,i) = ProductPrice
  
        DiscountPrice=ProductPrice
		
		'701 - 2011.05.18 - Bug Fix: Quantity pricing should always recalculate if database session is enabled
        CalculateUserPrice ProductPrice, ArrCart(cQuantity,i), DiscountPrice, ArrCart, i
		
        '701 - 2012.02.21 - Enhancement: Better hanlding on auto update price when databaes session is switched on
        if DiscountPrice <> 0 then ArrCart(cUnitPrice,i)=DiscountPrice

        '700 - Database Sessions For SQL Server
	    if isnumeric(ArrCart(cUnitPrice,i)) = false then ArrCart(cUnitPrice,i) = 0

        '800 - 2015.09.28 - Better hanlding on numeric values for MySQL DB on view cart page
		temptotalprice = cdbl(temptotalprice) + (cdbl(ArrCart(cUnitPrice,i)) * cdbl(ArrCart(cQuantity,i)))
		
		'701 - 2010.11.20 - Bug Fix: Project and database session not working properly
		else
		   '800 - 2015.09.28 - Better hanlding on numeric values for MySQL DB on view cart page
		   temptotalprice = cdbl(temptotalprice) + (cdbl(ArrCart(cUnitPrice,i)) * cdbl(ArrCart(cQuantity,i)))
		end if
		
	 end if
   Next
   setsessa "CartArray",ArrCart
   session("OrderTotal") = temptotalprice

   '701 - 2012.02.21 - Enhancement: Better hanlding on auto update price when databaes session is switched on
   on error goto 0
end sub

'702.04.23 - Bug Fix: Better handling on getfprice routine
function getfprice (feaid,passfeatureotherpricing)
   if len(feaid) <= 0 then
      getfprice = 0
	  exit function
   end if
   
   dim tempfeaidary(100),tempfeaidcnt

   '701 - 2011.11.25 - Bug Fix: Feature pricing is incorrect calculated from restore cart / saved cart / wishlist
   if instr(feaid," ") > 0 then
      parserecord feaid,tempfeaidary,tempfeaidcnt," "
   else
   parserecord feaid,tempfeaidary,tempfeaidcnt,","
   end if

   dim strsql,tempprice,orders,totalprice,icnt,otheramount
   totalprice = 0
   tempprice = 0
   otheramount = 0
   dim selectlistpos1,selectlistpos2,selectlistvalue

   '800 - 2016.04.21 - Bug Fix: Feature Quantity: Recalculate not working properly with custom feature quantity
   dim selectlistcnt,selectlists(99),iselectcnt,ordercnt
   ordercnt = 0

   for icnt = 0 to (tempfeaidcnt - 1)
      if isnumeric(tempfeaidary(icnt)) = false or instr(tempfeaidary(icnt),",") > 0 then
      else
         '800 - 2016.04.21 - Bug Fix: Feature Quantity: Recalculate not working properly with custom feature quantity
	     ordercnt = ordercnt + 1

         strsql = "select featuretype,featureprice from prodfeatures where id=" & tempfeaidary(icnt)
         Set Orders = Server.CreateObject("ADODB.Recordset")
         orders.open strsql, dbc, adopenkeyset, adlockoptimistic
         if not orders.eof then
		    if lcase(orders("featuretype")) = "selectlist" then
			   tempprice = 0
			'702.04.23 - Bug Fix: Better handling to featuretype Multiplier if remove item from cart
			'702.04.23 - Bug Fix: Better handling on getfprice routine
			elseif lcase(orders("featuretype")) = "quantity" or lcase(orders("featuretype")) = "multiplier" then
		       if trim(passfeatureotherpricing) <> "" then
                  '800 - 2016.04.21 - Bug Fix: Feature Quantity: Recalculate not working properly with custom feature quantity
			      parserecord passfeatureotherpricing,selectlists,selectlistcnt,"-"
				  selectlistvalue = 0
				  for iselectcnt = 0 to (selectlistcnt-1)
					 if instr(selectlists(iselectcnt),"selectquantity=[") > 0 then
 		      		    selectlistpos1 = instr(selectlists(iselectcnt),"selectquantity=[") + len("selectquantity=[") - 1
					    selectlistpos2 = instr(mid(selectlists(iselectcnt),selectlistpos1+1,len(selectlists(iselectcnt)) - selectlistpos1 + 1),"]")
					    selectlistvalue = mid(selectlists(iselectcnt),selectlistpos1+1,selectlistpos2-1)
                     else
					    selectlistvalue = 0
					 end if
					 if cstr(iselectcnt) = cstr(ordercnt-1) then
					    exit for
					 end if
			      next
               else
				  selectlistvalue = 0
			   end if
			   tempprice = orders("featureprice")
               if isnull(tempprice) then tempprice = 0
               if trim(tempprice) = "" then tempprice = 0
			   '800 - 2015.09.28 - Better hanlding on numeric values for MySQL DB on view cart page
               tempprice = cdbl(tempprice) * cdbl(selectlistvalue)
			else
               tempprice = orders("featureprice")
               if isnull(tempprice) then tempprice = 0
               if trim(tempprice) = "" then tempprice = 0
			   '800 - 2015.09.28 - Better hanlding on numeric values for MySQL DB on view cart page
			   otheramount = cdbl(otheramount) + cdbl(tempprice)
			end if
         end if
         Orders.close
         set Orders=Nothing
         totalprice = cdbl(totalprice) + cdbl(tempprice)
      end if
   next
   getfprice = totalprice
end function

'701 - 2011.08.26 - Bug Fix: Feature userprice are not carry forward to checkout process
function getfpricepercent (feaid,curprice,userprice)
   if len(feaid) <= 0 then
      getfpricepercent = 0
	  exit function
   end if

   if len(curprice) <= 0 then
      getfpricepercent = 0
	  exit function
   end if

   if isnumeric(curprice) = false then
      getfpricepercent = 0
	  exit function
   end if

   '701 - 2011.08.26 - Bug Fix: Feature userprice are not carry forward to checkout process
   if trim(userprice) <> "" then
	  getfpricepercent = userprice
	  exit function
   end if

   dim tempfeaidary(100),tempfeaidcnt

   '701 - 2011.11.25 - Bug Fix: Feature pricing is incorrect calculated from restore cart / saved cart / wishlist
   if instr(feaid," ") > 0 then
      parserecord feaid,tempfeaidary,tempfeaidcnt," "
   else
   parserecord feaid,tempfeaidary,tempfeaidcnt,","
   end if

   dim strsql,tempprice,orders,temppercent,icnt

   '700 - 2010.08.12 - Bug Fix: totalprice variable error if using feature percent
   dim totalprice
   
   totalprice = 0
   tempprice = 0
   for icnt = 0 to (tempfeaidcnt - 1)
      if isnumeric(tempfeaidary(icnt)) = false or instr(tempfeaidary(icnt),",") > 0 then
      else
         strsql = "select featurepercent from prodfeatures where id=" & tempfeaidary(icnt)
         Set Orders = Server.CreateObject("ADODB.Recordset")
         orders.open strsql, dbc, adopenkeyset, adlockoptimistic
         if not orders.eof then
            temppercent = orders("featurepercent")
         end if
         Orders.close
         set Orders=Nothing
         if isnull(temppercent) then temppercent = 0
         if trim(temppercent) = "" then temppercent = 0
		 
		 '701 - 2011.09.13 - Bug Fix: featurepercent should always accept less than 1 value
         if cdbl(temppercent) < 1 then temppercent = cdbl(temppercent) * 100

         if cdbl(temppercent) > 0 then
		    '800 - 2015.09.28 - Better hanlding on numeric values for MySQL DB on view cart page
            tempprice = (cdbl(temppercent) / 100) * cdbl(curprice)
			totalprice = cdbl(totalprice) + cdbl(tempprice)
         end if
      end if
   next
   getfpricepercent = totalprice
end function
%>