<%
function WordWrap(theString, wrapLength, checkchar)
   dim tempString, lenOfString, index
   dim lastSpace, startOfLine
   lenOfString = len(theString)
   index = 1
   startOfLine = 1
   while index < lenOfString
      if mid(theString, index, 1) = checkchar then
         lastSpace = index
      end if
      if index = startOfLine + wrapLength then
         tempString = tempString & trim(mid(theString, startOfLine, lastSpace - startOfLine + 1)) & "<br>"
         startOfLine = lastSpace + 1
         while mid(theString, startOfLine, 1) = checkchar
            startOfLine = startOfLine + 1
         wend
      end if
      index = index + 1
   wend
   tempString = tempString & trim(mid(theString, startOfLine)) & "<br>"
   WordWrap = tempString
end function

sub assigndbtable_filename (filename, filename2, filename3, filename4, filename5)
   if trim(filename) = "" then
      if instr(lcase(request.ServerVariables("SCRIPT_NAME")),"shopa_editrecord.asp") > 0 then
         filename = "shopa_editdisplay.asp"
      elseif instr(lcase(request.ServerVariables("SCRIPT_NAME")),"shopadmin1.asp") > 0 then
	     exit sub
	  end if
   end if
   dim DBTable
   GetTableName_menuaccess DBTable
   filename2 = ""
   select case lcase(filename)
      case "shopa_editdisplay.asp", "shopa_editrecord.asp", "shopa_editdisplaybulk.asp","shopa_exportsetup.asp","shopa_mailsetup.asp","shopa_import.asp"
	     if trim(DBTable) <> "" then
	        select case trim(lcase(request("SpecialFunction")))
			   case "export"
			      filename2 = "shopa_exportselect.asp"
				  if lcase(filename) = "shopa_editdisplay.asp" then
			         if trim(lcase(dbtable)) = "orders" then
					    filename2 = "shopa_exportsetup.asp?table=orders"
						filename3 = "shopa_displayorders.asp"
						filename4 = "shopa_tableselect.asp"
                     end if
				  end if
               case "mail"
			      filename2 = "shopa_mailsetup.asp"
			   case "delete"
			   case else
			      'if lcase(filename) = "shopa_import.asp" or lcase(filename) = "shopa_exportsetup.asp" then
  			         if lcase(filename) = "shopa_exportsetup.asp" then
			            filename2 = "shopa_exportselect.asp"
			         elseif lcase(filename) = "shopa_editdisplay.asp" then
					    filename2 = "shopa_mailsetup.asp"
						filename3 = "shopa_exportselect.asp"
				        filename4 = "shopa_tableselect.asp"
						select case trim(lcase(dbtable))
						   case "tblmenuheader","tblaccess"
						      filename5 = "shopa_menu_control.asp"
                           case "languages"
						      filename5 = "shopa_languageadmin.asp"
						end select
			         elseif lcase(filename) = "shopa_editdisplaybulk.asp" then
					    filename2 = "shopa_tableselectbulk.asp"
					 else
   		                filename2 = filename
                     end if
			      'end if
			end select
			select case lcase(DBTable)
			   case "languages"
			      filename2 = "shopa_languageadmin.asp"
			   case else
			      filename2 = filename
			      filename = ""& filename &"?table="& DBTable &""
			end select
         end if
      case "shopa_config.asp"
	     if request("newgroup") <> "" then
		    filename = "shopa_configsystem.asp?newgroup="& request("newgroup") &""
         elseif request("newgroup2") <> "" then
		    filename = "shopa_configsystem.asp?newgroup2="& request("newgroup2") &""
		 end if
   end select
   select case lcase(dbtable)
      case "xmlfeed"
	     filename = "shopa_xml_feed.asp"
      case "projects"
	     filename = "shopa_projectdisplay.asp"
   end select
   filename = replace(filename," ","+")
end sub

sub GetTableName_menuaccess (DBTable)
   DBTable = Request("Table")
   if DBTable = "" then
      DBTable = GetSess("table")
   end if
   if DBTable <> "" then
      SetSess "table", DBTable
   end if
end sub

function TestObject( comIdentity )
   dim xTestObj
   on error resume next
   TestObject = false
   err.clear
   set xTestObj = Server.createobject( comIdentity )
   if err = 0 then TestObject = true
   set xTestObj = nothing
   err.clear
   on error goto 0
end function

sub ParseRecord_split (record,words,wordcount,delimiter)
   dim prevalue,x
   prevalue = Split(record,delimiter)
   wordcount = 0
   for each x in prevalue
      words(wordcount) = x
      wordcount = wordcount + 1
   next
end sub

sub updateconfig (configname, configvalue)
   if trim(configname) = "" then exit sub
   dbc.execute ("update "& xconfigtable &" set fieldvalue='"& configvalue &"' where fieldname='"& configname &"'")
   SetConfig configname, configvalue
end sub

sub disable_all_gateways
   '800 - 2015.07.20 - xallowcreditcards should auto swtich off if any payment gateway is chosen
   updateconfig "xallowcreditcards", "No"

   updateconfig "xPayPal_Website_Payment_Pro", "No"
   updateconfig "xpppymt_enable", "No"
   updateconfig "xpayflowlink_enable", "No"
   updateconfig "xpayflowpro_enable", "No"
   dim rs, sql
   sql = "select addonenableconfig from addoninfo where addoncategory = 'gateway'"
   set rs = Server.createobject("ADODB.Recordset")
   rs.open sql, dbc, adOpenStatic, adLockReadOnly
   do while not rs.eof
      updateconfig rs("addonenableconfig"), "No"
	  rs.movenext
   loop
   closerecordset rs
end sub

'800 - 2015.04.28 - Enhancement: Better handling on numeric variable
function tonum(passnum)
   if isnull(passnum) then passnum = 0
   if trim(passnum) = "" then passnum = 0
   if cstr(passnum) = "**NULL**" then passnum = 0
   tonum = cdbl(passnum)
end function

'800 - 2016.02.23 - Enhancement: Admin: To have "Plain Text" option for Editor
sub generate_editor_wys_plain_js
   if lcase(GetConfig("xhtmleditor")) <> "yes" then exit sub
   %>
   <script type="text/javascript">
   $(document).ready(function(){
      $('.textmenu li').click(function(){
         clicked_li = $(this)
         fieldtype = $(this).attr('data-field')
         targetfield = $(this).closest('ul').attr('data-target');
         parentul = $(this).closest('ul');
         $('.textmenu li').not($(clicked_li)).removeClass('active');
         $(clicked_li).addClass('active')
         if(fieldtype == "plain"){
            $('#idAreaoEdit_'+targetfield).addClass('hide');
            $('#'+targetfield).attr('name','');
            $(parentul).siblings('.plaintext').attr('name', targetfield).removeClass('hide')
         } else {
            $('#idAreaoEdit_'+targetfield).removeClass('hide');
            $('#'+targetfield).attr('name',targetfield);
            $(parentul).siblings('.plaintext').attr('name', '').addClass('hide')
         }
      });
   });
   </script>
   <%
end sub
%>