<%
'*********************************************************************************
' 8.00
' 22 Feb 2016
' Category Tree View
'*********************************************************************************

const treeview_imgplus = "images/treeview/plus.gif"
const treeview_imgminus = "images/treeview/minus.gif"
const treeview_imgnone = "images/treeview/none.gif"
const treeview_initcnt = 5000

sub load_category_treeview (fieldname, fromwcatid, plevel, pcheck, filtercategories)
   if trim(filtercategories) = "" then
      filtercategories = session("filtercategories")
   else
      session("filtercategories") = filtercategories
   end if
   htmlwrite "<input type=""hidden"" name=""originfiltercategories"" value="""& filtercategories &"""/>"
   dim accesslist, accesscount
   redim accessarray(treeview_initcnt)
   accesslist = filtercategories
   ParseRecord_split accesslist, accessarray, accesscount, ","
   dim pcheckvalue
   if lcase(pcheck) = "y" then
      pcheckvalue = "checked"
   else
      pcheckvalue = ""
   end if
   loadtreeviewjs
   if trim(plevel) = "" then plevel = 0
   plevel = cdbl(plevel) + 1
   dim spacetohave, icnt
   spacetohave = ""
   if cdbl(plevel) >= 2 then
      for icnt = 1 to cdbl(plevel) - 1
         spacetohave = spacetohave & "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
      next
   end if
   dim sql, rs, tempname, imgstr, nextflag, accessfound2, accesstring, hassubcategory
   if fromwcatid = 0 then
      sql = "select categoryid,catdescription,hassubcategory from categories where (highercategoryid is null or highercategoryid = 0) order by categoryid asc"
   else
      sql = "select categoryid,catdescription,hassubcategory from categories where highercategoryid = "& fromwcatid &" order by categoryid asc"
	  htmlwrite "<input type=""hidden"" name=""c_exp_id_"& fromwcatid &""" value=""yes"" />"
   end if
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenKeyset, adLockReadOnly
   while not rs.eof
      hassubcategory = rs("hassubcategory")
	  if isnull(hassubcategory) then hassubcategory = ""
      accessfound2 = false
      if accesscount > 0 then
	     if checkcategoryaccess (rs("categoryid"), accessarray, accesscount) then
		    accessfound2 = true
		 end if
	  end if
	  if accessfound2 = True then
	     pcheckvalue = "checked"
	  else
	     pcheckvalue = ""
	  end if
      tempname = CMSRemoveHTML(rs("catdescription"))
	  htmlwrite "<div class=""checkbox_wrapper"">"
	  if trim(hassubcategory) <> "" then
         htmlwrite "<span id='menuimgdiv_main_"& rs("categoryid") &"'>"
         htmlwrite "<img onclick=""javascript:expandcategorymenu('menuimgdiv_main_"& rs("categoryid") &"','menunamediv_"& rs("categoryid") &"_1','"& rs("categoryid") &"','"& plevel &"');"" src="""& treeview_imgplus &""" border=""0"" align=""absmiddle"">"
         htmlwrite "</span>"
         htmlwrite "<input "& pcheckvalue &" name="""& fieldname &""" id=""chk_main_"& rs("categoryid") &""" onclick=""javascript:checkchildmenu('chk_main_"& rs("categoryid") &"','menunamediv_"& rs("categoryid") &"_1');"" type=""checkbox"" value=" & rs("categoryid") & ">"& tempname &""
		 nextflag = true
	  else
		 htmlwrite "<img src='"& treeview_imgnone &"' border=0 align='absmiddle' />"
		 htmlwrite "<input "& pcheckvalue &" name="""& fieldname &""" id=""chk_main_"& rs("categoryid") &""" onclick=""javascript:checkchildmenu('chk_main_"& rs("categoryid") &"','menunamediv_"& rs("categoryid") &"_1');"" type=""checkbox"" value=" & rs("categoryid") & ">"& tempname &""
		 nextflag = false
	  end if
	  htmlwrite "<input type=""hidden"" name=""c_exp_hassubcategory_"& rs("categoryid") &""" value="""& hassubcategory &""" />"
	  if nextflag then
	     htmlwrite "<span id='menunamediv_"& rs("categoryid") &"_1' style='visibility:hidden;display:none' class='child-tree'>"
		 htmlwrite "</span>"
	  end if
	  htmlwrite "</div>"
      rs.MoveNext
   wend
   closerecordset rs
end sub

sub loadtreeviewjs
%>
<script type="text/javascript" src="js/expandcategorymenu.js"></script>
<%
end sub

function checkcategoryaccess (categoryid, accessarray, accesscount)
   dim icnt, accessfound
   accessfound = false
   for icnt = 0 to (accesscount - 1)
      if cstr(categoryid) = cstr(accessarray(icnt)) then
         accessfound = true
         exit for
      end if
   next
   checkcategoryaccess = accessfound
end function

sub anaylsefiltercategories (filtercategories)
   dim filtercategoriescnt,icnt
   redim filtercategoriesary(treeview_initcnt)
   ParseRecord_split filtercategories, filtercategoriesary, filtercategoriescnt, ","
   dim c_exp_id, c_exp_hassubcategory, returncatid
   returncatid = ""
   dim originfiltercategories,originfiltercategoriescnt, jcnt, childflag, parentid
   redim originfiltercategoriesary(treeview_initcnt)
   originfiltercategories = cleanchars(request.form("originfiltercategories"))
   ParseRecord_split originfiltercategories, originfiltercategoriesary, originfiltercategoriescnt, ","
   for icnt = 0 to filtercategoriescnt - 1
      c_exp_id = cleanchars(request("c_exp_id_"& filtercategoriesary(icnt) &""))
	  c_exp_hassubcategory = cleanchars(request("c_exp_hassubcategory_"& filtercategoriesary(icnt) &""))
	  assignretruncatid returncatid, filtercategoriesary(icnt)
	  if (trim(c_exp_id) = "" or c_exp_id = "no") and ((lcase(c_exp_hassubcategory) = "yes") or c_exp_hassubcategory <> "") then
	     if trim(originfiltercategories) = "" then
   	        retrieve_all_subcategories filtercategoriesary(icnt), returncatid
         else
		    childflag = false
			parentid = ""
		    for jcnt = 0 to originfiltercategoriescnt - 1
			   if filtercategoriesary(icnt) = originfiltercategoriesary(jcnt) then
			      childflag = true
				  parentid = filtercategoriesary(icnt)
			   else
			      if childflag then
				     if ischild_category(originfiltercategoriesary(jcnt),parentid) then
					    assignretruncatid returncatid, originfiltercategoriesary(jcnt)
					 end if
				  end if
			   end if
			next
	     end if
	  end if
   next
   filtercategories = returncatid
end sub

sub retrieve_all_subcategories (fromcatid, returncatid)
   dim rs, sql, hassubcategory
   sql = "select categoryid,hassubcategory from categories where highercategoryid = "& fromcatid &" order by categoryid"
   set rs = Server.createobject("ADODB.Recordset")
   if instr(ucase(xdatabasetype), "MYSQL") > 0 or (lcase(xSqlOLEDb) = "yes" and ucase(xdatabasetype) = "SQLSERVER") then
      rs.CursorLocation = 3
   end if
   rs.open sql, dbc, adOpenStatic, adLockReadOnly
   do while not rs.eof
      hassubcategory = rs("hassubcategory")
	  if isnull(hassubcategory) then hassubcategory = ""
	  if right(returncatid,1) = "," then
	     returncatid = returncatid & rs("categoryid")
	  else
	     returncatid = returncatid & "," & rs("categoryid")
	  end if
	  if trim(hassubcategory) <> "" then
	     retrieve_all_subcategories rs("categoryid"), returncatid
	  end if
      rs.movenext
   loop
   CloseRecordSet rs
end sub

function ischild_category (categoryid, parentid)
   dim rs, sql, tempflag
   sql = "select highercategoryid from categories where categoryid = "& categoryid &""
   set rs = Server.createobject("ADODB.Recordset")
   if instr(ucase(xdatabasetype), "MYSQL") > 0 or (lcase(xSqlOLEDb) = "yes" and ucase(xdatabasetype) = "SQLSERVER") then
      rs.CursorLocation = 3
   end if
   rs.open sql, dbc, adOpenStatic, adLockReadOnly
   if rs.recordcount > 0 then
      if cint(rs("highercategoryid")) = cint(parentid) then
	     tempflag = true
      else
	     if cint(rs("highercategoryid")) = 0 then
		    tempflag = false
         else
		    tempflag = ischild_category(rs("highercategoryid"),parentid)
		 end if
	  end if
   else
      tempflag = false
   end if
   CloseRecordSet rs
   ischild_category = tempflag
end function

sub assignretruncatid (returncatid, passcatid)
   if trim(returncatid) = "" then
      returncatid = passcatid
   else
      if right(returncatid,1) = "," then
         returncatid = returncatid & passcatid
      else
	     returncatid = returncatid & "," & passcatid
      end if
   end if
end sub
%>