<%
'*********************************************************************************
' PayPal Admin Console
' PayPal Help File
' 7.02
' 26 July 2012
'*********************************************************************************

Sub GetPayPalHelp
%>
<div style="visibility:hidden">
<span name='help_xPaypalEmail' id='help_xPaypalEmail'><P>This is the email address your PayPal account is linked to. Enter the email address where you want to receive payments; you can set up a PayPal account later.</P></span>
<span name='help_xPayPal_API_UserName' id='help_xPayPal_API_UserName'><P>Enter your PayPal API user name here.</P></span>
<span name='help_xPayPal_API_Password' id='help_xPayPal_API_Password'><P>Enter your PayPal API Password here.</P></span>
<span name='help_xPayPal_API_Signature' id='help_xPayPal_API_Signature'><P>Enter your PayPal API Signature here.</P></span>
<span name='help_xPayPal_Express_companylogo' id='help_xPayPal_Express_companylogo'><P>URL of the company logo to show on the PayPal checkout page, relative to the shopping cart root folder.  The image must be no larger than 750x90px, and must be a JPEG, GIF, or PNG image.</P></span>
<span name='help_xPayPal_Test_Mode' id='help_xPayPal_Test_Mode'><P>Set this to Production to accept live transactions, or Sandbox to use PayPal's test environment.  You can set up a test account at <a href="https://developer.paypal.com" target="_blank">https://developer.paypal.com</a>.</P></span>
<span name='help_xpayflowpro_tr_enable' id='help_xpayflowpro_tr_enable'><P>Enables the use of PayPal's Transparent Redirect feature to aid in PCI compliance.  Only enable this option if you have a Payflow Pro account that includes this feature.  Contact PayPal for more information.</P></span>
<span name='help_xPayPal_Transaction_Type' id='help_xPayPal_Transaction_Type'><P>Set to use "Sale" or "Authorization" mode.<br />Sale means the fund will be captured immediately while Authorization will require a manual capture from PayPal administration page.</P></span>
<span name='help_xPayPal_CurrencyCode' id='help_xPayPal_CurrencyCode'><P>Set to use the specified currency.</P></span>
<span name='help_xPayPal_LCID' id='help_xPayPal_LCID'><P>Locale ID to use for PayPal.</P></span>
<span name='help_xpppymt_pageCollapseBgColor' id='help_xpppymt_pageCollapseBgColor'><P>This sets the color of the border around each payment option.  Eg: FFAA11</P></span>
<span name='help_xpppymt_pageCollapseTextColor' id='help_xpppymt_pageCollapseTextColor'><P>This sets the color of the words "Pay with PayPal" and "Pay with credit or debit card". Eg: 22FFFF</P></span>
<span name='help_xpppymt_pageButtonBgColor' id='help_xpppymt_pageButtonBgColor'><P>This sets the color of the Pay Now/Submit button. Eg: 880000</P></span>
<span name='help_xpppymt_pageButtonTextColor' id='help_xpppymt_pageButtonTextColor'><P>This sets the color of the text on the Pay Now/Submit button. Eg: BB66FF</P></span>
<span name='help_xpppymt_labelTextColor' id='help_xpppymt_labelTextColor'><P>The color of the text for "card number", "expiration date" etc. Eg: 22FFFFF</P></span>
<span name='help_xPayPal_Express_paymentpage_acent_color' id='help_xPayPal_Express_paymentpage_acent_color'><P>Specifies the gradient color that will be used around the "Your order summary" area on the PayPal checkout pages. Eg: 22FFFF</P></span>
<span name='help_xpaypal_pymtadv_PARTNER' id='help_xpaypal_pymtadv_PARTNER'><P>Your partner name is PayPal.</P></span>
<span name='help_xpaypal_pymtadv_MERCHANT' id='help_xpaypal_pymtadv_MERCHANT'><P>This is the login name you created when signing up for PayPal Payments Advanced.</P></span>
<span name='help_xpaypal_pymtadv_USER' id='help_xpaypal_pymtadv_USER'><P>PayPal recommends entering a User Login here instead of your Merchant Login. You can set up a User profile in PayPal Manager. [link]: https://manager.paypal.com This will enhance security and prevent service interruption should you change your Merchant Login password.</P></span>
<span name='help_xpaypal_pymtadv_PWD' id='help_xpaypal_pymtadv_PWD'><P>This is the password you created when signing up for PayPal Payments Advanced or the password you created for API calls.</P></span>
<span name='help_xpaypal_pfpro_PARTNER' id='help_xpaypal_pfpro_PARTNER'><P>This should be the same partner name that's used when logging into your PayPal Payflow account.</P></span>
<span name='help_xpaypal_pfpro_MERCHANT' id='help_xpaypal_pfpro_MERCHANT'><P>This is the login name you created when signing up for Payflow Pro.</P></span>
<span name='help_xpaypal_pfpro_USER' id='help_xpaypal_pfpro_USER'><P>PayPal recommends entering a User Login here instead of your Merchant Login. You can set up a User profile in PayPal Manager. [link]: https://manager.paypal.com This will enhance security and prevent service interruption should you change your Merchant Login password.</P></span>
<span name='help_xpaypal_pfpro_PWD' id='help_xpaypal_pfpro_PWD'><P>This is the password you created when signing up for Payflow Pro the password you created for API calls.</P></span>
<span name='help_xpaypal_pflink_PARTNER' id='help_xpaypal_pflink_PARTNER'><P>This should be the same partner name that's used when logging into your PayPal Payflow account.</P></span>
<span name='help_xpaypal_pflink_MERCHANT' id='help_xpaypal_pflink_MERCHANT'><P>This is the login name you created when signing up for Payflow Link.</P></span>
<span name='help_xpaypal_pflink_USER' id='help_xpaypal_pflink_USER'><P>PayPal recommends entering a User Login here instead of your Merchant Login. You can set up a User profile in PayPal Manager. [link]: https://manager.paypal.com This will enhance security and prevent service interruption should you change your Merchant Login password.</P></span>
<span name='help_xpaypal_pflink_PWD' id='help_xpaypal_pflink_PWD'><P>This is the password you created when signing up for Payflow Link the password you created for API calls.</P></span>
</div>
<% 	
end sub
%>