<%
sub refreshall
   dim sqlrs,strsql,tempstring,xcnt
   tempstring = ""
   xcnt = 0
   strsql="select groupid from groups where grouptype = 'dynamic' order by groupid"
   Set sqlrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
   sqlrs.open strsql, dbc, adOpenKeyset, adLockReadOnly

   sqlrs.movefirst
   do while not sqlrs.eof
      tempstring = tempstring & sqlrs("groupid") & ","
      xcnt = xcnt + 1
      sqlrs.movenext
   loop
   closerecordset sqlrs
   
   if xcnt > 0 then
      tempstring = mid(tempstring,1,len(tempstring)-1)
   end if
   response.write tempstring
end sub

sub refreshind (groupid,fromwhere)
   if trim(groupid) = "" then
      debugwrite getlang("langrefresherrors")
      exit sub
   end if
   
   if validgroup(groupid) = false then
      debugwrite getlang("langrefresherrors")
	  exit sub
   end if
   
   select case lcase(getgrouptype(groupid))
      case "dynamic"
	     refreshdynamic groupid,fromwhere
      case "static"
	     refreshstatic
	  case else
	     debugwrite getlang("langrefresherrors")
		 exit sub
   end select
end sub

sub refreshstatic
end sub

sub refreshdynamic (groupid,fromwhere)
   if trim(groupid) = "" then
      debugwrite getlang("langrefresherrors")
      exit sub
   end if

   dim sqlquery
   sqlquery = getsqlquery(groupid)
   if trim(sqlquery) = "" then
      debugwrite getlang("langrefresherrors")
	  exit sub
   end if

   processquery sqlquery, groupid,fromwhere
end sub

sub processquery (sqlquery,groupid,fromwhere)
   if trim(sqlquery) = "" then
      debugwrite getlang("langqueryerrors")
	  exit sub
   end if

   if trim(groupid) = "" then
      debugwrite getlang("langqueryerrors")
	  exit sub
   end if
   
   if checksqlquery(sqlquery) = false then
      debugwrite getlang("langqueryerrors")
	  exit sub
   end if
   'delete
   dim sqlrs,strsql,xcnt
   dim sqlrs2,foundflag,strsql2
   
   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   strsql = "select groupsid,contactid from customergroups where groupsid = "& groupid &""

   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
   sqlrs.open strsql, dbc, adOpenKeyset, adLockReadOnly

   '800 - 2016.06.29 - Bug Fix: Customer Group: Not working properly if query with multiple conditions without brackets
   dim pos1

   if sqlrs.eof then
   else
      sqlrs.movefirst
      do while not sqlrs.eof
	     foundflag = false

	     Set sqlrs2 = Server.CreateObject("ADODB.Recordset")
		 
		 '701 - 2010.11.18 - Enhancement: Fine tune the code while "refreshing" all customer group through admin
		 dim newsqlquery, tempsqlquery
		 tempsqlquery = sqlquery
		 if instr(lcase(tempsqlquery),"order by") > 0 or instr(lcase(tempsqlquery),"group by") > 0 then
		    newsqlquery = sqlquery 
		 else
		    if instr(lcase(tempsqlquery),"where ") > 0 then
               '800 - 2016.06.29 - Bug Fix: Customer Group: Not working properly if query with multiple conditions without brackets
			   pos1 = instr(lcase(tempsqlquery),"where ") + 5
			   newsqlquery = mid(tempsqlquery, 1,pos1) & "(" & mid(tempsqlquery,cdbl(pos1) + 1, len(tempsqlquery)) & ")"
			   newsqlquery = newsqlquery & " and contactid = "& sqlrs("contactid") &" "
			else
			   newsqlquery = sqlquery & " where contactid = "& sqlrs("contactid") &" "
			end if
		 end if

		 '800 - 2015.08.06 - Speed perforamnce on customer groups routines
		 sqlrs2.open newsqlquery, dbc, adOpenKeyset, adLockReadOnly

		 if sqlrs2.eof then
		 else
            foundflag = true
		 end if
		 closerecordset sqlrs2
		 
		 if foundflag = false then
		    dbc.execute ("delete from customergroups where groupsid = "& groupid &" and contactid = "& sqlrs("contactid") &"")
		 end if

	     sqlrs.movenext
		 
		 '701 - 2010.11.18 - Enhancement: Fine tune the code while "refreshing" all customer group through admin
		 response.flush
	  loop
   end if
   closerecordset sqlrs

   'add
   Set sqlrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
   sqlrs.open sqlquery, dbc, adOpenKeyset, adLockReadOnly

   if sqlrs.eof then
      '700 - 2010.05.31 - Bug Fix: SQL Query error with mysql database
	  if instr(lcase(request.ServerVariables("SCRIPT_NAME")),"shopa_addgroup.asp") <= 0 then debugwrite "0"
   else
      xcnt = 0
      sqlrs.movefirst
      do while not sqlrs.eof
	  
  	     strsql2 = "select groupsid,contactid from customergroups where groupsid = "& groupid &" and contactid = "& sqlrs("contactid") &""
	     Set sqlrs2 = Server.CreateObject("ADODB.Recordset")

		 '800 - 2015.08.06 - Speed perforamnce on customer groups routines
		 sqlrs2.open strsql2, dbc, adOpenKeyset, adLockReadOnly

		 if sqlrs2.eof then
		    'do updates
			dbc.execute ("insert into customergroups (groupsid,contactid) values("& groupid &","& sqlrs("contactid") &")")
		 else
		    'do nothing
		 end if
		 closerecordset sqlrs2

		 xcnt = xcnt + 1
	     sqlrs.movenext
		 
		 '701 - 2010.11.18 - Enhancement: Fine tune the code while "refreshing" all customer group through admin
		 response.flush
	  loop
	  if lcase(fromwhere) = "js" then
	     debugwrite xcnt
      end if
   end if
   closerecordset sqlrs
end sub

function checksqlquery (sqlquery)
   if trim(sqlquery) = "" then
      checksqlquery = false
	  exit function
   end if
   
   if lcase(mid(sqlquery,1,7)) <> "select " then
      checksqlquery = false
	  exit function
   end if

   if instr(lcase(sqlquery),"customers") <= 0 then
      checksqlquery = false
	  exit function
   end if

   if instr(lcase(sqlquery)," * ") <= 0 then
      if instr(lcase(sqlquery),"contactid") <= 0 then
	     checksqlquery = false
   	     exit function
	  end if
   end if
   
   dim sqlrs,tempflag
   on error resume next
   Set sqlrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
   sqlrs.open sqlquery, dbc, adOpenForwardOnly, adLockReadOnly
   
   if err.number <> 0 then
      checksqlquery = false

	  '800 - 2015.08.06 - Speed perforamnce on customer groups routines
	  closerecordset sqlrs

	  exit function
   end if

   '701 - 2012.03.13 - Enhancement: Better handling on updating customer dynamic group simultaneously
   closerecordset sqlrs
   on error goto 0

   checksqlquery = true
end function

function validgroup (groupid)
   if trim(groupid) = "" then
      validgroup = false
	  exit function
   end if

   dim sqlrs,strsql, tempflag
   strsql="select groupid from groups where groupid = "& groupid &""

   Set sqlrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
   sqlrs.open strsql, dbc, adOpenKeyset, adLockReadOnly

   if sqlrs.eof then
      tempflag = false
   else
      tempflag = true
   end if
   closerecordset sqlrs
   
   validgroup = tempflag
end function

function getgrouptype (groupid)
   if trim(groupid) = "" then
      getgrouptype = ""
	  exit function
   end if

   dim sqlrs,strsql, grouptype
   strsql="select grouptype from groups where groupid = "& groupid &""

   Set sqlrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
   sqlrs.open strsql, dbc, adOpenKeyset, adLockReadOnly

   if sqlrs.eof then
      grouptype = ""
   else
      grouptype = sqlrs("grouptype")
   end if
   closerecordset sqlrs
   
   getgrouptype = grouptype
end function

function getsqlquery (groupid)
   if trim(groupid) = "" then
      getsqlquery = ""
	  exit function
   end if

   dim sqlrs,strsql, sqlquery
   strsql="select groupsqlquery from groups where groupid = "& groupid &""

   Set sqlrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
   sqlrs.open strsql, dbc, adOpenKeyset, adLockReadOnly

   if sqlrs.eof then
      sqlquery = ""
   else
      sqlquery = sqlrs("groupsqlquery")
   end if
   closerecordset sqlrs
   
   getsqlquery = sqlquery
end function

sub refreshindfromcontact (contactid)
   if trim(contactid) = "" then
      debugwrite "Refreshing Errors"
      exit sub
   end if
   
   if validcontact(contactid) = false then
      debugwrite "Refreshing Errors"
	  exit sub
   end if
   
   'gettting group where grouptype = 'dynamic'
   dim sqlrs,strsql,tempstring
   strsql="select groupid,groupsqlquery from groups where grouptype = 'dynamic'"
   Set sqlrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
   sqlrs.open strsql, dbc, adOpenKeyset, adLockReadOnly

   do while not sqlrs.eof
      tempstring = ""
	  '701 - 2012.03.13 - Enhancement: Better handling on updating customer dynamic group simultaneously
	  if instr(lcase(sqlrs("groupsqlquery"))," where ") > 0 then
	     tempstring = mid(sqlrs("groupsqlquery"),1,instr(lcase(sqlrs("groupsqlquery"))," where ") - 1)
		 tempstring = tempstring & " where contactid = "& contactid &""
		 tempstring = tempstring & " and "

         '800 - 2016.06.29 - Bug Fix: Customer Group: Not working properly if query with multiple conditions without brackets
		 tempstring = tempstring & "(" & mid(sqlrs("groupsqlquery"),(instr(lcase(sqlrs("groupsqlquery"))," where ") + 7),len(sqlrs("groupsqlquery"))-(instr(lcase(sqlrs("groupsqlquery"))," where ") + 6)) & ")"
	  else
	     tempstring = sqlrs("groupsqlquery") & " where contactid = "& contactid &""
	  end if
	  processquerycon tempstring,sqlrs("groupid"),contactid
	  
      sqlrs.movenext
   loop
   closerecordset sqlrs
end sub

sub processquerycon (sqlquery,groupid,contactid)
   if trim(sqlquery) = "" then
      debugwrite getlang("langqueryerrors")
	  exit sub
   end if

   if trim(groupid) = "" then
      debugwrite getlang("langqueryerrors")
	  exit sub
   end if
   
   if checksqlquery(sqlquery) = false then
      debugwrite getlang("langqueryerrors")
	  exit sub
   end if
   
   'check existence
   dim sqlrs,strsql,xcnt
   dim sqlrs2,foundflag,strsql2
   
   Set sqlrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
   sqlrs.open sqlquery, dbc, adOpenForwardOnly, adLockReadOnly

   if sqlrs.eof then
      dbc.execute ("delete from customergroups where groupsid = "& groupid &" and contactid = "& contactid &"")
   else
      Set sqlrs2 = Server.CreateObject("ADODB.Recordset")
	  strsql = "select groupsid,contactid from customergroups where groupsid = "& groupid &" and contactid = "& contactid &""

	  '800 - 2015.08.06 - Speed perforamnce on customer groups routines
	  sqlrs2.open strsql, dbc, adOpenForwardOnly, adLockReadOnly

	  if sqlrs2.eof then
	     dbc.execute ("insert into customergroups (groupsid,contactid) values ("& groupid &","& contactid &")")
	  end if
	  closerecordset sqlrs2
   end if
   closerecordset sqlrs
end sub

function validcontact (contactid)
   if trim(contactid) = "" then
      validcontact = false
	  exit function
   end if

   dim sqlrs,strsql, tempflag
   strsql="select contactid from customers where contactid = "& contactid &""

   Set sqlrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
   sqlrs.open strsql, dbc, adOpenForwardOnly, adLockReadOnly

   if sqlrs.eof then
      tempflag = false
   else
      tempflag = true
   end if
   closerecordset sqlrs
   
   validcontact = tempflag
end function

sub updatecustomergroup (dbtable,oldwhich,which)
   if lcase(DBTable) = "customers" then
      if getconfig("xCustomerGroupDynamicAutoAssign") = "Yes" then
         if cstr(oldwhich) <> cstr(which) then
            dim sqlrs,strsql
			if oldwhich <> "" then
               strsql="select a.contactid,a.groupsid,b.grouptype from customergroups a,groups b where a.contactid = "& oldwhich &" and a.groupsid = b.groupid and b.grouptype = 'dynamic'"
               Set sqlrs = Server.CreateObject("ADODB.Recordset")

			   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
               sqlrs.open strsql, dbc, adOpenKeyset, adLockReadOnly

               do while not sqlrs.eof
                  dbc.execute ("insert into customergroups (groupsid,contactid) values ("& sqlrs("groupsid") &","& which &")")
                  sqlrs.movenext
               loop
               closerecordset sqlrs
		   	else
			   refreshindfromcontact which
			end if
         else
            'do refreshing
		    refreshindfromcontact which
         end if
      end if
   end if
end sub

function GenerateCustomerMatchSQL (matchfield,exmatchfield,matchfield2,whereok)
   dim tempstring,CustomerProductGroup
   tempstring = ""
   CustomerProductGroup = GetSess("CustomerProductGroup")
   
   '701 - 2011.11.24 - Bug Fix: Customer group is not working properly if customer saved cookie to the browser
   dim strcustomerid
   strcustomerid = getsess("CustomerID")
   if trim(strcustomerid) <> "" and trim(CustomerProductGroup) = "" then
      CustomerProductGroup = GetCustomerGroupDetails(strcustomerid)
      SetSess "Customerproductgroup",CustomerProductGroup
   end if
   
   '701 - 2011.02.16 - Enhancement: Speed enhancement
   if CustomerProductGroup<>"" then

      dim CustomerProductGroups, icnt
      CustomerProductGroups=split(CustomerProductGroup,",")
      for icnt = 0 to ubound(CustomerProductGroups)
	     if icnt = 0 then
		    if instr(lcase(xdatabasetype),"mysql") > 0 then
			   tempstring = tempstring & " "& whereok &" (concat(',',"& matchfield &",',') like '%," & CustomerProductGroups(icnt) & ",%' "
			else
			   tempstring = tempstring & " "& whereok &" (',' + "& matchfield &" + ',' like '%," & CustomerProductGroups(icnt) & ",%' "
			end if
		 else
		    if instr(lcase(xdatabasetype),"mysql") > 0 then
			   tempstring = tempstring & " or concat(',',"& matchfield &",',') like '%," & CustomerProductGroups(icnt) & ",%' "
			else
			   tempstring = tempstring & " or ',' + "& matchfield &" + ',' like '%," & CustomerProductGroups(icnt) & ",%' "
			end if
		 end if
	  next
      tempstring = tempstring & " or "& matchfield &" is null "
	  tempstring = tempstring & " or "& matchfield &" = '') "

      for icnt = 0 to ubound(CustomerProductGroups)
		 if icnt = 0 then
		    if instr(lcase(xdatabasetype),"mysql") > 0 then
			   tempstring = tempstring & " and (concat(',',"& exmatchfield &",',') not like '%," & CustomerProductGroups(icnt) & ",%' "
			else
			   tempstring = tempstring & " and (',' + "& exmatchfield &" + ',' not like '%," & CustomerProductGroups(icnt) & ",%' "
			end if
		 else
		    if instr(lcase(xdatabasetype),"mysql") > 0 then
		       tempstring = tempstring & " and concat(',',"& exmatchfield &",',') not like '%," & CustomerProductGroups(icnt) & ",%' "
			else
			   tempstring = tempstring & " and ',' + "& exmatchfield &" + ',' not like '%," & CustomerProductGroups(icnt) & ",%' "
            end if
		 end if
	  next
      tempstring = tempstring & " or "& exmatchfield &" is null "
	  tempstring = tempstring & " or "& exmatchfield &" = '') "

   else
      tempstring = tempstring & " "& whereok &" ("& matchfield &" is null "
	  tempstring = tempstring & " or "& matchfield &" = '') "
   end if

   if trim(getsess("CustomerID")) <> "" then
      if instr(ucase(xdatabasetype), "MYSQL") > 0 or instr(ucase(xdatabasetype), "SQLSERVER") > 0 then
	     tempstring = tempstring & " and ("& matchfield2 &" = 1 or "& matchfield2 &" = 0 or "& matchfield2 &" is null) "
	  else
         tempstring = tempstring & " and ("& matchfield2 &" = true or "& matchfield2 &" = false or "& matchfield2 &" is null) "
      end if
   else
      if instr(ucase(xdatabasetype), "MYSQL") > 0 or instr(ucase(xdatabasetype), "SQLSERVER") > 0 then
		 tempstring = tempstring & " and ("& matchfield2 &" = 0 or "& matchfield2 &" is null) "
	  else
         tempstring = tempstring & " and ("& matchfield2 &" = false or "& matchfield2 &" is null) "
      end if
   end if

   GenerateCustomerMatchSQL = tempstring
end function
%>