<%
'*********************************************************************************
' PayPal Admin Console
' PayPal Display Orders Routines
' 7.02
' 26 July 2012
'*********************************************************************************

sub DisplayPayPalHeaderRow
   '702 - 2012.08.07 - PayPal Enhancement
   htmlwrite "<th class=""al vt"">"& getlang("langpaypalpaymentstatus") &"</th>"
end sub

sub DisplayPayPalRow
   dim scriptresponder,displayflag,paypalprocessor,oprocessed
   scriptresponder = "shopa_paypalgatewayoptions.asp"
   paypalprocessor = rsorder("paypalprocessor")
   displayflag = false

   '702 - 2012.08.07 - PayPal Enhancement
   dim paypaltransactions
   paypaltransactions = false

   if not isnull(paypalprocessor) then
      if trim(paypalprocessor) <> "" then
	     if instr(lcase(paypalprocessor),"paypal") > 0 or instr(lcase(paypalprocessor),"payflow") > 0 then
		    '702 - 2012.08.07 - PayPal Enhancement
		    paypaltransactions = true
		 end if
	  end if
   end if

   '702 - 2012.08.24 - Bug Fix: Order listings page display incorrectly with package V7.02.2
   'oprocessed = rsorder("oprocessed")
   'if oprocessed = true or oprocessed = 1 then displayflag = false
   'if isnull(rsorder("ocardtype")) then displayflag = false

   '702 - 2012.08.07 - PayPal Enhancement
   dim maindisplaytext
   maindisplaytext = ""
   if paypaltransactions then
      dim displaytext
	  if ucase(mid(rsorder("paypaltranstype"),1,1)) = "A" then
	     displaytext = ""& getlang("langpaypalcapture") &"/"& getlang("langpaypalvoid") &""
	  elseif ucase(mid(rsorder("paypaltranstype"),1,1)) = "S" then
	     displaytext = getlang("langpaypalrefund")
	  end if

	  '702 - 2012.08.07 - PayPal Enhancement
	  select case ucase(mid(rsorder("paypaltranstype"),1,1))
	     case "A"
		    maindisplaytext = getlang("langpaypalauthorized")
	     case "S"
	        if instr(lcase(rsorder("ocardtype")),"partial refund") > 0 then
		       maindisplaytext = getlang("langpaypalpartiallyrefunded")
		    else
	           maindisplaytext = getlang("langbillcompleted")
		    end if
		 case "V"
		    maindisplaytext = getlang("langpaypalvoided")
		 case "R"
		    maindisplaytext = getlang("langpaypalrefunded")
		 case "D"
		    '800 - 2016.06.29 - Admin: Order Listings: Not showing properly if PayPal Flow not return reason properly
		    if not isnull(rsorder("oauthorization")) then
		       maindisplaytext = getlang("langpaypaldeclined") & "<br />" & replace(rsorder("oauthorization"),"+"," ")
            else
			   maindisplaytext = getlang("langpaypaldeclined")
			end if
	  end select

      '702 - 2012.11.28 - Bug Fix: PayPal should always display completed transaction in display orders listings page
	  if ucase(mid(rsorder("paypaltranstype"),1,1)) <> "D" then
	     maindisplaytext = rsorder("oauthorization") & "<br />" & maindisplaytext
	  end if
%>
<td class="al vt">
<%if trim(maindisplaytext) <> "" then response.write maindisplaytext & "<br />"%>
<a href="<%=scriptresponder%>?oid=<%=rsorder(IDField)%>"><%=displaytext%></a></td>
<%
   else
      '702 - 2012.08.07 - PayPal Enhancemen
	  maindisplaytext = rsorder("oauthorization")
%>
<td class="al vt"><%=maindisplaytext%></td>
<%
   end if
end sub
%>