<%Option Explicit%>
<%Response.buffer=false%>
<!-- #include file="setupsub.asp" -->
<!-- #include file="setupdesign.asp" -->
<%
dim currenturl,currentstep
currenturl = "setupdbconnection.asp"
currentstep = 1

dim saction,firstpending,reurl
saction = request("saction")

readsetupfile "setup.ini",firstpending
if trim(saction) <> "" then
   if lcase(session("setupdbconn")) = "ok" then
      'update setup.ini
	  astatus(currentstep) = "Completed"
	  writesetupfile "setup.ini"
	  writeconfigfile "config.asp"
	  moveconfigfile "config.asp"
   end if
end if

readconfigfile "config.asp"
readsetupfile "setup.ini",firstpending
reurl = getprocessurl(firstpending)
if trim(reurl) = "" then reurl = "setupsuccess.asp"

if lcase(reurl) <> lcase(currenturl) then
   response.redirect reurl
end if
if trim(saction) <> "" then
   reurl = getprocessurl(firstpending)  
   if trim(reurl) <> "" then
      response.redirect reurl
   end if
end if

dim accessdefaultpath
accessdefaultpath = Server.MapPath(replace(request.ServerVariables("SCRIPT_NAME"),"installation/"& currenturl &"","") & "database")

setuppageheader
setupleftlayout
displayform
setuptrailer

sub displayform
   dim dbtypeacces,dbtypemysql351,dbtypemysql510,dbtypesql2000,dbtypesql2005,dbaccessstylestr,dbsqlstylestr,verifybtnedstr,dbtypeodbc,dbodbcstylestr
   dbaccessstylestr = "style=""visibility:hidden;display:none;"""
   dbsqlstylestr = "style=""visibility:hidden;display:none;"""
   dbodbcstylestr = "style=""visibility:hidden;display:none;"""
   verifybtnedstr = "disabled"
   dbtypeacces = ""
   dbtypeodbc = ""
   dbtypemysql351 = ""
   dbtypemysql510 = ""
   dbtypesql2000 = ""
   dbtypesql2005 = ""
   select case lcase(session("setupxDatabaseType"))
      case "drive"
	     dbtypeacces = "checked"
		 dbtypeodbc = ""
		 dbtypemysql351 = ""
		 dbtypemysql510 = ""
		 dbtypesql2000 = ""
		 dbtypesql2005 = ""
		 dbaccessstylestr = "style=""visibility:visible;display:block;"""
		 verifybtnedstr = ""
      case "odbc"
	     dbtypeacces = ""
		 dbtypeodbc = "checked"
		 dbtypemysql351 = ""
		 dbtypemysql510 = ""
		 dbtypesql2000 = ""
		 dbtypesql2005 = ""
		 dbodbcstylestr = "style=""visibility:visible;display:block;"""
		 verifybtnedstr = ""
      case "mysql351","mysql510"
	     dbtypeacces = ""
		 dbtypeodbc = ""
		 if lcase(session("setupxDatabaseType")) = "mysql351" then
		    dbtypemysql351 = "checked"
			dbtypemysql510 = ""
		 else
		    dbtypemysql351 = ""
			dbtypemysql510 = "checked"
		 end if
		 dbtypesql2000 = ""
		 dbtypesql2005 = ""
		 dbsqlstylestr = "style=""visibility:visible;display:block;"""
		 verifybtnedstr = ""
      case "sqlserver"
	     dbtypeacces = ""
		 dbtypeodbc = ""
		 dbtypemysql351 = ""
		 dbtypemysql510 = ""
		 if lcase(session("setupxSQL05Above")) = "yes" then
		    dbtypesql2005 = "checked"
			dbtypesql2000 = ""
		 else
		    dbtypesql2005 = ""
			dbtypesql2000 = "checked"
		 end if
		 dbsqlstylestr = "style=""visibility:visible;display:block;"""
		 verifybtnedstr = ""
   end select
%>
   <form name="editform" id="editform" action='<%=currenturl%>' method=POST>
   <table width="400" border="0" cellspacing="0" cellpadding="0" class="main_container">
      <tr>
        <th class="container_header">Connect to database</th>
      </tr>
      <tr>
        <td class="content">
           <p>On this page you will be selecting which type of database you would like to use with your online store.</p>
           <p>VP-ASP supports Access, SQL Server and MySQL.</p>
           <p>If setting up on your local PC we recommend using Access and then, before going live on your remote web host, using our upgrade tools to migrate the data to a SQL Server or MySQL database.</p>
           <p>If setting up on a remote web server initially you may need to contact your web host and ask them what types of databases they offer and also what the connection details are for these databases if you do not already have this information.</p>
           <p>If using SQL Server or MySQL you will need to have handy the login details and the database server name which is where the database is installed. Your web host will once again be the best source for this information.</p>
           <p>If using 64 bit machine, please select SQL Server or MySQL as the database type.</p>
           <p>Before you can connect to your database you need to be sure you have a blank database already set up that you can use. VPCart comes with a blank Access database ready for you to work with. If using SQL Server or MySQL you will need to either set this up yourself or have your web host do this for you.</p>
           <p>If unsure you can simply select Access and change over at a later date. </p>
           <p>You need to make sure if using Access that the permissions for the folder where the Access database is located have been set to READ/WRITE</p>
          <p>If you are still having issues please open our <a href="http://www.vpcart.com/virtprog/quickstart.pdf" target="_blank">QuickStart Guide</a> for a step by step guide on how to create your database.</p>
          <table border="0" cellspacing="2" cellpadding="2">
  <tr>
    <td valign="top"><strong>Database type:</strong> </td>
    <td valign="top"><input <%=dbtypeacces%> type="radio" name="dbtype" id="dbtype" value="access" onclick="javascript:checkdatabasetype(this.value);" />Access
                <br /><input <%=dbtypeodbc%> type="radio" name="dbtype" id="dbtype" value="odbc" onclick="javascript:checkdatabasetype(this.value);" />ODBC
                <br /><input <%=dbtypemysql351%> type="radio" name="dbtype" id="dbtype" value="mysql351" onclick="javascript:checkdatabasetype(this.value);" />MySQL 351
                <br /><input <%=dbtypemysql510%> type="radio" name="dbtype" id="dbtype" value="mysql510" onclick="javascript:checkdatabasetype(this.value);" />MySQL 510
                <br /><input <%=dbtypesql2000%> type="radio" name="dbtype" id="dbtype" value="mssql2000" onclick="javascript:checkdatabasetype(this.value);" />MsSQL 2000
                <br /><input <%=dbtypesql2005%> type="radio" name="dbtype" id="dbtype" value="mssql2005" onclick="javascript:checkdatabasetype(this.value);" />MsSQL 2005 & above</td>
  </tr>
</table>

<div name="dbaccess" id="dbaccess" <%=dbaccessstylestr%>>
<table border="0" cellspacing="2" cellpadding="2">
  <tr>
    <td valign="top"><strong><p>Database name:</p></strong></td>
    <td width="77%" valign="top"><p>Please insert the name that you would like your  database to be called; for example &quot;shopping800&quot; without the quotes.</p>
      </td>
  </tr>
  <tr>
    <td width="23%">&nbsp;</td>
    <td><input type="text" name="dbname" id="dbname" class="txtinput" value="<%=session("setupxDatabase")%>" /> .mdb</td>
  </tr>
  <tr>
    <td valign="top"><strong><p>Database location:</p></strong></td>
    <td><p>The database is located in the <strong>database</strong> folder by default. </p>
      <p>If you wish to use a different folder location  please enter the drive path to the new folder below and upload the mdb file to that folder. </p>
      <p>This would be something like:</p>
      <p>C:\Inetpub\wwwroot\database</p></td>
  </tr>
  <tr>
    <td width="23%">&nbsp;</td>
    <td><input type="text" name="dbfolder" id="dbfolder" class="txtinput" value="<%=accessdefaultpath%>" size="70" /></td>
  </tr>
</table>
</div>

<div name="dbodbc" id="dbodbc" <%=dbodbcstylestr%>>
<table border="0" cellspacing="2" cellpadding="2">
  <tr>
    <td>&nbsp;</td>
    <td><p>Please insert the name of your ODBC DSN Connection. You need to set "Write" & "Read" permission to the database that your ODBC DSN connected to.</p>
    </td>
  </tr>
  <tr>
    <td width="20%"><strong>DSN name: </strong></td>
    <td><input type="text" name="dbname3" id="dbname3" class="txtinput" value="<%=session("setupxDatabase")%>" /></td>
  </tr>
</table>
</div>

<div name="dbsqlmysql" id="dbsqlmysql" <%=dbsqlstylestr%>>
<table border="0" cellspacing="2" cellpadding="2">
  <tr>
    <td><strong>Database name: </strong></td>
    <td><input type="text" name="dbname2" id="dbname2" class="txtinput" value="<%=session("setupxDatabase")%>" /></td>
    <td>Insert the name of the database here.</td>
  </tr>
  <tr>
    <td><strong>Database user ID: </strong></td>
    <td><input type="text" name="dbuserid2" id="dbuserid2" class="txtinput" value="<%=session("setupxSQLUser")%>" /></td>
    <td>Insert the SQL user ID here.</td>
  </tr>
  <tr>
    <td><strong>Database password:</strong></td>
    <td><input type="text" name="dbpassword2" id="dbpassword2" class="txtinput" value="<%=session("setupxSQLPwd")%>" /></td>
    <td>Insert the SQL user Password here.</td>
  </tr>
  <tr>
    <td><strong>Database address:</strong></td>
    <td><input type="text" name="dbaddress2" id="dbaddress2" class="txtinput" value="<%=session("setupxSQLServer")%>" /></td>
    <td>Insert the SQL server sddress here. This can be the server name or the IP of the database server.</td>
  </tr>
</table>
</div>
          <br />
          <span name="nextbtn" id="nextbtn">
          <input style="float:left;margin-right:5px;" <%=verifybtnedstr%> type="button" name="verifybtn" id="verifybtn" value="Check database" class="submitbtn" onclick="javascript:checkdbconnection();" />
<%
   dim continuestr
   continuestr = "To " & asteps(currentstep+1)
   session("continuestr") = continuestr
%>
          
          <input style="visibility:hidden;" disabled type="submit" name="saction" id="saction" value="Continue <%=continuestr%>" class="submitbtn"/>
          <br /><br />
<%
'   genwarningtable "Please choose Database Type.  After that please fill in Database Information.",errordesc
'   response.write errordesc
%>
            </span>
        </td>
      </tr>
      <tr>
        <td valign="top" background="../images/landingpage/container_footer.gif">&nbsp;</td>
      </tr>
    </table>
    </form>
<%
end sub
%>