$(document).ready(function(){
   if( ! $('#shipping_info').length){
      $('#shopcustregister .nextbtn').addClass('hide');
   }

   $("form").bind("keypress", function(e){
      if (e.keyCode == 13) {
	     if ($(window).width() <= 983){
		    return false;	
		 }
	  }
	});

	/* FOR MOBILE CUSTOMERPAGE FORM */
	basic_info = [
					{'field' : 'strfirstname', 'type' : 'text', 'required' : true},
					{'field' : 'strlastname', 'type' : 'text', 'required' : true},
					{'field' : 'straddress', 'type' : 'text', 'required' : true},
					{'field' : 'strcity', 'type' : 'text', 'required' : true},
					{'field' : 'straddress', 'type' : 'text', 'required' : true},
					{'field' : 'strstate', 'type' : 'select', 'required' : true},
					{'field' : 'strpostcode', 'type' : 'text', 'required' : true},
					{'field' : 'strEmail', 'type' : 'text', 'required' : true},
				];
				
	shipping_info = [
					{'field' : 'shipmethodType', 'type' : 'select', 'required' : true},
				];
	
	$('.nextbtn').click(function(e){
		e.preventDefault();
		current_wrapper = $(this).closest('.customer-wrapper');
		parent_form = $(this).closest('form');
		
		wrapper_id = $(current_wrapper).attr('id');
		
		
		
		
		switch(wrapper_id){
			
			case 'basic_info':
				
				//switch_next_wrapper(current_wrapper);
				validation_result = validate_wrapper(basic_info, parent_form);
				console.log(validation_result);
				if(validation_result == 0){
					switch_next_wrapper(current_wrapper)
				} else {
					$('#scrollUp').trigger('click');
				}
				
				break;
			case 'shipping_info':
				
				validation_result = validate_wrapper(shipping_info, parent_form);
				
				if(validation_result == 0){
					switch_next_wrapper('shipping_info')
				} else {
					$('#scrollUp').trigger('click');
				}
				
				
				break;
			case 'other_info':
				
				break;
			
		}
		
		
	});
	
	
});


function switch_next_wrapper(current_wrapper){
	$(current_wrapper).addClass('all-clear').removeClass('active');
	if(current_wrapper == 'shipping_info') {
		$('.customer-wrapper').removeClass('active');
		$('#other_info').addClass('active');
	} else {		
		$(current_wrapper).next('.customer-wrapper').addClass('active');
	}
	$('#scrollUp').trigger('click');
}


function validate_wrapper(wrapper_fields, parent_form){
	validation_ctr = 0;
	
	$.each(wrapper_fields,function(row, row_value){
		
		switch(row_value.type){
			case 'text':
				
				field_obj = $(parent_form).find('input[name="'+row_value.field+'"]');
				break;
			
			case 'select':
				field_obj = $(parent_form).find('select[name="'+row_value.field+'"]');
				break;
		}
		
		$(field_obj).removeClass('error_field').closest('div').find('span.errormsg').remove();
		
		if($(field_obj).val() == ''){
			console.log(row_value.field);
			validation_ctr++;
			$(field_obj).addClass('error_field').closest('div').append('<span class="errormsg"> error for this field </span>');
		}
	});
	
	return validation_ctr;
}