<%option explicit%>
<%response.buffer=true%>
<!-- #include file="shop$db.asp" -->
<%shopopendatabase dbc%>
<!--#include file="shopxmlhttp.asp"-->
<%
const PaypalVerify="Yes"
'***************************************************************
' PayPal Website Payment Standard - IPN Callback
' VP-ASP 7.02
' 26 July 2012
'************************************************************

dim PaypalGatewayLocation
if ucase(getconfig("xPayPal_Test_Mode")) = "YES" then
   PaypalGatewayLocation = "https://www.sandbox.paypal.com/cgi-bin/webscr"
else
   PaypalGatewayLocation = "https://www.paypal.com/cgi-bin/webscr"
end if

Dim pError
dim pAuthcode
dim poid

PAuthCode = ""
Poid = getsess("oid")
if trim(poid) = "" then poid = cleanchars(request("invoice"))
poid = replace(poid,xshopid&"-","")
if not isnumeric(poid) then poid=""
if poid = "" then shoperror getlang("langsessionlost")
setsess "Oid",Poid

createlogs_paypalstandard_callback Poid

GetResultValues

dim result
result=ucase(CleanChars(request("payment_status")))
if Result="FAILED" then
   PError="Your transaction failed<br />Either retry it or select another payment method"
end if

If Perror="" then
   Updateauthorization
   server.transfer "shopthanks.asp"
else
   setsess "PaymentError",PError
   UpdateauthorizationDeclined
end if 
shopclosedatabase dbc

Sub GetResultValues
   Dim str, OrderID
   Dim objHttp
   Dim ResponseText
   dim payment_status
   str = Request.Form
   OrderID = cleanchars(Request.Form("item_number"))
   Payment_status = cleanchars(Request.Form("payment_status"))
   If PaypalVerify="No" then
      handleUnverified
   end if   

   ' post back to PayPal system to validate
   on error resume next
   str = str & "&cmd=_notify-validate"

   '800 - 2016.02.03 - XML: To support TLS1.2
   dim rheadercnt, rheadertypeary(10), rheadervalueary(10), xmlerror
   rheadercnt = 0
   Shopxmlhttp_v8 "auto", paypalgatewaylocation, str, responsetext, "POST", xmlerror, rheadercnt, rheadertypeary, rheadervalueary, "", ""
   if (responsetext = "VERIFIED") then
      Perror=""
      pauthcode="Verified"
   else
      If responseText = "INVALID" then
         Pauthcode="Your payment was declined by Paypal,  Responsetext return is not Verified"
         Perror=Pauthcode
      end if
   end if

   If Perror="" then     
      If ucase(payment_status)="COMPLETED" Or ucase(Payment_status)="PENDING" then
         exit sub
      else
         Pauthcode="Paypal has declined payment." 
         Perror=Pauthcode
      end if
   end if
   on error goto 0
end sub

'***************************************************************
' Updates Authorization field in order
' PAuthcode has authorization value
' Proably no change required here
'**************************************************************
Sub UpdateAuthorization 
   dim sql
   'Security Patch - 17 April 2008
   dim Pauthcode,refno, PaymentStatus, txntype, strPendingReason
   refno=CleanChars(request("txn_id"))
   PaymentStatus=ucase(CleanChars(request("payment_status")))
   txntype = CleanChars(request("txn_type"))
   strPendingReason = CleanChars(request("pending_reason"))

   if PaymentStatus = "PENDING" then
      PauthCode = "PayPal " & PaymentStatus
      PauthCode = PauthCode & "<br>Transaction ID=" & refno
	  PauthCode = PauthCode & "<br>Transaction Type=" & txntype
	  PauthCode = PauthCode & "<br>Pending Reason=" & strPendingReason
   else
      PauthCode = "PayPal " & PaymentStatus
      PauthCode = PauthCode & "<br>Transaction ID=" & refno
	  PauthCode = PauthCode & "<br>Transaction Type=" & txntype
   end if

   sql="Update orders set "
   sql=sql & " oauthorization='" & PAuthCode &"'"
   if PaymentStatus = "PENDING" then
      sql=sql & " ,ocardtype='" & "PayPal-Pending" &"'"
   else
      sql=sql & " ,ocardtype='" & "PayPal" &"'"
   end if
   sql=sql & " ,ocardno=NULL"
   sql=sql & " where orderid=" & poid

   '800 - 2016.02.01 - Enhancement: Must always commit transaction if execute sql execute
   on error resume next
   dbc.BeginTrans
   on error goto 0
   dbc.execute(sql)
   on error resume next
   dbc.CommitTrans
   on error goto 0
end sub

'***************************************************************
' Updates Authorization field in order
' PAuthcode has authorization value
' Proably no change required here
'**************************************************************
Sub UpdateAuthorizationDeclined 
   dim sql,pAuthCode
   pAuthCode = "Declined " & PError

   sql = "Update orders set "
   sql = sql & " oauthorization='" & pAuthCode & "'"
   sql = sql & " ,ocardtype='" & "PayPal-Declined" & "'"
   sql = sql & " ,ocardno=NULL"
   sql = sql & " where orderid=" & poid

   '800 - 2016.02.01 - Enhancement: Must always commit transaction if execute sql execute
   on error resume next
   dbc.BeginTrans
   on error goto 0
   dbc.execute(sql)
   on error resume next
   dbc.CommitTrans
   on error goto 0
end sub

'***************************************************************
' Updates Authorization field in order
' PAuthcode has authorization value
' Proably no change required here
'**************************************************************
Sub HandleUnverified 
   Dim sql, pAuthCode
   pAuthCode = "Unknown"
   sql="Update orders set "
   sql=sql & " oauthorization='" & PAuthCode &"'"
   sql=sql & " ,ocardtype='" & "PayPal-Not Verified" &"'"
   sql=sql & " ,ocardno=NULL"
   sql=sql & " where orderid=" & poid

   '800 - 2016.02.01 - Enhancement: Must always commit transaction if execute sql execute
   on error resume next
   dbc.BeginTrans
   on error goto 0
   dbc.execute(sql)
   on error resume next
   dbc.CommitTrans
   on error goto 0
end sub

sub createlogs_paypalstandard_callback (oid)
   dim foldername,filename,nowdate
   nowdate = replace(date(),"/","_")
   nowdate = replace(nowdate,"\","_")
   foldername = "standard"
   filename = "paypalstandard_"& nowdate &"_"& oid &".txt"
   WriteLogPayPal foldername, filename, "Start (Callback Receive): =================================================="
   WriteLogPayPal foldername, filename, "For Order ID: "& oid &""
   dim sItem
   For Each sItem In Request.Form
      WriteLogPayPal foldername, filename, ""& sItem &" : "& Request.Form(sItem) &""
   Next
   WriteLogPayPal foldername, filename, "End (Callback Receive): =================================================="
end sub
%>