<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Paypal Specific code when integrating with other gateways
'*********************************************************************************

'not using these 2 variables, because they already integrated with vpasp 6.5
'const PAYPALEMAIL="yourpaypalemail@somewhere.com"
'const paypalMysITE="http://www.yourvpaspwebsiteurl.com/"

'Now controlled from online config.
dim CurrencyCode
dim ResetLcid
dim PaypalGatewayLocation

CurrencyCode = getconfig("xPayPal_CurrencyCode")
resetLcid = getconfig("xPayPal_LCID")

'702 - 2012.07.26 - PayPal Enhancement
dim paymentaction
paymentaction = lcase(getconfig("xPayPalStandard_Transaction_Type"))

'const CurrencyCode="USD"    'other values are EUR, CAD, GBP, JPY, USD


'Use these in European countries
'Used only for Countries using comma as secimal point
const CommaAsDecimal="No"  '

'Used only if you want amount converted to $US
'const ConvertToUS="No"     ' uses conversion rate in shop Configuration

'Used only if an LCID is not set in shop Configuration
'const ResetLcid="1036"      ' Reset LCid id


'const PaypalGatewayLocation="https://www.sandbox.paypal.com/cgi-bin/webscr"
'const PaypalGatewayLocation="https://www.paypal.com/cgi-bin/webscr"
if ucase(getconfig("xPayPal_Test_Mode")) = "YES" then
	PaypalGatewayLocation = "https://www.sandbox.paypal.com/cgi-bin/webscr"
else
	PaypalGatewayLocation="https://www.paypal.com/cgi-bin/webscr"
end if

sub PaypalPerformGateway (hiddenflag)
  '800 - 2015.06.24 - Better normal checkout layout
  htmlwrite "<div class=""main-product"">"

   dim oid
   oid=GetSess("oid")
   '702 - 2012.07.26 - PayPal Enhancement
   '800 - 2016.09.20 - Browser auto refresh JS/CSS files wihout hard refresh
%>
<link rel="stylesheet" type="text/css" media="all" href="stylesheets/paypal.css?<%=getfilelastupdatedate("stylesheets/paypal.css")%>" />
<%
   dim ReturnURL, subject, cancelreturnurl, callbackurl

   ReturnURL=genredirecturl("paypalresult.asp")

   '702 - 2012.07.26 - PayPal Enhancement
   cancelreturnurl=genredirecturl("paypalresult.asp?cancel=Yes")
   callbackurl=genredirecturl("paypalcallback.asp")

   subject=GetConfig("xEmailSubject") & " - " & oid

   '702 - 2012.07.26 - PayPal Enhancement
   ShopWriteHeaderPic GetLang("langpaybypaypal") & " (<span class=""h2link""><a href=""#"" onclick=""javascript:window.open('https://www.paypal.com/cgi-bin/webscr?cmd=xpt/Marketing/popup/OLCWhatIsPayPal-outside','olcwhatispaypal','toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizable=yes, width=500, height=350');"">"& getlang("langwhatispaypal") &"</a></span>)","https://www.paypal.com/en_US/i/logo/PayPal_mark_37x23.gif"

   '800 - 2015.05.01 - Enhancement: Layout updates
   htmlwrite "<div class=""std_table ac pull-right"">"

   response.write "<form id=""paymentform"" name=""paymentform"" method=""post"" action=""" & PaypalGatewayLocation & """ target=""_parent"">"
   PaypalGetDatabaseFields

   '702 - 2012.07.26 - PayPal Enhancement
%>
<input type="hidden" name="cmd" value="_ext-enter" />
<INPUT TYPE="hidden" NAME="redirect_cmd" VALUE="_xclick">
<input type="hidden" name="business" value="<%=GetConfig("xpaypalemail")%>" />
<input type="hidden" name="return" value="<%=ReturnURL%>" />
<input type="hidden" name="item_name" value="<%=subject%>" />
<input type="hidden" name="quantity" value="1" />
<input type="hidden" name="currency_code" value="<%=CurrencyCode%>" />
<input type="hidden" name="item_number" value="<%=oid%>" />
<input type="hidden" name="rm" value="2" />
<input type="hidden" name="bn" value="VPASP_ShoppingCart_WPS_AU" />
<input type="hidden" name="cancel_return" value="<%=cancelreturnurl%>">
<input type="hidden" name="notify_url" value="<%=callbackurl%>">
<input type="hidden" name="invoice" value="<%=xshopid&"-"&oid%>">
<input type="hidden" name="paymentaction" value="<%=paymentaction%>">
<%if lcase(hiddenflag) = "no" then%>
<input type="submit" value="<%=getlang("langpayusingpaypal")%>" name="submit" class="submitbtn" />
<%end if%>
</form>
<%
   if lcase(hiddenflag) = "yes" then
      generate_gateway_submit_auto_js "paymentform"
   end if
   htmlwrite "</div>"

   '800 - 2015.05.01 - Enhancement: Layout updates
   htmlwrite "<div class=""row""></div>"

   '800 - 2015.06.24 - Better normal checkout layout
   htmlwrite "</div>"
end sub

sub PaypalGetDatabaseFields
   dim myname, amount, StrSql, Orders
   dim oid
   oid=GetSess("oid")

   strsql = "select * from orders where orderid=" & oid
   Set Orders = Server.CreateObject("ADODB.Recordset")
   Orders.open strsql, dbc, adOpenStatic, adLockReadOnly
   if not Orders.eof then
      '701 - 2012.05.11 - Bug Fix: Should pass amount to PayPal based on xcurrencybase
	  '701 - 2012.07.24 - Bug Fix: PayPal is sending wrong amount if customer change currencybase
      amount=orders("orderamount")

      If CommaAsDecimal="Yes" then
         ConvertAmount amount
      else
         amount=formatnumber(amount,2)
         amount=replace(amount,",","")
      end if
      PaypalDoField "amount", amount
   else
      DebugWrite "Cannot find order"
   end if
   CloseRecordSet Orders
end sub

sub PaypalDoField (fieldname,fieldvalue)
   if fieldvalue="" or isnull(fieldvalue) then
      exit sub
   end if
   response.write "<input type=""hidden"" name=""" & fieldname & """ value=""" & Fieldvalue & """ />"
end sub

sub ConvertAmount (amount)
   dim savelcid, oamount, ydualconversionrate
   '6.50.4 - xlcid - remove redundant GetConfig("xlcid")
   savelcid=session.lcid
   if ConvertToUS="Yes" and GetConfig("Xdualconversionrate")<>"" then
      ydualconversionrate=GetConfig("xdualconversionrate")
      if isnumeric(ydualconversionrate) then
         ydualconversionrate=cdbl(ydualconversionrate)
         oamount=amount*ydualconversionrate
         amount=oamount
      end if
   end if
   session.lcid="2057"
   amount=formatnumber(amount,2)
   amount=replace(amount,",","")
   if Savelcid<>"" then
      session.lcid=savelcid
   else
      session.lcid=ResetLcid
   end if
end sub
%>