<%
'**************************************************************************
' Paypal Payment Advanced
' PayFlow Link
' PayFlow Pro Transparent Redirect
' VP-ASP 7.02
' 26 July 2012
'**************************************************************************

function genrandomvalue(passwordLength)
   Dim sDefaultChars
   Dim iCounter
   Dim sMyPassword
   Dim iPickedChar
   Dim iDefaultCharactersLength
   Dim iPasswordLength

   sDefaultChars="abcdefghijklmnopqrstuvxyzABCDEFGHIJKLMNOPQRSTUVXYZ0123456789"
   iPasswordLength=passwordLength
   iDefaultCharactersLength = Len(sDefaultChars) 

   Randomize
   For iCounter = 1 To iPasswordLength
      iPickedChar = Int((iDefaultCharactersLength * Rnd) + 1) 
      sMyPassword = sMyPassword & Mid(sDefaultChars,iPickedChar,1)
   Next 
   genrandomvalue = sMyPassword
end function

function getpaypalfieldvalue(tbl,whatfield,wherevalue,wherefield,isInt)
   dim sqlTC, rsTC
   if isInt = 1 then
      sqlTC = "select "&whatfield&" from "&tbl&" where "&wherefield&"="&wherevalue
   else
      sqlTC = "select "&whatfield&" from "&tbl&" where "&wherefield&"='"&wherevalue&"'"
   end if
   set rsTC = Server.createobject("ADODB.Recordset")
   rsTC.open sqlTC, dbc, adOpenForwardOnly, adLockReadOnly
   if not rsTC.eof then
      getpaypalfieldvalue = rsTC(""&whatfield&"")
   end if
   closerecordset rsTC
end function

sub UpdateSecureTokenIDtoOrders(newgenrandomvalue,poid,updatefield)
   if trim(poid) = "" then exit sub
   if trim(newgenrandomvalue) = "" then exit sub
   if trim(updatefield) = "" then exit sub
   Dim sql
   sql = "Update orders set "
   sql = sql & " "& updatefield &"='" & newgenrandomvalue & "'"
   sql = sql & " where orderid=" & poid

   '800 - 2016.02.01 - Enhancement: Must always commit transaction if execute sql execute
   on error resume next
   dbc.BeginTrans
   on error goto 0
   dbc.execute(sql)
   on error resume next
   dbc.CommitTrans
   on error goto 0
end sub

sub createlogs_paypalpymtlink_token (gateway, oid, newSecureTokenID, xmlsent, xmlreceive)
   dim foldername,filename,nowdate
   nowdate = replace(date(),"/","_")
   nowdate = replace(nowdate,"\","_")
   select case lcase(gateway)
      case "pymt"
	     foldername = "paymentadvanced"
		 filename = "paymentadvanced_"& nowdate &"_"& oid &".txt"
	  case "pflink"
	     foldername = "payflowlink"
		 filename = "payflowlink_"& nowdate &"_"& oid &".txt"
	  case "pfpro"
	     foldername = "payflowpro"
		 filename = "payflowpro_"& nowdate &"_"& oid &".txt"
   end select
   WriteLogPayPal foldername, filename, "Start (Token): =================================================="
   WriteLogPayPal foldername, filename, "For Order ID: "& oid &" - Token: "& newSecureTokenID &""
   WriteLogPayPal foldername, filename, "XML Sent: "& xmlsent &""
   WriteLogPayPal foldername, filename, "XML Received: "& xmlreceive &""
   WriteLogPayPal foldername, filename, "End (Token): =================================================="
end sub

sub createlogs_paypalpymtlink_callback (gateway,oid)
   dim foldername,filename,nowdate
   nowdate = replace(date(),"/","_")
   nowdate = replace(nowdate,"\","_")
   select case lcase(gateway)
      case "pymt"
	     foldername = "paymentadvanced"
		 filename = "paymentadvanced_"& nowdate &"_"& oid &".txt"
	  case "pflink"
	     foldername = "payflowlink"
		 filename = "payflowlink_"& nowdate &"_"& oid &".txt"
	  case "pfpro"
	     foldername = "payflowpro"
		 filename = "payflowpro_"& nowdate &"_"& oid &".txt"
   end select
   WriteLogPayPal foldername, filename, "Start (Callback Receive): =================================================="
   WriteLogPayPal foldername, filename, "For Order ID: "& oid &""
   dim sItem
   For Each sItem In Request.Form
      WriteLogPayPal foldername, filename, ""& sItem &" : "& Request.Form(sItem) &""
   Next
   WriteLogPayPal foldername, filename, "End (Callback Receive): =================================================="
end sub

Sub UpdateTransactionType (updatestring,updatecaption)
   Dim sql
   sql = "Update orders set "
   sql = sql & " paypalprocessor='"& updatecaption &"', "
   sql = sql & " paypaltranstype='" & updatestring & "'"
   sql = sql & " where orderid=" & getsess("oid")

   '800 - 2016.02.01 - Enhancement: Must always commit transaction if execute sql execute
   on error resume next
   dbc.BeginTrans
   on error goto 0
   dbc.execute(sql)
   on error resume next
   dbc.CommitTrans
   on error goto 0
end sub
%>