<%option explicit%>
<%response.buffer=true%>
<!--#include file="shop$db.asp"-->
<%ShopOpenDatabase dbc%>
<!--#include file="shopproductcreatesql.asp"-->
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Ajax Search Lookup
'*********************************************************************************

dim searchvalue

'701 - 2012.02.23 - Bug Fix: Double byte char not able to be searched via ajax search in IE
'800 - 2016.04.04 - Ajax Search: To trim keyword to have better search result
searchvalue = trim(URLDecode(JSURLDecode(cleanchars(request("keyword")))))

'800 - 2016.12.27 - Product search: Not able to search with comma
searchvalue = replace(searchvalue,","," ")

'800 - 2015.07.27 - Enhancement: Ajax Search: Better navigation and faster search
dim xAjaxSearchMinChars
xAjaxSearchMinChars = getconfig("xAjaxSearchMinChars")
if trim(xAjaxSearchMinChars) = "" then xAjaxSearchMinChars = 3
if not isnumeric(xAjaxSearchMinChars) then xAjaxSearchMinChars = 3
if Len(searchvalue) >= cdbl(xAjaxSearchMinChars) Then
   '800 - 2015.07.27 - Enhancement: Ajax Search: Better navigation and faster search
   if instr(searchvalue,"page=:=") > 0 then
      mypage = replace(searchvalue,"page=:=","")
      searchvalue = ""
   else
      session("ajaxsearch_searchvalue") = searchvalue
   end if
   if len(mypage) <= 0 then mypage = 1
   mypagesize = getconfig("xAjaxSearchPageSize")
   if trim(mypagesize) = "" then mypagesize = 10
   if not isnumeric(mypagesize) then mypagesize = 10

   '800 - 2015.06.03 - Enhancement: Better handling on Ajax predictive search
   dim predictive_sql,catalogid
   Generate_predictive_searchsql predictive_sql, searchvalue
   dim rst, productlist

   productlist = ""

   '800 - 2015.07.27 - Enhancement: Ajax Search: Better navigation and faster search
   ShopOpenRecordSet predictive_sql, rst, mypagesize, mypage
   dim ajax_search_recordcount
   ajax_search_recordcount = 0

   dim mylink
   if not rst.eof Then
      '800 - 2015.07.27 - Enhancement: Ajax Search: Better navigation and faster search
	  while not rst.eof and ajax_search_recordcount < maxrecs
         '800 - 2015.06.03 - Enhancement: Better handling on Ajax predictive search
	     catalogid = rst("catalogid")

         '800 - 2016.02.23 - Remove HTML tag from title on predictive search
         productlist = CMSRemoveHTML(rst("cname"))

         '700 - 2010.06.02 - Enhancement: Predictive search link / more details should open a popup windows if extended popup is enable
         if GetConfig("XextendedPopup") = "Yes" then
		    '800 - 2015.08.10 - Bug Fix: Ajax Search xCrossLinkurl not working properly
			if lcase(GetConfig("xGenerateShopexdLink")) = "yes" then
			   mylink = "<a href=""javascript:popUpAjaxSearchLookup('"& xmysite2 &"/shopexd.asp?id="& catalogid &"')"">"& productlist &"</a>"
			else
			   if ucase(GetConfig("xCrossLinkurl")) = "SHOPEXD.ASP" then
			      mylink = "<a href=""javascript:popUpAjaxSearchLookup('"& xmysite2 &"/shopexd.asp?id="& catalogid &"')"">"& productlist &"</a>"
			   else
			      mylink = "<a href=""javascript:popUpAjaxSearchLookup('"& xmysite2 &"/"& GetConfig("xCrossLinkurl") &"?catalogid="& catalogid &"')"">"& productlist &"</a>"
			   end if
			end if
         else
		    '800 - 2015.08.10 - Bug Fix: Ajax Search xCrossLinkurl not working properly
		    if lcase(GetConfig("xGenerateShopexdLink")) = "yes" then
			   mylink = "<a href=""shopexd.asp?id="& catalogid &""">"& productlist &"</a>"
			else
               if ucase(GetConfig("xCrossLinkurl")) = "SHOPEXD.ASP" then
                  mylink = "<a href=""shopexd.asp?id="& catalogid &""">"& productlist &"</a>"
               else
                  mylink = "<a href="""& GetConfig("xCrossLinkurl") &"?catalogid="& catalogid &""">"& productlist &"</a>"
               end if
			end if
         end if

	     '700 - SEO
		 '800 - 2015.07.21 - Bug fix: Predictive search link issue
	     genseoproductlink mylink,catalogid,productlist,"Yes"

		 mylink = mylink & ""
		 htmlwrite mylink
         '800 - 2015.07.27 - Enhancement: Ajax Search: Better navigation and faster search
		 ajax_search_recordcount = ajax_search_recordcount + 1
		 rst.movenext
      wend
      '800 - 2015.07.27 - Enhancement: Ajax Search: Better navigation and faster search
	  PageNavBarNext_ajaxsearch predictive_sql
   else
      'htmlwrite "<br />"
      htmlwrite GetLang("langcommonnoresults")
   end If

   '700 - 2010.05.03 - Check all databasae must close after opened.
   closerecordset rst
end if
shopclosedatabase dbc

'800 - 2015.06.03 - Enhancement: Better handling on Ajax predictive search
sub Generate_predictive_searchsql (sql, searchvalue)
   '800 - 2015.07.27 - Enhancement: Ajax Search: Better navigation and faster search
   if trim(searchvalue) = "" then
      sql = session("ajaxsearch_sqlquery")
   else

   sql = ""
   dim strdistinct
   strdistinct = "DISTINCT"
   if ucase(xDatabaseType) = "SQLSERVER" or ucase(GetConfig("xDatabaseType")) = "SQLSERVER" then
      strdistinct = "DISTINCT"
   end if
   dim ajaxsearch_fields
   ajaxsearch_fields = getconfig("xsearchfields")

   '800 - 2015.12.02 - To remove prodfeatures from sql query if xsearchfields does not have any prodfeatures fields
   dim productfeatureflag
   if instr(lcase(ajaxsearch_fields),"pf.") > 0 then
      productfeatureflag = true
   else
      productfeatureflag = false
   end if

   if trim(ajaxsearch_fields) = "" then ajaxsearch_fields = "p.cname,p.cdescription,p.ccode"
   dim ajaxsearch_fieldsary(20), ajaxsearch_fieldscnt
   if instr(lcase(ajaxsearch_fields),"p.") <= 0 then
      parserecord_split ajaxsearch_fields,ajaxsearch_fieldsary,ajaxsearch_fieldscnt,","
   end if
   dim icnt, tempstring
   tempstring = ""
   for icnt = 0 to (ajaxsearch_fieldscnt - 1)
      if left(ajaxsearch_fieldsary(icnt),3) <> "pf." then
         tempstring = tempstring & "p." & ajaxsearch_fieldsary(icnt) & ","
      else
	     tempstring = tempstring & "" & ajaxsearch_fieldsary(icnt) & ","
	  end if
   next
   if trim(tempstring) <> "" then
      ajaxsearch_fields = mid(tempstring,1,len(tempstring)-1)
   end if
   if instr(lcase(ajaxsearch_fields),"catalogid") <= 0 then
      ajaxsearch_fields = ajaxsearch_fields & "," & "p.catalogid"
   end if
   if instr(lcase(ajaxsearch_fields),"cname") <= 0 then
      ajaxsearch_fields = ajaxsearch_fields & "," & "p.cname"
   end if

   '800 - 2015.09.22 - Bug Fix: xsortproducts is not working properly if others than value cname,ccode,catalogid
   '800 - 2015.09.22 - Better handlling on configuration xsortproducts that able to handle DESC and ASC and multiple values
   dim xsortproducts, selectlist
   dim xsortproductsary(99), xsortproductscnt
   xsortproducts = getconfig("xsortproducts")
   selectlist = "p.cname,p.ccode,p.catalogid"
   parserecord_split xsortproducts,xsortproductsary,xsortproductscnt,","
   if trim(xsortproducts) <> "" then
      dim xsortproductsind
	  for icnt = 0 to (xsortproductscnt-1)
   	     xsortproductsind = trim(xsortproductsary(icnt))
	     xsortproductsind = replace(lcase(xsortproductsind)," desc","")
	     xsortproductsind = replace(lcase(xsortproductsind)," asc","")
	     if lcase(xsortproductsind) <> "cname" and lcase(xsortproductsind) <> "ccode" and lcase(xsortproductsind) <> "catalogid" then
            if instr(selectlist,replace(lcase(xsortproductsind),"p.","")) <= 0 then
	           if instr(lcase(xsortproducts),"p.") <= 0 then
                  selectlist = selectlist & ",p." & xsortproductsind
               else
		          selectlist = selectlist & "," & xsortproductsind
		       end if
            end if
		 end if
	  next
   end if
   sql = "select " & strdistinct & " " & selectlist

   if ucase(xdatabasetype) = "SQLSERVER" then
      sql = sql & " from products p inner join prodcategories cc on cc.intCatalogId = p.CatalogId inner join categories c on cc.intcategoryid=c.categoryid"

      '800 - 2015.12.02 - To remove prodfeatures from sql query if xsearchfields does not have any prodfeatures fields
	  if productfeatureflag then
	     sql = sql & " left join prodfeatures pf on ',' + p.features + ',' like '%,'+ convert(nvarchar,pf.featurenum) +',%' "
	  end if
   elseif instr(ucase(xdatabasetype), "MYSQL") > 0 then
      sql = sql & " from products p inner join prodcategories cc on cc.intCatalogId = p.CatalogId inner join categories c on cc.intcategoryid=c.categoryid"

      '800 - 2015.12.02 - To remove prodfeatures from sql query if xsearchfields does not have any prodfeatures fields
	  if productfeatureflag then
	     sql = sql & " left join prodfeatures pf on concat(',',p.features,',') like concat('%,',pf.featurenum,',%') "
	  end if
   else
      sql = sql & " from (((products p) inner join prodcategories cc on cc.intCatalogId = p.CatalogId) inner join categories c on cc.intcategoryid=c.categoryid)"

      '800 - 2015.12.02 - To remove prodfeatures from sql query if xsearchfields does not have any prodfeatures fields
	  if productfeatureflag then
         sql = sql & " left join prodfeatures pf on ',' + p.features + ',' like '%,'+ Iif(pf.featurenum Is Null, '', cstr(pf.featurenum)) +',%' "
	  end if
   end if
   sql = sql & " where "
   sql = sql & " ("
   parserecord_split ajaxsearch_fields,ajaxsearch_fieldsary,ajaxsearch_fieldscnt,","

   '800 - 2015.09.17 - Bug Fix: Ajax Search: should always returned "same" result with normal search
   dim searchvalueary(99),searchvaluecnt,jcnt,orstring,orstring2
   parserecord_split searchvalue, searchvalueary, searchvaluecnt, " "
   if icnt = (ajaxsearch_fieldscnt - 1) then
      orstring2 = ""
      for jcnt = 0 to (cdbl(searchvaluecnt) - 1)
	     sql = sql & " " & orstring2 & " "
         sql = sql & " ("
		 orstring = ""
		 for icnt = 0 to (ajaxsearch_fieldscnt - 1)
		    if instr(lcase(ajaxsearch_fieldsary(icnt)),"catalogid") <= 0 then
		       sql = sql & " "& orstring &" "& ajaxsearch_fieldsary(icnt) &" like "& sqlserverprefixn &"'%"& tosql(searchvalueary(jcnt),"Text") &"%'"
			   orstring = "or"
            end if
		 next
		 sql = sql & ") "
		 orstring2 = "and"
	  next
   else

   for icnt = 0 to (ajaxsearch_fieldscnt - 1)
      if icnt = (ajaxsearch_fieldscnt - 1) then
	     sql = sql & " "& ajaxsearch_fieldsary(icnt) &" like "& sqlserverprefixn &"'%"& tosql(searchvalue,"Text") &"%'"
	  else
	     sql = sql & " "& ajaxsearch_fieldsary(icnt) &" like "& sqlserverprefixn &"'%"& tosql(searchvalue,"Text") &"%' or "
	  end if
   next

   '800 - 2015.09.17 - Bug Fix: Ajax Search: should always returned "same" result with normal search
   end if

   sql = sql & " )"
   generateproductstdcriteriasql sql, "p.", "c.", "generateproductmatchsql"
   sql = sql & " AND (higherCatalogId is null)"
   generateprefixsortfield sql
   if GetConfig("xdebug") = "Yes" then
      DebugWrite sql
   end if

   '800 - 2015.07.27 - Enhancement: Ajax Search: Better navigation and faster search
   session("ajaxsearch_sqlquery") = sql
   end if
end sub

'800 - 2015.07.27 - Enhancement: Ajax Search: Better navigation and faster search
sub PageNavBarNext_ajaxsearch (sql)
   dim scriptname,ref
   dim nextpage, prevpage
   dim divname
   divname = cleanchars(request("divname"))
   SetSess "ajaxsearch_sqlquery",sql
   scriptname=request.servervariables("script_name")
   nextpage = mypage + 1
   prevpage = mypage - 1
   htmlwrite "<div class=""paginate"">"
   if prevpage >= 1  then
      ref="<a href=""javascript:getproductdesc('page=:="& prevpage &"','"& divname &"');"">"
	  ref = ref & "<span class=""fa fa-chevron-left"" aria-hidden=""true""></span> "& GetLang("langPrevious") &""
      ref=ref &  "</a>"
      htmlwrite ref
   end if
   htmlwrite "&nbsp;<a href="""& DoFriendlySEOPage("shopsearch.asp") &"?search=Yes&keyword="& session("ajaxsearch_searchvalue") &""">"& getlang("langviewallresults") &"</a>&nbsp;"
   if Nextpage =< maxpages then
      ref="<a href=""javascript:getproductdesc('page=:="& Nextpage &"','"& divname &"');"">"
 	  ref = ref & ""& GetLang("langNext") &" <span class=""fa fa-chevron-right"" aria-hidden=""true""></span>"
      ref=ref & "</a>"
      htmlwrite ref
   end if
   htmlwrite "</div>"
end sub
%>