<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Checkout indicator routines
'*********************************************************************************

sub addcheckoutindicator (pagename,stepseqno,stepimage)
   locatecheckoutsteps pagename,stepseqno,stepimage
end sub

sub locatecheckoutsteps (pagename,stepseqno,stepimage)
   '800 - 2016.08.03 - Should hide Checkout indicator if onepage checkout is enabled
   if check_onepage_status then exit sub

   if len(trim(pagename))<= 0 then exit sub

   dim rs,strsql,passflag
   passflag = true
   strsql="select * from checkoutsteps order by stepseqno asc"

   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open strsql, dbc, adopenkeyset, adlockoptimistic
   while not rs.eof and passflag = true
      if lcase(getsess("fromquickorder")) = "yes" then
	     stepseqno = 1
		 if rs("stepseqno") = 1 then
		    stepimage = rs("stepimage")
			passflag = false
		 end if
	  else
         if instr(pagename,rs("stepfile")) > 0 then
	        stepseqno = rs("stepseqno")
		    stepimage = rs("stepimage")
	        passflag = false
	     end if
	  end if
 	  rs.movenext
   wend
   closerecordset rs
end sub

function gettotalcheckoutsteps
   dim rs,strsql,tempvalue
   tempvalue = 0
   strsql="select count(stepseqno) as reccnt from checkoutsteps"

   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open strsql, dbc, adopenkeyset, adlockoptimistic
   tempvalue = rs("reccnt")
   closerecordset rs
   
   gettotalcheckoutsteps = tempvalue
end function

sub generatecheckoutsteps (totalcheckoutsteps,stepseqno,stepimage)
   if cdbl(totalcheckoutsteps) > 0 then
      if trim(stepseqno) <> "" then
	     if isnumeric(stepseqno) = true then
            '800 - 2016.03.02 - To replace SVG as checkout indicator%>
      <div class="checkoutsteps">
         <div class="step <% if(stepseqno = "1") then response.write "active" %>">
            <span>
               <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" x="0px" y="0px" viewBox="0 0 100 125" enable-background="new 0 0 100 100" xml:space="preserve">
                  <path d="M46.957,67.723c2.735,0,4.952,2.217,4.952,4.951c0,2.735-2.217,4.952-4.952,4.952s-4.952-2.217-4.952-4.952  C42.005,69.939,44.222,67.723,46.957,67.723z M75.257,67.721c2.735,0,4.953,2.218,4.953,4.953c0,2.736-2.218,4.953-4.953,4.953  s-4.952-2.217-4.952-4.953C70.305,69.938,72.521,67.721,75.257,67.721z M37.353,27.963h45.124v4.953H37.353V27.963z M43.131,36.905  h33.567v4.952H43.131V36.905z M47.808,45.848h24.213V50.8H47.808V45.848z M95.504,24.455l-5.686-2.082L77.693,55.479H43.929  L28.984,23.254V23.24H4.496v6.053h20.616l14.931,32.195l0.061-0.029v0.071h41.823v-0.146l0.044,0.015L95.504,24.455z"/>
               </svg>
            </span>
         </div>
         <div class="step <% if(stepseqno = "2") then response.write "active" %>">
            <span>
               <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" x="0px" y="0px" viewBox="0 0 16 20" style="enable-background:new 0 0 16 16;" xml:space="preserve">
                  <g>
                     <polygon points="14.293,8.293 10,12.586 7.707,10.293 6.293,11.707 10,15.414 15.707,9.707  "/>
                     <circle cx="5.5" cy="2.5" r="2.5"/>
                     <path d="M7.707,8.172L10,10.465l1-1V9c0-1.657-1.343-3-3-3H3C1.343,6,0,7.343,0,9v2.5C0,12.325,0.675,13,1.5,13h3.965l-1.293-1.293   L7.707,8.172z"/>
                  </g>
               </svg>
            </span>
         </div>
         <div class="step <% if(stepseqno = "3") then response.write "active" %>">
            <span>
               <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" x="0px" y="0px" viewBox="0 0 100 125" enable-background="new 0 0 100 100" xml:space="preserve">
                  <g display="none">
                     <g display="inline">
                        <g>
                           <path d="M64.917,38.881h-30.43v2.029h30.43V38.881z M16.229,83.512h12.172V71.34H16.229V83.512z M18.197,73.309h8.115v8.115     h-8.115V73.309z M16.229,28.738h12.172V16.566H16.229V28.738z M18.197,18.534h8.115v8.115h-8.115V18.534z M64.809,20.624H34.488     v2.029h30.321V20.624z M83.176,51.799V6.313c0-3.361-2.726-6.086-6.087-6.086H6.086C2.725,0.227,0,2.952,0,6.313v87.343     c0,3.359,2.725,6.086,6.086,6.086h68.059c0.41,0.021,0.821,0.031,1.235,0.031s0.826-0.013,1.235-0.031h0.474     c0.49,0,0.966-0.064,1.421-0.174C90.629,98.029,100,87.688,100,75.152C100,64.279,92.951,55.061,83.176,51.799z M9.982,95.895     c-3.36,0-6.085-2.727-6.085-6.086V10.44c0-3.362,2.725-6.086,6.085-6.086H73.21c3.36,0,6.086,2.724,6.086,6.086v40.404     c-1.274-0.203-2.583-0.312-3.916-0.312c-6.485,0-12.381,2.511-16.778,6.606H34.487v2.028H56.66     c-3.678,4.302-5.902,9.882-5.902,15.983c0,0.082,0.006,0.164,0.006,0.246H34.487v2.026h16.379     c0.711,7.765,5.024,14.479,11.256,18.47H9.982V95.895z M71.542,91.459l-11.19-13.27l4.797-4.318l6.715,6.717l11.99-20.783     l6.556,4.795L71.542,91.459z M16.229,46.996h12.172V34.824H16.229V46.996z M18.197,36.792h8.115v8.115h-8.115V36.792z      M16.229,65.254h12.172V53.082H16.229V65.254z M18.197,55.051h8.115v8.115h-8.115V55.051z"/>
                        </g>
                     </g>
                  </g>
                  <g>
                     <g>
                        <path d="M7.199,97c-2.21,0-4-1.79-4-4V7c0-2.21,1.79-4,4-4h69.657c2.21,0,4,1.79,4,4v41.17c1.369,0.2,1.845,0.5,3.145,0.89V6    c0-3.31-2.689-6-6-6H6C2.69,0,0,2.69,0,6v88c0,3.311,2.69,6,6,6h55.51l-4.09-3H7.199z"/>
                        <path d="M29,16H16v13h13V16z M27,27h-9v-9h9V27z"/>
                        <rect x="35" y="21" width="30" height="2"/>
                        <path d="M29,34H16v13h13V34z M27,45h-9v-9h9V45z"/>
                        <rect x="35" y="39" width="30" height="2"/>
                        <path d="M29,52H16v13h13V52z M27,63h-9v-9h9V63z"/>
                        <path d="M55.24,57H35v2h18.58C54.09,58.311,54.65,57.641,55.24,57z"/>
                        <path d="M16,83h13V70H16V83z M18,72h9v9h-9V72z"/>
                        <path d="M35,75v2h12.91c-0.02-0.35-0.03-0.7-0.03-1.061c0-0.319,0.01-0.631,0.03-0.939H35z"/>
                        <path d="M84,53.27c-1.279-0.459-2.62-0.81-4-1.039c-1.32-0.229-2.68-0.351-4.061-0.351c-5.59,0-10.739,1.899-14.819,5.12    c-0.8,0.609-1.55,1.279-2.261,2c-4.109,4.141-6.721,9.77-6.959,16c-0.012,0.311-0.021,0.63-0.021,0.939    c0,0.351,0.01,0.711,0.03,1.061c0.37,8.62,5.271,16.061,12.39,20c3.45,1.91,7.42,3,11.641,3H78c0.71,0,1.391-0.12,2.02-0.35    C91.37,97.721,100,87.84,100,75.939C100,65.48,93.33,56.58,84,53.27z M82.902,77.256l-3.226,4.756l-1.313,1.944l-3.805,5.604    l-5.209-4.086l-7.82-6.138L63.32,76.7l1.177-1.735l0.838-1.24l1.579,1.24l0.67,0.529l5.562,4.363l6.53-9.642l3.226-4.756    l1.645-2.431l5.217,4.088L82.902,77.256z"/>
                     </g>
                  </g>
               </svg>
            </span>
         </div>
         <div class="step <% if(stepseqno = "4") then response.write "active" %>">
            <span>
               <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" x="0px" y="0px" viewBox="0 0 512 640" enable-background="new 0 0 512 512" xml:space="preserve">
                  <g>
                     <path d="M336,320c12.344,0,23.5-4.813,32-12.469c8.5,7.656,19.656,12.469,32,12.469c26.5,0,48-21.5,48-48s-21.5-48-48-48   c-12.344,0-23.5,4.813-32,12.469C359.5,228.813,348.344,224,336,224c-26.5,0-48,21.5-48,48S309.5,320,336,320z"/>
                     <path d="M480,64H96c-17.688,0-32,14.313-32,32v96h32h160h224v160H256v32h224c17.688,0,32-14.313,32-32V96   C512,78.313,497.688,64,480,64z M480,128H96V96h384V128z"/>
                     <path d="M112,224C50.125,224,0,274.125,0,336s50.125,112,112,112s112-50.125,112-112S173.875,224,112,224z M89.375,403.875   l-56.563-56.563l22.625-22.625l33.938,33.938l79.188-79.188l22.625,22.625L89.375,403.875z"/>
                  </g>
               </svg>
            </span>
         </div>
         <div class="step <% if(stepseqno = "5") then response.write "active" %>">
            <span>
               <svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="-0.135 24.438 100 56.120000000000005" enable-background="new -0.135 24.438 100 44.896" xml:space="preserve">
                  <path d="M51.354,40.089c-0.155,0.066-0.315,0.136-0.493,0.212l0.406-0.179C51.294,40.108,51.328,40.099,51.354,40.089z"/>
                  <path d="M52.917,68.559l-0.034,0.037l-0.033,0.043c-0.857,1.085-2.428,1.278-3.521,0.418l-0.504-0.403l-0.55-0.439   c0.056-0.104,0.099-0.212,0.136-0.324l1.664-4.821c0.075,0.065,0.15,0.126,0.225,0.184c0.183,0.146,0.355,0.282,0.518,0.415   c0.091,0.074,0.176,0.14,0.261,0.206c0.114,0.095,0.227,0.184,0.33,0.269c0.066,0.052,0.126,0.099,0.186,0.151   c0.159,0.121,0.3,0.237,0.421,0.336c0.308,0.242,0.487,0.389,0.487,0.389C53.593,65.885,53.776,67.466,52.917,68.559z"/>
                  <path d="M73.206,59.914L73.14,60c-0.859,1.087-2.442,1.274-3.535,0.414c0,0-0.155-0.12-0.438-0.343   c-0.707-0.554-2.199-1.734-4.012-3.163c-0.245-0.195-0.494-0.392-0.744-0.59c-0.68-0.528-1.385-1.085-2.105-1.651   c-0.087-0.068-0.178-0.146-0.267-0.208c-0.405-0.324-0.815-0.646-1.224-0.969c-4.059-3.195-8.13-6.402-8.366-6.596   c-0.753-0.603-1.548,0.41-0.79,1.012c0.411,0.325,4.528,3.574,8.207,6.471c0.104,0.081,0.208,0.158,0.314,0.239   c0.226,0.179,0.455,0.357,0.68,0.537c0.277,0.221,0.556,0.438,0.822,0.646c0.123,0.094,0.243,0.192,0.365,0.285   c0.97,0.764,1.854,1.455,2.549,2.011c0.152,0.117,0.287,0.226,0.411,0.32c0.175,0.136,0.329,0.263,0.471,0.371   c0.073,0.059,0.146,0.113,0.21,0.167c0.005,0,0.013,0.007,0.013,0.007c0.004,0.009,0.004,0.009,0.008,0.012   c0.329,0.254,0.507,0.396,0.507,0.396c1.093,0.86,1.275,2.444,0.418,3.535l-0.025,0.021l-0.014,0.024l-0.029,0.031   c-0.86,1.092-2.441,1.277-3.53,0.415c0,0-0.137-0.108-0.39-0.306c-0.037-0.033-0.081-0.065-0.127-0.098   c-0.011-0.012-0.023-0.021-0.033-0.028c-0.057-0.048-0.122-0.095-0.188-0.146c-0.028-0.029-0.065-0.053-0.099-0.076   c-0.037-0.03-0.075-0.062-0.111-0.089c-0.087-0.069-0.176-0.143-0.274-0.217c-0.015-0.016-0.033-0.027-0.053-0.043   c-0.258-0.2-0.55-0.431-0.87-0.683c-0.074-0.061-0.148-0.116-0.223-0.175c-0.148-0.121-0.31-0.243-0.471-0.371   c-0.163-0.132-0.331-0.265-0.511-0.4c-0.142-0.117-0.291-0.231-0.443-0.349c-0.984-0.776-2.08-1.637-3.188-2.51   c-3.507-2.753-7.188-5.662-7.575-5.969c-0.758-0.598-1.563,0.409-0.8,1.013c0.447,0.353,4.296,3.407,7.397,5.866   c0.282,0.227,0.553,0.443,0.817,0.648c0.237,0.186,0.462,0.364,0.68,0.538c0.211,0.169,0.418,0.333,0.612,0.489   c0.324,0.254,0.621,0.491,0.89,0.702c0.104,0.08,0.198,0.155,0.287,0.227c0.057,0.046,0.108,0.085,0.153,0.126   c0.097,0.075,0.183,0.146,0.266,0.206c0.148,0.118,0.282,0.221,0.39,0.311c0.254,0.199,0.396,0.312,0.396,0.312   c1.087,0.858,1.275,2.443,0.414,3.531l-0.033,0.043l-0.004,0.009l-0.027,0.037c-0.86,1.088-2.443,1.267-3.535,0.404   c0,0-0.143-0.107-0.391-0.31c-0.033-0.025-0.075-0.058-0.111-0.085c-0.012-0.01-0.021-0.02-0.029-0.021   c-0.093-0.073-0.199-0.153-0.31-0.248c-0.58-0.458-1.416-1.116-2.373-1.874c-0.221-0.178-0.456-0.364-0.697-0.55   c-0.383-0.312-0.785-0.632-1.191-0.955c-0.281-0.226-0.565-0.452-0.851-0.678c0.046-0.613-0.071-1.224-0.348-1.789   c-0.416-0.849-1.136-1.482-2.03-1.789c-0.367-0.125-0.752-0.194-1.144-0.194c-0.358,0-0.711,0.059-1.041,0.158   c-0.584-0.46-1.026-0.809-1.248-0.986c-0.038-0.105-0.081-0.209-0.131-0.312c-0.415-0.849-1.135-1.483-2.029-1.79   c-0.372-0.126-0.752-0.187-1.145-0.187c-1.135,0-2.176,0.54-2.829,1.416c-0.278-1.122-1.103-2.092-2.279-2.494   c-0.371-0.126-0.758-0.189-1.144-0.189c-1.187,0-2.265,0.599-2.91,1.545c-0.286-1.112-1.106-2.062-2.269-2.462   c-0.373-0.126-0.758-0.193-1.149-0.193c-1.506,0-2.849,0.959-3.338,2.386l-0.023,0.077c-0.225-0.077-0.447-0.171-0.608-0.26   l-7.998-4.6c-0.306-0.174-0.419-0.574-0.245-0.884l8.554-15.41c0.17-0.311,0.583-0.457,0.914-0.33l4.053,1.567   c0.33,0.127,0.876,0.146,1.214,0.039l9.652-3.103c0.338-0.109,0.899-0.141,1.247-0.075l0.754,0.146   c0.348,0.065,0.4,0.292,0.113,0.504l-1.041,0.777c-0.009,0.009-0.019,0.014-0.027,0.028c-2.22,1.644-5.255,3.87-6.648,4.783   c-1.398,0.914-1.969,2.341-1.53,3.813c0.555,1.86,2.538,3.207,4.708,3.207c0.72,0,1.431-0.146,2.118-0.433   c2.052-0.856,5.07-2.133,7.579-3.196c0.033-0.004,0.062-0.014,0.089-0.028l0.951-0.411c0.607-0.259,1.167-0.493,1.646-0.702   l0.406-0.178c0.027-0.014,0.062-0.023,0.089-0.033c0.006,0,0.006,0,0.01,0c0.317-0.094,0.743-0.02,0.991,0.179l2.772,2.193   c0.276,0.217,0.732,0.579,1.012,0.796l8.492,6.695l7.649,6.025l0.509,0.4C73.884,57.239,74.069,58.826,73.206,59.914z"/>
                  <path d="M52.463,63.304c-0.388-0.306-0.79-0.626-1.196-0.95l0.004-0.006C51.678,62.674,52.079,62.993,52.463,63.304z"/>
                  <path d="M60.18,54.613c-0.105-0.079-0.211-0.158-0.316-0.239l0.007-0.006C59.974,54.448,60.074,54.529,60.18,54.613z"/>
                  <path d="M44.767,32.63c0.283-0.212,0.792-0.476,1.127-0.585l9.391-3.051c0.337-0.11,0.874-0.073,1.193,0.082l12.038,5.832   c0.317,0.154,0.851,0.175,1.18,0.047l4.053-1.569c0.33-0.128,0.741,0.021,0.913,0.331l8.555,15.41   c0.174,0.31,0.078,0.733-0.206,0.942l-7.903,5.756c-0.287,0.206-0.749,0.199-1.026-0.021L52.742,38.835   c-0.277-0.22-0.768-0.287-1.092-0.149c0,0-7.37,3.136-11.512,4.867c-3.695,1.546-7.209-2.544-4.196-4.519   C38.325,37.472,44.767,32.63,44.767,32.63z"/>
                  <g>
                     <g>
                        <path d="M47.74,58.982c1.355,0.463,2.074,1.936,1.61,3.288l-1.829,5.313c-0.464,1.352-1.935,2.072-3.287,1.607l0,0         c-1.353-0.464-2.072-1.936-1.608-3.285l1.825-5.317C44.914,59.237,46.386,58.517,47.74,58.982L47.74,58.982z"/>
                     </g>
                     <g>
                        <path d="M42.146,55.864c1.354,0.464,2.073,1.937,1.61,3.287l-1.828,5.316c-0.464,1.352-1.936,2.071-3.288,1.606l0,0         c-1.352-0.463-2.072-1.936-1.608-3.289l1.825-5.313C39.321,56.118,40.792,55.398,42.146,55.864L42.146,55.864z"/>
                     </g>
                     <g>
                        <path d="M35.893,54.597c1.35,0.463,2.071,1.937,1.607,3.287l-1.104,3.213c-0.464,1.353-1.937,2.071-3.288,1.608l0,0         c-1.353-0.464-2.071-1.937-1.608-3.287l1.103-3.214C33.068,54.853,34.539,54.133,35.893,54.597L35.893,54.597z"/>
                     </g>
                     <g>
                        <path d="M29.568,53.488c1.352,0.466,2.071,1.938,1.607,3.289l-0.398,1.163c-0.465,1.352-1.937,2.073-3.289,1.608l0,0         c-1.352-0.465-2.071-1.938-1.607-3.29l0.398-1.162C26.743,53.744,28.216,53.025,29.568,53.488L29.568,53.488z"/>
                     </g>
                  </g>
                  <path d="M99.744,41.724c0.262,0.482,0.083,1.092-0.4,1.354l-12.128,6.606c-0.481,0.263-1.092,0.083-1.354-0.398L76.729,32.52   c-0.264-0.483-0.084-1.091,0.398-1.354l12.13-6.606c0.482-0.263,1.091-0.083,1.352,0.398L99.744,41.724z"/>
                  <path d="M-0.015,41.724c-0.262,0.482-0.083,1.092,0.398,1.354l12.128,6.606c0.482,0.263,1.09,0.083,1.353-0.398L23,32.52   c0.263-0.483,0.083-1.091-0.398-1.354l-12.129-6.607c-0.482-0.263-1.092-0.083-1.354,0.398L-0.015,41.724z"/>
               </svg>
            </span>
         </div>
      </div><%
		 end if
	  end if
   end if
end sub

sub processcheckoutindicator
   dim xCheckoutIndicator
   xCheckoutIndicator = getconfig("xCheckoutIndicator")
   if xCheckoutIndicator = "Yes" then
      dim stepseqno,totalcheckoutsteps,stepimage
	  totalcheckoutsteps = gettotalcheckoutsteps
	  addcheckoutindicator request.ServerVariables("SCRIPT_NAME"),stepseqno,stepimage
	  generatecheckoutsteps totalcheckoutsteps, stepseqno,stepimage
   end if
end sub

function getcheckoutimage (stepseqno)
   dim rs,strsql,tempvalue
   tempvalue = 0
   strsql="select stepimagenormal from checkoutsteps where stepseqno = "& cdbl(stepseqno) &""

   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open strsql, dbc, adopenkeyset, adlockoptimistic
   tempvalue = rs("stepimagenormal")
   closerecordset rs
   
   getcheckoutimage = tempvalue
end function
%>