<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Customer Group routines
'*********************************************************************************

'800 - 2015.08.06 - Speed perforamnce on customer groups routines
sub refreshall_redundant
   'redundant
end sub

'800 - 2015.08.06 - Speed perforamnce on customer groups routines
sub refreshind_redundant
   'redundant
end sub

'800 - 2015.08.06 - Speed perforamnce on customer groups routines
sub refreshstatic_redundant
   'redundant
end sub

'800 - 2015.08.06 - Speed perforamnce on customer groups routines
sub refreshdynamic_redundant
   'redundant
end sub

'800 - 2015.08.06 - Speed perforamnce on customer groups routines
sub processquery_redundant
   'redundant
end sub

function checksqlquery (sqlquery)
   if trim(sqlquery) = "" then
      checksqlquery = false
	  exit function
   end if
   
   if lcase(mid(sqlquery,1,7)) <> "select " then
      checksqlquery = false
	  exit function
   end if

   if instr(lcase(sqlquery),"customers") <= 0 then
      checksqlquery = false
	  exit function
   end if

   if instr(lcase(sqlquery)," * ") <= 0 then
      if instr(lcase(sqlquery),"contactid") <= 0 then
	     checksqlquery = false
   	     exit function
	  end if
   end if
   
   dim sqlrs,tempflag
   on error resume next
   Set sqlrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
   sqlrs.open sqlquery, dbc, adOpenForwardOnly, adLockReadOnly
   
   if err.number <> 0 then
      checksqlquery = false

	  '800 - 2015.08.06 - Speed perforamnce on customer groups routines
	  closerecordset sqlrs

	  exit function
   end if

   '701 - 2012.03.13 - Enhancement: Better handling on updating customer dynamic group simultaneously
   closerecordset sqlrs
   on error goto 0

   checksqlquery = true
end function

'800 - 2015.08.06 - Speed perforamnce on customer groups routines
function validgroup_redundant
   'redundant
end function

'800 - 2015.08.06 - Speed perforamnce on customer groups routines
function getgrouptype_redundant
   'redundant
end function

'800 - 2015.08.06 - Speed perforamnce on customer groups routines
function getsqlquery_redundant
   'redundant
end function

sub refreshindfromcontact (contactid)
   if trim(contactid) = "" then
      debugwrite "Refreshing Errors"
      exit sub
   end if
   
   if validcontact(contactid) = false then
      debugwrite "Refreshing Errors"
	  exit sub
   end if
   
   'gettting group where grouptype = 'dynamic'
   dim sqlrs,strsql,tempstring
   strsql="select groupid,groupsqlquery from groups where grouptype = 'dynamic'"
   Set sqlrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
   sqlrs.open strsql, dbc, adOpenKeyset, adLockReadOnly

   do while not sqlrs.eof
      tempstring = ""
	  '701 - 2012.03.13 - Enhancement: Better handling on updating customer dynamic group simultaneously
	  if instr(lcase(sqlrs("groupsqlquery"))," where ") > 0 then
	     tempstring = mid(sqlrs("groupsqlquery"),1,instr(lcase(sqlrs("groupsqlquery"))," where ") - 1)
		 tempstring = tempstring & " where contactid = "& contactid &""
		 tempstring = tempstring & " and "

         '800 - 2016.06.29 - Bug Fix: Customer Group: Not working properly if query with multiple conditions without brackets
		 tempstring = tempstring & "(" & mid(sqlrs("groupsqlquery"),(instr(lcase(sqlrs("groupsqlquery"))," where ") + 7),len(sqlrs("groupsqlquery"))-(instr(lcase(sqlrs("groupsqlquery"))," where ") + 6)) & ")"

	  else
	     tempstring = sqlrs("groupsqlquery") & " where contactid = "& contactid &""
	  end if
	  processquerycon tempstring,sqlrs("groupid"),contactid
	  
      sqlrs.movenext
   loop
   closerecordset sqlrs
end sub

sub processquerycon (sqlquery,groupid,contactid)
   if trim(sqlquery) = "" then
      debugwrite getlang("langqueryerrors")
	  exit sub
   end if

   if trim(groupid) = "" then
      debugwrite getlang("langqueryerrors")
	  exit sub
   end if
   
   if checksqlquery(sqlquery) = false then
      debugwrite getlang("langqueryerrors")
	  exit sub
   end if
   
   'check existence
   dim sqlrs,strsql,xcnt
   dim sqlrs2,foundflag,strsql2
   
   Set sqlrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
   sqlrs.open sqlquery, dbc, adOpenForwardOnly, adLockReadOnly

   if sqlrs.eof then
      dbc.execute("delete from customergroups where groupsid = "& groupid &" and contactid = "& contactid &"")
   else
      Set sqlrs2 = Server.CreateObject("ADODB.Recordset")
	  strsql = "select groupsid,contactid from customergroups where groupsid = "& groupid &" and contactid = "& contactid &""

	  '800 - 2015.08.06 - Speed perforamnce on customer groups routines
	  sqlrs2.open strsql, dbc, adOpenForwardOnly, adLockReadOnly

	  if sqlrs2.eof then
         dbc.execute("insert into customergroups (groupsid,contactid) values ("& groupid &","& contactid &")")
	  end if
	  closerecordset sqlrs2
   end if
   closerecordset sqlrs
end sub

function validcontact (contactid)
   if trim(contactid) = "" then
      validcontact = false
	  exit function
   end if

   dim sqlrs,strsql, tempflag
   strsql="select contactid from customers where contactid = "& contactid &""

   Set sqlrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
   sqlrs.open strsql, dbc, adOpenForwardOnly, adLockReadOnly

   if sqlrs.eof then
      tempflag = false
   else
      tempflag = true
   end if
   closerecordset sqlrs
   
   validcontact = tempflag
end function

'700 - Customer Groups - update cusotmer group based on contactid
sub updatecustomergroup (dbtable,oldwhich,which)
   if lcase(DBTable) = "customers" then
      if getconfig("xCustomerGroupDynamicAutoAssign") = "Yes" then
         if cstr(oldwhich) <> cstr(which) then
            dim sqlrs,strsql
			if oldwhich <> "" then
               strsql="select a.contactid,a.groupsid,b.grouptype from customergroups a,groups b where a.contactid = "& oldwhich &" and a.groupsid = b.groupid and b.grouptype = 'dynamic'"
               Set sqlrs = Server.CreateObject("ADODB.Recordset")

			   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
               sqlrs.open strsql, dbc, adOpenKeyset, adLockReadOnly

               do while not sqlrs.eof
                  '800 - 2016.02.01 - Enhancement: Must always commit transaction if execute sql execute
				  on error resume next
                  dbc.BeginTrans
				  on error goto 0
                  dbc.execute("insert into customergroups (groupsid,contactid) values ("& sqlrs("groupsid") &","& which &")")
				  on error resume next
                  dbc.CommitTrans
				  on error goto 0

                  sqlrs.movenext
               loop
               closerecordset sqlrs
		   	else
			   refreshindfromcontact which
			end if
         else
            'do refreshing
		    refreshindfromcontact which
         end if
      end if
   end if
end sub

'700 - Customer Groups - Generate customermatch sql
function GenerateCustomerMatchSQL (matchfield,exmatchfield,matchfield2,whereok)
   GenerateCustomerMatchSQL = ""
end function

function getgroupdiscount(contactid)
   if trim(contactid) = "" then
      getgroupdiscount = 0
      exit function
   end if
   if isnumeric(contactid) = false then
      getgroupdiscount = 0
      exit function
   end if

   dim sqlrs,strsql,tempvalue
   dim sqlrs2,strsql2

   '800 - 2016.01.22 - Enhancement: Customer Prices: Speed Enhancement
   dim CustomerProductGroup
   CustomerProductGroup = session("Customerproductgroup")

   '800 - 2016.07.12 - Bug Fix: Customer Groups: Possible error while sign up new customer if cookies is enabled and xCustomerGroupDynamicAutoAssign set to No
   if not isnull(CustomerProductGroup)then
      if cstr(CustomerProductGroup) = "**NULL**" then
	     CustomerProductGroup = ""
		 session("Customerproductgroup") = ""
	  end if
   end if

   if trim(CustomerProductGroup) <> "" then
      strsql="select groupdiscount,grouppriority,groupid from groups where (grouppriority <> 0 and grouppriority is not NULL) and groupid in ("& CustomerProductGroup &") order by grouptype desc, grouppriority asc"
   else
      strsql="select c.groupdiscount,c.grouppriority,c.groupid from customergroups a,groups c where (c.grouppriority <> 0 and c.grouppriority is not NULL) and a.groupsid = c.groupid and a.contactid = "& contactid &" order by c.grouptype desc, c.grouppriority asc"
   end if

   Set sqlrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
   sqlrs.open strsql, dbc, adOpenKeyset, adLockReadOnly

   if not sqlrs.eof then
      tempvalue = sqlrs("groupdiscount")
	  if isnull(tempvalue) then tempvalue = 0
   else
      '800 - 2016.01.22 - Enhancement: Customer Prices: Speed Enhancement
	  if trim(CustomerProductGroup) <> "" then
	     strsql2="select groupdiscount,grouppriority,groupid from groups where (grouppriority = 0 or grouppriority is NULL) and groupid in ("& CustomerProductGroup &") order by grouptype desc, groupname asc"
	  else
	     strsql2="select c.groupdiscount,c.grouppriority,c.groupid from customergroups a,groups c where (c.grouppriority = 0 or c.grouppriority is NULL) and a.groupsid = c.groupid and a.contactid = "& contactid &" order by c.grouptype desc, c.groupname asc"
      end if

      Set sqlrs2 = Server.CreateObject("ADODB.Recordset")

	  '800 - 2015.08.06 - Speed perforamnce on customer groups routines
      sqlrs2.open strsql2, dbc, adOpenKeyset, adLockReadOnly

      if not sqlrs2.eof then
         tempvalue = sqlrs2("groupdiscount")
	     if isnull(tempvalue) then tempvalue = 0
      else
         tempvalue = 0
      end if
      closerecordset sqlrs2

   end if
   closerecordset sqlrs
   
   getgroupdiscount = tempvalue
end function

function getgrouppropricefield(contactid)
   if trim(contactid) = "" then
      getgrouppropricefield = ""
      exit function
   end if
   if isnumeric(contactid) = false then
      getgrouppropricefield = ""
      exit function
   end if

   dim sqlrs,strsql,tempvalue
   dim sqlrs2,strsql2

   '800 - 2016.01.22 - Enhancement: Customer Prices: Speed Enhancement
   dim CustomerProductGroup
   CustomerProductGroup = session("Customerproductgroup")
   if trim(CustomerProductGroup) <> "" then
      strsql="select grouppropricefield,grouppriority from groups where (grouppriority <> 0 and grouppriority is not NULL) and groupid in ("& CustomerProductGroup &") order by grouptype desc, grouppriority asc"
   else
      strsql="select c.grouppropricefield,c.grouppriority from customergroups a,groups c where (c.grouppriority <> 0 and c.grouppriority is not NULL) and a.groupsid = c.groupid and a.contactid = "& contactid &" order by c.grouptype desc, c.grouppriority asc"
   end if

   Set sqlrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.08.06 - Speed perforamnce on customer groups routines
   sqlrs.open strsql, dbc, adOpenKeyset, adLockReadOnly

   if not sqlrs.eof then
      tempvalue = sqlrs("grouppropricefield")
	  if isnull(tempvalue) then tempvalue = ""
   else
      '800 - 2016.01.22 - Enhancement: Customer Prices: Speed Enhancement
	  if trim(CustomerProductGroup) <> "" then
	     strsql2="select grouppropricefield,grouppriority from groups where (grouppriority = 0 or grouppriority is NULL) and groupid in ("& CustomerProductGroup &") order by grouptype desc, groupname asc"
	  else
	     strsql2="select c.grouppropricefield,c.grouppriority from customergroups a,groups c where (c.grouppriority = 0 or c.grouppriority is NULL) and a.groupsid = c.groupid and a.contactid = "& contactid &" order by c.grouptype desc, c.groupname asc"
      end if

      Set sqlrs2 = Server.CreateObject("ADODB.Recordset")

	  '800 - 2015.08.06 - Speed perforamnce on customer groups routines
      sqlrs2.open strsql2, dbc, adOpenKeyset, adLockReadOnly

      if not sqlrs2.eof then
         tempvalue = sqlrs2("grouppropricefield")
	     if isnull(tempvalue) then tempvalue = ""
      else
         tempvalue = ""
      end if
      closerecordset sqlrs2

   end if
   closerecordset sqlrs
   
   getgrouppropricefield = tempvalue
end function
%>