<!--#include file="shopcustomerprices.asp"-->
<!--#include file="shopyoutube.asp"-->
<!--#include file="shopprocat.asp"-->
<!--#include file="shoptax.asp"-->
<!--#include file="shopnewproductsub.asp"-->
<!--#include file="shopcrosssellingsubs.asp"-->
<!--#include file="shopstocknotification.asp" -->
<!--#include file="shoptellfriendsubs.asp"-->
<!--#include file="shopreviewssubs.asp"-->
<!--#include file="shopimageswatches.asp"-->
<!--#include file="shopprotabs.asp"-->
<!--#include file="shopsharesub.asp"-->
<!--#include file="shop_min_max_quatity_subs.asp"-->
<!--#include file="shop_compareproducts_subs.asp"-->
<!--#include file="shop_emaildownloadlink_subs.asp"-->
<!--#include file="shop_questions_subs.asp"-->
<!--#include file="shopproductformat.asp"-->
<!--#include file="shopproductformat_frontside_subs.asp"-->
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Merge Templates with Database
'*********************************************************************************

const pfieldnames=1
const pfieldvalues=2
const pfieldtypes=3
const pfieldcount=4
const ptableflag=5
const pTemplatedisplay=6
const pTemplaterray=7
const ptokenformat=8
const pIDField=9
const pidvalue=10
const ptokens=11
const pdatacurrentrecord=12
const pdata=13
const pdatarecordcount=14
const pdatainmemory=15
const pparseattributes=16

'filename to be opened
'rc=4 if file cannot be found
'returns fsObj and RecordObj
'take care the virtual directory issues
sub OpenInputFile (filename, fsObj, RecordObj, rc)
   '701 - 2010.12.21 - Bug Fix: Possible error while opening text file
   filename = replace(trim(filename),chr(13),"")

   if lcase(left(filename,10)) = "templates/" then filename = xmysite2 & "/" & filename
   on error resume next
   dim whichfile, dbfile, xtemplate, cmpstr1, cmpstr2, cmpstr3
   xtemplate = getconfig("xtemplate")
   cmpstr1 = lcase(filename)
   cmpstr2 = lcase(xmysite2 & "/templates/"& xtemplate &"/")
   dbfile=left(replace(cmpstr1,cmpstr2,""),3)
   if lcase(dbfile)="db=" then
      OpenInputFiledb replace(cmpstr1,cmpstr2,""), fsObj, RecordObj, rc
      exit sub
   end if
   
   dim dpos, dposstr
   dpos = instr(cmpstr1,"/" & "templates/")
   if dpos = 0 then dpos = instr(cmpstr1,"\" & "templates\")
   dposstr = mid(filename, dpos, len(filename) - dpos + 1)
   
   dim realfilename
   realfilename = lcase(dposstr)
   cmpstr2 = lcase("/" & "templates/" & xtemplate & "/")
   cmpstr3 = lcase("\" & "templates/" & xtemplate & "\")
   realfilename = replace(realfilename,cmpstr2,"")
   realfilename = replace(realfilename,cmpstr3,"")

   '700 - getting real subfolder name
   dim infolder
   infolder = server.mappath(filename)
   infolder = replace(lcase(infolder),lcase(dposstr),"")
   infolder = replace(lcase(infolder),replace(lcase(dposstr),"/","\"),"")

   whichfile=infolder & "\" & "templates\" & xtemplate & "\" & realfilename

   '700 - 2010.05.13 - Enhancement: Import text file using UTF8Filer class
   if lcase(getconfig("xReadTextUTF8Filer")) = "yes" and instr(lcase(realfilename),".txt") > 0 then
      Set RecordObj = New UTF8Filer
      RecordObj.UnicodeCharset = "utf-8"
      RecordObj.LoadFile(whichfile)
      RecordObj.cTextBuffer2Unicode
	  session("fromutf8codepage") = "Yes"
   else
      '701 - 2010.11.16 - Enhancement: To support directly inserting double byte characters to templates
	  Set fsObj = CreateObject("ADODB.Stream")
	  fsObj.Type = 2 '' # Text
	  fsObj.Open 
	  fsObj.CharSet = "UTF-8"
	  fsObj.LoadFromFile whichfile
	  fsObj.LineSeparator = 10 '' # Linefeed
	  set recordobj = fsobj
		
	  session("fromutf8codepage") = ""
   end if

   if err.number > 0 then
      rc=4

	  '700 - 2010.05.13 - Enhancement: Import text file using UTF8Filer class
	  if lcase(session("fromutf8codepage")) <> "yes" then
         fsObj.close
         set fsObj=nothing
      else
	     set RecordObj = nothing
      end if

   else
      rc=0
   end if
end sub

'close a file
'700 - 2010.05.13 - Enhancement: Import text file using UTF8Filer class
sub CloseFile (fsObj, RecordObj, rc, parsearray)
   if parsearray(pdatainmemory)="Yes" then exit sub

   if lcase(session("fromutf8codepage")) <> "yes" then
      set RecordObj = nothing
      set fsObj = nothing
   else
      set RecordObj = nothing
   end if
   rc=0
end sub

'reads and entire file Template into a memory array
'creates and array of converted records
sub ShopTemplateArray(Filename, RS, Outarray, Outcount)
dim parsearray, fieldnames, fieldvalues, fieldtypes, fieldcount

'6.50 - updated to 150 from 100
'701 - 2010.12.01 - Bug Fix: Possible error if fields are more than 150 for templates
'800 - 2015.07.20 - Better handling on number of fileds on templates
redim fieldnames(300)
redim fieldvalues(300)
redim fieldtypes(300)

redim parsearray(Pparseattributes)
dim i
dim NewRecord
dim fs,ts
dim rc
dim Bypass
dim tempcount

'700 moving to Template folder
dim xTemplate
dim tempfilename,tempfilename2
xTemplate= "Templates/" & GetConfig("xTemplate") & "/"
tempfilename=xTemplate & Filename
tempfilename2=Filename
OpenInputFile tempfilename, fs, ts, rc
if rc> 0 then
   ShopWriteError  GetLang("LangReadFail")  & tempfilename  
   exit sub
end if
GetFieldValues RS, fieldnames, fieldvalues, fieldtypes, fieldcount
dim Temparray
tempcount=ubound(outarray)
redim temparray(tempcount)
outcount=0
SetupParseArray Parsearray, tempfilename2, rs, fieldnames, fieldvalues, fieldtypes, fieldcount, fs, ts
ReadEntireFile fs, ts, Tempcount, TempArray, parsearray
CloseFile fs,ts, rc, parsearray
for i = 0 to tempcount - 1
   Substitute Temparray(i), NewRecord, Bypass, parsearray, rs
   if Bypass=False  then
      OutArray(outcount)=NewRecord
      outcount=outcount+1
   end if
next
end sub

sub SetupParseArray (Parsearray, filename, rs, fieldnames, fieldvalues, fieldtypes, fieldcount, fsoobj,recordobj)
dim data, datacount, rc, dbfieldname
redim parsearray(Pparseattributes)
parsearray(pfieldnames)=fieldnames
parsearray(pfieldvalues)=fieldvalues
parsearray(pfieldtypes)=fieldtypes
parsearray(pfieldcount)=fieldcount
parsearray(ptableflag)=""
parsearray(pTemplatedisplay)="No"
parsearray(pIDField)=rs(0).name
parsearray(pidvalue)=rs(0).value

'701.2011.11.22 - Bug Fix: Not able to translate home page random/new product if using sqlserver and xsortproducts is set
if lcase(rs(0).name) = "rownumber" then
   parsearray(pIDField)=rs(1).name
   parsearray(pidvalue)=rs(1).value
end if

parsearray(pdatarecordcount)=0
parsearray(pdatainmemory)=""
CheckFiledb filename,dbfieldname,rc
if rc=0 then
   redim data(500)
   ReadEntireFileDB  fsoobj, RecordObj, datacount,data,parsearray
   parsearray(pdata)=data
   parsearray(pdatarecordcount)=datacount
   parsearray(pdatacurrentrecord)=0
   parsearray(pdatainmemory)="Yes"
end if
end sub

'writes each record to browser
sub ShopTemplateWrite(Filename, RS, orc)
dim i
dim NewRecord
dim recordObj, FsObj
dim rc
dim MyText
dim readcount
dim Bypass

'700 moving to Template folder
dim xTemplate
dim tempfilename,tempfilename2
xTemplate= xmysite2 & "/" & "Templates/" & GetConfig("xTemplate") & "/"
tempfilename=xTemplate & Filename
tempfilename2=Filename

OpenInputFile tempfilename, fsObj, RecordObj, rc
if rc> 0 then
   ShopWriteError  GetLang("LangReadFail")  & tempfilename
   orc=4
   exit sub
end if
dim parsearray, fieldnames, fieldvalues, fieldtypes, fieldcount

'701 - 2010.12.01 - Bug Fix: Possible error if fields are more than 150 for templates
'800 - 2015.07.20 - Better handling on number of fileds on templates
redim fieldnames(300)
redim fieldvalues(300)
redim fieldtypes(300)

redim parsearray(Pparseattributes)
readcount=0
GetFieldValues RS, fieldnames, fieldvalues, fieldtypes, fieldcount
SetupParseArray Parsearray, tempfilename2, rs, fieldnames, fieldvalues, fieldtypes, fieldcount, fsobj, recordobj
Parsearray(pTemplateDisplay)="Yes"
ReadARecord RecordObj, MyText, rc, parsearray
do while rc=0
   Substitute mytext, NewRecord, Bypass, parsearray, rs
   if Bypass=False  then
      response.write NewRecord & vbcrlf
   end if
   readcount=readcount+1
   ReadARecord RecordObj, MyText, rc, parsearray
loop
CloseFile fsObj,RecordObj, rc, parsearray
orc=0
end sub

sub ReadEntireFile (fsoobj, RecordObj, readcount, readarray,parsearray)
dim rc
dim mytext, data, i
if parsearray(pdatainmemory)="Yes" then
   data=parsearray(Pdata)
   for i = 0 to parsearray(pdatarecordcount)-1
      readarray(i)=data(i)
   next
   readcount=parsearray(pdatarecordcount)
   exit sub
end if
rc=0
readcount=0
ReadARecord RecordObj, MyText, rc, parsearray
do while rc=0
   readarray(readcount)=mytext
   readcount=readcount+1
   ReadARecord RecordObj, MyText, rc, parsearray
loop
end sub

'700 - 2010.05.13 - Enhancement: Import text file using UTF8Filer class
sub ReadARecord (RecordObj, record, rc,parsearray)
   if parsearray(Pdatainmemory)="Yes" then
      ReadARecordDB RecordObj, record, rc,parsearray
      exit sub
   end if

   if lcase(session("fromutf8codepage")) <> "yes" then
	  '701 - 2010.11.16 - Enhancement: To support directly inserting double byte characters to templates
	  if RecordObj.EOS then
         rc=4
         exit sub
      end if
   else
      if RecordObj.eof then
         rc = 4
         exit sub
      end if
   end if
   
   '701 - 2011.02.17 - Bug Fix: Error with text file while xReadTextUTF8Filer is Yes
   if lcase(session("fromutf8codepage")) = "yes" then
      record = RecordObj.readline
   else
      '701 - 2010.11.16 - Enhancement: To support directly inserting double byte characters to templates
      record = recordObj.ReadText(-2)
   end if
   
   rc=0
end sub

function Find_Replace(srchString, FndString, InsertString,   strend )
dim i, LastChar, Next_Pos
dim CurrentPos, LastPos
dim tempstring

if strend > 0 then
   LastChar = strend
else
   LastChar = Len(srchString)
end if
tempstring = srchString
Next_Pos = 0
Next_Pos = InStr(Next_Pos + 1, tempstring, FndString)
do until (Next_Pos = 0) Or (Next_Pos > LastChar)
   tempstring = Left(tempstring, Next_Pos - 1) & InsertString & Right(tempstring, (Len(tempstring) - Len(FndString) - (Next_Pos - 1)))
   LastChar = LastChar - Len(FndString) + Len(InsertString)
   Next_Pos = 0
   Next_Pos = InStr(Next_Pos + 1, tempstring, FndString)
loop
Find_Replace = tempstring
end function

sub Substitute (inrecord, workrecord, Bypass, parsearray, parseRS)
   dim tokenformat
   dim tokens(5)
   dim tokencount
   dim rc
   dim morefields
   dim dbindex
   dim dbfieldname
   dim dbvalue
   dim dbvalue1
   dim token
   dim Newrecord
   dim fieldfound
   dim pos
   dim endpos
   dim specchar
   dim dbvalue2
   dim firstchar
   dim length
   pos = 1
   Bypass=False
   workrecord = inrecord
   morefields = True

   'VP-ASP 6.50.4 Bugs Fix - 08 October 2008
   fieldfound = ""        'used to determine if record is ouput if starts with a $
   firstchar = Left(workrecord, 1) ' save first character
   do while morefields = True
      pos = InStr(pos, workrecord, "[")
      if pos > 0 then
         endpos = InStr(pos, workrecord, "]")
         if endpos=0 then
		    '800 - 2015.04.24 - Include more info if trigger Missing ] on field
            WriteError "Missing ] on field "& workrecord &" starting at " & Pos

            morefields=false
         else
       	    length = endpos - pos + 1
	        tokenformat=""
    	    token = Mid(workrecord, pos, length)
	        specchar = Mid(token, 2, 1)
    	    dbfieldname = Mid(token, 2, length - 2)
	        ParseRecord dbfieldname, tokens, tokencount, " "
    	    if tokencount> 1 then
      	       dbfieldname=tokens(1)
		       tokenformat=ucase(tokens(0))      ' formatcurrency, formatnumber
            end if

 	        '6.50 - translate GetLang in Templates
	        if lcase(tokenformat)="getlang" then
	           handle_GetLang dbfieldname, dbvalue
    	       Newrecord = Find_Replace(workrecord, token, dbvalue, 0)
	           workrecord = Newrecord
    	    else
			   '700 - home page manager - random products
			   select case lcase(tokenformat)
			      case else
                     '6.50.4 Bugs Fix - 08 October 2008
        	         Parsearray(ptokenformat)=tokenformat
			   
	                 Parsearray(ptokens)=tokens
  		             FindField dbfieldname, dbvalue, rc, parsearray, parseRS
		             if rc > 0 then exit sub

					 '800 - 2015.09.24 - Bug Fix: Template not displaying properly if value returned "["
					 if instr(dbvalue,"[") > 0 then
					    dbvalue = replace(dbvalue,"[","***--*--***")
					 end if

		             Newrecord = Find_Replace(workrecord, token, dbvalue, 0)
                     if dbvalue <> "" then
                        if fieldfound <> False then
                           fieldfound = True ' used to determine if record written
                        end if
                     else
                        fieldfound = False 
                     end if
					 
					 '701 - 2011.02.16 - Bug Fix: Email should not convert the crlf to br
					 if istable(Newrecord) = false and session("templatefrommail") = "" then
					    workrecord = replace(Newrecord,vbcrlf,"<br />")
                     else
					    workrecord = Newrecord
					 end if
			   end select
	        end if
		 end if
      else
         morefields = False
      end if
   loop

   '800 - 2015.09.24 - Bug Fix: Template not displaying properly if value returned "["
   workrecord = replace(workrecord,"***--*--***","[")

   'at this point if record starts with a $ and no fields Substituted, do not write it
   if firstchar = "$" then
      if fieldfound = False then
         workrecord=""
         Bypass=True
         exit sub
      else
         length = Len(workrecord) - 1
         Newrecord = Mid(workrecord, 2, length)
         workrecord = Newrecord
         bypass=False
      end if
   end if
   Bypass=False
end sub

sub WriteError (msg)
   ShopWriteError  msg
end sub

sub FindField(fieldname, value, rc, parsearray, parsers)
   dim i
   dim temparea
   dim ucfieldname
   dim Fieldtype
   ucfieldname = UCase(fieldname)
   rc = 0
   ProcessKeyword ucfieldname, value, rc, parsearray, parseRS
   if rc = 0 then exit sub
   rc = 0

   '702 - 2012.10.30 - Enhancement: Better handling if not able to retrieve product field
   on error resume next
   '701 - 2011.02.16 - Enhancement: Speed enhancement
   temparea = parsers(ucfieldname)
   '702 - 2012.10.30 - Enhancement: Better handling if not able to retrieve product field
   '702 - 2012.11.22 - Enhancement: Better handling if no found code placement in template
   if err.number <> 0 then
      on error goto 0
	  on error resume next
      temparea = parsers("p." & ucfieldname)
	  if err.number <> 0 then
	     rc = 4
	  end if
	  on error goto 0
   end if
   on error goto 0
   if isnull(temparea) then temparea = ""
   
   '701 - 2010.11.02 - Bug Fix: Char [, ] issue while using templates
   temparea = replace(temparea,"[","&#91;")
   temparea = replace(temparea,"]","&#93;")

   if rc > 0 then
      WriteError  "Field " & fieldname & " " &  GetLang("LangDatabaseFail")
      value=""
      exit sub
   end if

   if temparea="" then
      value=""
      exit sub
   end if
   DoSpecialFormating temparea, Parsearray, parseRS
   value = temparea
end sub

sub FindInDatabase (fieldname, fieldvalue, fieldtype, rc, parsearray)
dim i
dim fieldcount, fieldvalues, fieldtypes, fieldnames
fieldname=ucase(fieldname)
fieldcount=parsearray(pfieldcount)
fieldnames=parsearray(pfieldnames)
fieldvalues=parsearray(pfieldvalues)
fieldtypes=parsearray(pfieldtypes)
for i=0 to fieldcount
   if fieldname=Fieldnames(i) then
      fieldvalue=fieldvalues(i)
      fieldtype=fieldtypes(i)

	   '6.50 - show placeholder if no image is available
	   if lcase(fieldname)="cimageurl" then
	      if fieldvalue="" then
	         fieldvalue=GetConfig("xnoimage")
	       end if
	   end if
	   if lcase(fieldname)="extendedimage" then
	      if fieldvalue="" then
	         fieldvalue=GetConfig("xnoimage")
	      end if
	   end if
      rc=0
      exit sub
   end if
next
rc=4
fieldvalue=""
end sub

sub ProcessKeyword (keyword, value, rc, parsearray,parseRS)
   dim tokenformat
   tokenformat=parsearray(ptokenformat)
   rc=4

   select case keyword
      case "ADD_OITEMS"
         Handle_OITEMS value, parsearray,parseRS
         rc=0
	   '6.50 - call random product display from Template
   	   case "ADD_RANDOMPRODUCTS"
         Handle_RANDOMPRODUCTS value, parsearray
         rc=0
      case "ADD_PAGEHEADER"
         Handle_PAGEHEADER value, parsearray
         rc=0
      case "ADD_PAGETRAILER"
         Handle_PageTrailer value, parsearray
         rc=0
      case "SPECIAL_ORDERBUTTON"
         Handle_SpecialOrderButton value,parsearray,parseRS
         rc=0
      case "SPECIAL_CHECKBOX"
         Handle_SpecialCheckbox value,parsearray,parseRS
         rc=0
      case "ADD_FORMSTART"
	     '7.00 - added xMySite call
		 Handle_FormStart "User",parsearray, genredirecturl("shopaddtocart.asp")
         rc=0
      case "ADD_FORMEND"
         Handle_FormEnd "User",parsearray
         rc=0
      case "ADD_PRODUCTFEATURES"
         Add_ProductFeatures "User",parsearray,"", parseRS
         rc=0
      case "ADD_QUANTITY"
	     '6.5.1 - don't display this if xpriceloggedinonly = True and customer isn't logged in
		 if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
	        rc=0
		 else
            Add_Quantity "User",parsearray,parseRS
            rc=0
	   	 end if
      case "ADD_ORDERBUTTON"
	   	 '6.5.1 - don't display this if xpriceloggedinonly = True and customer isn't logged in
		 if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
	        rc=0
		 else
            Add_Button "User",parsearray,parseRS
            rc=0
		 end if
      case "ADD_CHECKBOX"
         '6.5.1 - don't display this if xpriceloggedinonly = True and customer isn't logged in
		 if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
		    rc=0
		 else
		    '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
            Add_Checkbox "User",parsearray,parseRS
            rc=0
		 end if
      case "ADD_TABLE"
         Add_Table "User",parsearray
         rc=0
      case "ADD_TABLEEND"
         Add_TableEnd "User",parsearray
         rc=0
      case "ADD_PRODUCT"
	     '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
         Add_Product "User",parsearray, parseRS
         rc=0
      case "INCLUDE"
	     '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
         Handle_Include value,parsearray, parseRS
         rc=0
      case "ADD_CROSSSELLING"
         Handle_CROSSSELLING value,parsearray, parseRS
         rc=0
      case "SUB"
	     select case ucase(tokenformat)
		    '700 - New Products Widget
		    case "DISPLAYNEWPRODUCTS"
			   displaynewproducts "Yes"
			   rc=0
       	    '800 - Generate front page image
	        case "FORMATPRODIMAGE_FRONT_SIDE"
		       handle_formatprodimage_front_side value,parsearray, parseRS
			   rc = 0
            case else
               '800 - 2015.05.17 - Better handling on routine handle_product
			   Handle_Product ucase(tokenformat), value, parseRS
			   rc=0
		 end select
      case "ADD_OITEMSTEMPLATE"
         Handle_OITEMSTemplate value, parsearray, parseRS
         rc=0
      case "ADD_OITEMTOTAL"
         Handle_OitemTotal value, parsearray, parseRS
         rc=0
      case "ADD_OITEMDELIVERY"
         Handle_OitemDelivery value, parsearray, parseRS
         rc=0
      case "ADD_RATINGSUMMARY"
         Handle_RatingSummary value, parsearray, parseRS
         rc=0
      '6.50 - add handler to show/hide review links
      case "ADD_REVIEWLINKS"
         Handle_ReviewLinks value, parsearray, parseRS
  	     rc=0
  	  '6.50 - add handler to show/hide add to comparison link
      case "ADD_COMPARELINKS"
         Handle_CompareLinks value, parsearray, parseRS
	      rc=0
      case "ADD_INVENTORYPRODUCTS"
         Handle_INVENTORYPRODUCTS value,parsearray, parseRS
         rc=0
      case "INVOICE_OITEMS"
         Handle_INVOICEOITEMS value,parsearray, parseRS
         rc=0
      case "DISPLAY_QUANTITYDISCOUNTS"
         Handle_QUANTITYDISCOUNTS value,parsearray, parseRS
         rc=0
      case "ADD_WEBSESSLINK"
         Handle_ADDWEBSESSLINK value,parsearray, parseRS
         rc=0
      case "ADD_ALSOBOUGHT"
         Handle_ALSOBOUGHT value,parsearray, parseRS
         rc=0
      case "FORMATBREADCRUMB"
         Handle_Breadcrumb value,parsearray, parseRS
         rc=0
      '6.50 - show the number of sub-categories next to category listing
      case "ADDNUMBERSUBCATS"
         Handle_NumberSubCats value,parsearray, parseRS
         rc=0
      '700 - Change Quantity And Order Button On Product Page
      case "ADD_SUBMITOTHERITEMSBUTTON"
	     handle_submitbutton value,parsearray, parseRS
         rc=0
	  '700 - YouTube
	  case "ADD_YOUTUBE"
	     Handle_youtube value,parsearray, parseRS
		 rc=0 
	  '700 - YouTube
	  case "ADD_MOVIE"
		 Handle_movie value,parsearray, parseRS
		 rc=0 
	  '700 - Category Display Summary On Product Page - show products in same category
	  case "ADD_CATPRODUCTS"
         Handle_procatdisplay value,parsearray, parseRS
         rc=0
	  '700 - Advanced CMS
	  case "FORMATCONTENTHEADLINE"
         Handle_ContentHeadLine value,parsearray, parseRS
         rc=0
	  '700 - Advanced CMS
	  case "FORMATCONTENTMESSAGEHOME"
        Handle_ContentMessageHome value,parsearray, parseRS
        rc=0
	  '700 - News Manager
	  case "FORMATNEWSHEADLINE"
         Handle_NewsHeadLine value,parsearray, parseRS
         rc=0
	  '700 - News Manager
	  case "FORMATNEWSMESSAGEHOME"
         Handle_NewsMessageHome value,parsearray, parseRS
         rc=0
	  case "FORMATNEWSMESSAGEHOMEBOX"
         Handle_NewsMessageHomebox value,parsearray, parseRS
         rc=0
	  '700 - News Manager
	  case "SHOWNEWSHEADLINES"
         ShowNewsHeadlines 10
         rc=0
	  '700 - News Manager
	  case "FORMATNEWSMESSAGE"
         Handle_NewsMessage value,parsearray, parseRS
         rc=0
	  '700 - News Manager
	  case "ADD_NEWSREVIEWLINKS" 
         Handle_NewsReviewLinks value, parsearray, parseRS
	     rc=0
	  case "FORMATNEWSLINK"
         Handle_NewsLink value,parsearray, parseRS
		 rc=0
	  '700 - Blogs Manager
	  case "FORMATBLOGSHEADLINE"
         Handle_BlogsHeadLine value,parsearray, parseRS
         rc=0
	  '700 - Blogs Manager
	  case "FORMATBLOGSMESSAGEHOME"
         Handle_BlogsMessageHome value,parsearray, parseRS
         rc=0
	  case "FORMATBLOGSMESSAGEHOMEBOX"
         Handle_BlogsMessageHomebox value,parsearray, parseRS
         rc=0
	  '700 - Blogs Manager
	  case "SHOWBLOGSHEADLINES"
         ShowBlogsHeadlines 10
         rc=0
	  '700 - Blogs Manager
	  case "FORMATBLOGSMESSAGE"
         Handle_BlogsMessage value,parsearray, parseRS
         rc=0
	  case "FORMATBLOGSLINK"
         Handle_BlogsLink value,parsearray, parseRS
         rc=0
	  '700 - Blogs Manager
	  case "ADD_BLOGSREVIEWLINKS" 
         Handle_BlogsReviewLinks value, parsearray, parseRS
	     rc=0
	  '700 - Product Tabs
	  case "ADD_TELLAFRIEND" 
         displaytellafriendform
	     rc=0
	  case "ADD_REVIEWS"
	     displayreviews
		 rc=0
	  '700 - image swapper
	  case "ADD_IMAGESWATCHES"
	     handle_imageswatches value,parsearray,parseRS
		 rc=0
      case "ADD_TABS"
         Handle_producttabs value,parsearray, parseRS
		 rc=0
      case "ADD_WISHLIST"
         Handle_wishlist value,parsearray, parseRS
		 rc=0
      case "GETSTARRATING"
	     dim starimage
	     GetStars parseRS("rating"), starimage
		 htmlwrite "<img src=""" & starimage & """ class=""vm"" /><br />"
		 rc = 0
	  '700 - SEO
	  case "FORMATSHOPEXDLINK"
         Handle_shopexdlink value,parsearray, parseRS
         rc=0
	  '700 - 2010.04.02 - AddThis
      case "ADD_ADDTHIS"
         Handle_AddThis value,parsearray, parseRS
		 rc=0
	  '700 - 2010.04.02 - PolyVore
      case "ADD_POLYVORE"
         Handle_Polyvore value,parsearray, parseRS
		 rc=0
	  '7.00 - 2010.04.07 - Ask a aquestion
      case "ADD_QUESTION"
         Handle_question value,parsearray, parseRS
		 rc=0
		 
	  '701 - 2011.06.16 - Enhancement: To include Blog / News link in review email
	  case "FORMATBLOGSREVIEWLINK"
         Handle_BlogsReviewLink value,parsearray, parseRS
         rc=0
	  '701 - 2011.06.16 - Enhancement: To include Blog / News link in review email
	  case "FORMATNEWSREVIEWLINK"
         Handle_NewsReviewLink value,parsearray, parseRS
         rc=0
      '800 - mobile enhancement
      case "ADD_EMAILITEMBUTTON"
	     'Bobby - 2012.08.31 - It should be controlled by the config
	     if getconfig("xproductlinktellafriend") = "Yes" and getconfig("xtellafriend") = "Yes" then ShopButtonJS GetConfig("xbuttontellafriend"),getlang("langsendtoafriend"),"","onclick=""location.href='"& session("sitebaseurl") &"shoptellafriend_mobile.asp?id="& parsers("catalogid") &"'"""
         rc=0
      '800 - 2015.07.01 - Page Manager: More Flexibility on templates
      case "FORMATBREADCRUMB_CONTENT"
         Handle_Breadcrumb_content value,parsearray, parseRS
		 rc=0

      '800 - 2015.11.24 - Enhancement: New forgot password process
	  case "BASEURL", "XMYSITE"
	     value = "http://"& request.ServerVariables("HTTP_HOST") & xmysite2 &"/"
	     rc = 0

      '800 - 2016.03.02 - To have blog listing image snippet FORMATBLOG_HOMEPAGE_IMAGE
      case "FORMATBLOG_HOMEPAGE_IMAGE"
	     dim blogsimage, blogslink
		 blogsimage = parsers("blogsimage") 
		 if isnull(blogsimage) then blogsimage = ""
		 if trim(blogsimage) <> "" then 
		    blogslink = "shopblogs.asp?type=" & replace(parsers("messagetype")," ","_") & ""
			genseoblogslink blogslink,parsers("messagetype"),"","No",""
            value = "<a class=""detail_link"" href='"& blogslink &"'>"
            value = value & "<img src='"& blogsimage &"' class='img-responsive'/>"
            value = value & "</a>"
         end if 
         rc = 0

      '800 - 2016.03.02 - To have news listing image snippet FORMATNEWS_HOMEPAGE_IMAGE
      case "FORMATNEWS_HOMEPAGE_IMAGE"
	     dim newsimage, newslink
		 newsimage = parsers("newsimage") 
		 if isnull(newsimage) then newsimage = ""
		 if trim(newsimage) <> "" then 
		    newslink = "shopnews.asp?type=" & replace(parsers("messagetype")," ","_") & ""
			genseonewslink newslink,parsers("messagetype"),"","No",""
            value = "<a class=""detail_link"" href='"& newslink &"'>"
            value = value & "<img src='"& newsimage &"' class='img-responsive'/>"
            value = value & "</a>"
         end if
         rc = 0

   end select 
end sub

sub Handle_shopexdlink (ivalue,parsearray,parseRS)
   '700 - 2010.07.06 - code enhancement
   dim thelngcontentid
   thelngcontentid=parseRS("catalogid")

   if thelngcontentid <> "" then
	  dim mylink

      '700 - 2010.06.02 - Enhancement: Predictive search link / more details should open a popup windows if extended popup is enable
      if GetConfig("XextendedPopup") = "Yes" then
         mylink = "javascript:popUpAjaxSearchLookup('"& xmysite2 &"/shopexd.asp?id="& thelngcontentid &"')"
      else
         if ucase(getconfig("xCrossLinkurl"))="SHOPEXD.ASP" then
            mylink = "shopexd.asp?id="& thelngcontentid &""
         else
            mylink = "shopquery.asp?catalogid="& thelngcontentid &""
         end if
      end if

      '700 - SEO
      genseoproductlink mylink,thelngcontentid,"","No"
	  ivalue = mylink
   end if
end sub

sub Handle_wishlist (ivalue,parsearray,parseRS)
   dim strurl,strmessage,breaker
   breaker = ""
   if GetConfig("xProductwishlist") = "Yes" then
      '800 - Enhanced SEO
      strurl = ""& DoFriendlySEOPage("shopwishlist.asp") &"?action=add&amp;id=" & lngCatalogId

      strurl = addwebsess(strurl)
      strMessage = breaker & "<a href=""" & strURL & """ class=""feature-container"">" & GetLang("Langwishlistsave") & "</a>"
      htmlwrite strMessage
   end if
end sub

sub handle_submitbutton (ivalue,parsearray,parseRS)
   if selectedprodcutsflag = true and getconfig("xproductcatalogonly") <> "Yes" then
      HtmlWrite "<input class=""submitbtn"" name=""OrderSelected"" type=""submit"" value="""& getlang("langadditemselected") &""">"
   end if
end sub

sub DoSpecialFormating (value, parsearray, parseRS)
   '700 - Tax Inclusive/Exclusive Price Display - inclusive price
   dim taxamount, oprice, rctax, taxdone, tax, pst   
   
   dim tokenformat
   tokenformat=parsearray(ptokenformat)
   if tokenformat="" then exit sub
   dim strprice
   dim inventorycheck
   select case ucase(tokenformat)
   case "FORMATCURRENCY"
      if GetConfig("xdisplayprices") <> "No" then
		 if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
			value=""
		 else
            value = ShopFormatCurrency(value,GetConfig("xdecimalpoint"))
		 end if
	  else
		 value = ""
	  end if
   case "DUALPRICE"
      if GetConfig("xdisplayprices") <> "No" then
	     if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
			value=""
		 else
		    '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
            GetDualPricevalue value, strPrice, parsearray, parseRS
			
            value = formatnumber(strprice,GetConfig("xdecimalpoint"))
		 end if
	  else
		 value = ""
	  end if
   case "FORMATNUMBER"
      value = formatnumber(value,GetConfig("xdecimalpoint"))
   case "FORMATDATE"
      value = shopdateformat(value,GetConfig("xdateformat"))
   case "FORMATCUSTOMERPRICE"
      if GetConfig("xdisplayprices") <> "No" then
	  	 if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
		    value=""
		 else
            value = HandleCustomerPrice(value, parsearray, parseRS)

			'800 - 2015.10.09 - Layout: Hiding price if price is 0
			dim passvalueflag
			passvalueflag = false
			if isnull(value) then
			   value = ""
			   passvalueflag = true
			end if
			if isnumeric(value) then
			   if trim(getconfig("xprice0") = "") then
			      if cdbl(value) <= 0 then
				     value = ""
					 passvalueflag = true
				  end if
			   end if
			end if
			if not passvalueflag then value=ShopFormatCurrency(value,GetConfig("xdecimalpoint"))
		 end if
	  else
		 value = ""
	  end if
   case "FORMATTAXINCLUSIVE"
      '700 - Tax Inclusive/Exclusive Price Display - inclusive price
      '800 - 2016.11.18 - Bug Fix: Better hanlding on boolean type for mysql 5.6
      dim taxfreeinclusive
	  taxfreeinclusive = parseRS("taxfree")
	  if isnull(taxfreeinclusive) then taxfreeinclusive = false
	  if instr(ucase(xdatabasetype), "MYSQL") > 0 then
         if cbool(taxfreeinclusive) = true then
            value = ""
            exit sub
         end if
	  else
         if taxfreeinclusive = true or lcase(taxfreeinclusive) = "true" or taxfreeinclusive = 1 or taxfreeinclusive = "1" then
            value = ""
            exit sub
         end if
	  end if

      if GetConfig("xdisplayprices") <> "No" then
	  	 if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
		    value = ""
		 else
		    '700 - 2010.06.22 - Enhancement: Tax inclusive and exclusive checking with Customer Pricing
		    value = HandleCustomerPrice(value, parsearray, parseRS)

            Tax = 0
            taxdone = false
			oprice = value
			taxamount = 0
			rctax = 4
            TaxCheckcustomerexcept dbc, rctax
            if rctax = 0 then
               value = ""
			else
               if ucase(GetSess("country")) = "CA" then
                  TaxbyCanada value, tax, taxdone, dbc, pst
                  if taxdone = True then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value
                     else
					    value = value + taxamount
					 end if
                  else
				     taxamount = 0
                  end if
               end if
			   
			   if taxamount <= 0 then
			      TaxbyState value, tax, taxdone, dbc
                  if taxdone = True then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value
                     else
					    value = value + taxamount
					 end if
                  else
				     taxamount = 0
                  end if
			   end if
			   
			   if taxamount <= 0 then
                  TaxforEU value, tax, taxdone, dbc
                  if taxdone = true then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value
                     else
					    value = value + taxamount
					 end if
                  else
				     taxamount = 0
                  end if
			   end if
			   
			   if taxamount <= 0 then
                  Taxbycountry value, tax, taxdone, dbc
                  if taxdone = true then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value
                     else
					    value = value + taxamount
					 end if
                  else
				     taxamount = 0
                  end if
			   end if
			   
			   if taxamount <= 0 then
                  TaxbyProductID tax, taxdone, value, parseRS("catalogid")
                  if taxdone = true then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value
                     else
					    value = value + taxamount
					 end if
                  else
				     taxamount = 0
                  end if
			   end if
            end if

			'$10.00 inc TAX ; $8.88
			if taxamount > 0 then
               value = ShopFormatCurrency(value,GetConfig("xdecimalpoint")) & " Inc. Tax " & ShopFormatCurrency(taxamount,GetConfig("xdecimalpoint"))
            else
			   value = ""
			end if
		 end if
	  else
		 value = ""
	  end if
   case "FORMATTAXEXCLUSIVE"
      '700 - Tax Inclusive/Exclusive Price Display - exclusive price
      '800 - 2016.11.18 - Bug Fix: Better hanlding on boolean type for mysql 5.6
      dim taxfreeexclusive
	  taxfreeexclusive = parseRS("taxfree")
	  if isnull(taxfreeexclusive) then taxfreeexclusive = false
	  if instr(ucase(xdatabasetype), "MYSQL") > 0 then
         if cbool(taxfreeexclusive) = true then
            value = ""
            exit sub
         end if
	  else
         if taxfreeexclusive = true or lcase(taxfreeexclusive) = "true" or taxfreeexclusive = 1 or taxfreeexclusive = "1" then
            value = ""
            exit sub
         end if
	  end if

      if GetConfig("xdisplayprices") <> "No" then
	  	 if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
		    value = ""
		 else
		    '700 - 2010.06.22 - Enhancement: Tax inclusive and exclusive checking with Customer Pricing
		    value = HandleCustomerPrice(value, parsearray, parseRS)
			
            Tax = 0
            taxdone = false
			oprice = value
			taxamount = 0
			rctax = 4
            TaxCheckcustomerexcept dbc, rctax
            if rctax = 0 then
               value = ""
			else
               if ucase(GetSess("country")) = "CA" then
                  TaxbyCanada value, tax, taxdone, dbc, pst
                  if taxdone = True then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value - taxamount
                     else
					    value = value
					 end if
                  else
				     taxamount = 0
                  end if
               end if
			   
			   if taxamount <= 0 then
			      TaxbyState value, tax, taxdone, dbc
                  if taxdone = True then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value - taxamount
                     else
					    value = value
					 end if
                  else
				     taxamount = 0
                  end if
			   end if
			   
			   if taxamount <= 0 then
                  TaxforEU value, tax, taxdone, dbc
                  if taxdone = true then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value - taxamount
                     else
					    value = value
					 end if
                  else
				     taxamount = 0
                  end if
			   end if
			   
			   if taxamount <= 0 then
                  Taxbycountry value, tax, taxdone, dbc
                  if taxdone = true then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value - taxamount
                     else
						value = value
					 end if
                  else
				     taxamount = 0
                  end if
			   end if
			   
			   if taxamount <= 0 then
                  TaxbyProductID tax, taxdone, value, parseRS("catalogid")
                  if taxdone = true then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value - taxamount
                     else
						value = value
					 end if
                  else
				     taxamount = 0
                  end if
			   end if
            end if

			'$10.00 inc TAX ; $8.88
			if taxamount > 0 then
               value = ShopFormatCurrency(value,GetConfig("xdecimalpoint")) & " Exc. Tax " & ShopFormatCurrency(taxamount,GetConfig("xdecimalpoint"))
            else
			   value = ""
			end if
		 end if
	  else
		 value = ""
	  end if	  

   case "URLENCODE"
      value = server.urlencode(value)
   case "FORMATSAVING"
      if GetConfig("xdisplayprices") <> "No" then
	  	 if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
			value=""
		 else
            value = HandlePriceSaving(value, parsearray,parseRS)
            if value<>"" then
               value=ShopFormatCurrency(value,GetConfig("xdecimalpoint"))
            end if
	     end if
	  else
		 value = ""
	  end if
   case "FORMATTIME"
      value = formatdatetime(value,vbshorttime)
   case "DUALCUSTOMERPRICE"
	  if GetConfig("xdisplayprices") <> "No" then
	  	 if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
			value=""
		 else
		    value = HandleCustomerPrice(value, parsearray, parseRS)
  	   	    ConvertCurrency value, strPrice
		    value = formatnumber(strprice,GetConfig("xdecimalpoint"))
		 end if
	  else
		 value = ""
      end if
   case "DUALSAVING"
	  if GetConfig("xdisplayprices") <> "No" then
	  	 if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
			value=""
		 else
		    value = HandlePriceSaving(value, parsearray,parseRS)
		    if value<>"" then
	           ConvertCurrency value, strPrice
		       value = formatnumber(strprice,GetConfig("xdecimalpoint"))
		    end if
		 end if
	  else
		 value = ""
	  end if
   case "FORMATIMAGE"
      value = HandleFormatImage(value)
   case "FORMATOITEMTOTAL"
      value = Handleformatoitemtotal(value)
   case "FORMATCURRENCYCONVERSION"
      value=HandleFormatCurrencyConversion (value, parsearray,parseRS)
   case "TRANSLATE"
      Handle_Translate value,parsearray, parseRS
   case "TRANSLATEBLOGS"
      Handle_Translateblogs value,parsearray, parseRS
   case "TRANSLATENEWS"
      Handle_Translatenews value,parsearray, parseRS
   '6.09 - Remove HTML from meta and title tags
   case "CLEANSEHTML"
      Handle_cleansehtml value,parsearray, parseRS
   '6.09 - Translate keywords in shopdisplayproducts.asp and shopexd.asp
   case "GetLang"  
      Handle_GetLang value,parsearray, parseRS

   '7.00.1 - cross selling / also bought
   case "FORMATCROSSCHECKBOX"
	  dim strhassubproduct,fieldtype,rc,strfeatures

	  '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
	  strhassubproduct = parsers("HASSUBPRODUCT")
	  strfeatures = parsers("FEATURES")
	  
	  if getconfig("xcrossselling")="Yes" then
	     if instr(lcase(request.ServerVariables("script_name")),"shopaddtocart.asp")>0 then
	        value=""
		 else
		    '701 - 2011.03.22 - Bug Fix: xoutofstocklimit is not working with cross-selling, category-crossselling, also bought
		    dim tempcstock, xoutofstocklimit, temppassflag
			tempcstock = parsers("cstock")
			temppassflag = true
			if isnull(tempcstock) then tempcstock = 0
			if trim(tempcstock) = "" then tempcstock = 0
			xoutofstocklimit = getconfig("xoutofstocklimit")
			if isnull(xoutofstocklimit) then
			   temppassflag = true
            elseif trim(xoutofstocklimit) = "" then
			   temppassflag = true
			elseif isnumeric(xoutofstocklimit) = false then
			   temppassflag = true
			else
			   if cdbl(tempcstock) > cdbl(xoutofstocklimit) then
			      temppassflag = true
			   else
			      temppassflag = false
			   end if
			end if
			
			'701 - 2011.03.22 - Bug Fix: xoutofstocklimit is not working with cross-selling, category-crossselling, also bought
		    if strhassubproduct="Yes" or (strfeatures<>"" and isnull(strfeatures)=false) or getconfig("xproductcatalogonly") = "Yes" or temppassflag = false then
			   '800 - 2016.01.20 - Bug Fix: Not able to add cross-selling product to cart
		       value="<a href='shopexd.asp?id="& parsers("CATALOGID") &"'>" & getlang("LangCommonView") & "</a>"

	           '700 - SEO
	           dim seocatalogid

			   '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
			   seocatalogid = parsers("CATALOGID")
			   
	           genseoproductlink value,seocatalogid,getlang("LangCommonView"),"Yes"
		    else
			   '800 - 2016.01.20 - Bug Fix: Not able to add cross-selling product to cart
	           value="<input type='checkbox' name='catalogid' value='"& parsers("CATALOGID") &"'>"
			end if
		 end if
	  else
	     value=""
      end if
   end select
end sub

'Template format order items
'expects dbc to be open as open connection
sub Handle_OITEMS (body, parsearray,parseRS)
dim Isql, deliveryaddress, deliveryarray
dim orderid
dim rsitems
dim recordid
dim CR, itemname
dim downloadlink
recordid=parsearray(pidvalue)
if ucase(GetSess("emailformat"))="HTML" then
   CR="<br />"
else
   CR = GetMailCR
end if
isql="select * from oitems where orderid="
if GetSess("oid")<>"" then
   Orderid=GetSess("oid")
else
   Orderid=recordid
end if
Body=""
ISql=Isql & Orderid
Set rsitems = Server.CreateObject("ADODB.Recordset")
'700 - 2010.09.26 - Enhancement: Speed up front store performance
'800 - 2016.03.10 - Better DB handling
rsitems.open Isql, dbc, adOpenStatic, adLockReadOnly
do while Not RSItems.EOF
   itemname=rsitems("itemname")
   if GetConfig("xdeliveryaddress")="Yes" then
      deliveryaddress=rsitems("address")
      if not isnull(Deliveryaddress)  and Deliveryaddress<>"" then
         ConvertDeliveryToArray DeliveryArray, Deliveryaddress
         GetDeliveryName Itemname, DeliveryArray
      end if
   end if
   if ucase(GetSess("emailformat"))<>"HTML" then
      Itemname=RemoveHtmlFileio(itemname, CR)
   end if
   Body = Body & CR & Itemname & CR
   Body = Body &  GetLang("LangProductQuantity") & ": " & RSItems("numitems")  & CR
   if GetConfig("xDisplayPrices")<>"No" then
      Body = Body &  GetLang("LangProductPrice") & ": " & ShopFormatCurrency(RSItems("unitprice"),GetConfig("xdecimalpoint")) & CR
   end if
   if GetConfig("xendoforderhyperlinkemail")="Yes" or GetConfig("xdownloadsemail")="Yes" then
      downloadlink=GetEmaildownloadLink(RSItems("CatalogId"))
      if downloadlink <> "" then
         Body = Body & GetLang("LangorderDownload") & ": " & downloadLink  & CR
      end if
   end if
   RSItems.MoveNext
loop
rsitems.close
Set rsitems=nothing
end sub

'700 - 2010.04.23 - Bug Fix - not able to read xmaillist template
sub ShopReadEntireFile(Filename, Outarray, Outcount, parsearray)
   dim i
   dim NewRecord
   dim fs,ts
   dim rc

   '700 moving to Template folder
   dim xTemplate
   dim tempfilename
   xTemplate = xmysite2 & "/" & "Templates/" & GetConfig("xTemplate") & "/"
   tempfilename = xTemplate & Filename

   outcount=0
   OpenInputFile tempfilename, fs, ts, rc
   if rc> 0 then
      exit sub
   end if
   ReadEntireFile fs, ts, Outcount, OutArray, parsearray
   CloseFile fs,ts, rc, parsearray
   rc=0
end sub

sub Handle_PageHeader (value, parsearray)
dim Templatedisplay
Templatedisplay=parsearray(pTemplatedisplay)
Value=""
if TemplateDisplay="No" then exit sub
ShopPageHeader
end sub

'6.50 - call random product display from Template
sub Handle_RandomProducts (value, parsearray)
   dim Templatedisplay
   Templatedisplay=parsearray(pTemplatedisplay)
   Value=""
   if TemplateDisplay="No" then exit sub
   Displayrandomproducts
end sub

sub Handle_PageTrailer (value, parsearray)
dim Templatedisplay
Templatedisplay=parsearray(pTemplatedisplay)
Value=""
If TemplateDisplay="No" then exit sub
ShopPageTrailer
end sub

'add button to allow people to order but do not put this out if using
'Inventory products
'When using inventory products do not put out order button
Sub Handle_SpecialOrderButton (ivalue,parsearray,parseRS)
   dim rc, inventorycheck, pricedisplay, quantitydisplay
   Checkinventoryproducts ivalue,parsearray,parseRS, inventorycheck, pricedisplay, quantitydisplay, inventoryoutofstock
   if inventorycheck=true then
      Handle_Inventoryproducts ivalue, parsearray,parseRS
   end if
   Add_Table "", parsearray
   prodindex=""
   Add_ProductFeatures "",parsearray,"",parseRS
   
   if inventorycheck=false  then
      Add_Quantity "",parsearray,parseRS
   else
      if quantitydisplay=true then
         Add_Quantity "",parsearray,parseRS
      end if
   end if

   '6.50 - if showing table layout don't show order button
   if inventorycheck = true then
	   if pricedisplay = false then
	      'no button
   	   else
		  Add_Button "",parsearray,parseRS
  	   end if
   else
      Add_Button "",parsearray,parseRS
   end if

   '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
   Add_Product "",parsearray, parseRS
   
   Add_TableEnd "",parsearray
   'Handle_FormEnd "",parsearray
end sub

'701 - 2011.04.19 - Enhancement: Speed enhancement fixes
sub Add_Product (ivalue, parsearray, parseRS)
dim Id, fieldtype, rc
dim fieldname
fieldname="CatalogId"
id=0

'701 - 2011.04.19 - Enhancement: Speed enhancement fixes
id = parseRS(fieldname)

if rc > 0 then
   WriteError  "Field " & fieldname & " " &  GetLang("LangDatabaseFail")
end if
%>
<input type="hidden" name="productid" value="<%=ID%>" />
<%
end sub

sub Add_Table (ivalue, parsearray)
dim tableflag
WriteForm "<table cellspacing=""1"" cellpadding=""2"" border=""0"">"
TableFlag="True"
parsearray(ptableflag)=tableflag
end sub

sub Add_TableEnd (ivalue, parsearray)
dim tableflag
WriteForm "</table>"
Tableflag=""
parsearray(ptableflag)=tableflag
end sub

sub Handle_SpecialCheckBox (ivalue, parsearray, parseRS)
   '7.00 - added xMySite call
   Handle_FormStart ivalue, genredirecturl("shopproductselect.asp")
   Add_Table "",parsearray
   Add_ProductFeatures "",parsearray, "0"
   Add_Quantity "",parsearray,parseRS

   '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
   Add_CheckBox "",parsearray,parseRS

   Add_Button "",parsearray,parseRS
   Add_TableEnd "",parsearray
   Add_ProductIndex "",parsearray
   Handle_FormEnd "",parsearray
end sub

sub Add_ProductIndex (ivalue, parsearray)
WriteForm "<input type=""hidden"" name=""prodindex"" value=""1"" />"
end sub

'701 - 2011.04.19 - Enhancement: Speed enhancement fixes
sub Add_CheckBox (ivalue, parsearray,parseRS)
dim Id, fieldname,fieldtype, rc
fieldname="CatalogId"

'701 - 2011.04.19 - Enhancement: Speed enhancement fixes
id = parseRS(fieldname)

if rc > 0 then
   WriteError  "Field " & fieldname & " " &  GetLang("LangDatabaseFail")
end if
if TableFlag<>"" then
   htmlwrite "<tr>"  & "<td>"
end if
WriteForm "<input type=""checkbox"" name=""Processed0"" value=""" & ID & """ />"
if TableFlag<>"" then
   WriteForm "</td>"
   htmlwrite "</tr>"
end if
end sub

sub Add_Button (ivalue, parsearray, parseRS)
   '6.50 - if xpriceloggedinonly set to yes and customer isnt logged in, they shouldn't be able to purchase
   if GetConfig("xpriceloggedinonly") = "Yes" then
      if isnull(GetSess("Login")) or GetSess("Login") = "" then
         exit sub
      end if
   end if

   if GetConfig("xproductcatalogonly") = "Yes" then
	  exit sub
   end if

   dim inventorycheck, pricedisplay, quantitydisplay, addflag
   Checkinventoryproducts ivalue,parsearray,parseRS, inventorycheck, pricedisplay, quantitydisplay, inventoryoutofstock
   addflag = false
   if inventorycheck = true then
	  If pricedisplay = false then
		 addflag = false
  	  else
		 addflag = true
	  end if
   else 
      addflag = true
   end if
   if addflag then
   dim mytext, mybutton, tableflag
   tableflag=parsearray(ptableflag)
   dim fieldvalue
   dim rc
   dim Id, fieldname,fieldtype

   '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
   WriteNoStockMessage rc, parsearray, parseRS

   '701 - 2011.05.16 - Bug Fix: Add to notification message error at shopexd.asp if using SEO Dynamic
   dim lngCatalogId
   lngCatalogId = parsers("catalogid")
   
   if rc> 0 then
	  'response.write GetLang("LangOutOfStock")
      '800 - 2016.09.20 - Browser auto refresh JS/CSS files wihout hard refresh
      HtmlWrite "<script language=""javascript"" src=""js/stocknotification.js?"& getfilelastupdatedate("js/stocknotification.js") &""" type=""text/javascript""></script>"
      response.write GetLang("langOutOfStock")
	  '700 - Auto Notify When Stock Is Available
	  display_stocknotification_info
      exit sub
   end if
   fieldname="CatalogId"

   '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
   Id = parsers(fieldname)
   
   if rc > 0 then
      WriteError  "Field " & fieldname & " " &  GetLang("LangDatabaseFail")
   else
      ID=0
   end if
   if mytext="" then
      mytext=GetLang("langproductorder")
   end if
   if mytext="" then
      mytext="Order"
   end if
   mybutton=""
   fieldname="BUTTONIMAGE"
   fieldvalue=""

   '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
   fieldvalue = parsers(fieldname)
   
   if fieldvalue<>"" then
      mybutton= fieldvalue
   else
      if GetConfig("xButtonImage") <>"" then
         mybutton=GetConfig("xButtonImage")
      end if
   end if
   if tableflag<>"" then
      htmlwrite "<td class=""ac vm"">"
   end if

   if myButton="" then
      WriteForm  "<input class=""submitbtn"" type=""submit"" value="""  & mytext & """ name=""Order"" />"
   else
      WriteForm "<input class=""imgbtn"" src=""" & mybutton & """ type=""image"" />"
   end if
   if tableflag<>"" then
      htmlwrite "</td></tr>"
   end if
   end if
end sub

sub Add_Quantity (ivalue, parsearray, parseRS)
'6.50 - if xpriceloggedinonly set to yes and customer isnt logged in, they shouldn't be able to purchase
if GetConfig("xpriceloggedinonly") = "Yes" then
   if isnull(GetSess("Login")) or GetSess("Login") = "" then
      exit sub
   end if
end if

if GetConfig("xproductcatalogonly") = "Yes" then
	exit sub
end if

dim inventorycheck, pricedisplay, quantitydisplay,addflag
Checkinventoryproducts ivalue,parsearray,parseRS, inventorycheck, pricedisplay, quantitydisplay, inventoryoutofstock
addflag = false
If inventorycheck=false  then 
  addflag = true
else  
  If quantitydisplay=true then
     addflag = true
  end if
end if     
if addflag = true then
dim strminimumquantity, rc, tableflag, fieldtype

'701 - 2011.04.19 - Enhancement: Speed enhancement fixes
WriteNoStockMessage rc, parsearray, parseRS

if rc> 0 then exit sub
htmlwrite "<label class=""fontbold"">"& getlang("langproductquantity") &"</label>"
tableflag=parsearray(ptableflag)

'701 - 2011.04.19 - Enhancement: Speed enhancement fixes
strminimumquantity = parsers("MINIMUMQUANTITY")

'701 - 2011.07.06 - Quantity box is display incorrectly if minimumquantity is NULL
if isnull(strminimumquantity) then strminimumquantity=0
   
if strminimumquantity="" then
   strminimumquantity=0
end if
if strMinimumquantity=0 then
   if tableflag<>"" then
      htmlwrite "<tr>" & "<td class=""ac"">"
   end if

   dim fieldqtyclass
   fieldqtyclass = "txtfield"
%>
<input class="<%=fieldqtyclass%>" type="text" size="2" maxlength="3" name="quantity" value="1" />
<%
   if tableflag<>"" then
      htmlwrite "</td>"
   end if
else
   GenerateMinimumList strMinimumquantity, parsearray
end if
end if
end sub

sub GetFieldValues (RS, fieldnames, fieldvalues, fieldtypes, fieldcount)
dim i
dim fldname
i=0
for each fldName in RS.Fields
   fieldnames(i) = ucase(fldname.name)
   fieldTypes(i) = fldname.type
   if Fieldtypes(i)="201" then
      fieldvalues(i)=RS(i)
   end if
   i=i+1
next
fieldcount=i-1
for i=0 to fieldcount
   if fieldtypes(i)<>"201" then
      fieldvalues(i)=RS(i).value
   end if
   if isnull(fieldvalues(i)) then
      fieldvalues(i)=""
   end if
next
end sub

sub ParseRecord (record,words,wordcount,delimiter)
dim pos
dim recordl
dim bytex
dim temprec
dim maxwords
dim i
maxwords = 10
temprec = record
dim maxentries
pos = 1
wordcount = 0
'make sure word array is null
maxentries = UBound(words)
for i = 0 To maxentries - 1
   words(i) = ""
next
recordl = Len(temprec)
'first eliminate leading blanks
do
   bytex = Mid(temprec, pos, 1)
   while bytex = " " And pos <= recordl
      pos = pos + 1
      bytex = Mid(temprec, pos, 1)
   wend
   'copy word into word array
   while bytex <> delimiter And pos <= recordl
      words(wordcount) = words(wordcount) & bytex
      pos = pos + 1
      bytex = Mid(temprec, pos, 1)
   wend
   wordcount = wordcount + 1
   pos = pos + 1
   if wordcount > maxentries then exit sub
loop until pos > recordl
end sub

sub Add_ProductFeatures (ivalue, parsearray, Index,parseRS)
   dim rc, fieldtype, tableflag
   prodindex=index
   'tableflag=parsearray(ptableflag)

   '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
   strfeatures = parsers("FEATURES")

   if rc=0 then
	  '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
	  strselectlist = parsers("SELECTLIST")
	  lngCatalogId = parsers("CatalogId")
      FormatProductOptions
   end if
end sub

sub Handle_FormStart (value, parsearray, action)
   dim Newaction
   '7.00 - added xMySite call
   newaction=genredirecturl("shopaddtocart.asp")
   if action<>"" then
      newaction=action
   end if

   '800 - 2016.05.25 - Quick View: Speed improvement when opening quickview
   if lcase(request("quickview")) = "yes" then
      if instr(newaction,"?") > 0 then
	     newaction = newaction & "&quickvieworder=yes"
	  else
	     newaction = newaction & "?quickvieworder=yes"
	  end if
   end if
%>
<form id="<%=value%>" name="<%=value%>" method="post" action="<%=newaction%>">
<%
'700 - 2010.04.22 - cross site script security enhancement
htmlwrite "<input type=""hidden"" name=""genpredefinedsecuritycode"" value="""& session("genpredefinedsecuritycode") &""" />"
%>
<%
end sub

sub Handle_FormEnd (ivalue, parsearray)
   addwebsessform
   WriteForm "</form>"
end sub

sub WriteForm (text)
   response.write text
end sub


'[filename INCLUDE]
'field=abc INCLUDE]
'abc is field in recordset
'701 - 2011.04.19 - Enhancement: Speed enhancement fixes
sub Handle_Include (ivalue,parsearray, parseRS)
dim NewRecord, ucfieldname, tokens
dim recordObj, FsObj
dim rc
dim MyText
dim readcount
dim Bypass, filename, pos, fieldtype, filetype
dim values(10),valuecount
readcount=0
tokens=parsearray(ptokens)
filename=tokens(0)
pos=instr(filename,"=")
if pos>0 then
   ParseRecord filename,values,valuecount,"="
   ucfieldname=ucase(values(1))
   if ucase(values(0))="FIELD" then
      '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
	  filename = parseRS(ucfieldname)
	  
      if isnull(filename) or filename="" then
         exit sub
      end if
   else
      filename=values(1)
   end if
end if
dim savevalue
savevalue=parsearray(Pdatainmemory)
parsearray(Pdatainmemory)="No"
OpenInputFile Filename, fsObj, RecordObj, rc
if rc> 0 then
   parsearray(Pdatainmemory)=savevalue
   ShopWriteError  GetLang("LangReadFail")  & filename
   exit sub
else
   GetFileType filename,filetype
end if
ReadARecord RecordObj, MyText, rc, parsearray
do while rc=0
   if filetype="TXT" then
      ivalue=ivalue & Server.HTMLEncode(MyText)  & "<br />"
   else
      ivalue=ivalue &  mytext
   end if
   readcount=readcount+1
   ReadARecord RecordObj, MyText, rc, parsearray
loop
CloseFile fsObj,RecordObj, rc, parsearray
parsearray(Pdatainmemory)=savevalue
end sub

sub GetFileType(filename, filetype)
dim xtype
filetype="TXT"
xtype=ucase(right(filename,3))
select case xtype
   case "TXT"
      filetype="TXT"
   case "HTM"
      filetype="HTM"
   case "TML"
      filetype="HTM"
end select
end sub

function RemoveHtmlFileio(itemname, CR)
dim workrecord, firstchar, morefields, pos, endpos, length
dim token
workrecord=replace(itemname,"<br />",CR)

'VP-ASP 6.50.4 Bugs Fix - 08 October 2008
workrecord=replace(workrecord,"<br>",CR)
workrecord=replace(workrecord,"<br/>",CR)
workrecord=replace(workrecord,"<BR />",CR)
workrecord=replace(workrecord,"<BR>",CR)
workrecord=replace(workrecord,"<BR/>",CR)

pos=1
morefields = True
do while morefields = True
   pos=1
   pos = InStr(pos, workrecord, "<")
   if pos > 0 then
      endpos = InStr(pos, workrecord, ">")
      if endpos=0 then
         morefields=false
      else
         length = endpos - pos + 1
         token = Mid(workrecord, pos, length)
         workrecord=replace(workrecord,token,"")
      end if
   else
      morefields=false
   end if
loop
RemoveHtmlFileio=workrecord
end function

'add logic to test sub products out of stock
'701 - 2011.04.19 - Enhancement: Speed enhancement fixes
sub WriteNoStockMessage (rc, parsearray, parseRS)
dim lngcstock,id,fieldtype,rc1, fieldname
rc=0
if Inventoryoutofstock=true then
   rc=4
   exit sub
end if
if GetConfig("xOutOfStockLimit")="" then exit sub
fieldname="CSTOCK"

'701 - 2011.04.19 - Enhancement: Speed enhancement fixes
lngcstock = parseRS(fieldname)

'701 - 2011.02.01 - Bug Fix: Cstock null / empty should always treated as 0
if isnull(lngcstock) then lngcstock = 0
if trim(lngcstock) = "" then lngcstock = 0
   
if clng(lngcstock)>clng(GetConfig("xOutOfStocklImit")) then exit sub
rc=4
end sub

sub ShopMergeTemplate (DBTable, Template, CatalogId, IDField)
   '701 - 2010.01.13 - Bug Fix: Possible error while using routine sub ShopMergeTemplate
   dim sql

    dim tempDatabase, tmprs, rc
    if isnumeric (CatalogId) then
       Sql="select * from " & DBTable
       if IDField<>"" then
          sql=sql & "  where " & IDField & "="  & CatalogId
       end if
    else
       sql="select * from " & DBTable
       if IDField<>"" then
          sql=sql & "  where " & IDField & "='"  & CatalogId & "'"
       end if
    end if
    Set tmpRS = Server.CreateObject("ADODB.Recordset")
    '700 - 2010.09.26 - Enhancement: Speed up front store performance
    '800 - 2016.03.10 - Better DB handling
    tmpRS.open sql, dbc, adOpenStatic, adLockReadOnly
    if tmpRS.eof then
       if CatalogId<>"" then
          SError = SError &  GetLang("LangReadFail") & "-" & GetLang("LangEditTableName") & "=" & DBTable
       else
          SError = SError &  GetLang("LangReadFail") & " " & GetLang("langedittablename") & "=" & DBTable
       end if
    end if
    if SError="" then
	   '700 - 2010.07.20 - Bug Fix: [translate xxx] parameter in template is not working for non-product pages
	   if lcase(dbtable) <> "products" then
	      dim otable
		  otable = getsess("table")
	      setsess "table",dbtable
	   end if

       ShopTemplateWrite  Template, tmpRS, rc

       '700 - 2010.07.20 - Bug Fix: [translate xxx] parameter in template is not working for non-product pages
	   if lcase(dbtable) <> "products" then setsess "table",otable
    end if
    CloseRecordSet tmpRS
end sub

function HandleCustomerPrice (iprice, parsearray,parseRS)
dim discount, categoryid, ioprice, newprice
dim CatalogId	'VP-ASP 6.5
dim fieldtype, rc
newprice=iprice

'701 - 2011.02.16 - Enhancement: Speed enhancement
CatalogId = parseRS("CatalogId")
categoryid = parseRS("CCATEGORY")

shopcustomerprices ParseRS, CatalogId, categoryid, iprice, newprice,discount
HandleCustomerprice=newprice
end function

function HandlePriceSAving (iprice, parsearray,parseRS)
dim discount, categoryid, ioprice, newprice
dim strretailprice, saving
dim fieldtype, rc
newprice=iprice

'701 - 2011.04.19 - Enhancement: Speed enhancement fixes
strretailprice = parsers("RETAILPRICE")

if strretailprice="" then exit function
if strretailprice=0 then exit function

'701 - 2011.04.19 - Enhancement: Speed enhancement fixes
CatalogId = parsers("CatalogId")
categoryid = parsers("CCATEGORY")

shopcustomerprices ParseRS, CatalogId, categoryid, iprice, newprice,discount
saving=strretailprice-newprice
HandlePriceSaving=saving
end function

'Template format order items
'expects dbc to be open as open connection
sub Handle_OITEMSTemplate (body, parsearray,parseRS)
dim filename, outarray(10), outcount, suffix, emailformat
filename=GetConfig("xoitemsTemplate")
dim Isql,orderid, rsitems
dim recordid
dim CR, itemname, i
dim downloadlink
recordid=parsearray(pidvalue)
Suffix=right(filename,3)
if ucase(suffix)<>"TXT" then     ' oct 6
   SetSess "emailformat","HTML"
else
   SetSess "emailformat","TEXT"
end if
if ucase(GetSess("emailformat"))="HTML" then
   CR=""
else
   CR = GetMailCR
end if

isql="select * from oitems where orderid="
if GetSess("oid")<>"" then
   Orderid=GetSess("oid")
else
   Orderid=recordid
end if
Body=""
ISql=Isql & Orderid
Set rsitems = Server.CreateObject("ADODB.Recordset")
'700 - 2010.09.26 - Enhancement: Speed up front store performance
'800 - 2016.03.10 - Better DB handling
rsitems.open Isql, dbc, adOpenStatic, adLockReadOnly
if rsitems.eof then
   CloseRecordSet rsitems
   exit sub
end if
do while not rsitems.eof
   ShopTemplateArray Filename, RSITEMS, Outarray, Outcount
   for i = 0 to outcount-1
      itemname=outarray(i)
      if ucase(GetSess("emailformat"))<>"HTML" then
         Itemname=RemoveHtmlFileio(itemname, CR)
      end if
      Body = Body & CR & Itemname
   next
   if GetConfig("xendoforderhyperlinkemail")="Yes" or GetConfig("xdownloadsemail")="Yes" then
      downloadlink=GetEmaildownloadLink(RSItems("CatalogId"))
      if downloadlink <> "" then
         Body = Body & GetLang("LangorderDownload") & ": " & downloadLink  & CR
      end if
   end if
   rsitems.movenext
loop
CloseRecordSet rsitems
end sub

sub Handle_OitemTotal(value,parsearray,parseRS)
dim quantity, unitprice, rc, fieldtype, price, total

'701 - 2011.04.19 - Enhancement: Speed enhancement fixes
quantity = parsers("NUMITEMS")
unitprice = parsers("UNITPRICE")

Total=quantity*unitprice
value=ShopFormatCurrency(total,GetConfig("xdecimalpoint"))
end sub

sub Handle_OitemDelivery(value,parsearray,parseRS)
dim rc, fieldtype, price, total, itemname
dim CR
dim deliveryaddress, deliveryarray
if ucase(GetSess("emailformat"))="HTML" then
   CR="<br />"
else
   CR = GetMailCR
end if
if GetConfig("xdeliveryaddress")="Yes" then
   '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
   deliveryaddress = parsers("ADDRESS")
   
   if not isnull(Deliveryaddress)  and Deliveryaddress<>"" then
      ConvertDeliveryToArray DeliveryArray, Deliveryaddress
      GetDeliveryName Itemname, DeliveryArray
      if ucase(GetSess("emailformat"))<>"HTML" then
         Itemname=RemoveHtmlFileio(itemname, CR)
      end if
      value=itemname
   end if
end if
end sub

'see if Template is in Database. If it is open the recordset
'put whole Template into fsobj
sub OpenInputFiledb (filename, fsObj, RecordObj, rc)
dim dbprefix, dbfilename
dbprefix=left(filename,3)
if lcase(dbprefix)="db=" then
   dbfilename=right(filename,len(filename)-3)
else
   dbfilename=filename
end if
dim sql
'700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
'702 - 2013.05.20 - Enhancement: Better handling reading templates from DB
sql="select Template from templates where Templatename="& sqlserverprefixn &"'" & dbfilename & "'"
if GetConfig("xdebug")="Yes" then
   DebugWrite sql
end if
Set recordobj = Server.CreateObject("ADODB.Recordset")
'700 - 2010.09.26 - Enhancement: Speed up front store performance
'702 - 2013.05.20 - Enhancement: Better handling reading templates from DB
recordobj.open sql, dbc, adOpenStatic, adLockReadOnly
if not recordobj.eof then
   rc=0
   fsobj=recordobj("Template")
else
   rc=4
end if
CloseRecordSet recordobj
recordobj=""
If rc=0 then
   recordobj="db"
end if
end sub

sub ReadEntireFileDB  (fsoobj, RecordObj, readcount, readarray,parsearray)
dim data, delimiter, i
delimiter="~"
readcount=0
data=replace(fsoobj,vbcrlf,delimiter)
ParseRecord data, readarray, readcount,delimiter
end sub

'Record are already in memory in the parse arary
sub ReadARecordDB (RecordObj, record, rc,parsearray)
dim data, currentrecord, recordcount
currentrecord=parsearray(pdatacurrentrecord)
recordcount=parsearray(pdatarecordcount)
data=parsearray(pdata)
if currentrecord=recordcount then
   rc=4
   exit sub
end if
record=data(currentrecord)
currentrecord=currentrecord+1
parsearray(pdatacurrentrecord)=currentrecord
rc=0
end sub

sub CheckfileDB(filename,fieldname,rc)
dim dbprefix
dbprefix=left(filename,3)
if lcase(dbprefix)="db=" then
   fieldname=right(filename,len(filename)-3)
   rc=0
else
   fieldname=""
   rc=4
end if
end sub

sub Handle_RatingSummary (value, parsearray, parseRS)
   dim oaverage,image, count
   dim fieldtype, rc, lngCatalogId, fieldname
   if GetConfig("xAllowRatingProducts")<>"Yes" then exit sub
   if GetConfig("xAllowRatingSummary")<>"Yes" then exit sub
   fieldname="CatalogId"

   '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
   lngCatalogId = parsers(fieldname)
   
   FileioReviewaverage lngCatalogId, oaverage,image, count, dbc
   if image="" then
      response.write "" & GetLang("langNoReviews") & ""
      exit sub
   end if
   htmlwrite "<span class=""productinfolabel"">"& count & "&nbsp;" & GetLang("langratingheader") &"</span>"
   htmlwrite "<span class=""productinfodetails""><img src=""" & image & """ alt="" "" /></span><div class=""cb""></div>"
end sub

sub FileioReviewAverage(CatalogId, oaverage, image, outcount, dbc)
dim rs, rsql, strrating
rsql=" SELECT CatalogId, Avg(rating) AS avgofrating, count(CatalogId) as countCatalogId from reviews where CatalogId=" & CatalogId & " AND authorized IS NOT NULL GROUP BY CatalogId"
Set rs = Server.CreateObject("ADODB.Recordset")
'700 - 2010.09.26 - Enhancement: Speed up front store performance
'800 - 2016.03.10 - Better DB handling
rs.open rsql, dbc, adOpenStatic, adLockReadOnly
if not rs.eof then
   oaverage=rs("avgofrating")
   oaverage=clng(oaverage)
   strrating=cstr(oaverage)
   outcount=rs("countCatalogId")
   select case strrating
      case "1"
         image="vpasp_stars1.gif"
      case "2"
         image="vpasp_stars2.gif"
      case "3"
         image="vpasp_stars3.gif"
      case "4"
         image="vpasp_stars4.gif"
      case "5"
         image="vpasp_stars5.gif"
      case else
         image=""
   end select
   '600 - moved images to images/misc folder
   if image > "" then
   	image = "images/misc/" & image
	end if
else
   oaverage=""
   image=""
end if
rs.close
set rs=nothing
end sub

function HandleFormatImage (fieldvalue)
dim newvalue
if fieldvalue="" then
   handleFormatImage=""
   exit function
end if
newvalue="<img border=""0"" src=""" & fieldvalue & """ alt="" ""/>"
handleFormatImage=newvalue
end function

'add Inventory Products. Codse is in shopproductinventory
sub Handle_Inventoryproducts (ivalue, parsearray,parseRS)
if GetConfig("xinventoryproducts")<>"Yes" then exit sub
dim inventorycheck, pricedisplay, quantitydisplay 
Checkinventoryproducts ivalue,parsearray,parseRS, inventorycheck, pricedisplay, quantitydisplay, inventoryoutofstock
If inventorycheck=true then
   FormatInventoryproducts dbc, parseRS
end if
end sub

'if there are associated products then display them
'instead of the order button
sub Checkinventoryproducts (ivalue,parsearray,parseRS, inventorycheck,inventorypricedisplay, quantitydisplay, inventoryoutofstock)
dim CatalogId, spdisplaytype
inventorycheck=false
quantitydisplay=true
if GetConfig("xinventoryproducts")<>"Yes"  then exit sub
dim strCrossProductIDs,strsql, rs
dim fieldtype,rc

'701 - 2011.04.19 - Enhancement: Speed enhancement fixes
strcrossProductids = parsers("INVENTORYPRODUCTS")
CatalogId = parsers("CatalogId")
spdisplaytype = parsers("SPDISPLAYTYPE")

InventoryProductYesNo dbc, ParseRs, CatalogId, inventorycheck, Inventorypricedisplay, quantitydisplay, inventoryoutofstock
end sub

'Template format order items
'expects dbc to be open as open connection
'$H is one type header
'$T is one time trailer
sub Handle_INVOICEOITEMS (value,parsearray, parseRS)
dim filename, outarray(500), outcount, suffix, emailformat
dim headerwritten
dim body, record, outrec, prefix
filename=GetConfig("xinvoiceoitemsTemplate")
filename="tmp_invoiceoitems.htm"
headerwritten=false
dim Isql,orderid, rsitems
dim recordid
dim CR, itemname, i
recordid=parsearray(pidvalue)
isql="select * from oitems where orderid="
Orderid=recordid
Body=""
ISql=Isql & Orderid
Set rsitems = Server.CreateObject("ADODB.Recordset")
'700 - 2010.09.26 - Enhancement: Speed up front store performance
'800 - 2016.03.10 - Better DB handling
rsitems.open Isql, dbc, adOpenStatic, adLockReadOnly
if rsitems.eof then
   CloseRecordSet rsitems
   exit sub
end if
do while not rsitems.eof
   ShopTemplateArray Filename, RSITEMS, Outarray, Outcount
   for i = 0 to outcount-1
      record=outarray(i)
      outrec=Striprecord(record)
      prefix=ucase(left(record,2))
      if prefix=";T" then
         outrec=""
      end if
      if headerwritten=true then
         if prefix=";H" then
            outrec=""
         end if
      end if
      if outrec<>"" then
         response.write outrec & vbcrlf
      end if
   next
   headerwritten=true
   rsitems.movenext
loop
CloseRecordSet rsitems
for i = 0 to outcount-1
   record=outarray(i)
   outrec=striprecord(record)
   prefix=ucase(left(record,2))
   if prefix=";T" then
      response.write outrec & vbcrlf
   end if
next
end sub

'Display quantity discounts
sub Handle_Quantitydiscounts(value,parsearray,parseRS)
   if GetConfig("xquantityPrices")<>"Yes" then exit sub
   dim lookupsql, lookuprs, oldprice, newprice, iprice, discount, i
   dim quantitylowfield, quantityhighfield, quantitylow, quantityhigh, pricefield
   dim Discountamount,DiscountPercent
   dim CatalogId, categoryid, price, discountprice, discpercent
   dim fieldvalue
   dim quantitygroup
   CatalogId=parsers("CatalogId")
   categoryid=ParseRs("ccategory")
   quantitygroup=ParseRs("groupfordiscount")
   lookupsql="select * from quantitydiscounts "
   lookupsql = lookupsql & " where CatalogId=" & CatalogId
   lookupsql = lookupsql & " or categoryid=" & categoryid
   if not isnull(quantitygroup) then
      '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      lookupsql = lookupsql & " or groupfordiscount="& sqlserverprefixn &"'" & quantitygroup & "'"
   end if
   Set lookuprs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   lookuprs.open lookupsql, dbc, adOpenForwardOnly, adLockReadOnly
   if lookuprs.eof then
      '800 - 2016.02.29 - Quantity Discount: To display quantity discount table if catalogid and categoryid are empty
      'lookuprs.close
      'set lookuprs=nothing

      '701 - 2011.05.18 - Bug Fix: Quantity Discount not showing correctly in product description page
      dim categories,rs,sql
      categories = ""
      sql = "SELECT * from prodcategories where intCatalogId=" & CatalogId
      Set rs = Server.CreateObject("ADODB.Recordset")
      rs.open sql, dbc, adOpenForwardOnly, adLockReadOnly
      do while not rs.eof
         if categories<>"" then
            categories = categories & ","
         end if
         categories = categories & rs("intcategoryid")
         rs.movenext
      loop
      CloseRecordSet rs
	  if trim(categories) <> "" then
         lookupsql="select * from quantitydiscounts "
         lookupsql = lookupsql & " where CatalogId=" & CatalogId
         lookupsql = lookupsql & " or categoryid in (" & categories & ") "
         if not isnull(quantitygroup) then
            lookupsql = lookupsql & " or groupfordiscount="& sqlserverprefixn &"'" & quantitygroup & "'"
         end if

         '800 - 2016.02.29 - Quantity Discount: To display quantity discount table if catalogid and categoryid are empty
		 closerecordset lookuprs

         Set lookuprs = Server.CreateObject("ADODB.Recordset")
		 lookuprs.open lookupsql, dbc, adOpenForwardOnly, adLockReadOnly
		 '800 - 2016.02.29 - Quantity Discount: To display quantity discount table if catalogid and categoryid are empty
         'if lookuprs.eof then
            'lookuprs.close
            'set lookuprs=nothing
			'exit sub
	     'end if
	  else
	     '800 - 2016.02.29 - Quantity Discount: To display quantity discount table if catalogid and categoryid are empty
	     'exit sub
	  end if

   '800 - 2016.02.29 - Quantity Discount: To display quantity discount table if catalogid and categoryid are empty	  
   end if
   if lookuprs.eof then
	  closerecordset lookuprs
      lookupsql="select * from quantitydiscounts "
      lookupsql = lookupsql & " where (catalogid=0 or catalogid is null)"
      lookupsql = lookupsql & " and (categoryid=0 or categoryid is null) "
      Set lookuprs = Server.CreateObject("ADODB.Recordset")
	  lookuprs.open lookupsql, dbc, adOpenForwardOnly, adLockReadOnly
	  if lookuprs.eof then
	     closerecordset lookuprs
		 exit sub
	  end if
   end if

   '701 - 2011.05.18 - Bug Fix: Quantity Discount not showing correctly in product description page
   htmlwrite "<span class=""productinfolabel"">" &  GetLang("LangProductDiscount") & "</span>"
   
   HtmlWrite "<table border=""0"" cellpadding=""2"" cellspacing=""1"" width=""100%"" align=""center"">" & "<tr style=""background-color:#AAAAAA"">"
   HtmlWrite "<td class=""menuhdr ac""><span class='fontbold'>" & GetLang("LangProductQuantity") & "</span></td>"
   HtmlWrite "<td class=""menuhdr ac""><span class='fontbold'>" & GetLang("LangProductPrice") & "</span></td>"
   HtmlWrite "</tr>"
   newprice=Parsers("cprice")
   price=newprice
   shopcustomerprices ParseRS, CatalogId, categoryid, iprice, newprice,discount
   
   '701 - 2011.05.18 - Bug Fix: Quantity Discount not showing correctly in product description page
   if isnull(newprice) then newprice = price
   if trim(newprice) = "" then newprice = price
   
   for i = 1 to 5
      if i=1 then
         quantitylowField= "minquantity"
      else
         quantitylowField= "quantity" & i-1
      end if
      quantityhighfield="quantity" & i
      pricefield="discount" & i
      Quantitylow= lookuprs(quantitylowfield)
      quantityhigh=lookuprs(quantityhighfield)
      if isnull(quantityhigh) then exit for
      if quantityhigh=0 then exit for
      if I >1 then
         quantitylow=quantitylow+1
      end if
      fieldvalue= quantitylow & " to " & quantityhigh
      HtmlWrite "<tr style=""background-color:#f8f8f8"">"
      HtmlWrite "<td class=""al vt"">" & fieldvalue & "</td>"
      discpercent=lookuprs(pricefield)
      if discpercent>=1 then
         discount=discpercent
      else
	     '6504 - BUG - Updated Quantity Prices Table when using Customer Pricing
		 discount=newPrice*discpercent
      end if
	  '6504 - BUG - Updated Quantity Prices Table when using Customer Pricing
	  DiscountPrice=newPrice-discount

      DiscountPrice=ShopFormatCurrency(Discountprice,GetConfig("xdecimalpoint"))
      HtmlWrite "<td class=""al vt"">" & discountprice & "</td>"
      HtmlWrite "</tr>"
   next
   HtmlWrite "</table>"
   CloseRecordSet lookuprs
end sub

function StripRecord(inrec)
dim prefix, newrec
prefix=ucase(left(inrec,2))
newrec=inrec
if prefix=";H" or prefix=";T" then
   newrec=mid(inrec,3,len(inrec)-2)
end if
striprecord=newrec
end function

'adds &websess=xxxxxxxxxxxxxxxx
Sub Handle_ADDWEBSESSLINK( value,parsearray, parseRS)
value=addwebsesslink
end sub

'Create hyperlink to currency converter
function HandleFormatCurrencyConversion (total, parsearray,parseRS)
dim value, cprice
value=""
if GetConfig("xproductConvertCurrency")="Yes"  then
   cprice=ShopFormatNumber(total,GetConfig("xdecimalpoint"))
   ShopConvertCurrencyLink  cprice, value
end if
HandleFormatCurrencyConversion=value
end function

'701 - 2011.04.19 - Enhancement: Speed enhancement fixes
sub GetDualPricevalue( value, strcprice, parsearray, parseRS)
   exit sub
dim dualpricefield
if GetConfig("xdualpricefield")=""  then
   ConvertCurrency value, strcPrice
   exit sub
end if
dualpricefield=GetConfig("xdualpricefield")
dim fieldtype,rc

'701 - 2011.04.19 - Enhancement: Speed enhancement fixes
strcprice = parseRS(ucase(dualpricefield))

if isnumeric(strcprice) then exit sub
strcprice=value
end sub

'[Translate cdescription  products]
'[translate catdescription categories]
sub Handle_translate (value,parsearray, ParseRs)
   dim tokens, fieldname, table, IDField, idvalue, currentvalue
   dim fieldvalue, fieldtype, rc, ucfieldname
   tokens=parsearray(ptokens)
   fieldvalue=value
   fieldname=tokens(1)
   table=tokens(2)
   if table = "" then
	  table = GetSess("table")
   end if
   if table="" then
      table="products"
   else
      table=lcase(table)
   end if
   if fieldname="" then
      value=" Unknown field to translate "
      exit sub
   end if
   IDField=parsearray(pIDField)
   idvalue=parsearray(pidvalue)
   ucfieldname=ucase(fieldname)
   value=TranslateLanguage(dbc, table, fieldname,IDField, idvalue, fieldvalue)
end sub

'Remove HTML from title and meta tags
sub Handle_cleansehtml (value,parsearray, ParseRs)
dim cr
if ucase(GetSess("emailformat"))="HTML" then
   CR="<br />"
else
   CR = GetMailCR
end if
value=RemoveHtmlFileio(value, CR)
end sub

'VP-ASP 6.5
'[GetLang xxx]
'takes xxx and looks it up in language table
sub Handle_GetLang (langvalue, value)
   value=GetLang(langvalue)
end sub

'6.50 - Show/Hide review links
sub  Handle_ReviewLinks (value, parsearray, parseRS)
dim fieldname, lngCatalogId,fieldtype,rc
if GetConfig("xallowratingproducts")<>"Yes" then exit sub
fieldname="CatalogId"

'701 - 2011.04.19 - Enhancement: Speed enhancement fixes
lngCatalogId = parsers(fieldname)

if GetConfig("xbuttonwritereview")>"" then
	response.write "<a href=""shopreviewadd.asp?id=" & lngCatalogId & addwebsesslink & """><img src=""" & GetConfig("xbuttonwritereview") & """ alt=""" & GetLang("langratingwrite") & """ /></a>&nbsp;"
else
	response.write "<a href=""shopreviewadd.asp?id=" & lngCatalogId & addwebsesslink & """>" & GetLang("langratingwrite") & "</a>&nbsp;|&nbsp;"
end if

if GetConfig("xbuttonreadreview")>"" then
	response.write "<a href=""shopreviewlist.asp?id=" & lngCatalogId & addwebsesslink & """><img src=""" & GetConfig("xbuttonreadreview") & """ alt=""" & GetLang("langratingread") & """ /></a>"
else
	response.write "<a href=""shopreviewlist.asp?id=" & lngCatalogId & addwebsesslink & """>" & GetLang("langratingread") & "</a>"
end if

end sub

'6.50 - show the number of sub-categories next to category listing
sub Handle_NumberSubCats (value, parsearray,parseRS)
   '800 - 2015.05.01 - Enhancement: Loading total products counter for each category in Ajax to improve load speed on page shopdisplaycategories.asp
   session("load_NumberSubCats_js") = "Yes"
   htmlwrite "<span style=""visibility:hidden;"" id=""NumberSubCats_"& value &""" class=""NumberSubCats"">"& value &"</span>"
   exit sub
end sub

sub Handle_Breadcrumb (value, parsearray,parseRS)
   if Request("bc")<>"" or session("seocbc") <> "" then exit sub
   if GetConfig("xbreadcrumbs") <> "Yes" then exit sub

   '800 - 2015.06.08 - Bug Fix: Product breadcrumb is showing incorrectly
   if trim(session("breadcrumb")) = "" then
      generate_product_breadcrumb value, parsers
      exit sub
   end if
   compare_product_breadcrumb value, parsers, session("breadcrumb")
   'response.write session("breadcrumb")
end sub

'check is the string html coding
function istable (passstring)
   dim tempstring, intStartPos, intEndPos
   
   tempstring = passstring
   '700 - 2010.06.21 - Bug Fix: Delete extra <br /> at front page
   '701 - 2011.02.15 - Bug Fix: Delete extra <br /> if containing only ul source code
   if instr(lcase(tempstring),"<body") > 0 or instr(lcase(tempstring),"<html") > 0 or instr(lcase(tempstring),"<table") > 0 or instr(lcase(tempstring),"<td") > 0 or instr(lcase(tempstring),"<tr") or instr(lcase(tempstring),"<form") or instr(lcase(tempstring),"<img") > 0 or instr(lcase(tempstring),"<span") > 0 or instr(lcase(tempstring),"<div") > 0 or instr(lcase(tempstring),"<img") > 0 or instr(lcase(tempstring),"<p") > 0 or instr(lcase(tempstring),"<br") > 0 or instr(lcase(tempstring),"<ul") > 0 or instr(lcase(tempstring),"<ll") > 0 then
      istable = true
   else
      istable = false
   end if
end function

'800 - 2015.07.01 - Page Manager: More Flexibility on templates
sub Handle_Breadcrumb_content (value, parsearray,parseRS)
   if GetConfig("xbreadcrumbs") <> "Yes" then exit sub
   HtmlWrite "<a href=""" & GetConfig("xhome") & addwebsesslinkfirst & """>" & GetLang("langcommonhome") & "</a>&nbsp;" & SubCatSeparator & "&nbsp;" & RemoveHtml(parseRS("message"),"<br />") & ""
end sub
%>