<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Handle shipping calculation
'*********************************************************************************

dim ShipMethod
dim ShipCost

'701 - 2012.05.16 - Enhancement: Able to contain more shipping methods
dim ShippingMethods(500)

'6.00 - Nov 12,2005
'701 - 2012.05.16 - Enhancement: Able to contain more shipping methods
dim shippingvalues(500), tempvalue

dim ShippingCount
dim CalculationType
dim shiptotalWeight, shiptotalfeatureweight, shiptotalcost, shiptotalquantity
const productcostfield = "weight" ' set to other field if necessary
const shipcountrydefault = "other" ' set for other country
const shipstatedefault = "None" ' set for other country

sub UpdateShippingSessionData()
   ' called from shop customer to process form and get shipping price
   dim optionname
   dim optionPrice
   dim rc
   SetSess "shipname", strshipname
   SetSess "shipcompany", strshipcompany
   SetSess "shipaddress", strshipaddress
   SetSess "shiptown", strshiptown
   SetSess "shipzip", strshipzip
   SetSess "shipstate", strshipstate
   SetSess "shipcountry", strshipcountry
   SetSess "shipmessage", ""

   '6.09 Security Fix
   ShipMethodType = CleanChars(Request.form("ShipMethodType"))

   '800 - 2015.04.22 - Bug Fix: Onepage: Not able to checkout by guest checkout
   if trim(ShipMethodType) = "" then
      ShipMethodType = CleanChars(Request.form("strshipmethodtype_hidden"))
   end if

   '800 - 2016.09.08 - Bug Fix: Shipping: Improper shipping price if xshippingdatabaserecords is No, xdefaultcountry is empty and visitor not login
   dim fakeshipcost
   fakeshipcost = false

   if shipmethodtype = "" then
      shipmethodtype = GetConfig("xfixedshippingmethod")
   else
   dim ret_ShipMethodType, shipvalue
   checkshipmethodtype_smprice ShipMethodType, ret_ShipMethodType, shipvalue, ""
   Shipmethodtype = ret_ShipMethodType

      '800 - 2016.09.08 - Bug Fix: Shipping: Improper shipping price if xshippingdatabaserecords is No, xdefaultcountry is empty and visitor not login
      if trim(shipvalue) = "" then
         fakeshipcost = true
         shipvalue = ShipMethodType
	     shipvalue = replace(shipvalue,GetSess("Newcurrencysymbol"),"")
   	     shipvalue = replace(shipvalue,GetConfig("XCurrencySymbol"),"")
      end if

   ParseOption shipvalue, ShipMethod, ShipCost
   end if

   '800 - 2015.09.01 - Bug Fix: Free shipping method is showing "0" as shiping method type
   if cstr(shipvalue) = "0" then
      ShipMethod = Shipmethodtype
	  ShipCost = shipvalue
   end if

   SetSess("Shipmethodtype"), Shipmethodtype
   
   '701 - 2011.04.27 - Bug Fix: Should not display not-related contents if using paypal express checkout
   'DebugWrite "shipmethodtype="& shipmethod & "shipcost=" & shipcost
   '800 - 2015.10.06 - Bug Fix: Normal Checkout: Lookup method is not working properly if xshippingdatabaserecords set to No
   '800 - 2016.05.01 - Buf Fix: Shipping method is displaying as numeric in database if xshippingdatabaserecords set to No
   'if lcase(getconfig("xshippingdatabaserecords")) = "no" then
   '   ShipMethodType = CleanChars(Request.form("ShipMethodType"))
   '   Shipmethod = ShipMethodType
   'end if

   SetSess "ShipMethod", Shipmethod

   '701 - 2011.05.18 - Better handling with Ajax Shipping
   '800 - 2015.10.13 : Onepage checkout: Shipping cost is not working properly if it is not checkout with default currency
   'if getsess("Newcurrencysymbol")<>"" and Shipcost<>"" then
	  'shipcost = replace(shipcost, getsess("Newcurrencysymbol"), "")
	  'if getconfig("xAjaxShipping") = "Yes" then
         'if GetSess("Conversionvalue") <> 1 then
	        'ShipCost = ShipCost / GetSess("Conversionvalue")
         'end if
	  'end if
   'end if

   SetSess "smprice", ShipCost

   '800 - 2015.07.15 - Better handling on Free shipping cart option
   '800 - 2015.10.06 - Bug Fix: Normal Checkout: Lookup method is not working properly if xshippingdatabaserecords set to No
   if lcase(getconfig("xshippingdatabaserecords")) = "no" then
      HandleFreeShipping rc
      if rc = 0 then
         exit sub
      end if
   end if

   '800 - 2016.09.08 - Bug Fix: Shipping: Improper shipping price if xshippingdatabaserecords is No, xdefaultcountry is empty and visitor not login
   if not fakeshipcost then
   if cdbl(ShipCost) > 0 then
      exit sub
   end if
   '800 - 2016.09.08 - Bug Fix: Shipping: Improper shipping price if xshippingdatabaserecords is No, xdefaultcountry is empty and visitor not login
   end if

   ' VP-ASP 600 - Handle Other shipping 20/10/2005
   dim othershipsql, othershiprs

   '800 - 2016.07.12 - Bug Fix: Shipping: If ship method contain charactrer ', it throws error
   othershipsql = "Select * from shipmethods where shipmethod='" & tosql(shipmethod,"Text") & "'"

   AddShippingCountry othershipsql, othershiprs, dbc
   if not othershiprs.eof then
      if othershiprs("shiproutine") > "" then
         SetSess "ShipCalc", "OTHER"
         SetSess "followonURL", othershiprs("shiproutine")
         othershiprs.close
         set othershiprs = nothing
         exit sub
      end if
   else
      '702 - 2013.06.19 - Bug Fix: Fixed shipping is not working properly if shipmethod does not return matched record
      if ucase(getconfig("xShippingCalc")) <> "FIXED" then
         '800 - 2015.10.06 - Bug Fix: Normal Checkout: Lookup method is not working properly if xshippingdatabaserecords set to No
	     if lcase(getconfig("xshippingdatabaserecords")) = "yes" then
         '701 - 2011.05.18 - Better handling with Ajax Shipping
         exit sub
	     end if
	  '702 - 2013.06.19 - Bug Fix: Fixed shipping is not working properly if shipmethod does not return matched record
	  end if
   end if
   othershiprs.close
   set othershiprs = nothing
   CalculateShipping ' all others handled differently
   if GetConfig("xDeliveryShipping") = "Yes" then
      DeliveryShippingCalc ' handle delivery shipping
   end if
end sub

' Save all the other routines the trouble by recalculating cost, weight, weight
sub CalculateShipping
   LocateShippingRecord dbc, Shipmethod ' get shipping record
   CalculateShippingdetails dbc, shiptotalWeight, shiptotalfeatureweight, shiptotalcost, shiptotalquantity
   Calculationtype = ucase(GetConfigvalue("xShippingCalc")) ' What type of calculation are we doing
   if Calculationtype = "" then exit sub
   select case CalculationType
      Case "LOOKUP"
         HandlebyLookup
      case "WEIGHT"
         HandlebyWeight
      case "QUANTITY"
         HandlebyQuantity
      case "WEIGHTRANGE"
         HandlebyWeightRange
      case "PRICERANGE"
         HandlebyPriceRange
      case "FIXED"
         HandlebyFixed
      case "PRODUCT"
         HandlebyProduct
      case "QUANTITYRANGE"
         HandlebyQuantityrange
      case "MESSAGE"
         HandlebyMessage
      case "OTHER"
         HandlebyOther
      case "PRICEPERCENT"
         HandlebyPricePercent
      case else
         SError = "Unknown Shipping Method"
   end select
end sub

' Read Database and store dat in shippingmethods array
' because of curreny conversion there are two arrays
' shippingmethods is the display portion in current currency
' shippingvalues is the original price
sub GetShippingDatabase
   dim rsship
   dim TempOption, tempdisplay, tempvalue
   dim TempPrice
   dim prevMethod
   shippingcount = 0
   prevmethod = ""

   '800 - 2015.07.15 - Better handling on Free shipping cart option
   dim freeshipping_rc

   '800 - 2015.11.09 - Onepage checkout: Shiping cost is reset if click Cancel on PayPal
   HandleFreeShipping_nosession freeshipping_rc

   if cstr(freeshipping_rc) = "0" then
      ShippingMethods(shippingcount) = getlang("langfreeshipping")
      shippingvalues(shippingcount) = 0
      if ShippingCount = 0 then
         if GetSess("Shipmethodtype")<>"" then
            shipmethodtype = GetSess("shipmethodtype")
         else
            ShipMethodType = ShippingMethods(0)
         end if
      end if
      shippingcount = shippingcount + 1
   end if

   set rsship = Server.createobject ("ADODB.Recordset")

   '702 - 2012.10.11 - Bug Fix: Display wrong pirce if using pricerange, weightrange and quantityrange
   SQL = "SELECT * from shipmethods "
   GetRangeShippingSQL sql
   sql = sql & " order by shipmethod"
 
   rsship.open SQL, dbc, adOpenForwardOnly, adLockReadOnly, adCmdText
   '800 - 2015.05.10 - Should only show 1 Free Shipping option if Qualified for Free Shipping
   dim has_freeflag

   '800 - 2016.06.09 - Bug Fix: Weightrange Shipping: Wrongly calculate if extracost on extraweight
   dim Extraweight, Lowweight, extraprice

   do while not rsship.eof
      TempOption = ""
      TempValue = ""
      TempPrice = ""
      TempOption = rsship("shipmethod")

      '701 - 2012.05.14 - Bug Fix: Shipping dropdowns does not show shipbasecost if shipping methods is using range
      if ucase(GetConfigvalue("xShippingCalc")) = "WEIGHTRANGE" OR ucase(GetConfigvalue("xShippingCalc")) = "PRICERANGE" OR ucase(GetConfigvalue("xShippingCalc")) = "QUANTITYRANGE" then
	     '702 - 2012.10.11 - Bug Fix: Display wrong pirce if using pricerange, weightrange and quantityrange
         TempPrice = rsship("shipbasecost")
		 if not isnull(rsship("shipextracost")) then
		    if trim(rsship("shipextracost")) <> "" then
			   if cdbl(rsship("shipextracost")) > 0 then
			      '800 - 2016.06.09 - Bug Fix: Weightrange Shipping: Wrongly calculate if extracost on extraweight
			      if ucase(GetConfigvalue("xShippingCalc")) = "WEIGHTRANGE" then
				     lowweight = rsship("shipother1")
                     if not isnull(lowweight) then
                        lowweight = csng(lowweight)
					 else
					    lowweight = 0
                     end if
				     Extraweight = cdbl(shiptotalweight) - cdbl(Lowweight)
					 extraprice = rsship("shipextracost")
					 TempPrice = cdbl(TempPrice) + (cdbl(ExtraWeight) * cdbl(ExtraPrice))
				  '800 - 2016.10.19 - Bug Fix: QuantityRange Shipping: Wrongly calculate if extracost on extraquantity
				  elseif ucase(GetConfigvalue("xShippingCalc")) = "QUANTITYRANGE" then
				     lowweight = rsship("shipother1")
                     if not isnull(lowweight) then
                        lowweight = csng(lowweight)
					 else
					    lowweight = 0
                     end if
				     Extraweight = cdbl(shiptotalquantity) - cdbl(Lowweight)
					 extraprice = rsship("shipextracost")
					 TempPrice = cdbl(TempPrice) + (cdbl(ExtraWeight) * cdbl(ExtraPrice))
				  else
			      TempPrice = cdbl(TempPrice) + cdbl(rsship("shipextracost"))
				  '800 - 2016.06.09 - Bug Fix: Weightrange Shipping: Wrongly calculate if extracost on extraweight
				  end if
			   end if
			end if
		 end if
      else
         TempPrice = rsship("smprice")
      end if

      '800 - 2015.05.10 - Should only show 1 Free Shipping option if Qualified for Free Shipping
	  has_freeflag = false
	  if cstr(freeshipping_rc) = "0" then
	     if trim(TempPrice) = "" then
		    has_freeflag = true
		 end if
	     if cstr(TempPrice) = "0" then
		    has_freeflag = true
		 end if
	  end if

      Tempdisplay = tempoption
      tempvalue = tempoption
      if TempOption<>PrevMethod then
         if GetConfig("xdisplayprices") = "No" then
            TempPrice = ""
         end if
         if TempPrice<>"" then
            if TempPrice<>0 then
			   '800 - 2015.08.07 - Better handling on shiping calculation if xshippingbycountry and Xshippingbystate have been set
			   'if getconfig("xshippingbycountry") = "No" then
                  TempDisplay = TempOption & " [" & ShopFormatCurrency(TempPrice, GetConfig("xdecimalpoint")) & "]"
                  TempValue = TempOption & " [" & formatnumber(TempPrice, GetConfig("xdecimalpoint")) & "]"
			   '800 - 2015.08.07 - Better handling on shiping calculation if xshippingbycountry and Xshippingbystate have been set
               'else
               '   TempDisplay= TempOption
               '   TempValue= TempOption
			   'end if
			   'if getconfig("Xshippingbystate") = "No" then
               '   TempDisplay = TempOption & " [" & ShopFormatCurrency(TempPrice, GetConfig("xdecimalpoint")) & "]"
               '   TempValue = TempOption & " [" & formatnumber(TempPrice, GetConfig("xdecimalpoint")) & "]"
               'else
               '   TempDisplay= TempOption
               '   TempValue= TempOption
			   'end if
            end if
         end if

		 if getmodules_status(rsship("shipother1")) then
            '800 - 2015.05.10 - Should only show 1 Free Shipping option if Qualified for Free Shipping
		    if not has_freeflag then
            ShippingMethods(shippingcount) = TempDisplay
            shippingvalues(shippingcount) = Tempvalue
            if ShippingCount = 0 then
			   '800 - 2016.08.05 - Bug Fix: Onepage checkout: Ajax shipping: Should always revert back to first record as default if changing country/postal code
               'if GetSess("Shipmethodtype")<>"" then
               '   shipmethodtype = GetSess("shipmethodtype")
               'else
                  ShipMethodType = ShippingMethods(0) ' set defaut method
               'end if
            end if
		    shippingcount = shippingcount + 1
            '800 - 2015.05.10 - Should only show 1 Free Shipping option if Qualified for Free Shipping
			'800 - 2016.12.06 - Shipping method: Free shipping: Better hanlding on Display only ONE Free Shipping
			else
			   if trim(lcase(TempDisplay)) <> trim(lcase(getlang("langfreeshipping"))) then
                  ShippingMethods(shippingcount) = TempDisplay
                  shippingvalues(shippingcount) = Tempvalue
                  if ShippingCount = 0 then
                     ShipMethodType = ShippingMethods(0) ' set defaut method
                  end if
		          shippingcount = shippingcount + 1
			   end if
			end if
		 end if
      end if
      PrevMethod = TempOption

      '701 - 2012.05.07 - Bug Fix: shippingcount is wrongly counted if in same shipping method name
      'if ShippingCount = 0 then
      '   if GetSess("Shipmethodtype")<>"" then
      '      shipmethodtype = GetSess("shipmethodtype")
      '   else
      '      ShipMethodType = ShippingMethods(0) ' set defaut method
      '   end if
      'end if
      'shippingcount = shippingcount + 1

      rsship.MoveNext
   loop
   CloseRecordSet rsship
end sub

' gets one shipping method from Database
sub LocateShippingRecord (dbc, Shipmethod)
   dim shipsql
   dim i
   ' Reread Database record for a particular method
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues

   '800 - 2016.07.12 - Bug Fix: Shipping: If ship method contain charactrer ', it throws error
   shipsql = "select * from shipmethods where shipmethod="& sqlserverprefixn &"'" & tosql(shipmethod,"Text") & "'"

   AddShippingCountry shipsql, objrs, dbc

   if objRS.eof then
      '6.09 - fix for shipping displaying error inappropriately
      select case ucase(GetConfig("xshippingcalc"))
         case "FIXED"
		    '702.2012.11.21 - Bug Fix: Non-shipping items does not working for fixed shipping
		    if CheckNonShippingItems=false then
               cursmprice = ShopFormatCurrency(GetConfig("xfixedshippingcost"), GetConfig("xdecimalpoint"))
               Shipmethod = ucase(GetConfig("xshippingcalc")) & " " & cursmprice
               ShipCost = curSmprice
               SetSess "shipmessage", shipmethod
               SetSess "shipselectionerror", ""
			end if   
         case "PRODUCT"
            Shipmethod = ""
            SetSess "shipmessage", shipmethod
            SetSess "shipselectionerror", ""
         case else
	        '700 - AJAX Shipping Calculation
   	        Shipmethod = ""
            SetSess "shipmessage", shipmethod
      end select
   else
      lngshipmethodid = objrs("shipmethodid")
      strshipmethod = objrs("shipmethod")
      cursmprice = objrs("smprice")
      curshipbasecost = objrs("shipbasecost")
      curshipextracost = objrs("shipextracost")
      if isnull(curshipbasecost) then
         curshipbasecost = 0
      end if
      if isnull(curshipextracost) then
         curshipextracost = 0
      end if
      strshipother1 = objrs("shipother1")
      strshipother2 = objrs("shipother2")
      curshipcost2 = objrs("shipcost2")
      curshipcost1 = objrs("shipcost1")
      ShipCost = curSmprice
   end if
   CloseRecordSet objrs
end sub

' ShipMethod. Get total weight
' Base Cost + extracost*weight
sub HandleByWeight
   dim prodid, prodcode, prodname, Prodquantity, ProdPrice
   dim weight
   dim i
   dim ShippingPrice
   dim TotalPrice
   dim ShippingCost
   if shiptotalweight = 0 then
      'SetSess "smprice", 0
      exit sub
   end if
   TotalPrice = 0
   if not isnull(curshipbaseCost) then
      TotalPrice = curShipBaseCost
   end if

   ShipCost = CurShipExtraCost
   ShippingPrice = shipTotalWeight * ShipCost
   TotalPrice = ShippingPrice + TotalPrice
   'Fix bug: base price added to shipcost
   ShipCost = TotalPrice

   SetSess "smprice", TotalPrice
   SetSess "ShipMethod", ShipMethod
   SetSess "shipcalc", "Weight"
end sub

' ShipMethod
' ShipCost
' The weight field in the Database actually has product shipping cost
sub HandleByProduct
   dim rssql
   dim i
   dim ShippingPrice
   dim TotalPrice
   dim rsitem
   dim ShippingCost
   dim Prodid, prodquantity

   '800 - 2015.06.03 - Bug Fix: Onepage checkout: Throwing error if shipping is based by product
   dim scartItem, ArrCart

   scartItem = GetSess("CartCount")
   ArrCart = GetSessA("CartArray")
   ' go through all products
   for i = 1 to scartItem
      prodid = ArrCart(cProductid, i)
      Prodquantity = ArrCart(cQuantity, i)
      rssql = "Select * from products where CatalogId=" & prodid
      if GetConfig("xshippingfreeproducts") = "Yes" then
         rssql = rssql & " and (freeshipping=0 or freeshipping is null)"
      end if
      Set rsitem = Server.CreateObject("ADODB.Recordset")
      rsitem.open rssql, dbc, adOpenStatic, adLockReadOnly
      if not rsItem.eof then
         shippingcost = rsitem(ProductCostField)
         if isnull(shippingcost) then
            shippingcost = 0
         end if
         ShippingPrice = shippingcost * prodquantity
         TotalPrice = ShippingPrice + TotalPrice

         'Fix bug: base price added to shipcost
         ShipCost = TotalPrice

         if GetConfig("xdebug") = "Yes" then
            DebugWrite "ShippingPerItem=" & ShippingCost & " quantity=" & prodquantity
            DebugWrite "shippingPrice=" & ShippingPrice
            DebugWrite "total=" & Totalprice
         end if
      end if
	  closerecordset rsitem
   next
   SetSess "smprice", TotalPrice
end sub

' Use number of items as shipping calculation
' QuantityBase = base shipping Price
' QuantityExtra= Extra amount per item
sub HandleByQuantity
   dim prodid, prodcode, prodname, Prodquantity, ProdPrice
   dim i, calculate
   dim ShippingPrice
   dim TotalPrice
   dim QuantityExtra, DEliveryArray
   if shiptotalquantity = 0 then
      'SetSess "smprice", 0
      exit sub
   end if
   TotalPrice = 0 ' from Database
   QuantityExtra = curShipExtracost ' extra per unit
   if isnull(QuantityExtra) then
      QuantityExtra = 0
   end if
   TotalPrice = curShipBaseCost ' base amount
   scartItem = GetSess("CartCount")
   ArrCart = GetSessA("CartArray")
   ' go through all products
   for i = 1 to scartItem
      Calculate = True
      prodid = ArrCart(cProductid, i)
      prodcode = ArrCart(cProductCode, i)
      prodname = ArrCart(cProductname, i)
      Prodquantity = ArrCart(cQuantity, i)
      ProdPrice = ArrCart(cUnitPrice, i)
      Deliveryarray = ArrCart(cDelivery, i)
      Calculate = CheckDeliverySelf(deliveryArray)
      if calculate = True then
         Calculate = CheckDeliveryFree(dbc, prodid)
         if calculate = True then
            ShippingPrice = prodquantity * QuantityExtra
            TotalPrice = ShippingPrice + TotalPrice
         end if
      end if
      if GetConfig("xdebug") = "Yes" then
         DebugWrite "ExtraPerItem=" & QuantityExtra & " quantity=" & prodquantity
         DebugWrite "shippingPrice=" & ShippingPrice
         DebugWrite "total=" & Totalprice
      end if
   next
   SetSess "smprice", TotalPrice
   SetSess "ShipMethod", ShipMethod
   SetSess "shipcalc", "Quantity"
end sub

' Use numer of items as shipping calculation
' Calculate fill Price
sub HandleByPriceRange
   dim weight
   dim i
   dim ShippingPrice
   dim TotalPrice
   dim rsitem
   dim ShippingCost
   dim rsitems
   dim lowvalue, highvalue
   dim shipsql
   if shiptotalcost = 0 then
      'SetSess "smprice", 0
      exit sub
   end if
   TotalPrice = shiptotalcost
   if GetConfig("Xdeliveryshipping") = "Yes" then
      CalculateTotalPrice dbc, totalprice
      if totalprice = 0 then
         exit sub
      end if
   end if

   '800 - 2016.12.05 - Shipping: Free shipping on prices: Should always calculated after coupon and gift cert discount
   dim coupondiscount, giftamountmax
   shiptotalcostafterdiscount = shiptotalcost
   coupondiscount = convert_int_session_value(session("coupondiscount"))
   giftamountmax = convert_int_session_value(session("giftamountmax"))
   totalprice = cdbl(totalprice) - (coupondiscount + giftamountmax)

   ' Find the weight range using shipother1 and shipother2
   ' Reread Database record for a particular method
   '800 - 2016.07.12 - Bug Fix: Shipping: If ship method contain charactrer ', it throws error
   shipsql = "select * from shipmethods where shipmethod='" & tosql(shipmethod,"Text") & "'"

   AddShippingCountry shipsql, rsitems, dbc

   do while not rsitems.eof
      lowvalue = rsitems("shipcost1")
      highvalue = rsitems("shipcost2")
      if totalprice >= lowvalue and totalprice < highvalue then
         shipcost = rsitems("shipbasecost")
         CloseRecordSet rsitems
         SetSess "smprice", ShipCost
         exit sub
      end if
      rsitems.movenext
   loop
   ShipCost = 0
   CloseRecordSet rsitems
   SetSess "smprice", ""
   SetSess "ShipCalc", "Price Range"
end sub

' Use numer of items as shipping calculation
' Calculate weight on product id
' If shipother1 set then use extra when weight exceeds
' Shipother1=LowWeight Range
' ShipOther2=highweightrange
' ShipBasecost=cost in that range
' Shipextracost  if weight exceeds low range
' shipmethod	smprice	ShipBaseCost	ShipExtraCost	ShipOther1   ShipOther2
' GROUND		      $8.50	           $2.00	          0   		100
' 2nd DAY AIR		$18.50	        $3.00	          2
' Next Day Air		$35.50	        $3.50	          2
' International	$49.50	        $9.00	          2
sub HandleByWeightRange
   dim weight
   dim i
   dim ShippingPrice
   dim TotalPrice
   dim rsitem
   dim ShippingCost
   dim TotalWeight
   dim totalfeatureweight
   TotalWeight = 0
   TotalPrice = 0 ' set base price from Database or a constant
   if GetConfig("XdeliveryAddress") = "Yes" and shipTotalweight = 0 then exit sub
   totalweight = shiptotalweight
   LocateShippingWeightRange shipmethod, TotalWeight
end sub

' read all records with specific ship method name
' See which falls into weight range calculation
sub LocateShippingWeightRange (Shipmethod, Totalweight)
   dim rsitems
   dim lowweight, highweight
   dim addprice
   dim Extraweight
   dim ExtraPrice
   dim TotalPrice
   SetSess "ShipCalc", "Weight Range"
   ' Find the weight range using shipother1 and shipother2
   SetSess "Shipmethod", Shipmethod
   dim shipsql
   ' Reread Database record for a particular method
   '800 - 2016.07.12 - Bug Fix: Shipping: If ship method contain charactrer ', it throws error
   shipsql = "select * from shipmethods where shipmethod='" & tosql(shipmethod,"Text") & "'"

   AddShippingCountry shipsql, rsitems, dbc

   do while not rsitems.eof
      lowweight = rsitems("shipother1")
      highweight = rsitems("shipother2")
      if not isnull(lowweight) then
         lowweight = csng(lowweight)
      end if
      if not isnull(highweight) then
         highweight = csng(highweight)
      end if
      '702 - 2014.09.29 - Bug Fix: Better handling on weightrange calculation
      if totalweight >= lowweight and Totalweight < highweight then
         ShipCost = rsitems("ShipBaseCost")
         Extraweight = totalweight - Lowweight
         extraprice = rsitems("shipextracost")
         AddPrice = 0
         if not isnull(Extraprice) then
            if Extraweight>0 then
               AddPrice = ExtraWeight * ExtraPrice
            end if
         end if
         TotalPrice = ShipCost + AddPrice
         rsitems.close
         set rsitems = nothing
         SetSess "smprice", TotalPrice
         exit sub
      end if
      rsitems.movenext
   loop
   
   '700 - 2010.08.05 - Bug Fix: Able to return to other special shipping routine if no result
   if trim(shipmethod) <> "" then ShipCost = 99999.99
   
   rsitems.close
   set rsitems = nothing
   
   '700 - 2010.08.05 - Bug Fix: Able to return to other special shipping routine if no result
   if trim(shipmethod) <> "" then
      SetSess "smprice", ShipCost
      SetSess "shipselectionerror", "weight"
   end if

   '700 - 2010.06.03 - Enhancement: Better shipping calculation error handling
   '700 - 2010.08.05 - Bug Fix: Able to return to other special shipping routine if no result
   if trim(shipmethod) <> "" then shoperror "Shipping is out of range or mis-configure.<br />Please contact administrator for further assistance."
end sub

' if therte is no quantity then even fixed has no cost
sub HandleByFixed
   '702.2012.11.21 - Bug Fix: Non-shipping items does not working for fixed shipping
   if CheckNonShippingItems then exit sub
   ' Need to add xshippingmethod and xshipping cost to shop$config for this to work
   if shiptotalquantity = 0 then
      'SetSess "smprice", 0
      exit sub
   end if
   ShipMethod = GetConfig("xFixedShippingMethod")
   SetSess "smprice", GetConfig("xFixedShippingCost")
   SetSess "ShipMethod", GetConfig("xFixedShippingMethod")
end sub

' This allows a totally extendable shipping system by allowing the
' routine to be specified in the Database
sub HandlebyOther
   dim ShipSql, shipmethod, shiprs, routine
   if shiptotalquantity = 0 then
      'SetSess "smprice", 0
      exit sub
   end if
   shipmethod = GetSess("shipmethod")

   '800 - 2016.07.12 - Bug Fix: Shipping: If ship method contain charactrer ', it throws error
   shipsql = "Select * from shipmethods where shipmethod='" & tosql(shipmethod,"Text") & "'"

   AddShippingCountry shipsql, shiprs, dbc

   if not shiprs.eof then
      routine = shiprs("shiproutine")
      if not isnull(routine) then
         SetSess "followonURL", routine
      end if
   end if
   ' no routine name treat as lookup
   shiprs.close
   set shiprs = nothing
end sub

sub CalculateTotalPrice(dbc, TotalPrice)
   dim Prodquantity, ProdPrice, deliveryarray, i, price, prodid
   dim scartiten, ArrCart
   scartItem = GetSess("CartCount")
   ArrCart = GetSessA("CartArray")
   dim Calculate
   ' go through all products
   totalprice = 0
   for i = 1 to scartItem
      calculate = True
      Prodquantity = ArrCart(cQuantity, i)
      ProdPrice = ArrCart(cUnitPrice, i)
      DeliveryArray = ArrCart(cDelivery, i)
      prodid = ArrCart(cProductid, i)
      Calculate = CheckDeliverySelf(deliveryArray)
      if Calculate = True then
         calculate = CheckDeliveryfree (dbc, prodid)
         if calculate = true then
            Price = ProdPrice * ProdQuantity
            totalprice = totalprice+price
         end if
      end if
   next
end sub

function CheckDeliverySelf (deliveryArray)
   ' Returns tru if to calculate this product
   dim DeliveryType
   CheckDeliverySelf = True
   if GetConfig("Xdeliveryshipping")<>"Yes" then exit function
   if isarray(deliveryarray) then
      Deliverytype = Deliveryarray(dDeliveryType)
      if Deliveryarray(dDeliveryType)<>GetLang("LangDeliverySelf") then
         CheckDeliverySelf = False
      end if
   end if
end function

' Quantity range calculation
sub HandleByQuantityRange
   dim Totalquantity
   Totalquantity = 0
   if shiptotalquantity = 0 then exit sub
   GetProductQuantity TotalQuantity ' total weight of product
   if Totalquantity = 0 then exit sub
   LocateShippingQuantityRange shipmethod, totalQuantity
end sub

sub GetProductQuantity( TotalQuantity )
   dim scartitem, ArrCart, i, prodquantity, deliveryarray, calculate
   dim prodprice, Deliverytype
   totalquantity = 0
   scartItem = GetSess("CartCount")
   ArrCart = GetSessA("CartArray")
   ' go through all products
   for i = 1 to scartItem
      Calculate = True
      Prodquantity = ArrCart(cQuantity, i)
      ProdPrice = ArrCart(cUnitPrice, i)
      DeliveryArray = ArrCart(cDelivery, i)
      if GetConfig("Xdeliveryshipping") = "Yes" and isarray(deliveryarray) then
         Deliverytype = Deliveryarray(dDeliveryType)
         if Deliveryarray(dDeliveryType)<>GetLang("LangDeliverySelf") then
            Calculate = False
         end if
      end if
      if calculate = True then
         totalquantity = totalquantity + prodquantity
      end if
   next
end sub

sub LocateShippingQuantityRange (Shipmethod, TotalQuantity)
   dim rsitems
   dim lowweight, highweight
   dim addprice
   dim Extraweight
   dim ExtraPrice
   dim TotalPrice
   SetSess "ShipCalc", "Quantity Range"
   ' Find the quantity range using shipother1 and shipother2
   SetSess "Shipmethod", Shipmethod
   dim shipsql
   ' Reread Database record for a particular method
   '800 - 2016.07.12 - Bug Fix: Shipping: If ship method contain charactrer ', it throws error
   shipsql = "select * from shipmethods where shipmethod='" & tosql(shipmethod,"Text") & "'"

   AddShippingCountry shipsql, rsitems, dbc

   do while not rsitems.eof
      lowweight = rsitems("shipother1")
      highweight = rsitems("shipother2")
      if not isnull(lowweight) then
         lowweight = csng(lowweight)
      end if
      if not isnull(highweight) then
         highweight = csng(highweight)
      end if
      if totalquantity >= lowweight and Totalquantity <= highweight then
         shipcost = rsitems("shipbasecost")
         Extraweight = totalquantity - Lowweight
         extraprice = rsitems("shipextracost")
         AddPrice = 0
         if not isnull(Extraprice) then
            if Extraweight>0 then
               AddPrice = ExtraWeight * ExtraPrice
            end if
         end if
         TotalPrice = ShipCost + AddPrice
         CloseRecordSet rsitems
         SetSess "smprice", TotalPrice
         exit sub
      end if
      rsitems.movenext
   loop

   '700 - 2010.08.05 - Bug Fix: Able to return to other special shipping routine if no result
   if trim(shipmethod) <> "" then ShipCost = 99999.97

   CloseRecordSet rsitems
   
   '700 - 2010.08.05 - Bug Fix: Able to return to other special shipping routine if no result
   if trim(shipmethod) <> "" then 
      SetSess "smprice", ShipCost
      SetSess "shipselectionerror", "quantity"
   end if

   '700 - 2010.06.03 - Enhancement: Better shipping calculation error handling
   '700 - 2010.08.05 - Bug Fix: Able to return to other special shipping routine if no result
   if trim(shipmethod) <> "" then shoperror "Shipping is out of range or mis-configure.<br />Please contact administrator for further assistance."
end sub

sub GetProductRecord (dbc, rsitem, prodid)
   dim shipsql
   ShipSql = "Select * from products where CatalogId=" & prodid
   Set rsitem = Server.CreateObject("ADODB.Recordset")
   rsitem.open shipsql, dbc, adOpenStatic, adLockReadOnly
end sub

' a shipping message is to be displayed
sub HandleByMessage
   'SetSess "smprice", 0
   SetSess "shipmessage", GetLang("LangShippingMessage")
end sub

' a shipping message is to be displayed
sub HandleFreeShipping (rc)
   '701 - 2012.02.24 - Bug Fix: Free shipping message should always initial and only show at shopcreateorder.asp
   SetSess "shipmessage", ""

   dim shipcost, productcost
   rc = 4
   if GetConfig("xshippingfree")<>"" then
      shipcost = GetConfig("xshippingfree")
      if isnumeric(shipcost) then
         shipcost = csng(shipcost)
         productcost = GetSess("orderproducttotal")

		 '800 - 2016.12.05 - Shipping: Free shipping on prices: Should always calculated after coupon and gift cert discount
		 dim coupondiscount, giftamountmax
		 coupondiscount = convert_int_session_value(session("coupondiscount"))
		 giftamountmax = convert_int_session_value(session("giftamountmax"))
		 productcost = cdbl(productcost) - (coupondiscount + giftamountmax)

         productcost = csng(productcost)
         if productcost>= shipcost then
            SetSess "smprice", 0
            SetSess "shipmessage", GetLang("LangFreeShippingMessage")
            rc = 0
            exit sub
         end if
      end if
   end if
   if GetConfig("xshippingfreeproducts") = "Yes" then
      CalculateShippingdetails dbc, shiptotalWeight, shiptotalfeatureweight, shiptotalcost, shiptotalquantity
      if shiptotalcost = 0 then
	     '700 - 2010.05.14 - Bug Fix: Free shipping with product is not working with shipping addon
	     session("currentfreeshippingstatus") = "Yes"

         SetSess "smprice", 0
         rc = 0
         exit sub
      end if
   end if
end sub

' if doing country shipping then add country to supplied sql
' if we do not find any records, try using a default shipicountry of other
sub AddShippingCountry (shipsql, rs, dbc)
   dim shipcountry, tempsql
   tempsql = shipsql
   if GetConfig("xshippingbycountry") = "Yes" then
      shipcountry = GetSess("shipcountry")
      if shipcountry = "" then
         shipcountry = GetSess("country")
      end if
      if shipcountry<>"" then
	     '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
         tempsql = shipsql & " and shipcountry="& sqlserverprefixn &"'" & shipcountry & "'"
      end if
   end if
   

   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open tempsql, dbc, adOpenStatic, adLockReadOnly
   if not rs.eof then exit sub
   CloseRecordSet rs
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   tempsql = shipsql & " and (shipcountry="& sqlserverprefixn &"'" & shipcountrydefault & "'"
   
   tempsql = tempsql & " ) "
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open tempsql, dbc, adOpenStatic, adLockReadOnly
   if rs.eof and ucase(getconfig("xshippingcalc")) <> "LOOKUP" and ucase(getconfig("xshippingcalc")) <> "FIXED" and ucase(getconfig("xShippingCalc")) <> "PRODUCT" then
      'HandleShippingError tempsql
   end if
end sub

sub HandleShippingError (shipsql)
   dim shipmethod
   Shipmethod = "Cannot locate shipping record<br />" & shipsql
   SetSess "shipmessage", shipmethod
   SetSess "shipselectionerror", "country"
end sub

' xfixedshippingcost is used as a percent value
sub HandleByPricePercent
   dim TotalPrice, percent, shippingcost
   TotalPrice = GetSess("OrderProductTotal")
   percent = GetConfig("xFixedShippingCost")
   if not isnumeric(percent) then exit sub
   percent = csng(percent)
   shippingcost = totalprice * percent
   shippingcost = formatnumber(shippingcost, 2)
   SetSess "smprice", shippingcost
end sub

Sub HandleByLookup
   dim ShipSql, shipmethod, shiprs, shipcost
   shipmethod=Getsess("shipmethod")

   '800 - 2016.07.12 - Bug Fix: Shipping: If ship method contain charactrer ', it throws error
   shipsql="Select * from shipmethods where shipmethod='" & tosql(shipmethod,"Text") & "'"
   
   '700 - 2010.09.01 - Bug Fix: Possible Error while shipping with paypal express
   'ShopOpendatabase dbc
   
   AddShippingCountry shipsql,shiprs, dbc

   If not shiprs.eof then 
      shipcost= shiprs("smprice")
   End If
   
   '700 - 2010.09.01 - Bug Fix: Possible Error while shipping with paypal express
   'ShopCloseDatabase dbc
   
   SetSess "smprice",ShipCost
   SetSess "ShipCalc","LOOKUP"
end sub

'702 - 2012.10.11 - Bug Fix: Display wrong pirce if using pricerange, weightrange and quantityrange
sub GetRangeShippingSQL (sql)
   if ucase(GetConfigvalue("xShippingCalc")) <> "WEIGHTRANGE" and ucase(GetConfigvalue("xShippingCalc")) <> "PRICERANGE" and ucase(GetConfigvalue("xShippingCalc")) <> "QUANTITYRANGE" then exit sub
   CalculateShippingdetails dbc, shiptotalWeight, shiptotalfeatureweight, shiptotalcost, shiptotalquantity

   '800 - 2016.12.05 - Shipping: Free shipping on prices: Should always calculated after coupon and gift cert discount
   dim coupondiscount, giftamountmax
   coupondiscount = convert_int_session_value(session("coupondiscount"))
   giftamountmax = convert_int_session_value(session("giftamountmax"))
   shiptotalcost = cdbl(shiptotalcost) - (coupondiscount + giftamountmax)

   '702 - 2012.11.06 - Bug Fix: Shipping sql condition error if xajaxshipping is switchedd off
   dim whereandstring
   if instr(lcase(sql)," where ") > 0 then
      whereandstring = "and"
   else
      whereandstring = "where"
   end if

   select case ucase(GetConfigvalue("xShippingCalc"))
      case "PRICERANGE"
	     '800 - 2015.10.23 - Bug Fix: Ranged shipping throwing error if regional from european with comma settings
	     if instr(formatcurrency(100,2),",") > 0 then
		    shiptotalcost = replace(shiptotalcost,",",".")
		 end if

	     '702 - 2012.11.06 - Bug Fix: Shipping sql condition error if xajaxshipping is switchedd off
         SQL = SQL & " "& whereandstring &" (shipcost1 <= "& shiptotalcost &" and shipcost2 > "& shiptotalcost &" ) "
      case "WEIGHTRANGE"
	     '800 - 2015.10.23 - Bug Fix: Ranged shipping throwing error if regional from european with comma settings
	     if instr(formatcurrency(100,2),",") > 0 then
		    shiptotalweight = replace(shiptotalweight,",",".")
		 end if

	     '702 - 2012.11.02 - Bug Fix: Weightrange and quantityrange error after package released 11/oct/2012
		 '702 - 2012.11.06 - Bug Fix: Shipping sql condition error if xajaxshipping is switchedd off
         if ucase(xdatabasetype) = "SQLSERVER" then
		    '800 - 2015.11.12 - Bug Fix: Weight Range / Quantity Range: Not working properly if databasetype is sql and custom shippng is installed
			SQL = SQL & " "& whereandstring &" (CASE WHEN ISNUMERIC(shipother1)= 1 THEN convert(real,shipother1) ELSE 0 END <= "& shiptotalweight &" and CASE WHEN ISNUMERIC(shipother2)= 1 THEN convert(real,shipother2) ELSE 0 END > "& shiptotalweight &" ) "
         elseif instr(ucase(xdatabasetype), "MYSQL") > 0 then
		    SQL = SQL & " "& whereandstring &" (cast(shipother1 as signed)  <= "& shiptotalweight &" and cast(shipother2 as signed) > "& shiptotalweight &" ) "
		 else
		    '800 - 2015.04.15 - WeightRange and QuantityRange is not working properly
            '800 - 2016.04.21 - Bug Fix: MySQL: Weight Range & Quantity Range shipping: Decimal shipping is nt working properly
            SQL = SQL & " "& whereandstring &" (Iif(shipother1 Is Null, 0, cdbl(shipother1)) <= "& shiptotalweight &" and Iif(shipother2 Is Null, 0, cdbl(shipother2)) > "& shiptotalweight &" ) "
         end if
      case "QUANTITYRANGE"
	     dim TotalQuantity
		 TotalQuantity = 0
		 GetProductQuantity TotalQuantity

		 '800 - 2015.10.23 - Bug Fix: Ranged shipping throwing error if regional from european with comma settings
	     if instr(formatcurrency(100,2),",") > 0 then
		    TotalQuantity = replace(TotalQuantity,",",".")
		 end if

		 '702 - 2012.11.02 - Bug Fix: Weightrange and quantityrange error after package released 11/oct/2012
		 '702 - 2012.11.06 - Bug Fix: Shipping sql condition error if xajaxshipping is switchedd off
         if ucase(xdatabasetype) = "SQLSERVER" then
		    '800 - 2015.11.12 - Bug Fix: Weight Range / Quantity Range: Not working properly if databasetype is sql and custom shippng is installed
			'800 - 2016.10.13 : Bug Fix: Shipping: Quantity Range: SQL query typo error
		    SQL = SQL & " "& whereandstring &" (CASE WHEN ISNUMERIC(shipother1)= 1 THEN convert(real,shipother1) ELSE 0 END <= "& TotalQuantity &" and CASE WHEN ISNUMERIC(shipother2)= 1 THEN convert(real,shipother2) ELSE 0 END > "& TotalQuantity &" ) "
        elseif instr(ucase(xdatabasetype), "MYSQL") > 0 then
		    SQL = SQL & " "& whereandstring &" (cast(shipother1 as signed) <= "& TotalQuantity &" and cast(shipother2 as signed) > "& TotalQuantity &" ) "
		 else
		    '800 - 2015.04.15 - WeightRange and QuantityRange is not working properly
            '800 - 2016.04.21 - Bug Fix: MySQL: Weight Range & Quantity Range shipping: Decimal shipping is nt working properly
            SQL = SQL & " "& whereandstring &" (Iif(shipother1 Is Null, 0, cdbl(shipother1)) <= "& TotalQuantity &" and Iif(shipother2 Is Null, 0, cdbl(shipother2)) > "& TotalQuantity &" ) "
         end if
   end select

   '800 - 2015.06.29 - Better handling on shipping SQL query
   if instr(lcase(sql),"shiproutine") <= 0 then
      SQL = SQL & " or (shiproutine is not null and shiproutine <> '') "
   end if
end sub

'702.2012.11.21 - Bug Fix: Non-shipping items does not working for fixed shipping
'700 - Free Shipping Products enhancement - check shipping form should be displayed?
'800 - 2016.06.15 - Shipping: Better handling on routine CheckNonShippingItems, so it will be more accurate and faster
session("CheckNonShippingItems") = ""
function CheckNonShippingItems
   '800 - 2016.06.15 - Shipping: Better handling on routine CheckNonShippingItems, so it will be more accurate and faster
   if session("CheckNonShippingItems") <> "" then
      CheckNonShippingItems = session("CheckNonShippingItems")
	  exit function
   end if

   dim nonshippingitemcnt,i
   dim scartItem,ArrCart
   scartItem = GetSess("CartCount")
   ArrCart =   GetSessA("CartArray")

   nonshippingitemcnt=0
   'xgiftproductid
   'go through all products
   for i = 1 to scartItem
      'check project & gift & electronic download
      if GetConfig("xprojectCatalogId") <> "" and GetConfig("xgiftproductid") <> "" then
         if (CLng(ArrCart(cProductid,i)) <> CLng(GetConfig("xprojectCatalogId"))) and (CLng(ArrCart(cProductid,i)) <> CLng(GetConfig("xgiftproductid"))) then
	        if checkdnonshipping(ArrCart(cProductid,i)) = false then
            else
	   	       nonshippingitemcnt=nonshippingitemcnt+1
   		    end if
         else
	   	    nonshippingitemcnt=nonshippingitemcnt+1
         end if
      else
         'check electronic download
         if checkdnonshipping(ArrCart(cProductid,i)) = false then
         else
	   	    nonshippingitemcnt=nonshippingitemcnt+1
	     end if
      end if
   next
   if cdbl(nonshippingitemcnt) > 0 then
      '800 - 2015.05.20 - Bug Fix: Should display shipping form if there is any needs to ship product
      if cdbl(scartitem) > cdbl(nonshippingitemcnt) then
	     CheckNonShippingItems=false
	  else
         CheckNonShippingItems=true
      end if
   else
      CheckNonShippingItems=false
   end if

   '800 - 2016.06.15 - Shipping: Better handling on routine CheckNonShippingItems, so it will be more accurate and faster
   session("CheckNonShippingItems") = CheckNonShippingItems
end function

'702.2012.11.21 - Bug Fix: Non-shipping items does not working for fixed shipping
'700 - Free Shipping Products enhancement - check whether is download items?
function checkdnonshipping (productid)
   dim rs, sql, bflag
   if productid="" then
      checkdnonshipping = false
      exit function
   end if

   bflag=false
   sql = "select producttype from products where catalogid = "& productid &""
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open SQL, dbc, adOpenStatic, adLockReadOnly
   if not rs.EOF then
      if lcase(rs("producttype")) = "download" or lcase(rs("producttype")) = "gift" then
	     bflag=true
	  end if
   end if
   closerecordset rs
   checkdnonshipping=bflag
end function

function generate_shippingform_status
   if lcase(GetConfig("xshippingform")) = "no" and lcase(GetConfig("xshippingselection")) = "no" then
      generate_shippingform_status = false
      exit function
   end if
   if lcase(GetConfig("xgiftregistry")) = "yes"  and trim(GetSess(REGISTRANTID)) <> "" then
      generate_shippingform_status = false
      exit function
   end if
   if trim(GetSess(REGISTRY)) <> "" and lcase(getconfig("xgiftregallowcustomershippingaddr")) = "no" then
      generate_shippingform_status = false
      exit function
   end if
   if CheckNonShippingItems then
      generate_shippingform_status = false
      exit function
   end if
   generate_shippingform_status = true
end function

'800 - 2015.11.09 - Onepage checkout: Shiping cost is reset if click Cancel on PayPal
sub HandleFreeShipping_nosession (rc)
   dim shipcost, productcost
   rc = 4
   if GetConfig("xshippingfree")<>"" then
      shipcost = GetConfig("xshippingfree")
      if isnumeric(shipcost) then
         shipcost = csng(shipcost)
         productcost = GetSess("orderproducttotal")

		 '800 - 2016.12.05 - Shipping: Free shipping on prices: Should always calculated after coupon and gift cert discount
		 dim coupondiscount, giftamountmax
		 coupondiscount = convert_int_session_value(session("coupondiscount"))
		 giftamountmax = convert_int_session_value(session("giftamountmax"))
		 productcost = cdbl(productcost) - (coupondiscount + giftamountmax)

         productcost = csng(productcost)
         if productcost>= shipcost then
            rc = 0
            exit sub
         end if
      end if
   end if
   if GetConfig("xshippingfreeproducts") = "Yes" then
      CalculateShippingdetails dbc, shiptotalWeight, shiptotalfeatureweight, shiptotalcost, shiptotalquantity
      if shiptotalcost = 0 then
         rc = 0
         exit sub
      end if
   end if
end sub

'800 - 2016.12.05 - Shipping: Free shipping on prices: Should always calculated after coupon and gift cert discount
function convert_int_session_value (passvalue)
   dim tempvalue
   tempvalue = passvalue
   on error goto 0
   on error resume next
   tempvalue = cdbl(tempvalue)
   if err.number <> 0 then
	  tempvalue = 0
   end if
   on error goto 0
   tempvalue = cdbl(tempvalue)
   convert_int_session_value = tempvalue
end function
%>