<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Generates a drop down list of states. The fieldname is the current value of the
' state and will be set as selected if it exists. Group states by country
'*********************************************************************************

sub ShopStates (formname, fieldname, requiredflag, errorvalue)
   dim sql, rs, statename, stateabbrev, selected
   dim i, selecteddone
   dim countries(10), displaycount, country
   dim statelist ' list of countries
   statelist = GetConfig("xdisplaystates") ' find out what countries we want states for
   dim errorclass
   errorclass = ""
   if trim(errorvalue) <> "" then
      errorclass = "error_field"
   end if
   dim requiredstr
   requiredstr = ""
   if lcase(requiredflag) = "yes" then
      requiredstr = "required"
   end if

   '800 - 2016.09.16 - Ajax Shipping: To include state as Ajax shipping option on normal checkout
   dim pagename
   pagename = Request.ServerVariables("SCRIPT_NAME") 
   if inStr(pagename, "/") > 0 then 
	  pagename = Right(pagename, Len(pagename) - instrRev(pagename, "/")) 
   end if 
   if pagename = "shopcustomer.asp" then
      dim updatezipcodecountryajaxstr
      if getconfig("xshippingselection") = "Yes" and getconfig("xshippingform") = "No" then
	     updatezipcodecountryajaxstr = "onchange=""javascript:updatezipcodestrcountryajax(this.form);"""
	  else
         updatezipcodecountryajaxstr = "onchange=""javascript:updatezipcodecountryajax(this.form);"""
      end if
      if GetConfig("xshippingform")="No" and GetConfig("xshippingselection")="No" then
         if GetConfig("xgiftregistry")="Yes" and GetSess(REGISTRANTID)<>"" then
            if GetSess(REGISTRY) <> "" and getconfig("xgiftregallowcustomershippingaddr") = "No" then
               if CheckNonShippingItems=true then
			      updatezipcodecountryajaxstr = ""
			   end if
			end if
	     end if
	  end if
	  if formname = "strstate" then
		 if getconfig("xAjaxShipping") = "Yes" and getconfig("xLoadJLibJQuery") = "Yes" then
			htmlwrite "<select class=""txtfielddropdown form-control "& errorclass &""" name=""" & formname & """ id=""" & formname & """ size=""1"" "& updatezipcodecountryajaxstr &" "& requiredstr &">"
		 else
			htmlwrite "<select class=""txtfielddropdown form-control "& errorclass &""" name=""" & formname & """ id=""" & formname & """ size=""1"" "& requiredstr &">"
		 end if
	  else
		 if getconfig("xAjaxShipping") = "Yes" and getconfig("xLoadJLibJQuery") = "Yes" then
		    htmlwrite "<select class=""txtfielddropdown form-control "& errorclass &""" name=""" & formname & """ id=""" & formname & """ size=""1"" onchange=""javascript:updateshipzipcodecountryajax(this.form);"" "& requiredstr &">"
		 else
		    htmlwrite "<select class=""txtfielddropdown form-control "& errorclass &""" name=""" & formname & """ id=""" & formname & """ size=""1"" "& requiredstr &">"
		 end if
	  end if
   else
	  htmlwrite "<select class=""txtfielddropdown form-control "& errorclass &""" name=""" & formname & """ id=""" & formname & """ size=""1"" "& requiredstr &">"
   end if

   stateabbrev = ""
   statename = GetLang("langcuststate") ' prompt in drop down list
   if fieldname = "" then ' make prompt the default
      selected = " selected=""selected"""
      selecteddone = true
   else
      selecteddone = false
   end if
   htmlwrite "<option value=""" & stateabbrev & """ " & selected & ">" & statename & "</option>"
   if lcase(GetSess("State")) = "none" then
      selected = " selected=""selected"""
   elseif lcase(fieldname) = "none" then
      selected = " selected=""selected"""
   else
      selected = ""
   end if
   stateabbrev = "None"
   statename = getlang("langgpfnone")
   htmlwrite "<option value=""" & stateabbrev & """ " & selected & ">" & statename & "</option>"
   if statelist = "" then statelist = "US" ' default to only US states
   ParseRecord statelist, countries, displaycount, ","
   for i = 0 to displaycount -1 ' go through each country
      country = countries(i)
	  '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      '800 - 2016.04.11 - Speed: Faster retriving Countries and States
      sql = "Select statename,stateabbrev from shopstates where ((statehide=0) OR (statehide IS NULL)) "

      sql = sql & " and statecountry="& sqlserverprefixn &"'" & country & "'"
      sql = sql & " order by statename"
      Set rs = Server.CreateObject("ADODB.Recordset")

      '800 - 2016.04.11 - Speed: Faster retriving Countries and States
      rs.open sql, dbc, adOpenForwardOnly, adLockReadOnly

      if i>0 then
         shopstatedisplaycountry dbc, country
      end if
      do while not rs.eof ' go through all vales
         statename = rs("statename") ' full name
         stateabbrev = rs("stateabbrev") ' abrreviation
         selected = ""
         if selecteddone = false then ' have we seletec something
            '6.50.1 - added UCASE to both fields below
            if ucase(fieldname) = ucase(stateabbrev) then
               selected = " selected"
               selecteddone = true
            end if
         end if
         htmlwrite "<option value=""" & stateabbrev & """" & selected & ">" & statename & "</option>"
         selected = ""
         rs.movenext ' next state
      loop
      CloseRecordSet rs
   next ' go to next country
   htmlwrite "</select>"
end sub

' generate a html separator for each country
' in form
' <option value>----- CANADA ----
sub Shopstatedisplaycountry (dbc, country)
   dim countryname
   dim crs, csql
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   '800 - 2016.04.11 - Speed: Faster retriving Countries and States
   csql = "select countryname from shopcountries where country="& sqlserverprefixn &"'" & country & "'"

   Set crs = Server.CreateObject("ADODB.Recordset")

   '800 - 2016.04.11 - Speed: Faster retriving Countries and States
   crs.open csql, dbc, adOpenForwardOnly, adLockReadOnly

   if not crs.eof then
      countryname = crs("countryname")
   else
      countryname = ""
   end if
   CloseRecordSet crs
   htmlwrite "<option value="""">----- " & countryname & " ----- </option>"
end sub
%>